#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1579
#define LARGE_STATE_COUNT 96
#define SYMBOL_COUNT 296
#define ALIAS_COUNT 0
#define TOKEN_COUNT 109
#define EXTERNAL_TOKEN_COUNT 108
#define FIELD_COUNT 2
#define MAX_ALIAS_SEQUENCE_LENGTH 5
#define PRODUCTION_ID_COUNT 12

enum ts_symbol_identifiers {
  sym__eof = 1,
  sym__s_dir_yml_bgn = 2,
  sym__r_dir_yml_ver = 3,
  sym__s_dir_tag_bgn = 4,
  sym__r_dir_tag_hdl = 5,
  sym__r_dir_tag_pfx = 6,
  sym__s_dir_rsv_bgn = 7,
  sym__r_dir_rsv_prm = 8,
  sym__s_drs_end = 9,
  sym__s_doc_end = 10,
  sym__r_blk_seq_bgn = 11,
  sym__br_blk_seq_bgn = 12,
  sym__b_blk_seq_bgn = 13,
  sym__r_blk_key_bgn = 14,
  sym__br_blk_key_bgn = 15,
  sym__b_blk_key_bgn = 16,
  sym__r_blk_val_bgn = 17,
  sym__br_blk_val_bgn = 18,
  sym__b_blk_val_bgn = 19,
  sym__r_blk_imp_bgn = 20,
  sym__r_blk_lit_bgn = 21,
  sym__br_blk_lit_bgn = 22,
  sym__r_blk_fld_bgn = 23,
  sym__br_blk_fld_bgn = 24,
  sym__br_blk_str_ctn = 25,
  sym__r_flw_seq_bgn = 26,
  sym__br_flw_seq_bgn = 27,
  sym__b_flw_seq_bgn = 28,
  sym__r_flw_seq_end = 29,
  sym__br_flw_seq_end = 30,
  sym__b_flw_seq_end = 31,
  sym__r_flw_map_bgn = 32,
  sym__br_flw_map_bgn = 33,
  sym__b_flw_map_bgn = 34,
  sym__r_flw_map_end = 35,
  sym__br_flw_map_end = 36,
  sym__b_flw_map_end = 37,
  sym__r_flw_sep_bgn = 38,
  sym__br_flw_sep_bgn = 39,
  sym__r_flw_key_bgn = 40,
  sym__br_flw_key_bgn = 41,
  sym__r_flw_jsv_bgn = 42,
  sym__br_flw_jsv_bgn = 43,
  sym__r_flw_njv_bgn = 44,
  sym__br_flw_njv_bgn = 45,
  sym__r_dqt_str_bgn = 46,
  sym__br_dqt_str_bgn = 47,
  sym__b_dqt_str_bgn = 48,
  sym__r_dqt_str_ctn = 49,
  sym__br_dqt_str_ctn = 50,
  sym__r_dqt_esc_nwl = 51,
  sym__br_dqt_esc_nwl = 52,
  sym__r_dqt_esc_seq = 53,
  sym__br_dqt_esc_seq = 54,
  sym__r_dqt_str_end = 55,
  sym__br_dqt_str_end = 56,
  sym__r_sqt_str_bgn = 57,
  sym__br_sqt_str_bgn = 58,
  sym__b_sqt_str_bgn = 59,
  sym__r_sqt_str_ctn = 60,
  sym__br_sqt_str_ctn = 61,
  sym__r_sqt_esc_sqt = 62,
  sym__br_sqt_esc_sqt = 63,
  sym__r_sqt_str_end = 64,
  sym__br_sqt_str_end = 65,
  sym__r_sgl_pln_nul_blk = 66,
  sym__br_sgl_pln_nul_blk = 67,
  sym__b_sgl_pln_nul_blk = 68,
  sym__r_sgl_pln_nul_flw = 69,
  sym__br_sgl_pln_nul_flw = 70,
  sym__r_sgl_pln_bol_blk = 71,
  sym__br_sgl_pln_bol_blk = 72,
  sym__b_sgl_pln_bol_blk = 73,
  sym__r_sgl_pln_bol_flw = 74,
  sym__br_sgl_pln_bol_flw = 75,
  sym__r_sgl_pln_int_blk = 76,
  sym__br_sgl_pln_int_blk = 77,
  sym__b_sgl_pln_int_blk = 78,
  sym__r_sgl_pln_int_flw = 79,
  sym__br_sgl_pln_int_flw = 80,
  sym__r_sgl_pln_flt_blk = 81,
  sym__br_sgl_pln_flt_blk = 82,
  sym__b_sgl_pln_flt_blk = 83,
  sym__r_sgl_pln_flt_flw = 84,
  sym__br_sgl_pln_flt_flw = 85,
  sym__r_sgl_pln_str_blk = 86,
  sym__br_sgl_pln_str_blk = 87,
  sym__b_sgl_pln_str_blk = 88,
  sym__r_sgl_pln_str_flw = 89,
  sym__br_sgl_pln_str_flw = 90,
  sym__r_mtl_pln_str_blk = 91,
  sym__br_mtl_pln_str_blk = 92,
  sym__r_mtl_pln_str_flw = 93,
  sym__br_mtl_pln_str_flw = 94,
  sym__r_tag = 95,
  sym__br_tag = 96,
  sym__b_tag = 97,
  sym__r_acr_bgn = 98,
  sym__br_acr_bgn = 99,
  sym__b_acr_bgn = 100,
  sym__r_acr_ctn = 101,
  sym__r_als_bgn = 102,
  sym__br_als_bgn = 103,
  sym__b_als_bgn = 104,
  sym__r_als_ctn = 105,
  sym__bl = 106,
  sym_comment = 107,
  sym__err_rec = 108,
  sym_stream = 109,
  sym__doc_w_bgn_w_end_seq = 110,
  sym__doc_w_bgn_wo_end_seq = 111,
  sym__doc_wo_bgn_w_end_seq = 112,
  sym__doc_wo_bgn_wo_end_seq = 113,
  sym__doc_w_bgn_w_end = 114,
  sym__doc_w_bgn_wo_end = 115,
  sym__doc_wo_bgn_w_end = 116,
  sym__doc_wo_bgn_wo_end = 117,
  sym__bgn_imp_doc = 118,
  sym__drs_doc = 119,
  sym__exp_doc = 120,
  sym__imp_doc = 121,
  sym__drs_doc_end = 122,
  sym__exp_doc_end = 123,
  sym__imp_doc_end = 124,
  sym__bgn_imp_doc_end = 125,
  sym__doc_end = 126,
  sym__exp_doc_tal = 127,
  sym__s_dir = 128,
  sym__s_dir_yml = 129,
  sym__s_dir_tag = 130,
  sym__s_dir_rsv = 131,
  sym__r_prp_val = 132,
  sym__br_prp_val = 133,
  sym__r_sgl_prp_val = 134,
  sym__br_sgl_prp_val = 135,
  sym__b_sgl_prp_val = 136,
  sym__r_prp = 137,
  sym__br_prp = 138,
  sym__r_sgl_prp = 139,
  sym__br_sgl_prp = 140,
  sym__b_sgl_prp = 141,
  sym__r_blk_seq_r_val = 142,
  sym__r_blk_seq_br_val = 143,
  sym__br_blk_seq_val = 144,
  sym__r_blk_seq_spc_val = 145,
  sym__br_blk_seq_spc_val = 146,
  sym__b_blk_seq_spc_val = 147,
  sym__r_blk_seq = 148,
  sym__br_blk_seq = 149,
  sym__b_blk_seq_spc = 150,
  sym__r_blk_seq_itm = 151,
  sym__br_blk_seq_itm = 152,
  sym__b_blk_seq_itm = 153,
  sym__blk_seq_itm_tal = 154,
  sym__r_blk_map_r_val = 155,
  sym__r_blk_map_br_val = 156,
  sym__br_blk_map_val = 157,
  sym__r_blk_map = 158,
  sym__br_blk_map = 159,
  sym__r_blk_map_itm = 160,
  sym__br_blk_map_itm = 161,
  sym__b_blk_map_itm = 162,
  sym__r_blk_exp_itm = 163,
  sym__br_blk_exp_itm = 164,
  sym__b_blk_exp_itm = 165,
  sym__r_blk_key_itm = 166,
  sym__br_blk_key_itm = 167,
  sym__b_blk_key_itm = 168,
  sym__r_blk_val_itm = 169,
  sym__br_blk_val_itm = 170,
  sym__b_blk_val_itm = 171,
  sym__r_blk_imp_itm = 172,
  sym__br_blk_imp_itm = 173,
  sym__b_blk_imp_itm = 174,
  sym__blk_exp_itm_tal = 175,
  sym__blk_imp_itm_tal = 176,
  sym__r_blk_str_val = 177,
  sym__br_blk_str_val = 178,
  sym__r_blk_str = 179,
  sym__br_blk_str = 180,
  sym__r_flw_seq_val = 181,
  sym__br_flw_seq_val = 182,
  sym__r_sgl_flw_seq_val = 183,
  sym__br_sgl_flw_seq_val = 184,
  sym__b_sgl_flw_seq_val = 185,
  sym__r_flw_seq = 186,
  sym__br_flw_seq = 187,
  sym__r_sgl_flw_seq = 188,
  sym__br_sgl_flw_seq = 189,
  sym__b_sgl_flw_seq = 190,
  sym__flw_seq_tal = 191,
  sym__sgl_flw_seq_tal = 192,
  sym__r_flw_map_val = 193,
  sym__br_flw_map_val = 194,
  sym__r_sgl_flw_map_val = 195,
  sym__br_sgl_flw_map_val = 196,
  sym__b_sgl_flw_map_val = 197,
  sym__r_flw_map = 198,
  sym__br_flw_map = 199,
  sym__r_sgl_flw_map = 200,
  sym__br_sgl_flw_map = 201,
  sym__b_sgl_flw_map = 202,
  sym__flw_map_tal = 203,
  sym__sgl_flw_map_tal = 204,
  sym__r_flw_seq_dat = 205,
  sym__br_flw_seq_dat = 206,
  sym__r_flw_map_dat = 207,
  sym__br_flw_map_dat = 208,
  sym__r_sgl_flw_col_dat = 209,
  sym__flw_seq_dat_rpt = 210,
  sym__flw_map_dat_rpt = 211,
  sym__sgl_flw_col_dat_rpt = 212,
  sym__r_flw_seq_itm = 213,
  sym__br_flw_seq_itm = 214,
  sym__r_flw_map_itm = 215,
  sym__br_flw_map_itm = 216,
  sym__r_sgl_flw_col_itm = 217,
  sym__r_flw_exp_par = 218,
  sym__br_flw_exp_par = 219,
  sym__r_sgl_flw_exp_par = 220,
  sym__r_flw_imp_r_par = 221,
  sym__r_flw_imp_br_par = 222,
  sym__br_flw_imp_r_par = 223,
  sym__br_flw_imp_br_par = 224,
  sym__r_sgl_flw_imp_par = 225,
  sym__r_flw_jsl_ann_par = 226,
  sym__br_flw_jsl_ann_par = 227,
  sym__r_sgl_flw_jsl_ann_par = 228,
  sym__r_flw_njl_ann_par = 229,
  sym__br_flw_njl_ann_par = 230,
  sym__r_sgl_flw_njl_ann_par = 231,
  sym__flw_ann_par_tal = 232,
  sym__sgl_flw_ann_par_tal = 233,
  sym__r_dqt_str_val = 234,
  sym__br_dqt_str_val = 235,
  sym__r_sgl_dqt_str_val = 236,
  sym__br_sgl_dqt_str_val = 237,
  sym__b_sgl_dqt_str_val = 238,
  sym__r_dqt_str = 239,
  sym__br_dqt_str = 240,
  sym__r_sgl_dqt_str = 241,
  sym__br_sgl_dqt_str = 242,
  sym__b_sgl_dqt_str = 243,
  aux_sym__r_sgl_dqt_ctn = 244,
  sym__br_mtl_dqt_ctn = 245,
  sym__r_sqt_str_val = 246,
  sym__br_sqt_str_val = 247,
  sym__r_sgl_sqt_str_val = 248,
  sym__br_sgl_sqt_str_val = 249,
  sym__b_sgl_sqt_str_val = 250,
  sym__r_sqt_str = 251,
  sym__br_sqt_str = 252,
  sym__r_sgl_sqt_str = 253,
  sym__br_sgl_sqt_str = 254,
  sym__b_sgl_sqt_str = 255,
  aux_sym__r_sgl_sqt_ctn = 256,
  sym__br_mtl_sqt_ctn = 257,
  sym__r_pln_blk_val = 258,
  sym__br_pln_blk_val = 259,
  sym__r_sgl_pln_blk_val = 260,
  sym__br_sgl_pln_blk_val = 261,
  sym__b_sgl_pln_blk_val = 262,
  sym__r_pln_flw_val = 263,
  sym__br_pln_flw_val = 264,
  sym__r_sgl_pln_flw_val = 265,
  sym__r_sgl_pln_blk = 266,
  sym__br_sgl_pln_blk = 267,
  sym__b_sgl_pln_blk = 268,
  sym__r_sgl_pln_flw = 269,
  sym__br_sgl_pln_flw = 270,
  sym__r_mtl_pln_blk = 271,
  sym__br_mtl_pln_blk = 272,
  sym__r_mtl_pln_flw = 273,
  sym__br_mtl_pln_flw = 274,
  sym__r_als_val = 275,
  sym__br_als_val = 276,
  sym__b_als_val = 277,
  sym__r_als = 278,
  sym__br_als = 279,
  sym__b_als = 280,
  sym__r_acr = 281,
  sym__br_acr = 282,
  sym__b_acr = 283,
  aux_sym__drs_doc_repeat1 = 284,
  aux_sym__s_dir_rsv_repeat1 = 285,
  aux_sym__r_blk_seq_repeat1 = 286,
  aux_sym__r_blk_map_repeat1 = 287,
  aux_sym__r_blk_str_repeat1 = 288,
  aux_sym__r_flw_seq_dat_repeat1 = 289,
  aux_sym__r_flw_map_dat_repeat1 = 290,
  aux_sym__r_sgl_flw_col_dat_repeat1 = 291,
  aux_sym__r_dqt_str_repeat1 = 292,
  aux_sym__br_mtl_dqt_ctn_repeat1 = 293,
  aux_sym__r_sqt_str_repeat1 = 294,
  aux_sym__br_mtl_sqt_ctn_repeat1 = 295,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__eof] = "_eof",
  [sym__s_dir_yml_bgn] = "_s_dir_yml_bgn",
  [sym__r_dir_yml_ver] = "yaml_version",
  [sym__s_dir_tag_bgn] = "_s_dir_tag_bgn",
  [sym__r_dir_tag_hdl] = "tag_handle",
  [sym__r_dir_tag_pfx] = "tag_prefix",
  [sym__s_dir_rsv_bgn] = "directive_name",
  [sym__r_dir_rsv_prm] = "directive_parameter",
  [sym__s_drs_end] = "---",
  [sym__s_doc_end] = "...",
  [sym__r_blk_seq_bgn] = "-",
  [sym__br_blk_seq_bgn] = "-",
  [sym__b_blk_seq_bgn] = "-",
  [sym__r_blk_key_bgn] = "\?",
  [sym__br_blk_key_bgn] = "\?",
  [sym__b_blk_key_bgn] = "\?",
  [sym__r_blk_val_bgn] = ":",
  [sym__br_blk_val_bgn] = ":",
  [sym__b_blk_val_bgn] = ":",
  [sym__r_blk_imp_bgn] = ":",
  [sym__r_blk_lit_bgn] = "|",
  [sym__br_blk_lit_bgn] = "|",
  [sym__r_blk_fld_bgn] = ">",
  [sym__br_blk_fld_bgn] = ">",
  [sym__br_blk_str_ctn] = "_br_blk_str_ctn",
  [sym__r_flw_seq_bgn] = "[",
  [sym__br_flw_seq_bgn] = "[",
  [sym__b_flw_seq_bgn] = "[",
  [sym__r_flw_seq_end] = "]",
  [sym__br_flw_seq_end] = "]",
  [sym__b_flw_seq_end] = "]",
  [sym__r_flw_map_bgn] = "{",
  [sym__br_flw_map_bgn] = "{",
  [sym__b_flw_map_bgn] = "{",
  [sym__r_flw_map_end] = "}",
  [sym__br_flw_map_end] = "}",
  [sym__b_flw_map_end] = "}",
  [sym__r_flw_sep_bgn] = ",",
  [sym__br_flw_sep_bgn] = ",",
  [sym__r_flw_key_bgn] = "\?",
  [sym__br_flw_key_bgn] = "\?",
  [sym__r_flw_jsv_bgn] = ":",
  [sym__br_flw_jsv_bgn] = ":",
  [sym__r_flw_njv_bgn] = ":",
  [sym__br_flw_njv_bgn] = ":",
  [sym__r_dqt_str_bgn] = "\"",
  [sym__br_dqt_str_bgn] = "\"",
  [sym__b_dqt_str_bgn] = "\"",
  [sym__r_dqt_str_ctn] = "_r_dqt_str_ctn",
  [sym__br_dqt_str_ctn] = "_br_dqt_str_ctn",
  [sym__r_dqt_esc_nwl] = "escape_sequence",
  [sym__br_dqt_esc_nwl] = "escape_sequence",
  [sym__r_dqt_esc_seq] = "escape_sequence",
  [sym__br_dqt_esc_seq] = "escape_sequence",
  [sym__r_dqt_str_end] = "\"",
  [sym__br_dqt_str_end] = "\"",
  [sym__r_sqt_str_bgn] = "'",
  [sym__br_sqt_str_bgn] = "'",
  [sym__b_sqt_str_bgn] = "'",
  [sym__r_sqt_str_ctn] = "_r_sqt_str_ctn",
  [sym__br_sqt_str_ctn] = "_br_sqt_str_ctn",
  [sym__r_sqt_esc_sqt] = "escape_sequence",
  [sym__br_sqt_esc_sqt] = "escape_sequence",
  [sym__r_sqt_str_end] = "'",
  [sym__br_sqt_str_end] = "'",
  [sym__r_sgl_pln_nul_blk] = "null_scalar",
  [sym__br_sgl_pln_nul_blk] = "null_scalar",
  [sym__b_sgl_pln_nul_blk] = "null_scalar",
  [sym__r_sgl_pln_nul_flw] = "null_scalar",
  [sym__br_sgl_pln_nul_flw] = "null_scalar",
  [sym__r_sgl_pln_bol_blk] = "boolean_scalar",
  [sym__br_sgl_pln_bol_blk] = "boolean_scalar",
  [sym__b_sgl_pln_bol_blk] = "boolean_scalar",
  [sym__r_sgl_pln_bol_flw] = "boolean_scalar",
  [sym__br_sgl_pln_bol_flw] = "boolean_scalar",
  [sym__r_sgl_pln_int_blk] = "integer_scalar",
  [sym__br_sgl_pln_int_blk] = "integer_scalar",
  [sym__b_sgl_pln_int_blk] = "integer_scalar",
  [sym__r_sgl_pln_int_flw] = "integer_scalar",
  [sym__br_sgl_pln_int_flw] = "integer_scalar",
  [sym__r_sgl_pln_flt_blk] = "float_scalar",
  [sym__br_sgl_pln_flt_blk] = "float_scalar",
  [sym__b_sgl_pln_flt_blk] = "float_scalar",
  [sym__r_sgl_pln_flt_flw] = "float_scalar",
  [sym__br_sgl_pln_flt_flw] = "float_scalar",
  [sym__r_sgl_pln_str_blk] = "string_scalar",
  [sym__br_sgl_pln_str_blk] = "string_scalar",
  [sym__b_sgl_pln_str_blk] = "string_scalar",
  [sym__r_sgl_pln_str_flw] = "string_scalar",
  [sym__br_sgl_pln_str_flw] = "string_scalar",
  [sym__r_mtl_pln_str_blk] = "string_scalar",
  [sym__br_mtl_pln_str_blk] = "string_scalar",
  [sym__r_mtl_pln_str_flw] = "string_scalar",
  [sym__br_mtl_pln_str_flw] = "string_scalar",
  [sym__r_tag] = "tag",
  [sym__br_tag] = "tag",
  [sym__b_tag] = "tag",
  [sym__r_acr_bgn] = "&",
  [sym__br_acr_bgn] = "&",
  [sym__b_acr_bgn] = "&",
  [sym__r_acr_ctn] = "anchor_name",
  [sym__r_als_bgn] = "*",
  [sym__br_als_bgn] = "*",
  [sym__b_als_bgn] = "*",
  [sym__r_als_ctn] = "alias_name",
  [sym__bl] = "_bl",
  [sym_comment] = "comment",
  [sym__err_rec] = "_err_rec",
  [sym_stream] = "stream",
  [sym__doc_w_bgn_w_end_seq] = "_doc_w_bgn_w_end_seq",
  [sym__doc_w_bgn_wo_end_seq] = "_doc_w_bgn_wo_end_seq",
  [sym__doc_wo_bgn_w_end_seq] = "_doc_wo_bgn_w_end_seq",
  [sym__doc_wo_bgn_wo_end_seq] = "_doc_wo_bgn_wo_end_seq",
  [sym__doc_w_bgn_w_end] = "_doc_w_bgn_w_end",
  [sym__doc_w_bgn_wo_end] = "_doc_w_bgn_wo_end",
  [sym__doc_wo_bgn_w_end] = "_doc_wo_bgn_w_end",
  [sym__doc_wo_bgn_wo_end] = "_doc_wo_bgn_wo_end",
  [sym__bgn_imp_doc] = "_bgn_imp_doc",
  [sym__drs_doc] = "_drs_doc",
  [sym__exp_doc] = "_exp_doc",
  [sym__imp_doc] = "_imp_doc",
  [sym__drs_doc_end] = "document",
  [sym__exp_doc_end] = "document",
  [sym__imp_doc_end] = "document",
  [sym__bgn_imp_doc_end] = "document",
  [sym__doc_end] = "document",
  [sym__exp_doc_tal] = "_exp_doc_tal",
  [sym__s_dir] = "_s_dir",
  [sym__s_dir_yml] = "yaml_directive",
  [sym__s_dir_tag] = "tag_directive",
  [sym__s_dir_rsv] = "reserved_directive",
  [sym__r_prp_val] = "flow_node",
  [sym__br_prp_val] = "flow_node",
  [sym__r_sgl_prp_val] = "flow_node",
  [sym__br_sgl_prp_val] = "flow_node",
  [sym__b_sgl_prp_val] = "flow_node",
  [sym__r_prp] = "_r_prp",
  [sym__br_prp] = "_br_prp",
  [sym__r_sgl_prp] = "_r_sgl_prp",
  [sym__br_sgl_prp] = "_br_sgl_prp",
  [sym__b_sgl_prp] = "_b_sgl_prp",
  [sym__r_blk_seq_r_val] = "block_node",
  [sym__r_blk_seq_br_val] = "block_node",
  [sym__br_blk_seq_val] = "block_node",
  [sym__r_blk_seq_spc_val] = "block_node",
  [sym__br_blk_seq_spc_val] = "block_node",
  [sym__b_blk_seq_spc_val] = "block_node",
  [sym__r_blk_seq] = "block_sequence",
  [sym__br_blk_seq] = "block_sequence",
  [sym__b_blk_seq_spc] = "block_sequence",
  [sym__r_blk_seq_itm] = "block_sequence_item",
  [sym__br_blk_seq_itm] = "block_sequence_item",
  [sym__b_blk_seq_itm] = "block_sequence_item",
  [sym__blk_seq_itm_tal] = "_blk_seq_itm_tal",
  [sym__r_blk_map_r_val] = "block_node",
  [sym__r_blk_map_br_val] = "block_node",
  [sym__br_blk_map_val] = "block_node",
  [sym__r_blk_map] = "block_mapping",
  [sym__br_blk_map] = "block_mapping",
  [sym__r_blk_map_itm] = "_r_blk_map_itm",
  [sym__br_blk_map_itm] = "_br_blk_map_itm",
  [sym__b_blk_map_itm] = "_b_blk_map_itm",
  [sym__r_blk_exp_itm] = "block_mapping_pair",
  [sym__br_blk_exp_itm] = "block_mapping_pair",
  [sym__b_blk_exp_itm] = "block_mapping_pair",
  [sym__r_blk_key_itm] = "_r_blk_key_itm",
  [sym__br_blk_key_itm] = "_br_blk_key_itm",
  [sym__b_blk_key_itm] = "_b_blk_key_itm",
  [sym__r_blk_val_itm] = "_r_blk_val_itm",
  [sym__br_blk_val_itm] = "_br_blk_val_itm",
  [sym__b_blk_val_itm] = "_b_blk_val_itm",
  [sym__r_blk_imp_itm] = "block_mapping_pair",
  [sym__br_blk_imp_itm] = "block_mapping_pair",
  [sym__b_blk_imp_itm] = "block_mapping_pair",
  [sym__blk_exp_itm_tal] = "_blk_exp_itm_tal",
  [sym__blk_imp_itm_tal] = "_blk_imp_itm_tal",
  [sym__r_blk_str_val] = "block_node",
  [sym__br_blk_str_val] = "block_node",
  [sym__r_blk_str] = "block_scalar",
  [sym__br_blk_str] = "block_scalar",
  [sym__r_flw_seq_val] = "flow_node",
  [sym__br_flw_seq_val] = "flow_node",
  [sym__r_sgl_flw_seq_val] = "flow_node",
  [sym__br_sgl_flw_seq_val] = "flow_node",
  [sym__b_sgl_flw_seq_val] = "flow_node",
  [sym__r_flw_seq] = "flow_sequence",
  [sym__br_flw_seq] = "flow_sequence",
  [sym__r_sgl_flw_seq] = "flow_sequence",
  [sym__br_sgl_flw_seq] = "flow_sequence",
  [sym__b_sgl_flw_seq] = "flow_sequence",
  [sym__flw_seq_tal] = "_flw_seq_tal",
  [sym__sgl_flw_seq_tal] = "_sgl_flw_seq_tal",
  [sym__r_flw_map_val] = "flow_node",
  [sym__br_flw_map_val] = "flow_node",
  [sym__r_sgl_flw_map_val] = "flow_node",
  [sym__br_sgl_flw_map_val] = "flow_node",
  [sym__b_sgl_flw_map_val] = "flow_node",
  [sym__r_flw_map] = "flow_mapping",
  [sym__br_flw_map] = "flow_mapping",
  [sym__r_sgl_flw_map] = "flow_mapping",
  [sym__br_sgl_flw_map] = "flow_mapping",
  [sym__b_sgl_flw_map] = "flow_mapping",
  [sym__flw_map_tal] = "_flw_map_tal",
  [sym__sgl_flw_map_tal] = "_sgl_flw_map_tal",
  [sym__r_flw_seq_dat] = "_r_flw_seq_dat",
  [sym__br_flw_seq_dat] = "_br_flw_seq_dat",
  [sym__r_flw_map_dat] = "_r_flw_map_dat",
  [sym__br_flw_map_dat] = "_br_flw_map_dat",
  [sym__r_sgl_flw_col_dat] = "_r_sgl_flw_col_dat",
  [sym__flw_seq_dat_rpt] = "_flw_seq_dat_rpt",
  [sym__flw_map_dat_rpt] = "_flw_map_dat_rpt",
  [sym__sgl_flw_col_dat_rpt] = "_sgl_flw_col_dat_rpt",
  [sym__r_flw_seq_itm] = "_r_flw_seq_itm",
  [sym__br_flw_seq_itm] = "_br_flw_seq_itm",
  [sym__r_flw_map_itm] = "_r_flw_map_itm",
  [sym__br_flw_map_itm] = "_br_flw_map_itm",
  [sym__r_sgl_flw_col_itm] = "_r_sgl_flw_col_itm",
  [sym__r_flw_exp_par] = "flow_pair",
  [sym__br_flw_exp_par] = "flow_pair",
  [sym__r_sgl_flw_exp_par] = "flow_pair",
  [sym__r_flw_imp_r_par] = "_r_flw_imp_r_par",
  [sym__r_flw_imp_br_par] = "_r_flw_imp_br_par",
  [sym__br_flw_imp_r_par] = "_br_flw_imp_r_par",
  [sym__br_flw_imp_br_par] = "_br_flw_imp_br_par",
  [sym__r_sgl_flw_imp_par] = "_r_sgl_flw_imp_par",
  [sym__r_flw_jsl_ann_par] = "_r_flw_jsl_ann_par",
  [sym__br_flw_jsl_ann_par] = "_br_flw_jsl_ann_par",
  [sym__r_sgl_flw_jsl_ann_par] = "_r_sgl_flw_jsl_ann_par",
  [sym__r_flw_njl_ann_par] = "_r_flw_njl_ann_par",
  [sym__br_flw_njl_ann_par] = "_br_flw_njl_ann_par",
  [sym__r_sgl_flw_njl_ann_par] = "_r_sgl_flw_njl_ann_par",
  [sym__flw_ann_par_tal] = "_flw_ann_par_tal",
  [sym__sgl_flw_ann_par_tal] = "_sgl_flw_ann_par_tal",
  [sym__r_dqt_str_val] = "flow_node",
  [sym__br_dqt_str_val] = "flow_node",
  [sym__r_sgl_dqt_str_val] = "flow_node",
  [sym__br_sgl_dqt_str_val] = "flow_node",
  [sym__b_sgl_dqt_str_val] = "flow_node",
  [sym__r_dqt_str] = "double_quote_scalar",
  [sym__br_dqt_str] = "double_quote_scalar",
  [sym__r_sgl_dqt_str] = "double_quote_scalar",
  [sym__br_sgl_dqt_str] = "double_quote_scalar",
  [sym__b_sgl_dqt_str] = "double_quote_scalar",
  [aux_sym__r_sgl_dqt_ctn] = "_r_sgl_dqt_ctn",
  [sym__br_mtl_dqt_ctn] = "_br_mtl_dqt_ctn",
  [sym__r_sqt_str_val] = "flow_node",
  [sym__br_sqt_str_val] = "flow_node",
  [sym__r_sgl_sqt_str_val] = "flow_node",
  [sym__br_sgl_sqt_str_val] = "flow_node",
  [sym__b_sgl_sqt_str_val] = "flow_node",
  [sym__r_sqt_str] = "single_quote_scalar",
  [sym__br_sqt_str] = "single_quote_scalar",
  [sym__r_sgl_sqt_str] = "single_quote_scalar",
  [sym__br_sgl_sqt_str] = "single_quote_scalar",
  [sym__b_sgl_sqt_str] = "single_quote_scalar",
  [aux_sym__r_sgl_sqt_ctn] = "_r_sgl_sqt_ctn",
  [sym__br_mtl_sqt_ctn] = "_br_mtl_sqt_ctn",
  [sym__r_pln_blk_val] = "flow_node",
  [sym__br_pln_blk_val] = "flow_node",
  [sym__r_sgl_pln_blk_val] = "flow_node",
  [sym__br_sgl_pln_blk_val] = "flow_node",
  [sym__b_sgl_pln_blk_val] = "flow_node",
  [sym__r_pln_flw_val] = "flow_node",
  [sym__br_pln_flw_val] = "flow_node",
  [sym__r_sgl_pln_flw_val] = "flow_node",
  [sym__r_sgl_pln_blk] = "plain_scalar",
  [sym__br_sgl_pln_blk] = "plain_scalar",
  [sym__b_sgl_pln_blk] = "plain_scalar",
  [sym__r_sgl_pln_flw] = "plain_scalar",
  [sym__br_sgl_pln_flw] = "plain_scalar",
  [sym__r_mtl_pln_blk] = "plain_scalar",
  [sym__br_mtl_pln_blk] = "plain_scalar",
  [sym__r_mtl_pln_flw] = "plain_scalar",
  [sym__br_mtl_pln_flw] = "plain_scalar",
  [sym__r_als_val] = "flow_node",
  [sym__br_als_val] = "flow_node",
  [sym__b_als_val] = "flow_node",
  [sym__r_als] = "alias",
  [sym__br_als] = "alias",
  [sym__b_als] = "alias",
  [sym__r_acr] = "anchor",
  [sym__br_acr] = "anchor",
  [sym__b_acr] = "anchor",
  [aux_sym__drs_doc_repeat1] = "_drs_doc_repeat1",
  [aux_sym__s_dir_rsv_repeat1] = "_s_dir_rsv_repeat1",
  [aux_sym__r_blk_seq_repeat1] = "_r_blk_seq_repeat1",
  [aux_sym__r_blk_map_repeat1] = "_r_blk_map_repeat1",
  [aux_sym__r_blk_str_repeat1] = "_r_blk_str_repeat1",
  [aux_sym__r_flw_seq_dat_repeat1] = "_r_flw_seq_dat_repeat1",
  [aux_sym__r_flw_map_dat_repeat1] = "_r_flw_map_dat_repeat1",
  [aux_sym__r_sgl_flw_col_dat_repeat1] = "_r_sgl_flw_col_dat_repeat1",
  [aux_sym__r_dqt_str_repeat1] = "_r_dqt_str_repeat1",
  [aux_sym__br_mtl_dqt_ctn_repeat1] = "_br_mtl_dqt_ctn_repeat1",
  [aux_sym__r_sqt_str_repeat1] = "_r_sqt_str_repeat1",
  [aux_sym__br_mtl_sqt_ctn_repeat1] = "_br_mtl_sqt_ctn_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__eof] = sym__eof,
  [sym__s_dir_yml_bgn] = sym__s_dir_yml_bgn,
  [sym__r_dir_yml_ver] = sym__r_dir_yml_ver,
  [sym__s_dir_tag_bgn] = sym__s_dir_tag_bgn,
  [sym__r_dir_tag_hdl] = sym__r_dir_tag_hdl,
  [sym__r_dir_tag_pfx] = sym__r_dir_tag_pfx,
  [sym__s_dir_rsv_bgn] = sym__s_dir_rsv_bgn,
  [sym__r_dir_rsv_prm] = sym__r_dir_rsv_prm,
  [sym__s_drs_end] = sym__s_drs_end,
  [sym__s_doc_end] = sym__s_doc_end,
  [sym__r_blk_seq_bgn] = sym__r_blk_seq_bgn,
  [sym__br_blk_seq_bgn] = sym__r_blk_seq_bgn,
  [sym__b_blk_seq_bgn] = sym__r_blk_seq_bgn,
  [sym__r_blk_key_bgn] = sym__r_blk_key_bgn,
  [sym__br_blk_key_bgn] = sym__r_blk_key_bgn,
  [sym__b_blk_key_bgn] = sym__r_blk_key_bgn,
  [sym__r_blk_val_bgn] = sym__r_blk_val_bgn,
  [sym__br_blk_val_bgn] = sym__r_blk_val_bgn,
  [sym__b_blk_val_bgn] = sym__r_blk_val_bgn,
  [sym__r_blk_imp_bgn] = sym__r_blk_val_bgn,
  [sym__r_blk_lit_bgn] = sym__r_blk_lit_bgn,
  [sym__br_blk_lit_bgn] = sym__r_blk_lit_bgn,
  [sym__r_blk_fld_bgn] = sym__r_blk_fld_bgn,
  [sym__br_blk_fld_bgn] = sym__r_blk_fld_bgn,
  [sym__br_blk_str_ctn] = sym__br_blk_str_ctn,
  [sym__r_flw_seq_bgn] = sym__r_flw_seq_bgn,
  [sym__br_flw_seq_bgn] = sym__r_flw_seq_bgn,
  [sym__b_flw_seq_bgn] = sym__r_flw_seq_bgn,
  [sym__r_flw_seq_end] = sym__r_flw_seq_end,
  [sym__br_flw_seq_end] = sym__r_flw_seq_end,
  [sym__b_flw_seq_end] = sym__r_flw_seq_end,
  [sym__r_flw_map_bgn] = sym__r_flw_map_bgn,
  [sym__br_flw_map_bgn] = sym__r_flw_map_bgn,
  [sym__b_flw_map_bgn] = sym__r_flw_map_bgn,
  [sym__r_flw_map_end] = sym__r_flw_map_end,
  [sym__br_flw_map_end] = sym__r_flw_map_end,
  [sym__b_flw_map_end] = sym__r_flw_map_end,
  [sym__r_flw_sep_bgn] = sym__r_flw_sep_bgn,
  [sym__br_flw_sep_bgn] = sym__r_flw_sep_bgn,
  [sym__r_flw_key_bgn] = sym__r_blk_key_bgn,
  [sym__br_flw_key_bgn] = sym__r_blk_key_bgn,
  [sym__r_flw_jsv_bgn] = sym__r_blk_val_bgn,
  [sym__br_flw_jsv_bgn] = sym__r_blk_val_bgn,
  [sym__r_flw_njv_bgn] = sym__r_blk_val_bgn,
  [sym__br_flw_njv_bgn] = sym__r_blk_val_bgn,
  [sym__r_dqt_str_bgn] = sym__r_dqt_str_bgn,
  [sym__br_dqt_str_bgn] = sym__r_dqt_str_bgn,
  [sym__b_dqt_str_bgn] = sym__r_dqt_str_bgn,
  [sym__r_dqt_str_ctn] = sym__r_dqt_str_ctn,
  [sym__br_dqt_str_ctn] = sym__br_dqt_str_ctn,
  [sym__r_dqt_esc_nwl] = sym__r_dqt_esc_nwl,
  [sym__br_dqt_esc_nwl] = sym__r_dqt_esc_nwl,
  [sym__r_dqt_esc_seq] = sym__r_dqt_esc_nwl,
  [sym__br_dqt_esc_seq] = sym__r_dqt_esc_nwl,
  [sym__r_dqt_str_end] = sym__r_dqt_str_bgn,
  [sym__br_dqt_str_end] = sym__r_dqt_str_bgn,
  [sym__r_sqt_str_bgn] = sym__r_sqt_str_bgn,
  [sym__br_sqt_str_bgn] = sym__r_sqt_str_bgn,
  [sym__b_sqt_str_bgn] = sym__r_sqt_str_bgn,
  [sym__r_sqt_str_ctn] = sym__r_sqt_str_ctn,
  [sym__br_sqt_str_ctn] = sym__br_sqt_str_ctn,
  [sym__r_sqt_esc_sqt] = sym__r_dqt_esc_nwl,
  [sym__br_sqt_esc_sqt] = sym__r_dqt_esc_nwl,
  [sym__r_sqt_str_end] = sym__r_sqt_str_bgn,
  [sym__br_sqt_str_end] = sym__r_sqt_str_bgn,
  [sym__r_sgl_pln_nul_blk] = sym__r_sgl_pln_nul_blk,
  [sym__br_sgl_pln_nul_blk] = sym__r_sgl_pln_nul_blk,
  [sym__b_sgl_pln_nul_blk] = sym__r_sgl_pln_nul_blk,
  [sym__r_sgl_pln_nul_flw] = sym__r_sgl_pln_nul_blk,
  [sym__br_sgl_pln_nul_flw] = sym__r_sgl_pln_nul_blk,
  [sym__r_sgl_pln_bol_blk] = sym__r_sgl_pln_bol_blk,
  [sym__br_sgl_pln_bol_blk] = sym__r_sgl_pln_bol_blk,
  [sym__b_sgl_pln_bol_blk] = sym__r_sgl_pln_bol_blk,
  [sym__r_sgl_pln_bol_flw] = sym__r_sgl_pln_bol_blk,
  [sym__br_sgl_pln_bol_flw] = sym__r_sgl_pln_bol_blk,
  [sym__r_sgl_pln_int_blk] = sym__r_sgl_pln_int_blk,
  [sym__br_sgl_pln_int_blk] = sym__r_sgl_pln_int_blk,
  [sym__b_sgl_pln_int_blk] = sym__r_sgl_pln_int_blk,
  [sym__r_sgl_pln_int_flw] = sym__r_sgl_pln_int_blk,
  [sym__br_sgl_pln_int_flw] = sym__r_sgl_pln_int_blk,
  [sym__r_sgl_pln_flt_blk] = sym__r_sgl_pln_flt_blk,
  [sym__br_sgl_pln_flt_blk] = sym__r_sgl_pln_flt_blk,
  [sym__b_sgl_pln_flt_blk] = sym__r_sgl_pln_flt_blk,
  [sym__r_sgl_pln_flt_flw] = sym__r_sgl_pln_flt_blk,
  [sym__br_sgl_pln_flt_flw] = sym__r_sgl_pln_flt_blk,
  [sym__r_sgl_pln_str_blk] = sym__r_sgl_pln_str_blk,
  [sym__br_sgl_pln_str_blk] = sym__r_sgl_pln_str_blk,
  [sym__b_sgl_pln_str_blk] = sym__r_sgl_pln_str_blk,
  [sym__r_sgl_pln_str_flw] = sym__r_sgl_pln_str_blk,
  [sym__br_sgl_pln_str_flw] = sym__r_sgl_pln_str_blk,
  [sym__r_mtl_pln_str_blk] = sym__r_sgl_pln_str_blk,
  [sym__br_mtl_pln_str_blk] = sym__r_sgl_pln_str_blk,
  [sym__r_mtl_pln_str_flw] = sym__r_sgl_pln_str_blk,
  [sym__br_mtl_pln_str_flw] = sym__r_sgl_pln_str_blk,
  [sym__r_tag] = sym__r_tag,
  [sym__br_tag] = sym__r_tag,
  [sym__b_tag] = sym__r_tag,
  [sym__r_acr_bgn] = sym__r_acr_bgn,
  [sym__br_acr_bgn] = sym__r_acr_bgn,
  [sym__b_acr_bgn] = sym__r_acr_bgn,
  [sym__r_acr_ctn] = sym__r_acr_ctn,
  [sym__r_als_bgn] = sym__r_als_bgn,
  [sym__br_als_bgn] = sym__r_als_bgn,
  [sym__b_als_bgn] = sym__r_als_bgn,
  [sym__r_als_ctn] = sym__r_als_ctn,
  [sym__bl] = sym__bl,
  [sym_comment] = sym_comment,
  [sym__err_rec] = sym__err_rec,
  [sym_stream] = sym_stream,
  [sym__doc_w_bgn_w_end_seq] = sym__doc_w_bgn_w_end_seq,
  [sym__doc_w_bgn_wo_end_seq] = sym__doc_w_bgn_wo_end_seq,
  [sym__doc_wo_bgn_w_end_seq] = sym__doc_wo_bgn_w_end_seq,
  [sym__doc_wo_bgn_wo_end_seq] = sym__doc_wo_bgn_wo_end_seq,
  [sym__doc_w_bgn_w_end] = sym__doc_w_bgn_w_end,
  [sym__doc_w_bgn_wo_end] = sym__doc_w_bgn_wo_end,
  [sym__doc_wo_bgn_w_end] = sym__doc_wo_bgn_w_end,
  [sym__doc_wo_bgn_wo_end] = sym__doc_wo_bgn_wo_end,
  [sym__bgn_imp_doc] = sym__bgn_imp_doc,
  [sym__drs_doc] = sym__drs_doc,
  [sym__exp_doc] = sym__exp_doc,
  [sym__imp_doc] = sym__imp_doc,
  [sym__drs_doc_end] = sym__drs_doc_end,
  [sym__exp_doc_end] = sym__drs_doc_end,
  [sym__imp_doc_end] = sym__drs_doc_end,
  [sym__bgn_imp_doc_end] = sym__drs_doc_end,
  [sym__doc_end] = sym__drs_doc_end,
  [sym__exp_doc_tal] = sym__exp_doc_tal,
  [sym__s_dir] = sym__s_dir,
  [sym__s_dir_yml] = sym__s_dir_yml,
  [sym__s_dir_tag] = sym__s_dir_tag,
  [sym__s_dir_rsv] = sym__s_dir_rsv,
  [sym__r_prp_val] = sym__r_prp_val,
  [sym__br_prp_val] = sym__r_prp_val,
  [sym__r_sgl_prp_val] = sym__r_prp_val,
  [sym__br_sgl_prp_val] = sym__r_prp_val,
  [sym__b_sgl_prp_val] = sym__r_prp_val,
  [sym__r_prp] = sym__r_prp,
  [sym__br_prp] = sym__br_prp,
  [sym__r_sgl_prp] = sym__r_sgl_prp,
  [sym__br_sgl_prp] = sym__br_sgl_prp,
  [sym__b_sgl_prp] = sym__b_sgl_prp,
  [sym__r_blk_seq_r_val] = sym__r_blk_seq_r_val,
  [sym__r_blk_seq_br_val] = sym__r_blk_seq_r_val,
  [sym__br_blk_seq_val] = sym__r_blk_seq_r_val,
  [sym__r_blk_seq_spc_val] = sym__r_blk_seq_r_val,
  [sym__br_blk_seq_spc_val] = sym__r_blk_seq_r_val,
  [sym__b_blk_seq_spc_val] = sym__r_blk_seq_r_val,
  [sym__r_blk_seq] = sym__r_blk_seq,
  [sym__br_blk_seq] = sym__r_blk_seq,
  [sym__b_blk_seq_spc] = sym__r_blk_seq,
  [sym__r_blk_seq_itm] = sym__r_blk_seq_itm,
  [sym__br_blk_seq_itm] = sym__r_blk_seq_itm,
  [sym__b_blk_seq_itm] = sym__r_blk_seq_itm,
  [sym__blk_seq_itm_tal] = sym__blk_seq_itm_tal,
  [sym__r_blk_map_r_val] = sym__r_blk_seq_r_val,
  [sym__r_blk_map_br_val] = sym__r_blk_seq_r_val,
  [sym__br_blk_map_val] = sym__r_blk_seq_r_val,
  [sym__r_blk_map] = sym__r_blk_map,
  [sym__br_blk_map] = sym__r_blk_map,
  [sym__r_blk_map_itm] = sym__r_blk_map_itm,
  [sym__br_blk_map_itm] = sym__br_blk_map_itm,
  [sym__b_blk_map_itm] = sym__b_blk_map_itm,
  [sym__r_blk_exp_itm] = sym__r_blk_exp_itm,
  [sym__br_blk_exp_itm] = sym__r_blk_exp_itm,
  [sym__b_blk_exp_itm] = sym__r_blk_exp_itm,
  [sym__r_blk_key_itm] = sym__r_blk_key_itm,
  [sym__br_blk_key_itm] = sym__br_blk_key_itm,
  [sym__b_blk_key_itm] = sym__b_blk_key_itm,
  [sym__r_blk_val_itm] = sym__r_blk_val_itm,
  [sym__br_blk_val_itm] = sym__br_blk_val_itm,
  [sym__b_blk_val_itm] = sym__b_blk_val_itm,
  [sym__r_blk_imp_itm] = sym__r_blk_exp_itm,
  [sym__br_blk_imp_itm] = sym__r_blk_exp_itm,
  [sym__b_blk_imp_itm] = sym__r_blk_exp_itm,
  [sym__blk_exp_itm_tal] = sym__blk_exp_itm_tal,
  [sym__blk_imp_itm_tal] = sym__blk_imp_itm_tal,
  [sym__r_blk_str_val] = sym__r_blk_seq_r_val,
  [sym__br_blk_str_val] = sym__r_blk_seq_r_val,
  [sym__r_blk_str] = sym__r_blk_str,
  [sym__br_blk_str] = sym__r_blk_str,
  [sym__r_flw_seq_val] = sym__r_prp_val,
  [sym__br_flw_seq_val] = sym__r_prp_val,
  [sym__r_sgl_flw_seq_val] = sym__r_prp_val,
  [sym__br_sgl_flw_seq_val] = sym__r_prp_val,
  [sym__b_sgl_flw_seq_val] = sym__r_prp_val,
  [sym__r_flw_seq] = sym__r_flw_seq,
  [sym__br_flw_seq] = sym__r_flw_seq,
  [sym__r_sgl_flw_seq] = sym__r_flw_seq,
  [sym__br_sgl_flw_seq] = sym__r_flw_seq,
  [sym__b_sgl_flw_seq] = sym__r_flw_seq,
  [sym__flw_seq_tal] = sym__flw_seq_tal,
  [sym__sgl_flw_seq_tal] = sym__sgl_flw_seq_tal,
  [sym__r_flw_map_val] = sym__r_prp_val,
  [sym__br_flw_map_val] = sym__r_prp_val,
  [sym__r_sgl_flw_map_val] = sym__r_prp_val,
  [sym__br_sgl_flw_map_val] = sym__r_prp_val,
  [sym__b_sgl_flw_map_val] = sym__r_prp_val,
  [sym__r_flw_map] = sym__r_flw_map,
  [sym__br_flw_map] = sym__r_flw_map,
  [sym__r_sgl_flw_map] = sym__r_flw_map,
  [sym__br_sgl_flw_map] = sym__r_flw_map,
  [sym__b_sgl_flw_map] = sym__r_flw_map,
  [sym__flw_map_tal] = sym__flw_map_tal,
  [sym__sgl_flw_map_tal] = sym__sgl_flw_map_tal,
  [sym__r_flw_seq_dat] = sym__r_flw_seq_dat,
  [sym__br_flw_seq_dat] = sym__br_flw_seq_dat,
  [sym__r_flw_map_dat] = sym__r_flw_map_dat,
  [sym__br_flw_map_dat] = sym__br_flw_map_dat,
  [sym__r_sgl_flw_col_dat] = sym__r_sgl_flw_col_dat,
  [sym__flw_seq_dat_rpt] = sym__flw_seq_dat_rpt,
  [sym__flw_map_dat_rpt] = sym__flw_map_dat_rpt,
  [sym__sgl_flw_col_dat_rpt] = sym__sgl_flw_col_dat_rpt,
  [sym__r_flw_seq_itm] = sym__r_flw_seq_itm,
  [sym__br_flw_seq_itm] = sym__br_flw_seq_itm,
  [sym__r_flw_map_itm] = sym__r_flw_map_itm,
  [sym__br_flw_map_itm] = sym__br_flw_map_itm,
  [sym__r_sgl_flw_col_itm] = sym__r_sgl_flw_col_itm,
  [sym__r_flw_exp_par] = sym__r_flw_exp_par,
  [sym__br_flw_exp_par] = sym__r_flw_exp_par,
  [sym__r_sgl_flw_exp_par] = sym__r_flw_exp_par,
  [sym__r_flw_imp_r_par] = sym__r_flw_imp_r_par,
  [sym__r_flw_imp_br_par] = sym__r_flw_imp_br_par,
  [sym__br_flw_imp_r_par] = sym__br_flw_imp_r_par,
  [sym__br_flw_imp_br_par] = sym__br_flw_imp_br_par,
  [sym__r_sgl_flw_imp_par] = sym__r_sgl_flw_imp_par,
  [sym__r_flw_jsl_ann_par] = sym__r_flw_jsl_ann_par,
  [sym__br_flw_jsl_ann_par] = sym__br_flw_jsl_ann_par,
  [sym__r_sgl_flw_jsl_ann_par] = sym__r_sgl_flw_jsl_ann_par,
  [sym__r_flw_njl_ann_par] = sym__r_flw_njl_ann_par,
  [sym__br_flw_njl_ann_par] = sym__br_flw_njl_ann_par,
  [sym__r_sgl_flw_njl_ann_par] = sym__r_sgl_flw_njl_ann_par,
  [sym__flw_ann_par_tal] = sym__flw_ann_par_tal,
  [sym__sgl_flw_ann_par_tal] = sym__sgl_flw_ann_par_tal,
  [sym__r_dqt_str_val] = sym__r_prp_val,
  [sym__br_dqt_str_val] = sym__r_prp_val,
  [sym__r_sgl_dqt_str_val] = sym__r_prp_val,
  [sym__br_sgl_dqt_str_val] = sym__r_prp_val,
  [sym__b_sgl_dqt_str_val] = sym__r_prp_val,
  [sym__r_dqt_str] = sym__r_dqt_str,
  [sym__br_dqt_str] = sym__r_dqt_str,
  [sym__r_sgl_dqt_str] = sym__r_dqt_str,
  [sym__br_sgl_dqt_str] = sym__r_dqt_str,
  [sym__b_sgl_dqt_str] = sym__r_dqt_str,
  [aux_sym__r_sgl_dqt_ctn] = aux_sym__r_sgl_dqt_ctn,
  [sym__br_mtl_dqt_ctn] = sym__br_mtl_dqt_ctn,
  [sym__r_sqt_str_val] = sym__r_prp_val,
  [sym__br_sqt_str_val] = sym__r_prp_val,
  [sym__r_sgl_sqt_str_val] = sym__r_prp_val,
  [sym__br_sgl_sqt_str_val] = sym__r_prp_val,
  [sym__b_sgl_sqt_str_val] = sym__r_prp_val,
  [sym__r_sqt_str] = sym__r_sqt_str,
  [sym__br_sqt_str] = sym__r_sqt_str,
  [sym__r_sgl_sqt_str] = sym__r_sqt_str,
  [sym__br_sgl_sqt_str] = sym__r_sqt_str,
  [sym__b_sgl_sqt_str] = sym__r_sqt_str,
  [aux_sym__r_sgl_sqt_ctn] = aux_sym__r_sgl_sqt_ctn,
  [sym__br_mtl_sqt_ctn] = sym__br_mtl_sqt_ctn,
  [sym__r_pln_blk_val] = sym__r_prp_val,
  [sym__br_pln_blk_val] = sym__r_prp_val,
  [sym__r_sgl_pln_blk_val] = sym__r_prp_val,
  [sym__br_sgl_pln_blk_val] = sym__r_prp_val,
  [sym__b_sgl_pln_blk_val] = sym__r_prp_val,
  [sym__r_pln_flw_val] = sym__r_prp_val,
  [sym__br_pln_flw_val] = sym__r_prp_val,
  [sym__r_sgl_pln_flw_val] = sym__r_prp_val,
  [sym__r_sgl_pln_blk] = sym__r_sgl_pln_blk,
  [sym__br_sgl_pln_blk] = sym__r_sgl_pln_blk,
  [sym__b_sgl_pln_blk] = sym__r_sgl_pln_blk,
  [sym__r_sgl_pln_flw] = sym__r_sgl_pln_blk,
  [sym__br_sgl_pln_flw] = sym__r_sgl_pln_blk,
  [sym__r_mtl_pln_blk] = sym__r_sgl_pln_blk,
  [sym__br_mtl_pln_blk] = sym__r_sgl_pln_blk,
  [sym__r_mtl_pln_flw] = sym__r_sgl_pln_blk,
  [sym__br_mtl_pln_flw] = sym__r_sgl_pln_blk,
  [sym__r_als_val] = sym__r_prp_val,
  [sym__br_als_val] = sym__r_prp_val,
  [sym__b_als_val] = sym__r_prp_val,
  [sym__r_als] = sym__r_als,
  [sym__br_als] = sym__r_als,
  [sym__b_als] = sym__r_als,
  [sym__r_acr] = sym__r_acr,
  [sym__br_acr] = sym__r_acr,
  [sym__b_acr] = sym__r_acr,
  [aux_sym__drs_doc_repeat1] = aux_sym__drs_doc_repeat1,
  [aux_sym__s_dir_rsv_repeat1] = aux_sym__s_dir_rsv_repeat1,
  [aux_sym__r_blk_seq_repeat1] = aux_sym__r_blk_seq_repeat1,
  [aux_sym__r_blk_map_repeat1] = aux_sym__r_blk_map_repeat1,
  [aux_sym__r_blk_str_repeat1] = aux_sym__r_blk_str_repeat1,
  [aux_sym__r_flw_seq_dat_repeat1] = aux_sym__r_flw_seq_dat_repeat1,
  [aux_sym__r_flw_map_dat_repeat1] = aux_sym__r_flw_map_dat_repeat1,
  [aux_sym__r_sgl_flw_col_dat_repeat1] = aux_sym__r_sgl_flw_col_dat_repeat1,
  [aux_sym__r_dqt_str_repeat1] = aux_sym__r_dqt_str_repeat1,
  [aux_sym__br_mtl_dqt_ctn_repeat1] = aux_sym__br_mtl_dqt_ctn_repeat1,
  [aux_sym__r_sqt_str_repeat1] = aux_sym__r_sqt_str_repeat1,
  [aux_sym__br_mtl_sqt_ctn_repeat1] = aux_sym__br_mtl_sqt_ctn_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__eof] = {
    .visible = false,
    .named = true,
  },
  [sym__s_dir_yml_bgn] = {
    .visible = false,
    .named = true,
  },
  [sym__r_dir_yml_ver] = {
    .visible = true,
    .named = true,
  },
  [sym__s_dir_tag_bgn] = {
    .visible = false,
    .named = true,
  },
  [sym__r_dir_tag_hdl] = {
    .visible = true,
    .named = true,
  },
  [sym__r_dir_tag_pfx] = {
    .visible = true,
    .named = true,
  },
  [sym__s_dir_rsv_bgn] = {
    .visible = true,
    .named = true,
  },
  [sym__r_dir_rsv_prm] = {
    .visible = true,
    .named = true,
  },
  [sym__s_drs_end] = {
    .visible = true,
    .named = false,
  },
  [sym__s_doc_end] = {
    .visible = true,
    .named = false,
  },
  [sym__r_blk_seq_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_blk_seq_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__b_blk_seq_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_blk_key_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_blk_key_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__b_blk_key_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_blk_val_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_blk_val_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__b_blk_val_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_blk_imp_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_blk_lit_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_blk_lit_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_blk_fld_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_blk_fld_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_blk_str_ctn] = {
    .visible = false,
    .named = true,
  },
  [sym__r_flw_seq_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_flw_seq_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__b_flw_seq_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_flw_seq_end] = {
    .visible = true,
    .named = false,
  },
  [sym__br_flw_seq_end] = {
    .visible = true,
    .named = false,
  },
  [sym__b_flw_seq_end] = {
    .visible = true,
    .named = false,
  },
  [sym__r_flw_map_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_flw_map_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__b_flw_map_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_flw_map_end] = {
    .visible = true,
    .named = false,
  },
  [sym__br_flw_map_end] = {
    .visible = true,
    .named = false,
  },
  [sym__b_flw_map_end] = {
    .visible = true,
    .named = false,
  },
  [sym__r_flw_sep_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_flw_sep_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_flw_key_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_flw_key_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_flw_jsv_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_flw_jsv_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_flw_njv_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_flw_njv_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_dqt_str_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_dqt_str_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__b_dqt_str_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_dqt_str_ctn] = {
    .visible = false,
    .named = true,
  },
  [sym__br_dqt_str_ctn] = {
    .visible = false,
    .named = true,
  },
  [sym__r_dqt_esc_nwl] = {
    .visible = true,
    .named = true,
  },
  [sym__br_dqt_esc_nwl] = {
    .visible = true,
    .named = true,
  },
  [sym__r_dqt_esc_seq] = {
    .visible = true,
    .named = true,
  },
  [sym__br_dqt_esc_seq] = {
    .visible = true,
    .named = true,
  },
  [sym__r_dqt_str_end] = {
    .visible = true,
    .named = false,
  },
  [sym__br_dqt_str_end] = {
    .visible = true,
    .named = false,
  },
  [sym__r_sqt_str_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_sqt_str_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__b_sqt_str_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_sqt_str_ctn] = {
    .visible = false,
    .named = true,
  },
  [sym__br_sqt_str_ctn] = {
    .visible = false,
    .named = true,
  },
  [sym__r_sqt_esc_sqt] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sqt_esc_sqt] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sqt_str_end] = {
    .visible = true,
    .named = false,
  },
  [sym__br_sqt_str_end] = {
    .visible = true,
    .named = false,
  },
  [sym__r_sgl_pln_nul_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_nul_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_pln_nul_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_nul_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_nul_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_bol_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_bol_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_pln_bol_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_bol_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_bol_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_int_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_int_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_pln_int_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_int_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_int_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_flt_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_flt_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_pln_flt_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_flt_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_flt_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_str_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_str_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_pln_str_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_str_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_str_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__r_mtl_pln_str_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__br_mtl_pln_str_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__r_mtl_pln_str_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__br_mtl_pln_str_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__r_tag] = {
    .visible = true,
    .named = true,
  },
  [sym__br_tag] = {
    .visible = true,
    .named = true,
  },
  [sym__b_tag] = {
    .visible = true,
    .named = true,
  },
  [sym__r_acr_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_acr_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__b_acr_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_acr_ctn] = {
    .visible = true,
    .named = true,
  },
  [sym__r_als_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__br_als_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__b_als_bgn] = {
    .visible = true,
    .named = false,
  },
  [sym__r_als_ctn] = {
    .visible = true,
    .named = true,
  },
  [sym__bl] = {
    .visible = false,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__err_rec] = {
    .visible = false,
    .named = true,
  },
  [sym_stream] = {
    .visible = true,
    .named = true,
  },
  [sym__doc_w_bgn_w_end_seq] = {
    .visible = false,
    .named = true,
  },
  [sym__doc_w_bgn_wo_end_seq] = {
    .visible = false,
    .named = true,
  },
  [sym__doc_wo_bgn_w_end_seq] = {
    .visible = false,
    .named = true,
  },
  [sym__doc_wo_bgn_wo_end_seq] = {
    .visible = false,
    .named = true,
  },
  [sym__doc_w_bgn_w_end] = {
    .visible = false,
    .named = true,
  },
  [sym__doc_w_bgn_wo_end] = {
    .visible = false,
    .named = true,
  },
  [sym__doc_wo_bgn_w_end] = {
    .visible = false,
    .named = true,
  },
  [sym__doc_wo_bgn_wo_end] = {
    .visible = false,
    .named = true,
  },
  [sym__bgn_imp_doc] = {
    .visible = false,
    .named = true,
  },
  [sym__drs_doc] = {
    .visible = false,
    .named = true,
  },
  [sym__exp_doc] = {
    .visible = false,
    .named = true,
  },
  [sym__imp_doc] = {
    .visible = false,
    .named = true,
  },
  [sym__drs_doc_end] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_doc_end] = {
    .visible = true,
    .named = true,
  },
  [sym__imp_doc_end] = {
    .visible = true,
    .named = true,
  },
  [sym__bgn_imp_doc_end] = {
    .visible = true,
    .named = true,
  },
  [sym__doc_end] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_doc_tal] = {
    .visible = false,
    .named = true,
  },
  [sym__s_dir] = {
    .visible = false,
    .named = true,
  },
  [sym__s_dir_yml] = {
    .visible = true,
    .named = true,
  },
  [sym__s_dir_tag] = {
    .visible = true,
    .named = true,
  },
  [sym__s_dir_rsv] = {
    .visible = true,
    .named = true,
  },
  [sym__r_prp_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_prp_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_prp_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_prp_val] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_prp_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_prp] = {
    .visible = false,
    .named = true,
  },
  [sym__br_prp] = {
    .visible = false,
    .named = true,
  },
  [sym__r_sgl_prp] = {
    .visible = false,
    .named = true,
  },
  [sym__br_sgl_prp] = {
    .visible = false,
    .named = true,
  },
  [sym__b_sgl_prp] = {
    .visible = false,
    .named = true,
  },
  [sym__r_blk_seq_r_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_blk_seq_br_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_blk_seq_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_blk_seq_spc_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_blk_seq_spc_val] = {
    .visible = true,
    .named = true,
  },
  [sym__b_blk_seq_spc_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_blk_seq] = {
    .visible = true,
    .named = true,
  },
  [sym__br_blk_seq] = {
    .visible = true,
    .named = true,
  },
  [sym__b_blk_seq_spc] = {
    .visible = true,
    .named = true,
  },
  [sym__r_blk_seq_itm] = {
    .visible = true,
    .named = true,
  },
  [sym__br_blk_seq_itm] = {
    .visible = true,
    .named = true,
  },
  [sym__b_blk_seq_itm] = {
    .visible = true,
    .named = true,
  },
  [sym__blk_seq_itm_tal] = {
    .visible = false,
    .named = true,
  },
  [sym__r_blk_map_r_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_blk_map_br_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_blk_map_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_blk_map] = {
    .visible = true,
    .named = true,
  },
  [sym__br_blk_map] = {
    .visible = true,
    .named = true,
  },
  [sym__r_blk_map_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__br_blk_map_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__b_blk_map_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__r_blk_exp_itm] = {
    .visible = true,
    .named = true,
  },
  [sym__br_blk_exp_itm] = {
    .visible = true,
    .named = true,
  },
  [sym__b_blk_exp_itm] = {
    .visible = true,
    .named = true,
  },
  [sym__r_blk_key_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__br_blk_key_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__b_blk_key_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__r_blk_val_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__br_blk_val_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__b_blk_val_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__r_blk_imp_itm] = {
    .visible = true,
    .named = true,
  },
  [sym__br_blk_imp_itm] = {
    .visible = true,
    .named = true,
  },
  [sym__b_blk_imp_itm] = {
    .visible = true,
    .named = true,
  },
  [sym__blk_exp_itm_tal] = {
    .visible = false,
    .named = true,
  },
  [sym__blk_imp_itm_tal] = {
    .visible = false,
    .named = true,
  },
  [sym__r_blk_str_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_blk_str_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_blk_str] = {
    .visible = true,
    .named = true,
  },
  [sym__br_blk_str] = {
    .visible = true,
    .named = true,
  },
  [sym__r_flw_seq_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_flw_seq_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_flw_seq_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_flw_seq_val] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_flw_seq_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_flw_seq] = {
    .visible = true,
    .named = true,
  },
  [sym__br_flw_seq] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_flw_seq] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_flw_seq] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_flw_seq] = {
    .visible = true,
    .named = true,
  },
  [sym__flw_seq_tal] = {
    .visible = false,
    .named = true,
  },
  [sym__sgl_flw_seq_tal] = {
    .visible = false,
    .named = true,
  },
  [sym__r_flw_map_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_flw_map_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_flw_map_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_flw_map_val] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_flw_map_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_flw_map] = {
    .visible = true,
    .named = true,
  },
  [sym__br_flw_map] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_flw_map] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_flw_map] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_flw_map] = {
    .visible = true,
    .named = true,
  },
  [sym__flw_map_tal] = {
    .visible = false,
    .named = true,
  },
  [sym__sgl_flw_map_tal] = {
    .visible = false,
    .named = true,
  },
  [sym__r_flw_seq_dat] = {
    .visible = false,
    .named = true,
  },
  [sym__br_flw_seq_dat] = {
    .visible = false,
    .named = true,
  },
  [sym__r_flw_map_dat] = {
    .visible = false,
    .named = true,
  },
  [sym__br_flw_map_dat] = {
    .visible = false,
    .named = true,
  },
  [sym__r_sgl_flw_col_dat] = {
    .visible = false,
    .named = true,
  },
  [sym__flw_seq_dat_rpt] = {
    .visible = false,
    .named = true,
  },
  [sym__flw_map_dat_rpt] = {
    .visible = false,
    .named = true,
  },
  [sym__sgl_flw_col_dat_rpt] = {
    .visible = false,
    .named = true,
  },
  [sym__r_flw_seq_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__br_flw_seq_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__r_flw_map_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__br_flw_map_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__r_sgl_flw_col_itm] = {
    .visible = false,
    .named = true,
  },
  [sym__r_flw_exp_par] = {
    .visible = true,
    .named = true,
  },
  [sym__br_flw_exp_par] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_flw_exp_par] = {
    .visible = true,
    .named = true,
  },
  [sym__r_flw_imp_r_par] = {
    .visible = false,
    .named = true,
  },
  [sym__r_flw_imp_br_par] = {
    .visible = false,
    .named = true,
  },
  [sym__br_flw_imp_r_par] = {
    .visible = false,
    .named = true,
  },
  [sym__br_flw_imp_br_par] = {
    .visible = false,
    .named = true,
  },
  [sym__r_sgl_flw_imp_par] = {
    .visible = false,
    .named = true,
  },
  [sym__r_flw_jsl_ann_par] = {
    .visible = false,
    .named = true,
  },
  [sym__br_flw_jsl_ann_par] = {
    .visible = false,
    .named = true,
  },
  [sym__r_sgl_flw_jsl_ann_par] = {
    .visible = false,
    .named = true,
  },
  [sym__r_flw_njl_ann_par] = {
    .visible = false,
    .named = true,
  },
  [sym__br_flw_njl_ann_par] = {
    .visible = false,
    .named = true,
  },
  [sym__r_sgl_flw_njl_ann_par] = {
    .visible = false,
    .named = true,
  },
  [sym__flw_ann_par_tal] = {
    .visible = false,
    .named = true,
  },
  [sym__sgl_flw_ann_par_tal] = {
    .visible = false,
    .named = true,
  },
  [sym__r_dqt_str_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_dqt_str_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_dqt_str_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_dqt_str_val] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_dqt_str_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_dqt_str] = {
    .visible = true,
    .named = true,
  },
  [sym__br_dqt_str] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_dqt_str] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_dqt_str] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_dqt_str] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__r_sgl_dqt_ctn] = {
    .visible = false,
    .named = false,
  },
  [sym__br_mtl_dqt_ctn] = {
    .visible = false,
    .named = true,
  },
  [sym__r_sqt_str_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sqt_str_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_sqt_str_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_sqt_str_val] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_sqt_str_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sqt_str] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sqt_str] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_sqt_str] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_sqt_str] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_sqt_str] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__r_sgl_sqt_ctn] = {
    .visible = false,
    .named = false,
  },
  [sym__br_mtl_sqt_ctn] = {
    .visible = false,
    .named = true,
  },
  [sym__r_pln_blk_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_pln_blk_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_blk_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_blk_val] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_pln_blk_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_pln_flw_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_pln_flw_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_flw_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__b_sgl_pln_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__r_sgl_pln_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__br_sgl_pln_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__r_mtl_pln_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__br_mtl_pln_blk] = {
    .visible = true,
    .named = true,
  },
  [sym__r_mtl_pln_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__br_mtl_pln_flw] = {
    .visible = true,
    .named = true,
  },
  [sym__r_als_val] = {
    .visible = true,
    .named = true,
  },
  [sym__br_als_val] = {
    .visible = true,
    .named = true,
  },
  [sym__b_als_val] = {
    .visible = true,
    .named = true,
  },
  [sym__r_als] = {
    .visible = true,
    .named = true,
  },
  [sym__br_als] = {
    .visible = true,
    .named = true,
  },
  [sym__b_als] = {
    .visible = true,
    .named = true,
  },
  [sym__r_acr] = {
    .visible = true,
    .named = true,
  },
  [sym__br_acr] = {
    .visible = true,
    .named = true,
  },
  [sym__b_acr] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__drs_doc_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__s_dir_rsv_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__r_blk_seq_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__r_blk_map_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__r_blk_str_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__r_flw_seq_dat_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__r_flw_map_dat_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__r_sgl_flw_col_dat_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__r_dqt_str_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__br_mtl_dqt_ctn_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__r_sqt_str_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__br_mtl_sqt_ctn_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_key = 1,
  field_value = 2,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_key] = "key",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 1},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 0, .length = 2},
  [7] = {.index = 3, .length = 1},
  [9] = {.index = 6, .length = 2},
  [10] = {.index = 8, .length = 2},
  [11] = {.index = 10, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_key, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [2] =
    {field_key, 0, .inherited = true},
  [3] =
    {field_value, 0, .inherited = true},
  [4] =
    {field_key, 1},
  [5] =
    {field_value, 1},
  [6] =
    {field_key, 0},
    {field_value, 1, .inherited = true},
  [8] =
    {field_key, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [10] =
    {field_key, 1, .inherited = true},
    {field_value, 1, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [6] = {
    [0] = sym__r_flw_exp_par,
  },
  [7] = {
    [0] = sym__r_flw_exp_par,
  },
  [8] = {
    [0] = sym__drs_doc_end,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__bgn_imp_doc, 2,
    sym__bgn_imp_doc,
    sym__drs_doc_end,
  sym__drs_doc, 2,
    sym__drs_doc,
    sym__drs_doc_end,
  sym__exp_doc, 2,
    sym__exp_doc,
    sym__drs_doc_end,
  sym__imp_doc, 2,
    sym__imp_doc,
    sym__drs_doc_end,
  sym__r_flw_imp_r_par, 2,
    sym__r_flw_imp_r_par,
    sym__r_flw_exp_par,
  sym__r_flw_imp_br_par, 2,
    sym__r_flw_imp_br_par,
    sym__r_flw_exp_par,
  sym__br_flw_imp_r_par, 2,
    sym__br_flw_imp_r_par,
    sym__r_flw_exp_par,
  sym__br_flw_imp_br_par, 2,
    sym__br_flw_imp_br_par,
    sym__r_flw_exp_par,
  sym__r_sgl_flw_imp_par, 2,
    sym__r_sgl_flw_imp_par,
    sym__r_flw_exp_par,
  sym__r_flw_njl_ann_par, 2,
    sym__r_flw_njl_ann_par,
    sym__r_flw_exp_par,
  sym__br_flw_njl_ann_par, 2,
    sym__br_flw_njl_ann_par,
    sym__r_flw_exp_par,
  sym__r_sgl_flw_njl_ann_par, 2,
    sym__r_sgl_flw_njl_ann_par,
    sym__r_flw_exp_par,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 13,
  [15] = 13,
  [16] = 16,
  [17] = 13,
  [18] = 16,
  [19] = 13,
  [20] = 13,
  [21] = 13,
  [22] = 16,
  [23] = 13,
  [24] = 24,
  [25] = 25,
  [26] = 25,
  [27] = 24,
  [28] = 25,
  [29] = 25,
  [30] = 24,
  [31] = 25,
  [32] = 25,
  [33] = 25,
  [34] = 25,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 40,
  [42] = 42,
  [43] = 43,
  [44] = 43,
  [45] = 42,
  [46] = 43,
  [47] = 43,
  [48] = 42,
  [49] = 43,
  [50] = 43,
  [51] = 43,
  [52] = 42,
  [53] = 42,
  [54] = 43,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 55,
  [59] = 56,
  [60] = 57,
  [61] = 57,
  [62] = 55,
  [63] = 57,
  [64] = 55,
  [65] = 57,
  [66] = 57,
  [67] = 55,
  [68] = 57,
  [69] = 57,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 80,
  [83] = 81,
  [84] = 84,
  [85] = 85,
  [86] = 84,
  [87] = 85,
  [88] = 88,
  [89] = 88,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 90,
  [94] = 92,
  [95] = 91,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 102,
  [107] = 102,
  [108] = 99,
  [109] = 102,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 112,
  [115] = 113,
  [116] = 112,
  [117] = 96,
  [118] = 112,
  [119] = 113,
  [120] = 113,
  [121] = 97,
  [122] = 122,
  [123] = 123,
  [124] = 96,
  [125] = 97,
  [126] = 122,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 122,
  [133] = 127,
  [134] = 98,
  [135] = 129,
  [136] = 128,
  [137] = 129,
  [138] = 130,
  [139] = 131,
  [140] = 140,
  [141] = 141,
  [142] = 128,
  [143] = 129,
  [144] = 130,
  [145] = 128,
  [146] = 129,
  [147] = 131,
  [148] = 127,
  [149] = 128,
  [150] = 129,
  [151] = 128,
  [152] = 101,
  [153] = 102,
  [154] = 99,
  [155] = 100,
  [156] = 156,
  [157] = 157,
  [158] = 102,
  [159] = 157,
  [160] = 104,
  [161] = 105,
  [162] = 102,
  [163] = 112,
  [164] = 102,
  [165] = 99,
  [166] = 100,
  [167] = 101,
  [168] = 113,
  [169] = 156,
  [170] = 103,
  [171] = 111,
  [172] = 105,
  [173] = 102,
  [174] = 102,
  [175] = 175,
  [176] = 110,
  [177] = 103,
  [178] = 99,
  [179] = 175,
  [180] = 111,
  [181] = 110,
  [182] = 99,
  [183] = 96,
  [184] = 98,
  [185] = 185,
  [186] = 96,
  [187] = 98,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 188,
  [192] = 185,
  [193] = 189,
  [194] = 190,
  [195] = 104,
  [196] = 185,
  [197] = 100,
  [198] = 98,
  [199] = 99,
  [200] = 98,
  [201] = 201,
  [202] = 102,
  [203] = 96,
  [204] = 96,
  [205] = 185,
  [206] = 99,
  [207] = 102,
  [208] = 104,
  [209] = 100,
  [210] = 201,
  [211] = 201,
  [212] = 103,
  [213] = 110,
  [214] = 111,
  [215] = 104,
  [216] = 99,
  [217] = 104,
  [218] = 100,
  [219] = 100,
  [220] = 201,
  [221] = 102,
  [222] = 99,
  [223] = 102,
  [224] = 99,
  [225] = 102,
  [226] = 103,
  [227] = 111,
  [228] = 99,
  [229] = 102,
  [230] = 185,
  [231] = 110,
  [232] = 98,
  [233] = 96,
  [234] = 102,
  [235] = 99,
  [236] = 103,
  [237] = 99,
  [238] = 111,
  [239] = 110,
  [240] = 103,
  [241] = 110,
  [242] = 111,
  [243] = 102,
  [244] = 244,
  [245] = 104,
  [246] = 201,
  [247] = 247,
  [248] = 102,
  [249] = 100,
  [250] = 250,
  [251] = 99,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 102,
  [257] = 99,
  [258] = 103,
  [259] = 110,
  [260] = 111,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 261,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 261,
  [275] = 275,
  [276] = 261,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 273,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 266,
  [331] = 331,
  [332] = 332,
  [333] = 275,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 261,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 392,
  [394] = 392,
  [395] = 395,
  [396] = 102,
  [397] = 102,
  [398] = 395,
  [399] = 392,
  [400] = 102,
  [401] = 395,
  [402] = 102,
  [403] = 102,
  [404] = 404,
  [405] = 395,
  [406] = 406,
  [407] = 407,
  [408] = 392,
  [409] = 102,
  [410] = 404,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 413,
  [417] = 404,
  [418] = 412,
  [419] = 419,
  [420] = 412,
  [421] = 419,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 411,
  [426] = 413,
  [427] = 414,
  [428] = 415,
  [429] = 411,
  [430] = 412,
  [431] = 419,
  [432] = 422,
  [433] = 404,
  [434] = 411,
  [435] = 414,
  [436] = 99,
  [437] = 413,
  [438] = 414,
  [439] = 422,
  [440] = 412,
  [441] = 419,
  [442] = 102,
  [443] = 422,
  [444] = 423,
  [445] = 102,
  [446] = 411,
  [447] = 102,
  [448] = 413,
  [449] = 414,
  [450] = 412,
  [451] = 419,
  [452] = 422,
  [453] = 414,
  [454] = 454,
  [455] = 395,
  [456] = 412,
  [457] = 422,
  [458] = 423,
  [459] = 422,
  [460] = 411,
  [461] = 414,
  [462] = 412,
  [463] = 415,
  [464] = 422,
  [465] = 411,
  [466] = 411,
  [467] = 414,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 102,
  [477] = 404,
  [478] = 478,
  [479] = 479,
  [480] = 102,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 481,
  [489] = 482,
  [490] = 484,
  [491] = 483,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 481,
  [496] = 494,
  [497] = 497,
  [498] = 498,
  [499] = 485,
  [500] = 487,
  [501] = 501,
  [502] = 494,
  [503] = 487,
  [504] = 485,
  [505] = 481,
  [506] = 483,
  [507] = 507,
  [508] = 487,
  [509] = 485,
  [510] = 481,
  [511] = 481,
  [512] = 512,
  [513] = 485,
  [514] = 482,
  [515] = 487,
  [516] = 487,
  [517] = 484,
  [518] = 487,
  [519] = 485,
  [520] = 483,
  [521] = 483,
  [522] = 494,
  [523] = 523,
  [524] = 481,
  [525] = 482,
  [526] = 485,
  [527] = 482,
  [528] = 487,
  [529] = 529,
  [530] = 494,
  [531] = 483,
  [532] = 485,
  [533] = 483,
  [534] = 483,
  [535] = 486,
  [536] = 481,
  [537] = 486,
  [538] = 538,
  [539] = 539,
  [540] = 347,
  [541] = 541,
  [542] = 348,
  [543] = 543,
  [544] = 544,
  [545] = 349,
  [546] = 546,
  [547] = 350,
  [548] = 351,
  [549] = 352,
  [550] = 353,
  [551] = 283,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 284,
  [556] = 556,
  [557] = 557,
  [558] = 553,
  [559] = 559,
  [560] = 560,
  [561] = 539,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 366,
  [567] = 567,
  [568] = 367,
  [569] = 285,
  [570] = 369,
  [571] = 370,
  [572] = 286,
  [573] = 372,
  [574] = 373,
  [575] = 541,
  [576] = 288,
  [577] = 543,
  [578] = 544,
  [579] = 546,
  [580] = 374,
  [581] = 376,
  [582] = 559,
  [583] = 560,
  [584] = 539,
  [585] = 562,
  [586] = 586,
  [587] = 557,
  [588] = 553,
  [589] = 559,
  [590] = 560,
  [591] = 539,
  [592] = 562,
  [593] = 290,
  [594] = 382,
  [595] = 383,
  [596] = 384,
  [597] = 385,
  [598] = 378,
  [599] = 339,
  [600] = 295,
  [601] = 355,
  [602] = 320,
  [603] = 321,
  [604] = 324,
  [605] = 541,
  [606] = 269,
  [607] = 543,
  [608] = 544,
  [609] = 546,
  [610] = 354,
  [611] = 271,
  [612] = 363,
  [613] = 371,
  [614] = 614,
  [615] = 615,
  [616] = 293,
  [617] = 557,
  [618] = 553,
  [619] = 559,
  [620] = 560,
  [621] = 539,
  [622] = 562,
  [623] = 346,
  [624] = 391,
  [625] = 541,
  [626] = 296,
  [627] = 543,
  [628] = 544,
  [629] = 543,
  [630] = 546,
  [631] = 541,
  [632] = 297,
  [633] = 543,
  [634] = 544,
  [635] = 546,
  [636] = 298,
  [637] = 637,
  [638] = 266,
  [639] = 639,
  [640] = 544,
  [641] = 557,
  [642] = 553,
  [643] = 559,
  [644] = 560,
  [645] = 645,
  [646] = 562,
  [647] = 546,
  [648] = 648,
  [649] = 649,
  [650] = 557,
  [651] = 553,
  [652] = 559,
  [653] = 560,
  [654] = 539,
  [655] = 541,
  [656] = 562,
  [657] = 543,
  [658] = 544,
  [659] = 546,
  [660] = 660,
  [661] = 661,
  [662] = 275,
  [663] = 663,
  [664] = 557,
  [665] = 553,
  [666] = 559,
  [667] = 560,
  [668] = 539,
  [669] = 562,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 541,
  [677] = 677,
  [678] = 541,
  [679] = 679,
  [680] = 543,
  [681] = 544,
  [682] = 546,
  [683] = 683,
  [684] = 684,
  [685] = 557,
  [686] = 557,
  [687] = 553,
  [688] = 559,
  [689] = 560,
  [690] = 539,
  [691] = 562,
  [692] = 294,
  [693] = 693,
  [694] = 694,
  [695] = 677,
  [696] = 679,
  [697] = 683,
  [698] = 698,
  [699] = 684,
  [700] = 637,
  [701] = 639,
  [702] = 346,
  [703] = 347,
  [704] = 348,
  [705] = 349,
  [706] = 350,
  [707] = 351,
  [708] = 352,
  [709] = 353,
  [710] = 283,
  [711] = 284,
  [712] = 366,
  [713] = 367,
  [714] = 285,
  [715] = 369,
  [716] = 370,
  [717] = 286,
  [718] = 372,
  [719] = 373,
  [720] = 288,
  [721] = 374,
  [722] = 376,
  [723] = 290,
  [724] = 382,
  [725] = 383,
  [726] = 384,
  [727] = 385,
  [728] = 378,
  [729] = 339,
  [730] = 295,
  [731] = 355,
  [732] = 320,
  [733] = 321,
  [734] = 324,
  [735] = 269,
  [736] = 354,
  [737] = 271,
  [738] = 363,
  [739] = 371,
  [740] = 293,
  [741] = 741,
  [742] = 391,
  [743] = 296,
  [744] = 297,
  [745] = 298,
  [746] = 266,
  [747] = 556,
  [748] = 563,
  [749] = 564,
  [750] = 750,
  [751] = 751,
  [752] = 741,
  [753] = 275,
  [754] = 754,
  [755] = 754,
  [756] = 693,
  [757] = 693,
  [758] = 758,
  [759] = 750,
  [760] = 741,
  [761] = 754,
  [762] = 693,
  [763] = 750,
  [764] = 741,
  [765] = 754,
  [766] = 693,
  [767] = 750,
  [768] = 741,
  [769] = 754,
  [770] = 693,
  [771] = 750,
  [772] = 741,
  [773] = 754,
  [774] = 693,
  [775] = 750,
  [776] = 741,
  [777] = 754,
  [778] = 750,
  [779] = 741,
  [780] = 754,
  [781] = 693,
  [782] = 750,
  [783] = 294,
  [784] = 366,
  [785] = 556,
  [786] = 563,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 564,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 679,
  [797] = 683,
  [798] = 684,
  [799] = 799,
  [800] = 800,
  [801] = 556,
  [802] = 563,
  [803] = 564,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 637,
  [812] = 639,
  [813] = 677,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 346,
  [818] = 347,
  [819] = 348,
  [820] = 349,
  [821] = 350,
  [822] = 351,
  [823] = 352,
  [824] = 353,
  [825] = 825,
  [826] = 826,
  [827] = 284,
  [828] = 366,
  [829] = 367,
  [830] = 285,
  [831] = 369,
  [832] = 370,
  [833] = 286,
  [834] = 372,
  [835] = 373,
  [836] = 288,
  [837] = 374,
  [838] = 376,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 382,
  [843] = 383,
  [844] = 384,
  [845] = 385,
  [846] = 378,
  [847] = 339,
  [848] = 295,
  [849] = 355,
  [850] = 320,
  [851] = 321,
  [852] = 324,
  [853] = 269,
  [854] = 354,
  [855] = 271,
  [856] = 363,
  [857] = 371,
  [858] = 293,
  [859] = 294,
  [860] = 391,
  [861] = 296,
  [862] = 297,
  [863] = 298,
  [864] = 864,
  [865] = 346,
  [866] = 347,
  [867] = 348,
  [868] = 349,
  [869] = 350,
  [870] = 351,
  [871] = 352,
  [872] = 353,
  [873] = 266,
  [874] = 283,
  [875] = 875,
  [876] = 284,
  [877] = 367,
  [878] = 285,
  [879] = 369,
  [880] = 370,
  [881] = 286,
  [882] = 372,
  [883] = 373,
  [884] = 288,
  [885] = 374,
  [886] = 376,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 275,
  [891] = 290,
  [892] = 382,
  [893] = 383,
  [894] = 384,
  [895] = 385,
  [896] = 378,
  [897] = 339,
  [898] = 295,
  [899] = 355,
  [900] = 320,
  [901] = 321,
  [902] = 269,
  [903] = 354,
  [904] = 271,
  [905] = 363,
  [906] = 371,
  [907] = 293,
  [908] = 294,
  [909] = 391,
  [910] = 296,
  [911] = 297,
  [912] = 298,
  [913] = 266,
  [914] = 283,
  [915] = 275,
  [916] = 290,
  [917] = 917,
  [918] = 918,
  [919] = 919,
  [920] = 920,
  [921] = 921,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 926,
  [927] = 804,
  [928] = 805,
  [929] = 806,
  [930] = 637,
  [931] = 807,
  [932] = 808,
  [933] = 809,
  [934] = 810,
  [935] = 919,
  [936] = 920,
  [937] = 921,
  [938] = 923,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 639,
  [943] = 922,
  [944] = 944,
  [945] = 945,
  [946] = 787,
  [947] = 788,
  [948] = 924,
  [949] = 793,
  [950] = 940,
  [951] = 816,
  [952] = 941,
  [953] = 925,
  [954] = 864,
  [955] = 677,
  [956] = 944,
  [957] = 679,
  [958] = 683,
  [959] = 684,
  [960] = 926,
  [961] = 945,
  [962] = 324,
  [963] = 963,
  [964] = 964,
  [965] = 965,
  [966] = 966,
  [967] = 262,
  [968] = 968,
  [969] = 263,
  [970] = 970,
  [971] = 971,
  [972] = 972,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 980,
  [982] = 971,
  [983] = 972,
  [984] = 984,
  [985] = 272,
  [986] = 964,
  [987] = 271,
  [988] = 285,
  [989] = 269,
  [990] = 270,
  [991] = 984,
  [992] = 977,
  [993] = 977,
  [994] = 978,
  [995] = 974,
  [996] = 286,
  [997] = 282,
  [998] = 973,
  [999] = 266,
  [1000] = 287,
  [1001] = 283,
  [1002] = 965,
  [1003] = 966,
  [1004] = 965,
  [1005] = 288,
  [1006] = 977,
  [1007] = 978,
  [1008] = 289,
  [1009] = 1009,
  [1010] = 971,
  [1011] = 972,
  [1012] = 1012,
  [1013] = 978,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 1012,
  [1017] = 971,
  [1018] = 1018,
  [1019] = 972,
  [1020] = 977,
  [1021] = 978,
  [1022] = 973,
  [1023] = 501,
  [1024] = 615,
  [1025] = 1025,
  [1026] = 974,
  [1027] = 971,
  [1028] = 972,
  [1029] = 1029,
  [1030] = 273,
  [1031] = 1009,
  [1032] = 977,
  [1033] = 978,
  [1034] = 963,
  [1035] = 1018,
  [1036] = 280,
  [1037] = 267,
  [1038] = 976,
  [1039] = 275,
  [1040] = 268,
  [1041] = 1041,
  [1042] = 971,
  [1043] = 972,
  [1044] = 290,
  [1045] = 1025,
  [1046] = 281,
  [1047] = 284,
  [1048] = 966,
  [1049] = 266,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 305,
  [1056] = 1056,
  [1057] = 307,
  [1058] = 1058,
  [1059] = 677,
  [1060] = 350,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 362,
  [1064] = 1064,
  [1065] = 299,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 292,
  [1070] = 348,
  [1071] = 349,
  [1072] = 1072,
  [1073] = 321,
  [1074] = 1074,
  [1075] = 324,
  [1076] = 370,
  [1077] = 677,
  [1078] = 1078,
  [1079] = 275,
  [1080] = 301,
  [1081] = 1081,
  [1082] = 354,
  [1083] = 344,
  [1084] = 1084,
  [1085] = 1085,
  [1086] = 363,
  [1087] = 351,
  [1088] = 361,
  [1089] = 1089,
  [1090] = 371,
  [1091] = 368,
  [1092] = 293,
  [1093] = 294,
  [1094] = 356,
  [1095] = 357,
  [1096] = 391,
  [1097] = 266,
  [1098] = 296,
  [1099] = 275,
  [1100] = 266,
  [1101] = 275,
  [1102] = 372,
  [1103] = 345,
  [1104] = 297,
  [1105] = 298,
  [1106] = 273,
  [1107] = 280,
  [1108] = 373,
  [1109] = 367,
  [1110] = 1110,
  [1111] = 1078,
  [1112] = 1081,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 346,
  [1116] = 1116,
  [1117] = 281,
  [1118] = 282,
  [1119] = 358,
  [1120] = 1089,
  [1121] = 1066,
  [1122] = 283,
  [1123] = 1123,
  [1124] = 1058,
  [1125] = 1125,
  [1126] = 374,
  [1127] = 352,
  [1128] = 284,
  [1129] = 353,
  [1130] = 376,
  [1131] = 366,
  [1132] = 1132,
  [1133] = 369,
  [1134] = 320,
  [1135] = 336,
  [1136] = 375,
  [1137] = 266,
  [1138] = 1125,
  [1139] = 1050,
  [1140] = 1078,
  [1141] = 1081,
  [1142] = 337,
  [1143] = 1143,
  [1144] = 285,
  [1145] = 1064,
  [1146] = 286,
  [1147] = 1089,
  [1148] = 1066,
  [1149] = 287,
  [1150] = 288,
  [1151] = 1058,
  [1152] = 1125,
  [1153] = 289,
  [1154] = 340,
  [1155] = 1155,
  [1156] = 347,
  [1157] = 275,
  [1158] = 290,
  [1159] = 267,
  [1160] = 268,
  [1161] = 1051,
  [1162] = 1052,
  [1163] = 1053,
  [1164] = 1054,
  [1165] = 1058,
  [1166] = 1125,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 341,
  [1171] = 1084,
  [1172] = 1058,
  [1173] = 1125,
  [1174] = 1061,
  [1175] = 342,
  [1176] = 387,
  [1177] = 379,
  [1178] = 1062,
  [1179] = 269,
  [1180] = 270,
  [1181] = 271,
  [1182] = 1058,
  [1183] = 1125,
  [1184] = 272,
  [1185] = 380,
  [1186] = 381,
  [1187] = 1132,
  [1188] = 382,
  [1189] = 1067,
  [1190] = 1068,
  [1191] = 383,
  [1192] = 384,
  [1193] = 1058,
  [1194] = 1125,
  [1195] = 1072,
  [1196] = 1074,
  [1197] = 385,
  [1198] = 273,
  [1199] = 386,
  [1200] = 343,
  [1201] = 388,
  [1202] = 389,
  [1203] = 390,
  [1204] = 378,
  [1205] = 339,
  [1206] = 295,
  [1207] = 355,
  [1208] = 335,
  [1209] = 1110,
  [1210] = 1113,
  [1211] = 1058,
  [1212] = 1125,
  [1213] = 1114,
  [1214] = 1116,
  [1215] = 377,
  [1216] = 679,
  [1217] = 352,
  [1218] = 353,
  [1219] = 1110,
  [1220] = 356,
  [1221] = 357,
  [1222] = 564,
  [1223] = 1113,
  [1224] = 1114,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 1116,
  [1229] = 361,
  [1230] = 362,
  [1231] = 1051,
  [1232] = 1052,
  [1233] = 1053,
  [1234] = 1054,
  [1235] = 1235,
  [1236] = 1084,
  [1237] = 1237,
  [1238] = 1061,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 1062,
  [1242] = 1242,
  [1243] = 556,
  [1244] = 1242,
  [1245] = 1245,
  [1246] = 266,
  [1247] = 366,
  [1248] = 275,
  [1249] = 1067,
  [1250] = 1225,
  [1251] = 1240,
  [1252] = 1252,
  [1253] = 1252,
  [1254] = 290,
  [1255] = 1068,
  [1256] = 367,
  [1257] = 1050,
  [1258] = 369,
  [1259] = 370,
  [1260] = 372,
  [1261] = 373,
  [1262] = 683,
  [1263] = 684,
  [1264] = 1064,
  [1265] = 374,
  [1266] = 376,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1084,
  [1270] = 1072,
  [1271] = 1074,
  [1272] = 283,
  [1273] = 379,
  [1274] = 380,
  [1275] = 381,
  [1276] = 382,
  [1277] = 383,
  [1278] = 384,
  [1279] = 385,
  [1280] = 386,
  [1281] = 273,
  [1282] = 346,
  [1283] = 347,
  [1284] = 388,
  [1285] = 389,
  [1286] = 390,
  [1287] = 378,
  [1288] = 339,
  [1289] = 295,
  [1290] = 355,
  [1291] = 335,
  [1292] = 1292,
  [1293] = 677,
  [1294] = 358,
  [1295] = 368,
  [1296] = 299,
  [1297] = 301,
  [1298] = 677,
  [1299] = 1299,
  [1300] = 305,
  [1301] = 1110,
  [1302] = 348,
  [1303] = 307,
  [1304] = 349,
  [1305] = 1113,
  [1306] = 350,
  [1307] = 351,
  [1308] = 1114,
  [1309] = 352,
  [1310] = 353,
  [1311] = 1116,
  [1312] = 1292,
  [1313] = 1313,
  [1314] = 284,
  [1315] = 677,
  [1316] = 366,
  [1317] = 1050,
  [1318] = 367,
  [1319] = 1319,
  [1320] = 285,
  [1321] = 369,
  [1322] = 1064,
  [1323] = 370,
  [1324] = 298,
  [1325] = 286,
  [1326] = 1132,
  [1327] = 1327,
  [1328] = 372,
  [1329] = 373,
  [1330] = 288,
  [1331] = 374,
  [1332] = 1235,
  [1333] = 320,
  [1334] = 376,
  [1335] = 1335,
  [1336] = 1132,
  [1337] = 1335,
  [1338] = 382,
  [1339] = 383,
  [1340] = 384,
  [1341] = 385,
  [1342] = 378,
  [1343] = 339,
  [1344] = 321,
  [1345] = 563,
  [1346] = 295,
  [1347] = 324,
  [1348] = 266,
  [1349] = 355,
  [1350] = 354,
  [1351] = 363,
  [1352] = 275,
  [1353] = 266,
  [1354] = 1051,
  [1355] = 371,
  [1356] = 275,
  [1357] = 1052,
  [1358] = 1053,
  [1359] = 1239,
  [1360] = 1054,
  [1361] = 320,
  [1362] = 375,
  [1363] = 377,
  [1364] = 387,
  [1365] = 292,
  [1366] = 1061,
  [1367] = 321,
  [1368] = 1062,
  [1369] = 324,
  [1370] = 269,
  [1371] = 1327,
  [1372] = 1245,
  [1373] = 354,
  [1374] = 271,
  [1375] = 293,
  [1376] = 294,
  [1377] = 391,
  [1378] = 296,
  [1379] = 1319,
  [1380] = 336,
  [1381] = 337,
  [1382] = 297,
  [1383] = 298,
  [1384] = 363,
  [1385] = 371,
  [1386] = 340,
  [1387] = 341,
  [1388] = 342,
  [1389] = 343,
  [1390] = 344,
  [1391] = 1067,
  [1392] = 1068,
  [1393] = 345,
  [1394] = 346,
  [1395] = 347,
  [1396] = 293,
  [1397] = 294,
  [1398] = 637,
  [1399] = 391,
  [1400] = 639,
  [1401] = 348,
  [1402] = 349,
  [1403] = 296,
  [1404] = 350,
  [1405] = 1072,
  [1406] = 1074,
  [1407] = 351,
  [1408] = 297,
  [1409] = 1226,
  [1410] = 1410,
  [1411] = 1116,
  [1412] = 1412,
  [1413] = 1062,
  [1414] = 1061,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 1110,
  [1421] = 1072,
  [1422] = 1064,
  [1423] = 1050,
  [1424] = 290,
  [1425] = 1074,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1410,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1410,
  [1434] = 1431,
  [1435] = 1432,
  [1436] = 1436,
  [1437] = 1436,
  [1438] = 1410,
  [1439] = 1431,
  [1440] = 1432,
  [1441] = 1436,
  [1442] = 1113,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1062,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1067,
  [1452] = 1452,
  [1453] = 1114,
  [1454] = 1454,
  [1455] = 266,
  [1456] = 1456,
  [1457] = 1447,
  [1458] = 1068,
  [1459] = 1447,
  [1460] = 1449,
  [1461] = 1461,
  [1462] = 275,
  [1463] = 1114,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1052,
  [1467] = 1116,
  [1468] = 1447,
  [1469] = 1053,
  [1470] = 1084,
  [1471] = 1449,
  [1472] = 1410,
  [1473] = 1447,
  [1474] = 1432,
  [1475] = 677,
  [1476] = 1449,
  [1477] = 1067,
  [1478] = 1410,
  [1479] = 1431,
  [1480] = 1432,
  [1481] = 1436,
  [1482] = 1054,
  [1483] = 1431,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1436,
  [1487] = 283,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1491,
  [1492] = 1492,
  [1493] = 1493,
  [1494] = 1432,
  [1495] = 1072,
  [1496] = 1496,
  [1497] = 1497,
  [1498] = 1410,
  [1499] = 1499,
  [1500] = 1068,
  [1501] = 1061,
  [1502] = 1502,
  [1503] = 1431,
  [1504] = 1432,
  [1505] = 1436,
  [1506] = 1110,
  [1507] = 1074,
  [1508] = 1436,
  [1509] = 1050,
  [1510] = 1410,
  [1511] = 1431,
  [1512] = 1432,
  [1513] = 1436,
  [1514] = 1514,
  [1515] = 1515,
  [1516] = 1449,
  [1517] = 1064,
  [1518] = 1132,
  [1519] = 1431,
  [1520] = 1520,
  [1521] = 1051,
  [1522] = 273,
  [1523] = 1052,
  [1524] = 1053,
  [1525] = 1447,
  [1526] = 1526,
  [1527] = 1449,
  [1528] = 1054,
  [1529] = 1529,
  [1530] = 1530,
  [1531] = 1531,
  [1532] = 1532,
  [1533] = 1533,
  [1534] = 1113,
  [1535] = 1051,
  [1536] = 1536,
  [1537] = 1537,
  [1538] = 1410,
  [1539] = 1431,
  [1540] = 1432,
  [1541] = 1436,
  [1542] = 1410,
  [1543] = 1431,
  [1544] = 1432,
  [1545] = 1410,
  [1546] = 1431,
  [1547] = 1432,
  [1548] = 1410,
  [1549] = 1431,
  [1550] = 1432,
  [1551] = 1551,
  [1552] = 1431,
  [1553] = 1432,
  [1554] = 1410,
  [1555] = 1431,
  [1556] = 1432,
  [1557] = 1410,
  [1558] = 1431,
  [1559] = 1432,
  [1560] = 1410,
  [1561] = 1431,
  [1562] = 1410,
  [1563] = 1431,
  [1564] = 1410,
  [1565] = 1410,
  [1566] = 1410,
  [1567] = 1410,
  [1568] = 1410,
  [1569] = 1410,
  [1570] = 1410,
  [1571] = 1410,
  [1572] = 1410,
  [1573] = 1410,
  [1574] = 1410,
  [1575] = 1410,
  [1576] = 1410,
  [1577] = 1410,
  [1578] = 1410,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      if (eof) ADVANCE(1);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 0, .external_lex_state = 2},
  [2] = {.lex_state = 0, .external_lex_state = 3},
  [3] = {.lex_state = 0, .external_lex_state = 3},
  [4] = {.lex_state = 0, .external_lex_state = 3},
  [5] = {.lex_state = 0, .external_lex_state = 3},
  [6] = {.lex_state = 0, .external_lex_state = 3},
  [7] = {.lex_state = 0, .external_lex_state = 3},
  [8] = {.lex_state = 0, .external_lex_state = 4},
  [9] = {.lex_state = 0, .external_lex_state = 4},
  [10] = {.lex_state = 0, .external_lex_state = 4},
  [11] = {.lex_state = 0, .external_lex_state = 5},
  [12] = {.lex_state = 0, .external_lex_state = 6},
  [13] = {.lex_state = 0, .external_lex_state = 7},
  [14] = {.lex_state = 0, .external_lex_state = 7},
  [15] = {.lex_state = 0, .external_lex_state = 7},
  [16] = {.lex_state = 0, .external_lex_state = 7},
  [17] = {.lex_state = 0, .external_lex_state = 7},
  [18] = {.lex_state = 0, .external_lex_state = 7},
  [19] = {.lex_state = 0, .external_lex_state = 7},
  [20] = {.lex_state = 0, .external_lex_state = 7},
  [21] = {.lex_state = 0, .external_lex_state = 7},
  [22] = {.lex_state = 0, .external_lex_state = 7},
  [23] = {.lex_state = 0, .external_lex_state = 7},
  [24] = {.lex_state = 0, .external_lex_state = 8},
  [25] = {.lex_state = 0, .external_lex_state = 8},
  [26] = {.lex_state = 0, .external_lex_state = 8},
  [27] = {.lex_state = 0, .external_lex_state = 8},
  [28] = {.lex_state = 0, .external_lex_state = 8},
  [29] = {.lex_state = 0, .external_lex_state = 8},
  [30] = {.lex_state = 0, .external_lex_state = 8},
  [31] = {.lex_state = 0, .external_lex_state = 8},
  [32] = {.lex_state = 0, .external_lex_state = 8},
  [33] = {.lex_state = 0, .external_lex_state = 8},
  [34] = {.lex_state = 0, .external_lex_state = 8},
  [35] = {.lex_state = 0, .external_lex_state = 9},
  [36] = {.lex_state = 0, .external_lex_state = 9},
  [37] = {.lex_state = 0, .external_lex_state = 10},
  [38] = {.lex_state = 0, .external_lex_state = 10},
  [39] = {.lex_state = 0, .external_lex_state = 10},
  [40] = {.lex_state = 0, .external_lex_state = 11},
  [41] = {.lex_state = 0, .external_lex_state = 12},
  [42] = {.lex_state = 0, .external_lex_state = 7},
  [43] = {.lex_state = 0, .external_lex_state = 7},
  [44] = {.lex_state = 0, .external_lex_state = 7},
  [45] = {.lex_state = 0, .external_lex_state = 7},
  [46] = {.lex_state = 0, .external_lex_state = 7},
  [47] = {.lex_state = 0, .external_lex_state = 7},
  [48] = {.lex_state = 0, .external_lex_state = 7},
  [49] = {.lex_state = 0, .external_lex_state = 7},
  [50] = {.lex_state = 0, .external_lex_state = 7},
  [51] = {.lex_state = 0, .external_lex_state = 7},
  [52] = {.lex_state = 0, .external_lex_state = 7},
  [53] = {.lex_state = 0, .external_lex_state = 7},
  [54] = {.lex_state = 0, .external_lex_state = 7},
  [55] = {.lex_state = 0, .external_lex_state = 8},
  [56] = {.lex_state = 0, .external_lex_state = 11},
  [57] = {.lex_state = 0, .external_lex_state = 8},
  [58] = {.lex_state = 0, .external_lex_state = 8},
  [59] = {.lex_state = 0, .external_lex_state = 12},
  [60] = {.lex_state = 0, .external_lex_state = 8},
  [61] = {.lex_state = 0, .external_lex_state = 8},
  [62] = {.lex_state = 0, .external_lex_state = 8},
  [63] = {.lex_state = 0, .external_lex_state = 8},
  [64] = {.lex_state = 0, .external_lex_state = 8},
  [65] = {.lex_state = 0, .external_lex_state = 8},
  [66] = {.lex_state = 0, .external_lex_state = 8},
  [67] = {.lex_state = 0, .external_lex_state = 8},
  [68] = {.lex_state = 0, .external_lex_state = 8},
  [69] = {.lex_state = 0, .external_lex_state = 8},
  [70] = {.lex_state = 0, .external_lex_state = 7},
  [71] = {.lex_state = 0, .external_lex_state = 7},
  [72] = {.lex_state = 0, .external_lex_state = 7},
  [73] = {.lex_state = 0, .external_lex_state = 7},
  [74] = {.lex_state = 0, .external_lex_state = 8},
  [75] = {.lex_state = 0, .external_lex_state = 8},
  [76] = {.lex_state = 0, .external_lex_state = 8},
  [77] = {.lex_state = 0, .external_lex_state = 8},
  [78] = {.lex_state = 0, .external_lex_state = 13},
  [79] = {.lex_state = 0, .external_lex_state = 13},
  [80] = {.lex_state = 0, .external_lex_state = 14},
  [81] = {.lex_state = 0, .external_lex_state = 14},
  [82] = {.lex_state = 0, .external_lex_state = 15},
  [83] = {.lex_state = 0, .external_lex_state = 15},
  [84] = {.lex_state = 0, .external_lex_state = 11},
  [85] = {.lex_state = 0, .external_lex_state = 11},
  [86] = {.lex_state = 0, .external_lex_state = 12},
  [87] = {.lex_state = 0, .external_lex_state = 12},
  [88] = {.lex_state = 0, .external_lex_state = 12},
  [89] = {.lex_state = 0, .external_lex_state = 11},
  [90] = {.lex_state = 0, .external_lex_state = 11},
  [91] = {.lex_state = 0, .external_lex_state = 11},
  [92] = {.lex_state = 0, .external_lex_state = 12},
  [93] = {.lex_state = 0, .external_lex_state = 12},
  [94] = {.lex_state = 0, .external_lex_state = 11},
  [95] = {.lex_state = 0, .external_lex_state = 12},
  [96] = {.lex_state = 0, .external_lex_state = 16},
  [97] = {.lex_state = 0, .external_lex_state = 16},
  [98] = {.lex_state = 0, .external_lex_state = 17},
  [99] = {.lex_state = 0, .external_lex_state = 18},
  [100] = {.lex_state = 0, .external_lex_state = 18},
  [101] = {.lex_state = 0, .external_lex_state = 18},
  [102] = {.lex_state = 0, .external_lex_state = 18},
  [103] = {.lex_state = 0, .external_lex_state = 19},
  [104] = {.lex_state = 0, .external_lex_state = 20},
  [105] = {.lex_state = 0, .external_lex_state = 19},
  [106] = {.lex_state = 0, .external_lex_state = 19},
  [107] = {.lex_state = 0, .external_lex_state = 20},
  [108] = {.lex_state = 0, .external_lex_state = 9},
  [109] = {.lex_state = 0, .external_lex_state = 9},
  [110] = {.lex_state = 0, .external_lex_state = 9},
  [111] = {.lex_state = 0, .external_lex_state = 9},
  [112] = {.lex_state = 0, .external_lex_state = 21},
  [113] = {.lex_state = 0, .external_lex_state = 21},
  [114] = {.lex_state = 0, .external_lex_state = 22},
  [115] = {.lex_state = 0, .external_lex_state = 22},
  [116] = {.lex_state = 0, .external_lex_state = 23},
  [117] = {.lex_state = 0, .external_lex_state = 24},
  [118] = {.lex_state = 0, .external_lex_state = 25},
  [119] = {.lex_state = 0, .external_lex_state = 25},
  [120] = {.lex_state = 0, .external_lex_state = 23},
  [121] = {.lex_state = 0, .external_lex_state = 24},
  [122] = {.lex_state = 0, .external_lex_state = 26},
  [123] = {.lex_state = 0, .external_lex_state = 26},
  [124] = {.lex_state = 0, .external_lex_state = 27},
  [125] = {.lex_state = 0, .external_lex_state = 27},
  [126] = {.lex_state = 0, .external_lex_state = 26},
  [127] = {.lex_state = 0, .external_lex_state = 26},
  [128] = {.lex_state = 0, .external_lex_state = 28},
  [129] = {.lex_state = 0, .external_lex_state = 29},
  [130] = {.lex_state = 0, .external_lex_state = 26},
  [131] = {.lex_state = 0, .external_lex_state = 26},
  [132] = {.lex_state = 0, .external_lex_state = 26},
  [133] = {.lex_state = 0, .external_lex_state = 26},
  [134] = {.lex_state = 0, .external_lex_state = 30},
  [135] = {.lex_state = 0, .external_lex_state = 29},
  [136] = {.lex_state = 0, .external_lex_state = 28},
  [137] = {.lex_state = 0, .external_lex_state = 29},
  [138] = {.lex_state = 0, .external_lex_state = 26},
  [139] = {.lex_state = 0, .external_lex_state = 26},
  [140] = {.lex_state = 0, .external_lex_state = 28},
  [141] = {.lex_state = 0, .external_lex_state = 29},
  [142] = {.lex_state = 0, .external_lex_state = 28},
  [143] = {.lex_state = 0, .external_lex_state = 29},
  [144] = {.lex_state = 0, .external_lex_state = 26},
  [145] = {.lex_state = 0, .external_lex_state = 28},
  [146] = {.lex_state = 0, .external_lex_state = 29},
  [147] = {.lex_state = 0, .external_lex_state = 26},
  [148] = {.lex_state = 0, .external_lex_state = 26},
  [149] = {.lex_state = 0, .external_lex_state = 28},
  [150] = {.lex_state = 0, .external_lex_state = 29},
  [151] = {.lex_state = 0, .external_lex_state = 28},
  [152] = {.lex_state = 0, .external_lex_state = 31},
  [153] = {.lex_state = 0, .external_lex_state = 31},
  [154] = {.lex_state = 0, .external_lex_state = 31},
  [155] = {.lex_state = 0, .external_lex_state = 31},
  [156] = {.lex_state = 0, .external_lex_state = 28},
  [157] = {.lex_state = 0, .external_lex_state = 29},
  [158] = {.lex_state = 0, .external_lex_state = 32},
  [159] = {.lex_state = 0, .external_lex_state = 28},
  [160] = {.lex_state = 0, .external_lex_state = 33},
  [161] = {.lex_state = 0, .external_lex_state = 32},
  [162] = {.lex_state = 0, .external_lex_state = 34},
  [163] = {.lex_state = 0, .external_lex_state = 35},
  [164] = {.lex_state = 0, .external_lex_state = 33},
  [165] = {.lex_state = 0, .external_lex_state = 34},
  [166] = {.lex_state = 0, .external_lex_state = 34},
  [167] = {.lex_state = 0, .external_lex_state = 34},
  [168] = {.lex_state = 0, .external_lex_state = 35},
  [169] = {.lex_state = 0, .external_lex_state = 29},
  [170] = {.lex_state = 0, .external_lex_state = 32},
  [171] = {.lex_state = 0, .external_lex_state = 14},
  [172] = {.lex_state = 0, .external_lex_state = 36},
  [173] = {.lex_state = 0, .external_lex_state = 36},
  [174] = {.lex_state = 0, .external_lex_state = 14},
  [175] = {.lex_state = 0, .external_lex_state = 37},
  [176] = {.lex_state = 0, .external_lex_state = 14},
  [177] = {.lex_state = 0, .external_lex_state = 36},
  [178] = {.lex_state = 0, .external_lex_state = 14},
  [179] = {.lex_state = 0, .external_lex_state = 37},
  [180] = {.lex_state = 0, .external_lex_state = 15},
  [181] = {.lex_state = 0, .external_lex_state = 15},
  [182] = {.lex_state = 0, .external_lex_state = 15},
  [183] = {.lex_state = 0, .external_lex_state = 38},
  [184] = {.lex_state = 0, .external_lex_state = 38},
  [185] = {.lex_state = 0, .external_lex_state = 38},
  [186] = {.lex_state = 0, .external_lex_state = 39},
  [187] = {.lex_state = 0, .external_lex_state = 39},
  [188] = {.lex_state = 0, .external_lex_state = 40},
  [189] = {.lex_state = 0, .external_lex_state = 41},
  [190] = {.lex_state = 0, .external_lex_state = 41},
  [191] = {.lex_state = 0, .external_lex_state = 41},
  [192] = {.lex_state = 0, .external_lex_state = 39},
  [193] = {.lex_state = 0, .external_lex_state = 40},
  [194] = {.lex_state = 0, .external_lex_state = 40},
  [195] = {.lex_state = 0, .external_lex_state = 42},
  [196] = {.lex_state = 0, .external_lex_state = 43},
  [197] = {.lex_state = 0, .external_lex_state = 42},
  [198] = {.lex_state = 0, .external_lex_state = 44},
  [199] = {.lex_state = 0, .external_lex_state = 42},
  [200] = {.lex_state = 0, .external_lex_state = 43},
  [201] = {.lex_state = 0, .external_lex_state = 42},
  [202] = {.lex_state = 0, .external_lex_state = 42},
  [203] = {.lex_state = 0, .external_lex_state = 44},
  [204] = {.lex_state = 0, .external_lex_state = 43},
  [205] = {.lex_state = 0, .external_lex_state = 44},
  [206] = {.lex_state = 0, .external_lex_state = 45},
  [207] = {.lex_state = 0, .external_lex_state = 45},
  [208] = {.lex_state = 0, .external_lex_state = 45},
  [209] = {.lex_state = 0, .external_lex_state = 45},
  [210] = {.lex_state = 0, .external_lex_state = 45},
  [211] = {.lex_state = 0, .external_lex_state = 46},
  [212] = {.lex_state = 0, .external_lex_state = 21},
  [213] = {.lex_state = 0, .external_lex_state = 21},
  [214] = {.lex_state = 0, .external_lex_state = 21},
  [215] = {.lex_state = 0, .external_lex_state = 47},
  [216] = {.lex_state = 0, .external_lex_state = 21},
  [217] = {.lex_state = 0, .external_lex_state = 46},
  [218] = {.lex_state = 0, .external_lex_state = 47},
  [219] = {.lex_state = 0, .external_lex_state = 46},
  [220] = {.lex_state = 0, .external_lex_state = 47},
  [221] = {.lex_state = 0, .external_lex_state = 21},
  [222] = {.lex_state = 0, .external_lex_state = 47},
  [223] = {.lex_state = 0, .external_lex_state = 47},
  [224] = {.lex_state = 0, .external_lex_state = 46},
  [225] = {.lex_state = 0, .external_lex_state = 46},
  [226] = {.lex_state = 0, .external_lex_state = 22},
  [227] = {.lex_state = 0, .external_lex_state = 22},
  [228] = {.lex_state = 0, .external_lex_state = 22},
  [229] = {.lex_state = 0, .external_lex_state = 22},
  [230] = {.lex_state = 0, .external_lex_state = 48},
  [231] = {.lex_state = 0, .external_lex_state = 22},
  [232] = {.lex_state = 0, .external_lex_state = 48},
  [233] = {.lex_state = 0, .external_lex_state = 48},
  [234] = {.lex_state = 0, .external_lex_state = 25},
  [235] = {.lex_state = 0, .external_lex_state = 25},
  [236] = {.lex_state = 0, .external_lex_state = 25},
  [237] = {.lex_state = 0, .external_lex_state = 23},
  [238] = {.lex_state = 0, .external_lex_state = 25},
  [239] = {.lex_state = 0, .external_lex_state = 25},
  [240] = {.lex_state = 0, .external_lex_state = 23},
  [241] = {.lex_state = 0, .external_lex_state = 23},
  [242] = {.lex_state = 0, .external_lex_state = 23},
  [243] = {.lex_state = 0, .external_lex_state = 23},
  [244] = {.lex_state = 0, .external_lex_state = 10},
  [245] = {.lex_state = 0, .external_lex_state = 49},
  [246] = {.lex_state = 0, .external_lex_state = 49},
  [247] = {.lex_state = 0, .external_lex_state = 10},
  [248] = {.lex_state = 0, .external_lex_state = 49},
  [249] = {.lex_state = 0, .external_lex_state = 49},
  [250] = {.lex_state = 0, .external_lex_state = 10},
  [251] = {.lex_state = 0, .external_lex_state = 49},
  [252] = {.lex_state = 0, .external_lex_state = 10},
  [253] = {.lex_state = 0, .external_lex_state = 10},
  [254] = {.lex_state = 0, .external_lex_state = 10},
  [255] = {.lex_state = 0, .external_lex_state = 10},
  [256] = {.lex_state = 0, .external_lex_state = 35},
  [257] = {.lex_state = 0, .external_lex_state = 35},
  [258] = {.lex_state = 0, .external_lex_state = 35},
  [259] = {.lex_state = 0, .external_lex_state = 35},
  [260] = {.lex_state = 0, .external_lex_state = 35},
  [261] = {.lex_state = 0, .external_lex_state = 50},
  [262] = {.lex_state = 0, .external_lex_state = 51},
  [263] = {.lex_state = 0, .external_lex_state = 51},
  [264] = {.lex_state = 0, .external_lex_state = 52},
  [265] = {.lex_state = 0, .external_lex_state = 51},
  [266] = {.lex_state = 0, .external_lex_state = 51},
  [267] = {.lex_state = 0, .external_lex_state = 51},
  [268] = {.lex_state = 0, .external_lex_state = 51},
  [269] = {.lex_state = 0, .external_lex_state = 51},
  [270] = {.lex_state = 0, .external_lex_state = 51},
  [271] = {.lex_state = 0, .external_lex_state = 51},
  [272] = {.lex_state = 0, .external_lex_state = 51},
  [273] = {.lex_state = 0, .external_lex_state = 51},
  [274] = {.lex_state = 0, .external_lex_state = 53},
  [275] = {.lex_state = 0, .external_lex_state = 51},
  [276] = {.lex_state = 0, .external_lex_state = 54},
  [277] = {.lex_state = 0, .external_lex_state = 26},
  [278] = {.lex_state = 0, .external_lex_state = 26},
  [279] = {.lex_state = 0, .external_lex_state = 26},
  [280] = {.lex_state = 0, .external_lex_state = 51},
  [281] = {.lex_state = 0, .external_lex_state = 51},
  [282] = {.lex_state = 0, .external_lex_state = 51},
  [283] = {.lex_state = 0, .external_lex_state = 51},
  [284] = {.lex_state = 0, .external_lex_state = 51},
  [285] = {.lex_state = 0, .external_lex_state = 51},
  [286] = {.lex_state = 0, .external_lex_state = 51},
  [287] = {.lex_state = 0, .external_lex_state = 51},
  [288] = {.lex_state = 0, .external_lex_state = 51},
  [289] = {.lex_state = 0, .external_lex_state = 51},
  [290] = {.lex_state = 0, .external_lex_state = 51},
  [291] = {.lex_state = 0, .external_lex_state = 26},
  [292] = {.lex_state = 0, .external_lex_state = 26},
  [293] = {.lex_state = 0, .external_lex_state = 26},
  [294] = {.lex_state = 0, .external_lex_state = 26},
  [295] = {.lex_state = 0, .external_lex_state = 26},
  [296] = {.lex_state = 0, .external_lex_state = 26},
  [297] = {.lex_state = 0, .external_lex_state = 26},
  [298] = {.lex_state = 0, .external_lex_state = 26},
  [299] = {.lex_state = 0, .external_lex_state = 26},
  [300] = {.lex_state = 0, .external_lex_state = 26},
  [301] = {.lex_state = 0, .external_lex_state = 26},
  [302] = {.lex_state = 0, .external_lex_state = 26},
  [303] = {.lex_state = 0, .external_lex_state = 26},
  [304] = {.lex_state = 0, .external_lex_state = 26},
  [305] = {.lex_state = 0, .external_lex_state = 26},
  [306] = {.lex_state = 0, .external_lex_state = 26},
  [307] = {.lex_state = 0, .external_lex_state = 26},
  [308] = {.lex_state = 0, .external_lex_state = 55},
  [309] = {.lex_state = 0, .external_lex_state = 55},
  [310] = {.lex_state = 0, .external_lex_state = 26},
  [311] = {.lex_state = 0, .external_lex_state = 26},
  [312] = {.lex_state = 0, .external_lex_state = 26},
  [313] = {.lex_state = 0, .external_lex_state = 26},
  [314] = {.lex_state = 0, .external_lex_state = 26},
  [315] = {.lex_state = 0, .external_lex_state = 26},
  [316] = {.lex_state = 0, .external_lex_state = 26},
  [317] = {.lex_state = 0, .external_lex_state = 26},
  [318] = {.lex_state = 0, .external_lex_state = 26},
  [319] = {.lex_state = 0, .external_lex_state = 26},
  [320] = {.lex_state = 0, .external_lex_state = 26},
  [321] = {.lex_state = 0, .external_lex_state = 26},
  [322] = {.lex_state = 0, .external_lex_state = 55},
  [323] = {.lex_state = 0, .external_lex_state = 26},
  [324] = {.lex_state = 0, .external_lex_state = 26},
  [325] = {.lex_state = 0, .external_lex_state = 26},
  [326] = {.lex_state = 0, .external_lex_state = 26},
  [327] = {.lex_state = 0, .external_lex_state = 26},
  [328] = {.lex_state = 0, .external_lex_state = 26},
  [329] = {.lex_state = 0, .external_lex_state = 26},
  [330] = {.lex_state = 0, .external_lex_state = 26},
  [331] = {.lex_state = 0, .external_lex_state = 26},
  [332] = {.lex_state = 0, .external_lex_state = 26},
  [333] = {.lex_state = 0, .external_lex_state = 26},
  [334] = {.lex_state = 0, .external_lex_state = 26},
  [335] = {.lex_state = 0, .external_lex_state = 26},
  [336] = {.lex_state = 0, .external_lex_state = 26},
  [337] = {.lex_state = 0, .external_lex_state = 26},
  [338] = {.lex_state = 0, .external_lex_state = 26},
  [339] = {.lex_state = 0, .external_lex_state = 26},
  [340] = {.lex_state = 0, .external_lex_state = 26},
  [341] = {.lex_state = 0, .external_lex_state = 26},
  [342] = {.lex_state = 0, .external_lex_state = 26},
  [343] = {.lex_state = 0, .external_lex_state = 26},
  [344] = {.lex_state = 0, .external_lex_state = 26},
  [345] = {.lex_state = 0, .external_lex_state = 26},
  [346] = {.lex_state = 0, .external_lex_state = 26},
  [347] = {.lex_state = 0, .external_lex_state = 26},
  [348] = {.lex_state = 0, .external_lex_state = 26},
  [349] = {.lex_state = 0, .external_lex_state = 26},
  [350] = {.lex_state = 0, .external_lex_state = 26},
  [351] = {.lex_state = 0, .external_lex_state = 26},
  [352] = {.lex_state = 0, .external_lex_state = 26},
  [353] = {.lex_state = 0, .external_lex_state = 26},
  [354] = {.lex_state = 0, .external_lex_state = 26},
  [355] = {.lex_state = 0, .external_lex_state = 26},
  [356] = {.lex_state = 0, .external_lex_state = 26},
  [357] = {.lex_state = 0, .external_lex_state = 26},
  [358] = {.lex_state = 0, .external_lex_state = 26},
  [359] = {.lex_state = 0, .external_lex_state = 26},
  [360] = {.lex_state = 0, .external_lex_state = 26},
  [361] = {.lex_state = 0, .external_lex_state = 26},
  [362] = {.lex_state = 0, .external_lex_state = 26},
  [363] = {.lex_state = 0, .external_lex_state = 26},
  [364] = {.lex_state = 0, .external_lex_state = 26},
  [365] = {.lex_state = 0, .external_lex_state = 56},
  [366] = {.lex_state = 0, .external_lex_state = 26},
  [367] = {.lex_state = 0, .external_lex_state = 26},
  [368] = {.lex_state = 0, .external_lex_state = 26},
  [369] = {.lex_state = 0, .external_lex_state = 26},
  [370] = {.lex_state = 0, .external_lex_state = 26},
  [371] = {.lex_state = 0, .external_lex_state = 26},
  [372] = {.lex_state = 0, .external_lex_state = 26},
  [373] = {.lex_state = 0, .external_lex_state = 26},
  [374] = {.lex_state = 0, .external_lex_state = 26},
  [375] = {.lex_state = 0, .external_lex_state = 26},
  [376] = {.lex_state = 0, .external_lex_state = 26},
  [377] = {.lex_state = 0, .external_lex_state = 26},
  [378] = {.lex_state = 0, .external_lex_state = 26},
  [379] = {.lex_state = 0, .external_lex_state = 26},
  [380] = {.lex_state = 0, .external_lex_state = 26},
  [381] = {.lex_state = 0, .external_lex_state = 26},
  [382] = {.lex_state = 0, .external_lex_state = 26},
  [383] = {.lex_state = 0, .external_lex_state = 26},
  [384] = {.lex_state = 0, .external_lex_state = 26},
  [385] = {.lex_state = 0, .external_lex_state = 26},
  [386] = {.lex_state = 0, .external_lex_state = 26},
  [387] = {.lex_state = 0, .external_lex_state = 26},
  [388] = {.lex_state = 0, .external_lex_state = 26},
  [389] = {.lex_state = 0, .external_lex_state = 26},
  [390] = {.lex_state = 0, .external_lex_state = 26},
  [391] = {.lex_state = 0, .external_lex_state = 26},
  [392] = {.lex_state = 0, .external_lex_state = 57},
  [393] = {.lex_state = 0, .external_lex_state = 58},
  [394] = {.lex_state = 0, .external_lex_state = 59},
  [395] = {.lex_state = 0, .external_lex_state = 60},
  [396] = {.lex_state = 0, .external_lex_state = 60},
  [397] = {.lex_state = 0, .external_lex_state = 61},
  [398] = {.lex_state = 0, .external_lex_state = 61},
  [399] = {.lex_state = 0, .external_lex_state = 62},
  [400] = {.lex_state = 0, .external_lex_state = 63},
  [401] = {.lex_state = 0, .external_lex_state = 64},
  [402] = {.lex_state = 0, .external_lex_state = 50},
  [403] = {.lex_state = 0, .external_lex_state = 52},
  [404] = {.lex_state = 0, .external_lex_state = 50},
  [405] = {.lex_state = 0, .external_lex_state = 63},
  [406] = {.lex_state = 0, .external_lex_state = 65},
  [407] = {.lex_state = 0, .external_lex_state = 65},
  [408] = {.lex_state = 0, .external_lex_state = 66},
  [409] = {.lex_state = 0, .external_lex_state = 64},
  [410] = {.lex_state = 0, .external_lex_state = 52},
  [411] = {.lex_state = 0, .external_lex_state = 67},
  [412] = {.lex_state = 0, .external_lex_state = 67},
  [413] = {.lex_state = 0, .external_lex_state = 67},
  [414] = {.lex_state = 0, .external_lex_state = 67},
  [415] = {.lex_state = 0, .external_lex_state = 67},
  [416] = {.lex_state = 0, .external_lex_state = 67},
  [417] = {.lex_state = 0, .external_lex_state = 54},
  [418] = {.lex_state = 0, .external_lex_state = 67},
  [419] = {.lex_state = 0, .external_lex_state = 67},
  [420] = {.lex_state = 0, .external_lex_state = 67},
  [421] = {.lex_state = 0, .external_lex_state = 67},
  [422] = {.lex_state = 0, .external_lex_state = 67},
  [423] = {.lex_state = 0, .external_lex_state = 67},
  [424] = {.lex_state = 0, .external_lex_state = 68},
  [425] = {.lex_state = 0, .external_lex_state = 67},
  [426] = {.lex_state = 0, .external_lex_state = 67},
  [427] = {.lex_state = 0, .external_lex_state = 67},
  [428] = {.lex_state = 0, .external_lex_state = 67},
  [429] = {.lex_state = 0, .external_lex_state = 67},
  [430] = {.lex_state = 0, .external_lex_state = 67},
  [431] = {.lex_state = 0, .external_lex_state = 67},
  [432] = {.lex_state = 0, .external_lex_state = 67},
  [433] = {.lex_state = 0, .external_lex_state = 53},
  [434] = {.lex_state = 0, .external_lex_state = 67},
  [435] = {.lex_state = 0, .external_lex_state = 67},
  [436] = {.lex_state = 0, .external_lex_state = 68},
  [437] = {.lex_state = 0, .external_lex_state = 67},
  [438] = {.lex_state = 0, .external_lex_state = 67},
  [439] = {.lex_state = 0, .external_lex_state = 67},
  [440] = {.lex_state = 0, .external_lex_state = 67},
  [441] = {.lex_state = 0, .external_lex_state = 67},
  [442] = {.lex_state = 0, .external_lex_state = 69},
  [443] = {.lex_state = 0, .external_lex_state = 67},
  [444] = {.lex_state = 0, .external_lex_state = 67},
  [445] = {.lex_state = 0, .external_lex_state = 53},
  [446] = {.lex_state = 0, .external_lex_state = 67},
  [447] = {.lex_state = 0, .external_lex_state = 54},
  [448] = {.lex_state = 0, .external_lex_state = 67},
  [449] = {.lex_state = 0, .external_lex_state = 67},
  [450] = {.lex_state = 0, .external_lex_state = 67},
  [451] = {.lex_state = 0, .external_lex_state = 67},
  [452] = {.lex_state = 0, .external_lex_state = 67},
  [453] = {.lex_state = 0, .external_lex_state = 67},
  [454] = {.lex_state = 0, .external_lex_state = 68},
  [455] = {.lex_state = 0, .external_lex_state = 69},
  [456] = {.lex_state = 0, .external_lex_state = 67},
  [457] = {.lex_state = 0, .external_lex_state = 67},
  [458] = {.lex_state = 0, .external_lex_state = 67},
  [459] = {.lex_state = 0, .external_lex_state = 67},
  [460] = {.lex_state = 0, .external_lex_state = 67},
  [461] = {.lex_state = 0, .external_lex_state = 67},
  [462] = {.lex_state = 0, .external_lex_state = 67},
  [463] = {.lex_state = 0, .external_lex_state = 67},
  [464] = {.lex_state = 0, .external_lex_state = 67},
  [465] = {.lex_state = 0, .external_lex_state = 67},
  [466] = {.lex_state = 0, .external_lex_state = 67},
  [467] = {.lex_state = 0, .external_lex_state = 67},
  [468] = {.lex_state = 0, .external_lex_state = 68},
  [469] = {.lex_state = 0, .external_lex_state = 70},
  [470] = {.lex_state = 0, .external_lex_state = 55},
  [471] = {.lex_state = 0, .external_lex_state = 71},
  [472] = {.lex_state = 0, .external_lex_state = 72},
  [473] = {.lex_state = 0, .external_lex_state = 55},
  [474] = {.lex_state = 0, .external_lex_state = 72},
  [475] = {.lex_state = 0, .external_lex_state = 72},
  [476] = {.lex_state = 0, .external_lex_state = 55},
  [477] = {.lex_state = 0, .external_lex_state = 56},
  [478] = {.lex_state = 0, .external_lex_state = 72},
  [479] = {.lex_state = 0, .external_lex_state = 72},
  [480] = {.lex_state = 0, .external_lex_state = 56},
  [481] = {.lex_state = 0, .external_lex_state = 73},
  [482] = {.lex_state = 0, .external_lex_state = 73},
  [483] = {.lex_state = 0, .external_lex_state = 73},
  [484] = {.lex_state = 0, .external_lex_state = 73},
  [485] = {.lex_state = 0, .external_lex_state = 73},
  [486] = {.lex_state = 0, .external_lex_state = 73},
  [487] = {.lex_state = 0, .external_lex_state = 73},
  [488] = {.lex_state = 0, .external_lex_state = 73},
  [489] = {.lex_state = 0, .external_lex_state = 73},
  [490] = {.lex_state = 0, .external_lex_state = 73},
  [491] = {.lex_state = 0, .external_lex_state = 73},
  [492] = {.lex_state = 0, .external_lex_state = 70},
  [493] = {.lex_state = 0, .external_lex_state = 70},
  [494] = {.lex_state = 0, .external_lex_state = 73},
  [495] = {.lex_state = 0, .external_lex_state = 73},
  [496] = {.lex_state = 0, .external_lex_state = 73},
  [497] = {.lex_state = 0, .external_lex_state = 74},
  [498] = {.lex_state = 0, .external_lex_state = 67},
  [499] = {.lex_state = 0, .external_lex_state = 73},
  [500] = {.lex_state = 0, .external_lex_state = 73},
  [501] = {.lex_state = 0, .external_lex_state = 67},
  [502] = {.lex_state = 0, .external_lex_state = 73},
  [503] = {.lex_state = 0, .external_lex_state = 73},
  [504] = {.lex_state = 0, .external_lex_state = 73},
  [505] = {.lex_state = 0, .external_lex_state = 73},
  [506] = {.lex_state = 0, .external_lex_state = 73},
  [507] = {.lex_state = 0, .external_lex_state = 67},
  [508] = {.lex_state = 0, .external_lex_state = 73},
  [509] = {.lex_state = 0, .external_lex_state = 73},
  [510] = {.lex_state = 0, .external_lex_state = 73},
  [511] = {.lex_state = 0, .external_lex_state = 73},
  [512] = {.lex_state = 0, .external_lex_state = 71},
  [513] = {.lex_state = 0, .external_lex_state = 73},
  [514] = {.lex_state = 0, .external_lex_state = 73},
  [515] = {.lex_state = 0, .external_lex_state = 73},
  [516] = {.lex_state = 0, .external_lex_state = 73},
  [517] = {.lex_state = 0, .external_lex_state = 73},
  [518] = {.lex_state = 0, .external_lex_state = 73},
  [519] = {.lex_state = 0, .external_lex_state = 73},
  [520] = {.lex_state = 0, .external_lex_state = 73},
  [521] = {.lex_state = 0, .external_lex_state = 73},
  [522] = {.lex_state = 0, .external_lex_state = 73},
  [523] = {.lex_state = 0, .external_lex_state = 67},
  [524] = {.lex_state = 0, .external_lex_state = 73},
  [525] = {.lex_state = 0, .external_lex_state = 73},
  [526] = {.lex_state = 0, .external_lex_state = 73},
  [527] = {.lex_state = 0, .external_lex_state = 73},
  [528] = {.lex_state = 0, .external_lex_state = 73},
  [529] = {.lex_state = 0, .external_lex_state = 74},
  [530] = {.lex_state = 0, .external_lex_state = 73},
  [531] = {.lex_state = 0, .external_lex_state = 73},
  [532] = {.lex_state = 0, .external_lex_state = 73},
  [533] = {.lex_state = 0, .external_lex_state = 73},
  [534] = {.lex_state = 0, .external_lex_state = 73},
  [535] = {.lex_state = 0, .external_lex_state = 73},
  [536] = {.lex_state = 0, .external_lex_state = 73},
  [537] = {.lex_state = 0, .external_lex_state = 73},
  [538] = {.lex_state = 0, .external_lex_state = 75},
  [539] = {.lex_state = 0, .external_lex_state = 76},
  [540] = {.lex_state = 0, .external_lex_state = 74},
  [541] = {.lex_state = 0, .external_lex_state = 76},
  [542] = {.lex_state = 0, .external_lex_state = 74},
  [543] = {.lex_state = 0, .external_lex_state = 76},
  [544] = {.lex_state = 0, .external_lex_state = 76},
  [545] = {.lex_state = 0, .external_lex_state = 74},
  [546] = {.lex_state = 0, .external_lex_state = 76},
  [547] = {.lex_state = 0, .external_lex_state = 74},
  [548] = {.lex_state = 0, .external_lex_state = 74},
  [549] = {.lex_state = 0, .external_lex_state = 74},
  [550] = {.lex_state = 0, .external_lex_state = 74},
  [551] = {.lex_state = 0, .external_lex_state = 70},
  [552] = {.lex_state = 0, .external_lex_state = 77},
  [553] = {.lex_state = 0, .external_lex_state = 76},
  [554] = {.lex_state = 0, .external_lex_state = 78},
  [555] = {.lex_state = 0, .external_lex_state = 74},
  [556] = {.lex_state = 0, .external_lex_state = 70},
  [557] = {.lex_state = 0, .external_lex_state = 76},
  [558] = {.lex_state = 0, .external_lex_state = 76},
  [559] = {.lex_state = 0, .external_lex_state = 76},
  [560] = {.lex_state = 0, .external_lex_state = 76},
  [561] = {.lex_state = 0, .external_lex_state = 76},
  [562] = {.lex_state = 0, .external_lex_state = 76},
  [563] = {.lex_state = 0, .external_lex_state = 70},
  [564] = {.lex_state = 0, .external_lex_state = 70},
  [565] = {.lex_state = 0, .external_lex_state = 76},
  [566] = {.lex_state = 0, .external_lex_state = 74},
  [567] = {.lex_state = 0, .external_lex_state = 79},
  [568] = {.lex_state = 0, .external_lex_state = 74},
  [569] = {.lex_state = 0, .external_lex_state = 74},
  [570] = {.lex_state = 0, .external_lex_state = 74},
  [571] = {.lex_state = 0, .external_lex_state = 74},
  [572] = {.lex_state = 0, .external_lex_state = 74},
  [573] = {.lex_state = 0, .external_lex_state = 74},
  [574] = {.lex_state = 0, .external_lex_state = 74},
  [575] = {.lex_state = 0, .external_lex_state = 76},
  [576] = {.lex_state = 0, .external_lex_state = 74},
  [577] = {.lex_state = 0, .external_lex_state = 76},
  [578] = {.lex_state = 0, .external_lex_state = 76},
  [579] = {.lex_state = 0, .external_lex_state = 76},
  [580] = {.lex_state = 0, .external_lex_state = 74},
  [581] = {.lex_state = 0, .external_lex_state = 74},
  [582] = {.lex_state = 0, .external_lex_state = 76},
  [583] = {.lex_state = 0, .external_lex_state = 76},
  [584] = {.lex_state = 0, .external_lex_state = 76},
  [585] = {.lex_state = 0, .external_lex_state = 76},
  [586] = {.lex_state = 0, .external_lex_state = 73},
  [587] = {.lex_state = 0, .external_lex_state = 76},
  [588] = {.lex_state = 0, .external_lex_state = 76},
  [589] = {.lex_state = 0, .external_lex_state = 76},
  [590] = {.lex_state = 0, .external_lex_state = 76},
  [591] = {.lex_state = 0, .external_lex_state = 76},
  [592] = {.lex_state = 0, .external_lex_state = 76},
  [593] = {.lex_state = 0, .external_lex_state = 70},
  [594] = {.lex_state = 0, .external_lex_state = 74},
  [595] = {.lex_state = 0, .external_lex_state = 74},
  [596] = {.lex_state = 0, .external_lex_state = 74},
  [597] = {.lex_state = 0, .external_lex_state = 74},
  [598] = {.lex_state = 0, .external_lex_state = 74},
  [599] = {.lex_state = 0, .external_lex_state = 74},
  [600] = {.lex_state = 0, .external_lex_state = 74},
  [601] = {.lex_state = 0, .external_lex_state = 74},
  [602] = {.lex_state = 0, .external_lex_state = 74},
  [603] = {.lex_state = 0, .external_lex_state = 74},
  [604] = {.lex_state = 0, .external_lex_state = 74},
  [605] = {.lex_state = 0, .external_lex_state = 76},
  [606] = {.lex_state = 0, .external_lex_state = 74},
  [607] = {.lex_state = 0, .external_lex_state = 76},
  [608] = {.lex_state = 0, .external_lex_state = 76},
  [609] = {.lex_state = 0, .external_lex_state = 76},
  [610] = {.lex_state = 0, .external_lex_state = 74},
  [611] = {.lex_state = 0, .external_lex_state = 74},
  [612] = {.lex_state = 0, .external_lex_state = 74},
  [613] = {.lex_state = 0, .external_lex_state = 74},
  [614] = {.lex_state = 0, .external_lex_state = 73},
  [615] = {.lex_state = 0, .external_lex_state = 73},
  [616] = {.lex_state = 0, .external_lex_state = 74},
  [617] = {.lex_state = 0, .external_lex_state = 76},
  [618] = {.lex_state = 0, .external_lex_state = 76},
  [619] = {.lex_state = 0, .external_lex_state = 76},
  [620] = {.lex_state = 0, .external_lex_state = 76},
  [621] = {.lex_state = 0, .external_lex_state = 76},
  [622] = {.lex_state = 0, .external_lex_state = 76},
  [623] = {.lex_state = 0, .external_lex_state = 74},
  [624] = {.lex_state = 0, .external_lex_state = 74},
  [625] = {.lex_state = 0, .external_lex_state = 76},
  [626] = {.lex_state = 0, .external_lex_state = 74},
  [627] = {.lex_state = 0, .external_lex_state = 76},
  [628] = {.lex_state = 0, .external_lex_state = 76},
  [629] = {.lex_state = 0, .external_lex_state = 76},
  [630] = {.lex_state = 0, .external_lex_state = 76},
  [631] = {.lex_state = 0, .external_lex_state = 76},
  [632] = {.lex_state = 0, .external_lex_state = 74},
  [633] = {.lex_state = 0, .external_lex_state = 76},
  [634] = {.lex_state = 0, .external_lex_state = 76},
  [635] = {.lex_state = 0, .external_lex_state = 76},
  [636] = {.lex_state = 0, .external_lex_state = 74},
  [637] = {.lex_state = 0, .external_lex_state = 70},
  [638] = {.lex_state = 0, .external_lex_state = 70},
  [639] = {.lex_state = 0, .external_lex_state = 70},
  [640] = {.lex_state = 0, .external_lex_state = 76},
  [641] = {.lex_state = 0, .external_lex_state = 76},
  [642] = {.lex_state = 0, .external_lex_state = 76},
  [643] = {.lex_state = 0, .external_lex_state = 76},
  [644] = {.lex_state = 0, .external_lex_state = 76},
  [645] = {.lex_state = 0, .external_lex_state = 78},
  [646] = {.lex_state = 0, .external_lex_state = 76},
  [647] = {.lex_state = 0, .external_lex_state = 76},
  [648] = {.lex_state = 0, .external_lex_state = 73},
  [649] = {.lex_state = 0, .external_lex_state = 77},
  [650] = {.lex_state = 0, .external_lex_state = 76},
  [651] = {.lex_state = 0, .external_lex_state = 76},
  [652] = {.lex_state = 0, .external_lex_state = 76},
  [653] = {.lex_state = 0, .external_lex_state = 76},
  [654] = {.lex_state = 0, .external_lex_state = 76},
  [655] = {.lex_state = 0, .external_lex_state = 76},
  [656] = {.lex_state = 0, .external_lex_state = 76},
  [657] = {.lex_state = 0, .external_lex_state = 76},
  [658] = {.lex_state = 0, .external_lex_state = 76},
  [659] = {.lex_state = 0, .external_lex_state = 76},
  [660] = {.lex_state = 0, .external_lex_state = 77},
  [661] = {.lex_state = 0, .external_lex_state = 77},
  [662] = {.lex_state = 0, .external_lex_state = 70},
  [663] = {.lex_state = 0, .external_lex_state = 77},
  [664] = {.lex_state = 0, .external_lex_state = 76},
  [665] = {.lex_state = 0, .external_lex_state = 76},
  [666] = {.lex_state = 0, .external_lex_state = 76},
  [667] = {.lex_state = 0, .external_lex_state = 76},
  [668] = {.lex_state = 0, .external_lex_state = 76},
  [669] = {.lex_state = 0, .external_lex_state = 76},
  [670] = {.lex_state = 0, .external_lex_state = 79},
  [671] = {.lex_state = 0, .external_lex_state = 79},
  [672] = {.lex_state = 0, .external_lex_state = 75},
  [673] = {.lex_state = 0, .external_lex_state = 79},
  [674] = {.lex_state = 0, .external_lex_state = 75},
  [675] = {.lex_state = 0, .external_lex_state = 79},
  [676] = {.lex_state = 0, .external_lex_state = 76},
  [677] = {.lex_state = 0, .external_lex_state = 70},
  [678] = {.lex_state = 0, .external_lex_state = 76},
  [679] = {.lex_state = 0, .external_lex_state = 70},
  [680] = {.lex_state = 0, .external_lex_state = 76},
  [681] = {.lex_state = 0, .external_lex_state = 76},
  [682] = {.lex_state = 0, .external_lex_state = 76},
  [683] = {.lex_state = 0, .external_lex_state = 70},
  [684] = {.lex_state = 0, .external_lex_state = 70},
  [685] = {.lex_state = 0, .external_lex_state = 76},
  [686] = {.lex_state = 0, .external_lex_state = 76},
  [687] = {.lex_state = 0, .external_lex_state = 76},
  [688] = {.lex_state = 0, .external_lex_state = 76},
  [689] = {.lex_state = 0, .external_lex_state = 76},
  [690] = {.lex_state = 0, .external_lex_state = 76},
  [691] = {.lex_state = 0, .external_lex_state = 76},
  [692] = {.lex_state = 0, .external_lex_state = 74},
  [693] = {.lex_state = 0, .external_lex_state = 80},
  [694] = {.lex_state = 0, .external_lex_state = 81},
  [695] = {.lex_state = 0, .external_lex_state = 75},
  [696] = {.lex_state = 0, .external_lex_state = 75},
  [697] = {.lex_state = 0, .external_lex_state = 75},
  [698] = {.lex_state = 0, .external_lex_state = 81},
  [699] = {.lex_state = 0, .external_lex_state = 75},
  [700] = {.lex_state = 0, .external_lex_state = 75},
  [701] = {.lex_state = 0, .external_lex_state = 75},
  [702] = {.lex_state = 0, .external_lex_state = 78},
  [703] = {.lex_state = 0, .external_lex_state = 78},
  [704] = {.lex_state = 0, .external_lex_state = 78},
  [705] = {.lex_state = 0, .external_lex_state = 78},
  [706] = {.lex_state = 0, .external_lex_state = 78},
  [707] = {.lex_state = 0, .external_lex_state = 78},
  [708] = {.lex_state = 0, .external_lex_state = 78},
  [709] = {.lex_state = 0, .external_lex_state = 78},
  [710] = {.lex_state = 0, .external_lex_state = 75},
  [711] = {.lex_state = 0, .external_lex_state = 78},
  [712] = {.lex_state = 0, .external_lex_state = 78},
  [713] = {.lex_state = 0, .external_lex_state = 78},
  [714] = {.lex_state = 0, .external_lex_state = 78},
  [715] = {.lex_state = 0, .external_lex_state = 78},
  [716] = {.lex_state = 0, .external_lex_state = 78},
  [717] = {.lex_state = 0, .external_lex_state = 78},
  [718] = {.lex_state = 0, .external_lex_state = 78},
  [719] = {.lex_state = 0, .external_lex_state = 78},
  [720] = {.lex_state = 0, .external_lex_state = 78},
  [721] = {.lex_state = 0, .external_lex_state = 78},
  [722] = {.lex_state = 0, .external_lex_state = 78},
  [723] = {.lex_state = 0, .external_lex_state = 75},
  [724] = {.lex_state = 0, .external_lex_state = 78},
  [725] = {.lex_state = 0, .external_lex_state = 78},
  [726] = {.lex_state = 0, .external_lex_state = 78},
  [727] = {.lex_state = 0, .external_lex_state = 78},
  [728] = {.lex_state = 0, .external_lex_state = 78},
  [729] = {.lex_state = 0, .external_lex_state = 78},
  [730] = {.lex_state = 0, .external_lex_state = 78},
  [731] = {.lex_state = 0, .external_lex_state = 78},
  [732] = {.lex_state = 0, .external_lex_state = 78},
  [733] = {.lex_state = 0, .external_lex_state = 78},
  [734] = {.lex_state = 0, .external_lex_state = 78},
  [735] = {.lex_state = 0, .external_lex_state = 78},
  [736] = {.lex_state = 0, .external_lex_state = 78},
  [737] = {.lex_state = 0, .external_lex_state = 78},
  [738] = {.lex_state = 0, .external_lex_state = 78},
  [739] = {.lex_state = 0, .external_lex_state = 78},
  [740] = {.lex_state = 0, .external_lex_state = 78},
  [741] = {.lex_state = 0, .external_lex_state = 80},
  [742] = {.lex_state = 0, .external_lex_state = 78},
  [743] = {.lex_state = 0, .external_lex_state = 78},
  [744] = {.lex_state = 0, .external_lex_state = 78},
  [745] = {.lex_state = 0, .external_lex_state = 78},
  [746] = {.lex_state = 0, .external_lex_state = 75},
  [747] = {.lex_state = 0, .external_lex_state = 75},
  [748] = {.lex_state = 0, .external_lex_state = 75},
  [749] = {.lex_state = 0, .external_lex_state = 75},
  [750] = {.lex_state = 0, .external_lex_state = 80},
  [751] = {.lex_state = 0, .external_lex_state = 80},
  [752] = {.lex_state = 0, .external_lex_state = 80},
  [753] = {.lex_state = 0, .external_lex_state = 75},
  [754] = {.lex_state = 0, .external_lex_state = 80},
  [755] = {.lex_state = 0, .external_lex_state = 80},
  [756] = {.lex_state = 0, .external_lex_state = 80},
  [757] = {.lex_state = 0, .external_lex_state = 80},
  [758] = {.lex_state = 0, .external_lex_state = 81},
  [759] = {.lex_state = 0, .external_lex_state = 80},
  [760] = {.lex_state = 0, .external_lex_state = 80},
  [761] = {.lex_state = 0, .external_lex_state = 80},
  [762] = {.lex_state = 0, .external_lex_state = 80},
  [763] = {.lex_state = 0, .external_lex_state = 80},
  [764] = {.lex_state = 0, .external_lex_state = 80},
  [765] = {.lex_state = 0, .external_lex_state = 80},
  [766] = {.lex_state = 0, .external_lex_state = 80},
  [767] = {.lex_state = 0, .external_lex_state = 80},
  [768] = {.lex_state = 0, .external_lex_state = 80},
  [769] = {.lex_state = 0, .external_lex_state = 80},
  [770] = {.lex_state = 0, .external_lex_state = 80},
  [771] = {.lex_state = 0, .external_lex_state = 80},
  [772] = {.lex_state = 0, .external_lex_state = 80},
  [773] = {.lex_state = 0, .external_lex_state = 80},
  [774] = {.lex_state = 0, .external_lex_state = 80},
  [775] = {.lex_state = 0, .external_lex_state = 80},
  [776] = {.lex_state = 0, .external_lex_state = 80},
  [777] = {.lex_state = 0, .external_lex_state = 80},
  [778] = {.lex_state = 0, .external_lex_state = 80},
  [779] = {.lex_state = 0, .external_lex_state = 80},
  [780] = {.lex_state = 0, .external_lex_state = 80},
  [781] = {.lex_state = 0, .external_lex_state = 80},
  [782] = {.lex_state = 0, .external_lex_state = 80},
  [783] = {.lex_state = 0, .external_lex_state = 78},
  [784] = {.lex_state = 0, .external_lex_state = 79},
  [785] = {.lex_state = 0, .external_lex_state = 77},
  [786] = {.lex_state = 0, .external_lex_state = 77},
  [787] = {.lex_state = 0, .external_lex_state = 79},
  [788] = {.lex_state = 0, .external_lex_state = 79},
  [789] = {.lex_state = 0, .external_lex_state = 77},
  [790] = {.lex_state = 0, .external_lex_state = 77},
  [791] = {.lex_state = 0, .external_lex_state = 77},
  [792] = {.lex_state = 0, .external_lex_state = 77},
  [793] = {.lex_state = 0, .external_lex_state = 79},
  [794] = {.lex_state = 0, .external_lex_state = 76},
  [795] = {.lex_state = 0, .external_lex_state = 77},
  [796] = {.lex_state = 0, .external_lex_state = 79},
  [797] = {.lex_state = 0, .external_lex_state = 79},
  [798] = {.lex_state = 0, .external_lex_state = 79},
  [799] = {.lex_state = 0, .external_lex_state = 77},
  [800] = {.lex_state = 0, .external_lex_state = 77},
  [801] = {.lex_state = 0, .external_lex_state = 79},
  [802] = {.lex_state = 0, .external_lex_state = 79},
  [803] = {.lex_state = 0, .external_lex_state = 79},
  [804] = {.lex_state = 0, .external_lex_state = 77},
  [805] = {.lex_state = 0, .external_lex_state = 82},
  [806] = {.lex_state = 0, .external_lex_state = 77},
  [807] = {.lex_state = 0, .external_lex_state = 77},
  [808] = {.lex_state = 0, .external_lex_state = 77},
  [809] = {.lex_state = 0, .external_lex_state = 77},
  [810] = {.lex_state = 0, .external_lex_state = 77},
  [811] = {.lex_state = 0, .external_lex_state = 79},
  [812] = {.lex_state = 0, .external_lex_state = 79},
  [813] = {.lex_state = 0, .external_lex_state = 79},
  [814] = {.lex_state = 0, .external_lex_state = 79},
  [815] = {.lex_state = 0, .external_lex_state = 79},
  [816] = {.lex_state = 0, .external_lex_state = 77},
  [817] = {.lex_state = 0, .external_lex_state = 77},
  [818] = {.lex_state = 0, .external_lex_state = 77},
  [819] = {.lex_state = 0, .external_lex_state = 77},
  [820] = {.lex_state = 0, .external_lex_state = 77},
  [821] = {.lex_state = 0, .external_lex_state = 77},
  [822] = {.lex_state = 0, .external_lex_state = 77},
  [823] = {.lex_state = 0, .external_lex_state = 77},
  [824] = {.lex_state = 0, .external_lex_state = 77},
  [825] = {.lex_state = 0, .external_lex_state = 77},
  [826] = {.lex_state = 0, .external_lex_state = 79},
  [827] = {.lex_state = 0, .external_lex_state = 77},
  [828] = {.lex_state = 0, .external_lex_state = 77},
  [829] = {.lex_state = 0, .external_lex_state = 77},
  [830] = {.lex_state = 0, .external_lex_state = 77},
  [831] = {.lex_state = 0, .external_lex_state = 77},
  [832] = {.lex_state = 0, .external_lex_state = 77},
  [833] = {.lex_state = 0, .external_lex_state = 77},
  [834] = {.lex_state = 0, .external_lex_state = 77},
  [835] = {.lex_state = 0, .external_lex_state = 77},
  [836] = {.lex_state = 0, .external_lex_state = 77},
  [837] = {.lex_state = 0, .external_lex_state = 77},
  [838] = {.lex_state = 0, .external_lex_state = 77},
  [839] = {.lex_state = 0, .external_lex_state = 79},
  [840] = {.lex_state = 0, .external_lex_state = 79},
  [841] = {.lex_state = 0, .external_lex_state = 79},
  [842] = {.lex_state = 0, .external_lex_state = 77},
  [843] = {.lex_state = 0, .external_lex_state = 77},
  [844] = {.lex_state = 0, .external_lex_state = 77},
  [845] = {.lex_state = 0, .external_lex_state = 77},
  [846] = {.lex_state = 0, .external_lex_state = 77},
  [847] = {.lex_state = 0, .external_lex_state = 77},
  [848] = {.lex_state = 0, .external_lex_state = 77},
  [849] = {.lex_state = 0, .external_lex_state = 77},
  [850] = {.lex_state = 0, .external_lex_state = 77},
  [851] = {.lex_state = 0, .external_lex_state = 77},
  [852] = {.lex_state = 0, .external_lex_state = 77},
  [853] = {.lex_state = 0, .external_lex_state = 77},
  [854] = {.lex_state = 0, .external_lex_state = 77},
  [855] = {.lex_state = 0, .external_lex_state = 77},
  [856] = {.lex_state = 0, .external_lex_state = 77},
  [857] = {.lex_state = 0, .external_lex_state = 77},
  [858] = {.lex_state = 0, .external_lex_state = 77},
  [859] = {.lex_state = 0, .external_lex_state = 77},
  [860] = {.lex_state = 0, .external_lex_state = 77},
  [861] = {.lex_state = 0, .external_lex_state = 77},
  [862] = {.lex_state = 0, .external_lex_state = 77},
  [863] = {.lex_state = 0, .external_lex_state = 77},
  [864] = {.lex_state = 0, .external_lex_state = 79},
  [865] = {.lex_state = 0, .external_lex_state = 79},
  [866] = {.lex_state = 0, .external_lex_state = 79},
  [867] = {.lex_state = 0, .external_lex_state = 79},
  [868] = {.lex_state = 0, .external_lex_state = 79},
  [869] = {.lex_state = 0, .external_lex_state = 79},
  [870] = {.lex_state = 0, .external_lex_state = 79},
  [871] = {.lex_state = 0, .external_lex_state = 79},
  [872] = {.lex_state = 0, .external_lex_state = 79},
  [873] = {.lex_state = 0, .external_lex_state = 77},
  [874] = {.lex_state = 0, .external_lex_state = 77},
  [875] = {.lex_state = 0, .external_lex_state = 79},
  [876] = {.lex_state = 0, .external_lex_state = 79},
  [877] = {.lex_state = 0, .external_lex_state = 79},
  [878] = {.lex_state = 0, .external_lex_state = 79},
  [879] = {.lex_state = 0, .external_lex_state = 79},
  [880] = {.lex_state = 0, .external_lex_state = 79},
  [881] = {.lex_state = 0, .external_lex_state = 79},
  [882] = {.lex_state = 0, .external_lex_state = 79},
  [883] = {.lex_state = 0, .external_lex_state = 79},
  [884] = {.lex_state = 0, .external_lex_state = 79},
  [885] = {.lex_state = 0, .external_lex_state = 79},
  [886] = {.lex_state = 0, .external_lex_state = 79},
  [887] = {.lex_state = 0, .external_lex_state = 79},
  [888] = {.lex_state = 0, .external_lex_state = 79},
  [889] = {.lex_state = 0, .external_lex_state = 76},
  [890] = {.lex_state = 0, .external_lex_state = 77},
  [891] = {.lex_state = 0, .external_lex_state = 77},
  [892] = {.lex_state = 0, .external_lex_state = 79},
  [893] = {.lex_state = 0, .external_lex_state = 79},
  [894] = {.lex_state = 0, .external_lex_state = 79},
  [895] = {.lex_state = 0, .external_lex_state = 79},
  [896] = {.lex_state = 0, .external_lex_state = 79},
  [897] = {.lex_state = 0, .external_lex_state = 79},
  [898] = {.lex_state = 0, .external_lex_state = 79},
  [899] = {.lex_state = 0, .external_lex_state = 79},
  [900] = {.lex_state = 0, .external_lex_state = 79},
  [901] = {.lex_state = 0, .external_lex_state = 79},
  [902] = {.lex_state = 0, .external_lex_state = 79},
  [903] = {.lex_state = 0, .external_lex_state = 79},
  [904] = {.lex_state = 0, .external_lex_state = 79},
  [905] = {.lex_state = 0, .external_lex_state = 79},
  [906] = {.lex_state = 0, .external_lex_state = 79},
  [907] = {.lex_state = 0, .external_lex_state = 79},
  [908] = {.lex_state = 0, .external_lex_state = 79},
  [909] = {.lex_state = 0, .external_lex_state = 79},
  [910] = {.lex_state = 0, .external_lex_state = 79},
  [911] = {.lex_state = 0, .external_lex_state = 79},
  [912] = {.lex_state = 0, .external_lex_state = 79},
  [913] = {.lex_state = 0, .external_lex_state = 79},
  [914] = {.lex_state = 0, .external_lex_state = 79},
  [915] = {.lex_state = 0, .external_lex_state = 79},
  [916] = {.lex_state = 0, .external_lex_state = 79},
  [917] = {.lex_state = 0, .external_lex_state = 83},
  [918] = {.lex_state = 0, .external_lex_state = 83},
  [919] = {.lex_state = 0, .external_lex_state = 77},
  [920] = {.lex_state = 0, .external_lex_state = 77},
  [921] = {.lex_state = 0, .external_lex_state = 77},
  [922] = {.lex_state = 0, .external_lex_state = 77},
  [923] = {.lex_state = 0, .external_lex_state = 77},
  [924] = {.lex_state = 0, .external_lex_state = 79},
  [925] = {.lex_state = 0, .external_lex_state = 79},
  [926] = {.lex_state = 0, .external_lex_state = 79},
  [927] = {.lex_state = 0, .external_lex_state = 79},
  [928] = {.lex_state = 0, .external_lex_state = 82},
  [929] = {.lex_state = 0, .external_lex_state = 79},
  [930] = {.lex_state = 0, .external_lex_state = 77},
  [931] = {.lex_state = 0, .external_lex_state = 79},
  [932] = {.lex_state = 0, .external_lex_state = 79},
  [933] = {.lex_state = 0, .external_lex_state = 79},
  [934] = {.lex_state = 0, .external_lex_state = 79},
  [935] = {.lex_state = 0, .external_lex_state = 79},
  [936] = {.lex_state = 0, .external_lex_state = 79},
  [937] = {.lex_state = 0, .external_lex_state = 79},
  [938] = {.lex_state = 0, .external_lex_state = 79},
  [939] = {.lex_state = 0, .external_lex_state = 83},
  [940] = {.lex_state = 0, .external_lex_state = 79},
  [941] = {.lex_state = 0, .external_lex_state = 79},
  [942] = {.lex_state = 0, .external_lex_state = 77},
  [943] = {.lex_state = 0, .external_lex_state = 79},
  [944] = {.lex_state = 0, .external_lex_state = 77},
  [945] = {.lex_state = 0, .external_lex_state = 77},
  [946] = {.lex_state = 0, .external_lex_state = 77},
  [947] = {.lex_state = 0, .external_lex_state = 77},
  [948] = {.lex_state = 0, .external_lex_state = 77},
  [949] = {.lex_state = 0, .external_lex_state = 77},
  [950] = {.lex_state = 0, .external_lex_state = 77},
  [951] = {.lex_state = 0, .external_lex_state = 79},
  [952] = {.lex_state = 0, .external_lex_state = 77},
  [953] = {.lex_state = 0, .external_lex_state = 77},
  [954] = {.lex_state = 0, .external_lex_state = 77},
  [955] = {.lex_state = 0, .external_lex_state = 77},
  [956] = {.lex_state = 0, .external_lex_state = 79},
  [957] = {.lex_state = 0, .external_lex_state = 77},
  [958] = {.lex_state = 0, .external_lex_state = 77},
  [959] = {.lex_state = 0, .external_lex_state = 77},
  [960] = {.lex_state = 0, .external_lex_state = 77},
  [961] = {.lex_state = 0, .external_lex_state = 79},
  [962] = {.lex_state = 0, .external_lex_state = 79},
  [963] = {.lex_state = 0, .external_lex_state = 84},
  [964] = {.lex_state = 0, .external_lex_state = 85},
  [965] = {.lex_state = 0, .external_lex_state = 86},
  [966] = {.lex_state = 0, .external_lex_state = 86},
  [967] = {.lex_state = 0, .external_lex_state = 87},
  [968] = {.lex_state = 0, .external_lex_state = 71},
  [969] = {.lex_state = 0, .external_lex_state = 87},
  [970] = {.lex_state = 0, .external_lex_state = 88},
  [971] = {.lex_state = 0, .external_lex_state = 88},
  [972] = {.lex_state = 0, .external_lex_state = 89},
  [973] = {.lex_state = 0, .external_lex_state = 86},
  [974] = {.lex_state = 0, .external_lex_state = 86},
  [975] = {.lex_state = 0, .external_lex_state = 89},
  [976] = {.lex_state = 0, .external_lex_state = 90},
  [977] = {.lex_state = 0, .external_lex_state = 88},
  [978] = {.lex_state = 0, .external_lex_state = 89},
  [979] = {.lex_state = 0, .external_lex_state = 86},
  [980] = {.lex_state = 0, .external_lex_state = 82},
  [981] = {.lex_state = 0, .external_lex_state = 82},
  [982] = {.lex_state = 0, .external_lex_state = 88},
  [983] = {.lex_state = 0, .external_lex_state = 89},
  [984] = {.lex_state = 0, .external_lex_state = 82},
  [985] = {.lex_state = 0, .external_lex_state = 83},
  [986] = {.lex_state = 0, .external_lex_state = 84},
  [987] = {.lex_state = 0, .external_lex_state = 83},
  [988] = {.lex_state = 0, .external_lex_state = 83},
  [989] = {.lex_state = 0, .external_lex_state = 83},
  [990] = {.lex_state = 0, .external_lex_state = 83},
  [991] = {.lex_state = 0, .external_lex_state = 82},
  [992] = {.lex_state = 0, .external_lex_state = 88},
  [993] = {.lex_state = 0, .external_lex_state = 88},
  [994] = {.lex_state = 0, .external_lex_state = 89},
  [995] = {.lex_state = 0, .external_lex_state = 86},
  [996] = {.lex_state = 0, .external_lex_state = 83},
  [997] = {.lex_state = 0, .external_lex_state = 83},
  [998] = {.lex_state = 0, .external_lex_state = 86},
  [999] = {.lex_state = 0, .external_lex_state = 83},
  [1000] = {.lex_state = 0, .external_lex_state = 83},
  [1001] = {.lex_state = 0, .external_lex_state = 83},
  [1002] = {.lex_state = 0, .external_lex_state = 86},
  [1003] = {.lex_state = 0, .external_lex_state = 86},
  [1004] = {.lex_state = 0, .external_lex_state = 86},
  [1005] = {.lex_state = 0, .external_lex_state = 83},
  [1006] = {.lex_state = 0, .external_lex_state = 88},
  [1007] = {.lex_state = 0, .external_lex_state = 89},
  [1008] = {.lex_state = 0, .external_lex_state = 83},
  [1009] = {.lex_state = 0, .external_lex_state = 91},
  [1010] = {.lex_state = 0, .external_lex_state = 88},
  [1011] = {.lex_state = 0, .external_lex_state = 89},
  [1012] = {.lex_state = 0, .external_lex_state = 85},
  [1013] = {.lex_state = 0, .external_lex_state = 89},
  [1014] = {.lex_state = 0, .external_lex_state = 88},
  [1015] = {.lex_state = 0, .external_lex_state = 71},
  [1016] = {.lex_state = 0, .external_lex_state = 84},
  [1017] = {.lex_state = 0, .external_lex_state = 88},
  [1018] = {.lex_state = 0, .external_lex_state = 91},
  [1019] = {.lex_state = 0, .external_lex_state = 89},
  [1020] = {.lex_state = 0, .external_lex_state = 88},
  [1021] = {.lex_state = 0, .external_lex_state = 89},
  [1022] = {.lex_state = 0, .external_lex_state = 86},
  [1023] = {.lex_state = 0, .external_lex_state = 88},
  [1024] = {.lex_state = 0, .external_lex_state = 89},
  [1025] = {.lex_state = 0, .external_lex_state = 92},
  [1026] = {.lex_state = 0, .external_lex_state = 86},
  [1027] = {.lex_state = 0, .external_lex_state = 88},
  [1028] = {.lex_state = 0, .external_lex_state = 89},
  [1029] = {.lex_state = 0, .external_lex_state = 89},
  [1030] = {.lex_state = 0, .external_lex_state = 83},
  [1031] = {.lex_state = 0, .external_lex_state = 91},
  [1032] = {.lex_state = 0, .external_lex_state = 88},
  [1033] = {.lex_state = 0, .external_lex_state = 89},
  [1034] = {.lex_state = 0, .external_lex_state = 85},
  [1035] = {.lex_state = 0, .external_lex_state = 91},
  [1036] = {.lex_state = 0, .external_lex_state = 83},
  [1037] = {.lex_state = 0, .external_lex_state = 83},
  [1038] = {.lex_state = 0, .external_lex_state = 93},
  [1039] = {.lex_state = 0, .external_lex_state = 83},
  [1040] = {.lex_state = 0, .external_lex_state = 83},
  [1041] = {.lex_state = 0, .external_lex_state = 86},
  [1042] = {.lex_state = 0, .external_lex_state = 88},
  [1043] = {.lex_state = 0, .external_lex_state = 89},
  [1044] = {.lex_state = 0, .external_lex_state = 83},
  [1045] = {.lex_state = 0, .external_lex_state = 94},
  [1046] = {.lex_state = 0, .external_lex_state = 83},
  [1047] = {.lex_state = 0, .external_lex_state = 83},
  [1048] = {.lex_state = 0, .external_lex_state = 86},
  [1049] = {.lex_state = 0, .external_lex_state = 72},
  [1050] = {.lex_state = 0, .external_lex_state = 94},
  [1051] = {.lex_state = 0, .external_lex_state = 94},
  [1052] = {.lex_state = 0, .external_lex_state = 94},
  [1053] = {.lex_state = 0, .external_lex_state = 94},
  [1054] = {.lex_state = 0, .external_lex_state = 94},
  [1055] = {.lex_state = 0, .external_lex_state = 72},
  [1056] = {.lex_state = 0, .external_lex_state = 95},
  [1057] = {.lex_state = 0, .external_lex_state = 72},
  [1058] = {.lex_state = 0, .external_lex_state = 96},
  [1059] = {.lex_state = 0, .external_lex_state = 93},
  [1060] = {.lex_state = 0, .external_lex_state = 72},
  [1061] = {.lex_state = 0, .external_lex_state = 94},
  [1062] = {.lex_state = 0, .external_lex_state = 94},
  [1063] = {.lex_state = 0, .external_lex_state = 72},
  [1064] = {.lex_state = 0, .external_lex_state = 94},
  [1065] = {.lex_state = 0, .external_lex_state = 72},
  [1066] = {.lex_state = 0, .external_lex_state = 95},
  [1067] = {.lex_state = 0, .external_lex_state = 94},
  [1068] = {.lex_state = 0, .external_lex_state = 94},
  [1069] = {.lex_state = 0, .external_lex_state = 72},
  [1070] = {.lex_state = 0, .external_lex_state = 72},
  [1071] = {.lex_state = 0, .external_lex_state = 72},
  [1072] = {.lex_state = 0, .external_lex_state = 94},
  [1073] = {.lex_state = 0, .external_lex_state = 72},
  [1074] = {.lex_state = 0, .external_lex_state = 94},
  [1075] = {.lex_state = 0, .external_lex_state = 72},
  [1076] = {.lex_state = 0, .external_lex_state = 72},
  [1077] = {.lex_state = 0, .external_lex_state = 90},
  [1078] = {.lex_state = 0, .external_lex_state = 95},
  [1079] = {.lex_state = 0, .external_lex_state = 87},
  [1080] = {.lex_state = 0, .external_lex_state = 72},
  [1081] = {.lex_state = 0, .external_lex_state = 95},
  [1082] = {.lex_state = 0, .external_lex_state = 72},
  [1083] = {.lex_state = 0, .external_lex_state = 72},
  [1084] = {.lex_state = 0, .external_lex_state = 90},
  [1085] = {.lex_state = 0, .external_lex_state = 72},
  [1086] = {.lex_state = 0, .external_lex_state = 72},
  [1087] = {.lex_state = 0, .external_lex_state = 72},
  [1088] = {.lex_state = 0, .external_lex_state = 72},
  [1089] = {.lex_state = 0, .external_lex_state = 95},
  [1090] = {.lex_state = 0, .external_lex_state = 72},
  [1091] = {.lex_state = 0, .external_lex_state = 72},
  [1092] = {.lex_state = 0, .external_lex_state = 72},
  [1093] = {.lex_state = 0, .external_lex_state = 72},
  [1094] = {.lex_state = 0, .external_lex_state = 72},
  [1095] = {.lex_state = 0, .external_lex_state = 72},
  [1096] = {.lex_state = 0, .external_lex_state = 72},
  [1097] = {.lex_state = 0, .external_lex_state = 90},
  [1098] = {.lex_state = 0, .external_lex_state = 72},
  [1099] = {.lex_state = 0, .external_lex_state = 90},
  [1100] = {.lex_state = 0, .external_lex_state = 93},
  [1101] = {.lex_state = 0, .external_lex_state = 93},
  [1102] = {.lex_state = 0, .external_lex_state = 72},
  [1103] = {.lex_state = 0, .external_lex_state = 72},
  [1104] = {.lex_state = 0, .external_lex_state = 72},
  [1105] = {.lex_state = 0, .external_lex_state = 72},
  [1106] = {.lex_state = 0, .external_lex_state = 72},
  [1107] = {.lex_state = 0, .external_lex_state = 87},
  [1108] = {.lex_state = 0, .external_lex_state = 72},
  [1109] = {.lex_state = 0, .external_lex_state = 72},
  [1110] = {.lex_state = 0, .external_lex_state = 92},
  [1111] = {.lex_state = 0, .external_lex_state = 95},
  [1112] = {.lex_state = 0, .external_lex_state = 95},
  [1113] = {.lex_state = 0, .external_lex_state = 92},
  [1114] = {.lex_state = 0, .external_lex_state = 92},
  [1115] = {.lex_state = 0, .external_lex_state = 72},
  [1116] = {.lex_state = 0, .external_lex_state = 92},
  [1117] = {.lex_state = 0, .external_lex_state = 87},
  [1118] = {.lex_state = 0, .external_lex_state = 87},
  [1119] = {.lex_state = 0, .external_lex_state = 72},
  [1120] = {.lex_state = 0, .external_lex_state = 95},
  [1121] = {.lex_state = 0, .external_lex_state = 95},
  [1122] = {.lex_state = 0, .external_lex_state = 87},
  [1123] = {.lex_state = 0, .external_lex_state = 72},
  [1124] = {.lex_state = 0, .external_lex_state = 96},
  [1125] = {.lex_state = 0, .external_lex_state = 97},
  [1126] = {.lex_state = 0, .external_lex_state = 72},
  [1127] = {.lex_state = 0, .external_lex_state = 72},
  [1128] = {.lex_state = 0, .external_lex_state = 87},
  [1129] = {.lex_state = 0, .external_lex_state = 72},
  [1130] = {.lex_state = 0, .external_lex_state = 72},
  [1131] = {.lex_state = 0, .external_lex_state = 72},
  [1132] = {.lex_state = 0, .external_lex_state = 90},
  [1133] = {.lex_state = 0, .external_lex_state = 72},
  [1134] = {.lex_state = 0, .external_lex_state = 72},
  [1135] = {.lex_state = 0, .external_lex_state = 72},
  [1136] = {.lex_state = 0, .external_lex_state = 72},
  [1137] = {.lex_state = 0, .external_lex_state = 87},
  [1138] = {.lex_state = 0, .external_lex_state = 97},
  [1139] = {.lex_state = 0, .external_lex_state = 92},
  [1140] = {.lex_state = 0, .external_lex_state = 95},
  [1141] = {.lex_state = 0, .external_lex_state = 95},
  [1142] = {.lex_state = 0, .external_lex_state = 72},
  [1143] = {.lex_state = 0, .external_lex_state = 72},
  [1144] = {.lex_state = 0, .external_lex_state = 87},
  [1145] = {.lex_state = 0, .external_lex_state = 92},
  [1146] = {.lex_state = 0, .external_lex_state = 87},
  [1147] = {.lex_state = 0, .external_lex_state = 95},
  [1148] = {.lex_state = 0, .external_lex_state = 95},
  [1149] = {.lex_state = 0, .external_lex_state = 87},
  [1150] = {.lex_state = 0, .external_lex_state = 87},
  [1151] = {.lex_state = 0, .external_lex_state = 96},
  [1152] = {.lex_state = 0, .external_lex_state = 97},
  [1153] = {.lex_state = 0, .external_lex_state = 87},
  [1154] = {.lex_state = 0, .external_lex_state = 72},
  [1155] = {.lex_state = 0, .external_lex_state = 72},
  [1156] = {.lex_state = 0, .external_lex_state = 72},
  [1157] = {.lex_state = 0, .external_lex_state = 72},
  [1158] = {.lex_state = 0, .external_lex_state = 87},
  [1159] = {.lex_state = 0, .external_lex_state = 87},
  [1160] = {.lex_state = 0, .external_lex_state = 87},
  [1161] = {.lex_state = 0, .external_lex_state = 92},
  [1162] = {.lex_state = 0, .external_lex_state = 92},
  [1163] = {.lex_state = 0, .external_lex_state = 92},
  [1164] = {.lex_state = 0, .external_lex_state = 92},
  [1165] = {.lex_state = 0, .external_lex_state = 96},
  [1166] = {.lex_state = 0, .external_lex_state = 97},
  [1167] = {.lex_state = 0, .external_lex_state = 72},
  [1168] = {.lex_state = 0, .external_lex_state = 72},
  [1169] = {.lex_state = 0, .external_lex_state = 72},
  [1170] = {.lex_state = 0, .external_lex_state = 72},
  [1171] = {.lex_state = 0, .external_lex_state = 93},
  [1172] = {.lex_state = 0, .external_lex_state = 96},
  [1173] = {.lex_state = 0, .external_lex_state = 97},
  [1174] = {.lex_state = 0, .external_lex_state = 92},
  [1175] = {.lex_state = 0, .external_lex_state = 72},
  [1176] = {.lex_state = 0, .external_lex_state = 72},
  [1177] = {.lex_state = 0, .external_lex_state = 72},
  [1178] = {.lex_state = 0, .external_lex_state = 92},
  [1179] = {.lex_state = 0, .external_lex_state = 87},
  [1180] = {.lex_state = 0, .external_lex_state = 87},
  [1181] = {.lex_state = 0, .external_lex_state = 87},
  [1182] = {.lex_state = 0, .external_lex_state = 96},
  [1183] = {.lex_state = 0, .external_lex_state = 97},
  [1184] = {.lex_state = 0, .external_lex_state = 87},
  [1185] = {.lex_state = 0, .external_lex_state = 72},
  [1186] = {.lex_state = 0, .external_lex_state = 72},
  [1187] = {.lex_state = 0, .external_lex_state = 93},
  [1188] = {.lex_state = 0, .external_lex_state = 72},
  [1189] = {.lex_state = 0, .external_lex_state = 92},
  [1190] = {.lex_state = 0, .external_lex_state = 92},
  [1191] = {.lex_state = 0, .external_lex_state = 72},
  [1192] = {.lex_state = 0, .external_lex_state = 72},
  [1193] = {.lex_state = 0, .external_lex_state = 96},
  [1194] = {.lex_state = 0, .external_lex_state = 97},
  [1195] = {.lex_state = 0, .external_lex_state = 92},
  [1196] = {.lex_state = 0, .external_lex_state = 92},
  [1197] = {.lex_state = 0, .external_lex_state = 72},
  [1198] = {.lex_state = 0, .external_lex_state = 87},
  [1199] = {.lex_state = 0, .external_lex_state = 72},
  [1200] = {.lex_state = 0, .external_lex_state = 72},
  [1201] = {.lex_state = 0, .external_lex_state = 72},
  [1202] = {.lex_state = 0, .external_lex_state = 72},
  [1203] = {.lex_state = 0, .external_lex_state = 72},
  [1204] = {.lex_state = 0, .external_lex_state = 72},
  [1205] = {.lex_state = 0, .external_lex_state = 72},
  [1206] = {.lex_state = 0, .external_lex_state = 72},
  [1207] = {.lex_state = 0, .external_lex_state = 72},
  [1208] = {.lex_state = 0, .external_lex_state = 72},
  [1209] = {.lex_state = 0, .external_lex_state = 94},
  [1210] = {.lex_state = 0, .external_lex_state = 94},
  [1211] = {.lex_state = 0, .external_lex_state = 96},
  [1212] = {.lex_state = 0, .external_lex_state = 97},
  [1213] = {.lex_state = 0, .external_lex_state = 94},
  [1214] = {.lex_state = 0, .external_lex_state = 94},
  [1215] = {.lex_state = 0, .external_lex_state = 72},
  [1216] = {.lex_state = 0, .external_lex_state = 82},
  [1217] = {.lex_state = 0, .external_lex_state = 86},
  [1218] = {.lex_state = 0, .external_lex_state = 86},
  [1219] = {.lex_state = 0, .external_lex_state = 84},
  [1220] = {.lex_state = 0, .external_lex_state = 86},
  [1221] = {.lex_state = 0, .external_lex_state = 86},
  [1222] = {.lex_state = 0, .external_lex_state = 82},
  [1223] = {.lex_state = 0, .external_lex_state = 84},
  [1224] = {.lex_state = 0, .external_lex_state = 84},
  [1225] = {.lex_state = 0, .external_lex_state = 84},
  [1226] = {.lex_state = 0, .external_lex_state = 84},
  [1227] = {.lex_state = 0, .external_lex_state = 98},
  [1228] = {.lex_state = 0, .external_lex_state = 84},
  [1229] = {.lex_state = 0, .external_lex_state = 86},
  [1230] = {.lex_state = 0, .external_lex_state = 86},
  [1231] = {.lex_state = 0, .external_lex_state = 84},
  [1232] = {.lex_state = 0, .external_lex_state = 84},
  [1233] = {.lex_state = 0, .external_lex_state = 84},
  [1234] = {.lex_state = 0, .external_lex_state = 84},
  [1235] = {.lex_state = 0, .external_lex_state = 84},
  [1236] = {.lex_state = 0, .external_lex_state = 85},
  [1237] = {.lex_state = 0, .external_lex_state = 98},
  [1238] = {.lex_state = 0, .external_lex_state = 84},
  [1239] = {.lex_state = 0, .external_lex_state = 99},
  [1240] = {.lex_state = 0, .external_lex_state = 84},
  [1241] = {.lex_state = 0, .external_lex_state = 84},
  [1242] = {.lex_state = 0, .external_lex_state = 100},
  [1243] = {.lex_state = 0, .external_lex_state = 82},
  [1244] = {.lex_state = 0, .external_lex_state = 100},
  [1245] = {.lex_state = 0, .external_lex_state = 84},
  [1246] = {.lex_state = 0, .external_lex_state = 82},
  [1247] = {.lex_state = 0, .external_lex_state = 86},
  [1248] = {.lex_state = 0, .external_lex_state = 82},
  [1249] = {.lex_state = 0, .external_lex_state = 84},
  [1250] = {.lex_state = 0, .external_lex_state = 85},
  [1251] = {.lex_state = 0, .external_lex_state = 85},
  [1252] = {.lex_state = 0, .external_lex_state = 85},
  [1253] = {.lex_state = 0, .external_lex_state = 84},
  [1254] = {.lex_state = 0, .external_lex_state = 82},
  [1255] = {.lex_state = 0, .external_lex_state = 84},
  [1256] = {.lex_state = 0, .external_lex_state = 86},
  [1257] = {.lex_state = 0, .external_lex_state = 84},
  [1258] = {.lex_state = 0, .external_lex_state = 86},
  [1259] = {.lex_state = 0, .external_lex_state = 86},
  [1260] = {.lex_state = 0, .external_lex_state = 86},
  [1261] = {.lex_state = 0, .external_lex_state = 86},
  [1262] = {.lex_state = 0, .external_lex_state = 82},
  [1263] = {.lex_state = 0, .external_lex_state = 82},
  [1264] = {.lex_state = 0, .external_lex_state = 84},
  [1265] = {.lex_state = 0, .external_lex_state = 86},
  [1266] = {.lex_state = 0, .external_lex_state = 86},
  [1267] = {.lex_state = 0, .external_lex_state = 86},
  [1268] = {.lex_state = 0, .external_lex_state = 86},
  [1269] = {.lex_state = 0, .external_lex_state = 84},
  [1270] = {.lex_state = 0, .external_lex_state = 84},
  [1271] = {.lex_state = 0, .external_lex_state = 84},
  [1272] = {.lex_state = 0, .external_lex_state = 82},
  [1273] = {.lex_state = 0, .external_lex_state = 86},
  [1274] = {.lex_state = 0, .external_lex_state = 86},
  [1275] = {.lex_state = 0, .external_lex_state = 86},
  [1276] = {.lex_state = 0, .external_lex_state = 86},
  [1277] = {.lex_state = 0, .external_lex_state = 86},
  [1278] = {.lex_state = 0, .external_lex_state = 86},
  [1279] = {.lex_state = 0, .external_lex_state = 86},
  [1280] = {.lex_state = 0, .external_lex_state = 86},
  [1281] = {.lex_state = 0, .external_lex_state = 86},
  [1282] = {.lex_state = 0, .external_lex_state = 91},
  [1283] = {.lex_state = 0, .external_lex_state = 91},
  [1284] = {.lex_state = 0, .external_lex_state = 86},
  [1285] = {.lex_state = 0, .external_lex_state = 86},
  [1286] = {.lex_state = 0, .external_lex_state = 86},
  [1287] = {.lex_state = 0, .external_lex_state = 86},
  [1288] = {.lex_state = 0, .external_lex_state = 86},
  [1289] = {.lex_state = 0, .external_lex_state = 86},
  [1290] = {.lex_state = 0, .external_lex_state = 86},
  [1291] = {.lex_state = 0, .external_lex_state = 86},
  [1292] = {.lex_state = 0, .external_lex_state = 84},
  [1293] = {.lex_state = 0, .external_lex_state = 84},
  [1294] = {.lex_state = 0, .external_lex_state = 86},
  [1295] = {.lex_state = 0, .external_lex_state = 86},
  [1296] = {.lex_state = 0, .external_lex_state = 86},
  [1297] = {.lex_state = 0, .external_lex_state = 86},
  [1298] = {.lex_state = 0, .external_lex_state = 85},
  [1299] = {.lex_state = 0, .external_lex_state = 98},
  [1300] = {.lex_state = 0, .external_lex_state = 86},
  [1301] = {.lex_state = 0, .external_lex_state = 85},
  [1302] = {.lex_state = 0, .external_lex_state = 91},
  [1303] = {.lex_state = 0, .external_lex_state = 86},
  [1304] = {.lex_state = 0, .external_lex_state = 91},
  [1305] = {.lex_state = 0, .external_lex_state = 85},
  [1306] = {.lex_state = 0, .external_lex_state = 91},
  [1307] = {.lex_state = 0, .external_lex_state = 91},
  [1308] = {.lex_state = 0, .external_lex_state = 85},
  [1309] = {.lex_state = 0, .external_lex_state = 91},
  [1310] = {.lex_state = 0, .external_lex_state = 91},
  [1311] = {.lex_state = 0, .external_lex_state = 85},
  [1312] = {.lex_state = 0, .external_lex_state = 85},
  [1313] = {.lex_state = 0, .external_lex_state = 86},
  [1314] = {.lex_state = 0, .external_lex_state = 91},
  [1315] = {.lex_state = 0, .external_lex_state = 82},
  [1316] = {.lex_state = 0, .external_lex_state = 91},
  [1317] = {.lex_state = 0, .external_lex_state = 85},
  [1318] = {.lex_state = 0, .external_lex_state = 91},
  [1319] = {.lex_state = 0, .external_lex_state = 85},
  [1320] = {.lex_state = 0, .external_lex_state = 91},
  [1321] = {.lex_state = 0, .external_lex_state = 91},
  [1322] = {.lex_state = 0, .external_lex_state = 85},
  [1323] = {.lex_state = 0, .external_lex_state = 91},
  [1324] = {.lex_state = 0, .external_lex_state = 91},
  [1325] = {.lex_state = 0, .external_lex_state = 91},
  [1326] = {.lex_state = 0, .external_lex_state = 84},
  [1327] = {.lex_state = 0, .external_lex_state = 84},
  [1328] = {.lex_state = 0, .external_lex_state = 91},
  [1329] = {.lex_state = 0, .external_lex_state = 91},
  [1330] = {.lex_state = 0, .external_lex_state = 91},
  [1331] = {.lex_state = 0, .external_lex_state = 91},
  [1332] = {.lex_state = 0, .external_lex_state = 85},
  [1333] = {.lex_state = 0, .external_lex_state = 86},
  [1334] = {.lex_state = 0, .external_lex_state = 91},
  [1335] = {.lex_state = 0, .external_lex_state = 84},
  [1336] = {.lex_state = 0, .external_lex_state = 85},
  [1337] = {.lex_state = 0, .external_lex_state = 85},
  [1338] = {.lex_state = 0, .external_lex_state = 91},
  [1339] = {.lex_state = 0, .external_lex_state = 91},
  [1340] = {.lex_state = 0, .external_lex_state = 91},
  [1341] = {.lex_state = 0, .external_lex_state = 91},
  [1342] = {.lex_state = 0, .external_lex_state = 91},
  [1343] = {.lex_state = 0, .external_lex_state = 91},
  [1344] = {.lex_state = 0, .external_lex_state = 86},
  [1345] = {.lex_state = 0, .external_lex_state = 82},
  [1346] = {.lex_state = 0, .external_lex_state = 91},
  [1347] = {.lex_state = 0, .external_lex_state = 86},
  [1348] = {.lex_state = 0, .external_lex_state = 84},
  [1349] = {.lex_state = 0, .external_lex_state = 91},
  [1350] = {.lex_state = 0, .external_lex_state = 86},
  [1351] = {.lex_state = 0, .external_lex_state = 86},
  [1352] = {.lex_state = 0, .external_lex_state = 84},
  [1353] = {.lex_state = 0, .external_lex_state = 85},
  [1354] = {.lex_state = 0, .external_lex_state = 85},
  [1355] = {.lex_state = 0, .external_lex_state = 86},
  [1356] = {.lex_state = 0, .external_lex_state = 85},
  [1357] = {.lex_state = 0, .external_lex_state = 85},
  [1358] = {.lex_state = 0, .external_lex_state = 85},
  [1359] = {.lex_state = 0, .external_lex_state = 99},
  [1360] = {.lex_state = 0, .external_lex_state = 85},
  [1361] = {.lex_state = 0, .external_lex_state = 91},
  [1362] = {.lex_state = 0, .external_lex_state = 86},
  [1363] = {.lex_state = 0, .external_lex_state = 86},
  [1364] = {.lex_state = 0, .external_lex_state = 86},
  [1365] = {.lex_state = 0, .external_lex_state = 86},
  [1366] = {.lex_state = 0, .external_lex_state = 85},
  [1367] = {.lex_state = 0, .external_lex_state = 91},
  [1368] = {.lex_state = 0, .external_lex_state = 85},
  [1369] = {.lex_state = 0, .external_lex_state = 91},
  [1370] = {.lex_state = 0, .external_lex_state = 91},
  [1371] = {.lex_state = 0, .external_lex_state = 85},
  [1372] = {.lex_state = 0, .external_lex_state = 85},
  [1373] = {.lex_state = 0, .external_lex_state = 91},
  [1374] = {.lex_state = 0, .external_lex_state = 91},
  [1375] = {.lex_state = 0, .external_lex_state = 86},
  [1376] = {.lex_state = 0, .external_lex_state = 86},
  [1377] = {.lex_state = 0, .external_lex_state = 86},
  [1378] = {.lex_state = 0, .external_lex_state = 86},
  [1379] = {.lex_state = 0, .external_lex_state = 84},
  [1380] = {.lex_state = 0, .external_lex_state = 86},
  [1381] = {.lex_state = 0, .external_lex_state = 86},
  [1382] = {.lex_state = 0, .external_lex_state = 86},
  [1383] = {.lex_state = 0, .external_lex_state = 86},
  [1384] = {.lex_state = 0, .external_lex_state = 91},
  [1385] = {.lex_state = 0, .external_lex_state = 91},
  [1386] = {.lex_state = 0, .external_lex_state = 86},
  [1387] = {.lex_state = 0, .external_lex_state = 86},
  [1388] = {.lex_state = 0, .external_lex_state = 86},
  [1389] = {.lex_state = 0, .external_lex_state = 86},
  [1390] = {.lex_state = 0, .external_lex_state = 86},
  [1391] = {.lex_state = 0, .external_lex_state = 85},
  [1392] = {.lex_state = 0, .external_lex_state = 85},
  [1393] = {.lex_state = 0, .external_lex_state = 86},
  [1394] = {.lex_state = 0, .external_lex_state = 86},
  [1395] = {.lex_state = 0, .external_lex_state = 86},
  [1396] = {.lex_state = 0, .external_lex_state = 91},
  [1397] = {.lex_state = 0, .external_lex_state = 91},
  [1398] = {.lex_state = 0, .external_lex_state = 82},
  [1399] = {.lex_state = 0, .external_lex_state = 91},
  [1400] = {.lex_state = 0, .external_lex_state = 82},
  [1401] = {.lex_state = 0, .external_lex_state = 86},
  [1402] = {.lex_state = 0, .external_lex_state = 86},
  [1403] = {.lex_state = 0, .external_lex_state = 91},
  [1404] = {.lex_state = 0, .external_lex_state = 86},
  [1405] = {.lex_state = 0, .external_lex_state = 85},
  [1406] = {.lex_state = 0, .external_lex_state = 85},
  [1407] = {.lex_state = 0, .external_lex_state = 86},
  [1408] = {.lex_state = 0, .external_lex_state = 91},
  [1409] = {.lex_state = 0, .external_lex_state = 85},
  [1410] = {.lex_state = 0, .external_lex_state = 101},
  [1411] = {.lex_state = 0, .external_lex_state = 98},
  [1412] = {.lex_state = 0, .external_lex_state = 98},
  [1413] = {.lex_state = 0, .external_lex_state = 98},
  [1414] = {.lex_state = 0, .external_lex_state = 100},
  [1415] = {.lex_state = 0, .external_lex_state = 98},
  [1416] = {.lex_state = 0, .external_lex_state = 98},
  [1417] = {.lex_state = 0, .external_lex_state = 98},
  [1418] = {.lex_state = 0, .external_lex_state = 98},
  [1419] = {.lex_state = 0, .external_lex_state = 98},
  [1420] = {.lex_state = 0, .external_lex_state = 98},
  [1421] = {.lex_state = 0, .external_lex_state = 98},
  [1422] = {.lex_state = 0, .external_lex_state = 100},
  [1423] = {.lex_state = 0, .external_lex_state = 98},
  [1424] = {.lex_state = 0, .external_lex_state = 98},
  [1425] = {.lex_state = 0, .external_lex_state = 98},
  [1426] = {.lex_state = 0, .external_lex_state = 102},
  [1427] = {.lex_state = 0, .external_lex_state = 103},
  [1428] = {.lex_state = 0, .external_lex_state = 104},
  [1429] = {.lex_state = 0, .external_lex_state = 102},
  [1430] = {.lex_state = 0, .external_lex_state = 101},
  [1431] = {.lex_state = 0, .external_lex_state = 101},
  [1432] = {.lex_state = 0, .external_lex_state = 105},
  [1433] = {.lex_state = 0, .external_lex_state = 101},
  [1434] = {.lex_state = 0, .external_lex_state = 101},
  [1435] = {.lex_state = 0, .external_lex_state = 105},
  [1436] = {.lex_state = 0, .external_lex_state = 105},
  [1437] = {.lex_state = 0, .external_lex_state = 105},
  [1438] = {.lex_state = 0, .external_lex_state = 101},
  [1439] = {.lex_state = 0, .external_lex_state = 101},
  [1440] = {.lex_state = 0, .external_lex_state = 105},
  [1441] = {.lex_state = 0, .external_lex_state = 105},
  [1442] = {.lex_state = 0, .external_lex_state = 98},
  [1443] = {.lex_state = 0, .external_lex_state = 98},
  [1444] = {.lex_state = 0, .external_lex_state = 98},
  [1445] = {.lex_state = 0, .external_lex_state = 98},
  [1446] = {.lex_state = 0, .external_lex_state = 98},
  [1447] = {.lex_state = 0, .external_lex_state = 106},
  [1448] = {.lex_state = 0, .external_lex_state = 100},
  [1449] = {.lex_state = 0, .external_lex_state = 107},
  [1450] = {.lex_state = 0, .external_lex_state = 98},
  [1451] = {.lex_state = 0, .external_lex_state = 100},
  [1452] = {.lex_state = 0, .external_lex_state = 102},
  [1453] = {.lex_state = 0, .external_lex_state = 98},
  [1454] = {.lex_state = 0, .external_lex_state = 108},
  [1455] = {.lex_state = 0, .external_lex_state = 99},
  [1456] = {.lex_state = 0, .external_lex_state = 104},
  [1457] = {.lex_state = 0, .external_lex_state = 106},
  [1458] = {.lex_state = 0, .external_lex_state = 100},
  [1459] = {.lex_state = 0, .external_lex_state = 106},
  [1460] = {.lex_state = 0, .external_lex_state = 107},
  [1461] = {.lex_state = 0, .external_lex_state = 98},
  [1462] = {.lex_state = 0, .external_lex_state = 99},
  [1463] = {.lex_state = 0, .external_lex_state = 100},
  [1464] = {.lex_state = 0, .external_lex_state = 98},
  [1465] = {.lex_state = 0, .external_lex_state = 102},
  [1466] = {.lex_state = 0, .external_lex_state = 100},
  [1467] = {.lex_state = 0, .external_lex_state = 100},
  [1468] = {.lex_state = 0, .external_lex_state = 106},
  [1469] = {.lex_state = 0, .external_lex_state = 100},
  [1470] = {.lex_state = 0, .external_lex_state = 99},
  [1471] = {.lex_state = 0, .external_lex_state = 107},
  [1472] = {.lex_state = 0, .external_lex_state = 101},
  [1473] = {.lex_state = 0, .external_lex_state = 106},
  [1474] = {.lex_state = 0, .external_lex_state = 105},
  [1475] = {.lex_state = 0, .external_lex_state = 99},
  [1476] = {.lex_state = 0, .external_lex_state = 107},
  [1477] = {.lex_state = 0, .external_lex_state = 98},
  [1478] = {.lex_state = 0, .external_lex_state = 101},
  [1479] = {.lex_state = 0, .external_lex_state = 101},
  [1480] = {.lex_state = 0, .external_lex_state = 105},
  [1481] = {.lex_state = 0, .external_lex_state = 105},
  [1482] = {.lex_state = 0, .external_lex_state = 100},
  [1483] = {.lex_state = 0, .external_lex_state = 101},
  [1484] = {.lex_state = 0, .external_lex_state = 101},
  [1485] = {.lex_state = 0, .external_lex_state = 98},
  [1486] = {.lex_state = 0, .external_lex_state = 105},
  [1487] = {.lex_state = 0, .external_lex_state = 98},
  [1488] = {.lex_state = 0, .external_lex_state = 105},
  [1489] = {.lex_state = 0, .external_lex_state = 104},
  [1490] = {.lex_state = 0, .external_lex_state = 104},
  [1491] = {.lex_state = 0, .external_lex_state = 98},
  [1492] = {.lex_state = 0, .external_lex_state = 98},
  [1493] = {.lex_state = 0, .external_lex_state = 98},
  [1494] = {.lex_state = 0, .external_lex_state = 105},
  [1495] = {.lex_state = 0, .external_lex_state = 100},
  [1496] = {.lex_state = 0, .external_lex_state = 98},
  [1497] = {.lex_state = 0, .external_lex_state = 98},
  [1498] = {.lex_state = 0, .external_lex_state = 101},
  [1499] = {.lex_state = 0, .external_lex_state = 98},
  [1500] = {.lex_state = 0, .external_lex_state = 98},
  [1501] = {.lex_state = 0, .external_lex_state = 98},
  [1502] = {.lex_state = 0, .external_lex_state = 98},
  [1503] = {.lex_state = 0, .external_lex_state = 101},
  [1504] = {.lex_state = 0, .external_lex_state = 105},
  [1505] = {.lex_state = 0, .external_lex_state = 105},
  [1506] = {.lex_state = 0, .external_lex_state = 100},
  [1507] = {.lex_state = 0, .external_lex_state = 100},
  [1508] = {.lex_state = 0, .external_lex_state = 105},
  [1509] = {.lex_state = 0, .external_lex_state = 100},
  [1510] = {.lex_state = 0, .external_lex_state = 101},
  [1511] = {.lex_state = 0, .external_lex_state = 101},
  [1512] = {.lex_state = 0, .external_lex_state = 105},
  [1513] = {.lex_state = 0, .external_lex_state = 105},
  [1514] = {.lex_state = 0, .external_lex_state = 98},
  [1515] = {.lex_state = 0, .external_lex_state = 109},
  [1516] = {.lex_state = 0, .external_lex_state = 107},
  [1517] = {.lex_state = 0, .external_lex_state = 98},
  [1518] = {.lex_state = 0, .external_lex_state = 99},
  [1519] = {.lex_state = 0, .external_lex_state = 101},
  [1520] = {.lex_state = 0, .external_lex_state = 98},
  [1521] = {.lex_state = 0, .external_lex_state = 98},
  [1522] = {.lex_state = 0, .external_lex_state = 98},
  [1523] = {.lex_state = 0, .external_lex_state = 98},
  [1524] = {.lex_state = 0, .external_lex_state = 98},
  [1525] = {.lex_state = 0, .external_lex_state = 106},
  [1526] = {.lex_state = 0, .external_lex_state = 104},
  [1527] = {.lex_state = 0, .external_lex_state = 107},
  [1528] = {.lex_state = 0, .external_lex_state = 98},
  [1529] = {.lex_state = 0, .external_lex_state = 98},
  [1530] = {.lex_state = 0, .external_lex_state = 98},
  [1531] = {.lex_state = 0, .external_lex_state = 98},
  [1532] = {.lex_state = 0, .external_lex_state = 98},
  [1533] = {.lex_state = 0, .external_lex_state = 98},
  [1534] = {.lex_state = 0, .external_lex_state = 100},
  [1535] = {.lex_state = 0, .external_lex_state = 100},
  [1536] = {.lex_state = 0, .external_lex_state = 98},
  [1537] = {.lex_state = 0, .external_lex_state = 98},
  [1538] = {.lex_state = 0, .external_lex_state = 101},
  [1539] = {.lex_state = 0, .external_lex_state = 101},
  [1540] = {.lex_state = 0, .external_lex_state = 105},
  [1541] = {.lex_state = 0, .external_lex_state = 105},
  [1542] = {.lex_state = 0, .external_lex_state = 101},
  [1543] = {.lex_state = 0, .external_lex_state = 101},
  [1544] = {.lex_state = 0, .external_lex_state = 105},
  [1545] = {.lex_state = 0, .external_lex_state = 101},
  [1546] = {.lex_state = 0, .external_lex_state = 101},
  [1547] = {.lex_state = 0, .external_lex_state = 105},
  [1548] = {.lex_state = 0, .external_lex_state = 101},
  [1549] = {.lex_state = 0, .external_lex_state = 101},
  [1550] = {.lex_state = 0, .external_lex_state = 105},
  [1551] = {.lex_state = 0, .external_lex_state = 98},
  [1552] = {.lex_state = 0, .external_lex_state = 101},
  [1553] = {.lex_state = 0, .external_lex_state = 105},
  [1554] = {.lex_state = 0, .external_lex_state = 101},
  [1555] = {.lex_state = 0, .external_lex_state = 101},
  [1556] = {.lex_state = 0, .external_lex_state = 105},
  [1557] = {.lex_state = 0, .external_lex_state = 101},
  [1558] = {.lex_state = 0, .external_lex_state = 101},
  [1559] = {.lex_state = 0, .external_lex_state = 105},
  [1560] = {.lex_state = 0, .external_lex_state = 101},
  [1561] = {.lex_state = 0, .external_lex_state = 101},
  [1562] = {.lex_state = 0, .external_lex_state = 101},
  [1563] = {.lex_state = 0, .external_lex_state = 101},
  [1564] = {.lex_state = 0, .external_lex_state = 101},
  [1565] = {.lex_state = 0, .external_lex_state = 101},
  [1566] = {.lex_state = 0, .external_lex_state = 101},
  [1567] = {.lex_state = 0, .external_lex_state = 101},
  [1568] = {.lex_state = 0, .external_lex_state = 101},
  [1569] = {.lex_state = 0, .external_lex_state = 101},
  [1570] = {.lex_state = 0, .external_lex_state = 101},
  [1571] = {.lex_state = 0, .external_lex_state = 101},
  [1572] = {.lex_state = 0, .external_lex_state = 101},
  [1573] = {.lex_state = 0, .external_lex_state = 101},
  [1574] = {.lex_state = 0, .external_lex_state = 101},
  [1575] = {.lex_state = 0, .external_lex_state = 101},
  [1576] = {.lex_state = 0, .external_lex_state = 101},
  [1577] = {.lex_state = 0, .external_lex_state = 101},
  [1578] = {.lex_state = 0, .external_lex_state = 101},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__eof] = ACTIONS(1),
    [sym__s_dir_yml_bgn] = ACTIONS(1),
    [sym__r_dir_yml_ver] = ACTIONS(1),
    [sym__s_dir_tag_bgn] = ACTIONS(1),
    [sym__r_dir_tag_hdl] = ACTIONS(1),
    [sym__r_dir_tag_pfx] = ACTIONS(1),
    [sym__s_dir_rsv_bgn] = ACTIONS(1),
    [sym__r_dir_rsv_prm] = ACTIONS(1),
    [sym__s_drs_end] = ACTIONS(1),
    [sym__s_doc_end] = ACTIONS(1),
    [sym__r_blk_seq_bgn] = ACTIONS(1),
    [sym__br_blk_seq_bgn] = ACTIONS(1),
    [sym__b_blk_seq_bgn] = ACTIONS(1),
    [sym__r_blk_key_bgn] = ACTIONS(1),
    [sym__br_blk_key_bgn] = ACTIONS(1),
    [sym__b_blk_key_bgn] = ACTIONS(1),
    [sym__r_blk_val_bgn] = ACTIONS(1),
    [sym__br_blk_val_bgn] = ACTIONS(1),
    [sym__b_blk_val_bgn] = ACTIONS(1),
    [sym__r_blk_imp_bgn] = ACTIONS(1),
    [sym__r_blk_lit_bgn] = ACTIONS(1),
    [sym__br_blk_lit_bgn] = ACTIONS(1),
    [sym__r_blk_fld_bgn] = ACTIONS(1),
    [sym__br_blk_fld_bgn] = ACTIONS(1),
    [sym__br_blk_str_ctn] = ACTIONS(1),
    [sym__r_flw_seq_bgn] = ACTIONS(1),
    [sym__br_flw_seq_bgn] = ACTIONS(1),
    [sym__b_flw_seq_bgn] = ACTIONS(1),
    [sym__r_flw_seq_end] = ACTIONS(1),
    [sym__br_flw_seq_end] = ACTIONS(1),
    [sym__b_flw_seq_end] = ACTIONS(1),
    [sym__r_flw_map_bgn] = ACTIONS(1),
    [sym__br_flw_map_bgn] = ACTIONS(1),
    [sym__b_flw_map_bgn] = ACTIONS(1),
    [sym__r_flw_map_end] = ACTIONS(1),
    [sym__br_flw_map_end] = ACTIONS(1),
    [sym__b_flw_map_end] = ACTIONS(1),
    [sym__r_flw_sep_bgn] = ACTIONS(1),
    [sym__br_flw_sep_bgn] = ACTIONS(1),
    [sym__r_flw_key_bgn] = ACTIONS(1),
    [sym__br_flw_key_bgn] = ACTIONS(1),
    [sym__r_flw_jsv_bgn] = ACTIONS(1),
    [sym__br_flw_jsv_bgn] = ACTIONS(1),
    [sym__r_flw_njv_bgn] = ACTIONS(1),
    [sym__br_flw_njv_bgn] = ACTIONS(1),
    [sym__r_dqt_str_bgn] = ACTIONS(1),
    [sym__br_dqt_str_bgn] = ACTIONS(1),
    [sym__b_dqt_str_bgn] = ACTIONS(1),
    [sym__r_dqt_str_ctn] = ACTIONS(1),
    [sym__br_dqt_str_ctn] = ACTIONS(1),
    [sym__r_dqt_esc_nwl] = ACTIONS(1),
    [sym__br_dqt_esc_nwl] = ACTIONS(1),
    [sym__r_dqt_esc_seq] = ACTIONS(1),
    [sym__br_dqt_esc_seq] = ACTIONS(1),
    [sym__r_dqt_str_end] = ACTIONS(1),
    [sym__br_dqt_str_end] = ACTIONS(1),
    [sym__r_sqt_str_bgn] = ACTIONS(1),
    [sym__br_sqt_str_bgn] = ACTIONS(1),
    [sym__b_sqt_str_bgn] = ACTIONS(1),
    [sym__r_sqt_str_ctn] = ACTIONS(1),
    [sym__br_sqt_str_ctn] = ACTIONS(1),
    [sym__r_sqt_esc_sqt] = ACTIONS(1),
    [sym__br_sqt_esc_sqt] = ACTIONS(1),
    [sym__r_sqt_str_end] = ACTIONS(1),
    [sym__br_sqt_str_end] = ACTIONS(1),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(1),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(1),
    [sym__b_sgl_pln_nul_blk] = ACTIONS(1),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(1),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(1),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(1),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(1),
    [sym__b_sgl_pln_bol_blk] = ACTIONS(1),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(1),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(1),
    [sym__r_sgl_pln_int_blk] = ACTIONS(1),
    [sym__br_sgl_pln_int_blk] = ACTIONS(1),
    [sym__b_sgl_pln_int_blk] = ACTIONS(1),
    [sym__r_sgl_pln_int_flw] = ACTIONS(1),
    [sym__br_sgl_pln_int_flw] = ACTIONS(1),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(1),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(1),
    [sym__b_sgl_pln_flt_blk] = ACTIONS(1),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(1),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(1),
    [sym__r_sgl_pln_str_blk] = ACTIONS(1),
    [sym__br_sgl_pln_str_blk] = ACTIONS(1),
    [sym__b_sgl_pln_str_blk] = ACTIONS(1),
    [sym__r_sgl_pln_str_flw] = ACTIONS(1),
    [sym__br_sgl_pln_str_flw] = ACTIONS(1),
    [sym__r_mtl_pln_str_blk] = ACTIONS(1),
    [sym__br_mtl_pln_str_blk] = ACTIONS(1),
    [sym__r_mtl_pln_str_flw] = ACTIONS(1),
    [sym__br_mtl_pln_str_flw] = ACTIONS(1),
    [sym__r_tag] = ACTIONS(1),
    [sym__br_tag] = ACTIONS(1),
    [sym__b_tag] = ACTIONS(1),
    [sym__r_acr_bgn] = ACTIONS(1),
    [sym__br_acr_bgn] = ACTIONS(1),
    [sym__b_acr_bgn] = ACTIONS(1),
    [sym__r_acr_ctn] = ACTIONS(1),
    [sym__r_als_bgn] = ACTIONS(1),
    [sym__br_als_bgn] = ACTIONS(1),
    [sym__b_als_bgn] = ACTIONS(1),
    [sym__r_als_ctn] = ACTIONS(1),
    [sym__bl] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__err_rec] = ACTIONS(1),
  },
  [1] = {
    [sym_stream] = STATE(1429),
    [sym__bgn_imp_doc] = STATE(474),
    [sym__drs_doc] = STATE(478),
    [sym__exp_doc] = STATE(475),
    [sym__drs_doc_end] = STATE(39),
    [sym__exp_doc_end] = STATE(39),
    [sym__bgn_imp_doc_end] = STATE(39),
    [sym__doc_end] = STATE(39),
    [sym__exp_doc_tal] = STATE(1123),
    [sym__s_dir] = STATE(471),
    [sym__s_dir_yml] = STATE(471),
    [sym__s_dir_tag] = STATE(471),
    [sym__s_dir_rsv] = STATE(471),
    [sym__r_prp_val] = STATE(1123),
    [sym__br_prp_val] = STATE(1123),
    [sym__r_sgl_prp_val] = STATE(1227),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__r_prp] = STATE(81),
    [sym__br_prp] = STATE(80),
    [sym__r_sgl_prp] = STATE(308),
    [sym__br_sgl_prp] = STATE(309),
    [sym__r_blk_seq_r_val] = STATE(1123),
    [sym__r_blk_seq_br_val] = STATE(1123),
    [sym__br_blk_seq_val] = STATE(1123),
    [sym__r_blk_seq] = STATE(1154),
    [sym__br_blk_seq] = STATE(1170),
    [sym__r_blk_seq_itm] = STATE(1004),
    [sym__br_blk_seq_itm] = STATE(1048),
    [sym__r_blk_map_r_val] = STATE(1123),
    [sym__r_blk_map_br_val] = STATE(1123),
    [sym__br_blk_map_val] = STATE(1123),
    [sym__r_blk_map] = STATE(1175),
    [sym__br_blk_map] = STATE(1200),
    [sym__r_blk_map_itm] = STATE(122),
    [sym__br_blk_map_itm] = STATE(148),
    [sym__r_blk_exp_itm] = STATE(318),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__r_blk_key_itm] = STATE(277),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__r_blk_val_itm] = STATE(327),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__r_blk_imp_itm] = STATE(360),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__r_blk_str_val] = STATE(1123),
    [sym__br_blk_str_val] = STATE(1123),
    [sym__r_blk_str] = STATE(1083),
    [sym__br_blk_str] = STATE(1103),
    [sym__r_flw_seq_val] = STATE(1123),
    [sym__br_flw_seq_val] = STATE(1123),
    [sym__r_sgl_flw_seq_val] = STATE(1227),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(1115),
    [sym__br_flw_seq] = STATE(1156),
    [sym__r_sgl_flw_seq] = STATE(1420),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__r_flw_map_val] = STATE(1123),
    [sym__br_flw_map_val] = STATE(1123),
    [sym__r_sgl_flw_map_val] = STATE(1227),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(1070),
    [sym__br_flw_map] = STATE(1071),
    [sym__r_sgl_flw_map] = STATE(1442),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__r_dqt_str_val] = STATE(1123),
    [sym__br_dqt_str_val] = STATE(1123),
    [sym__r_sgl_dqt_str_val] = STATE(1227),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(1060),
    [sym__br_dqt_str] = STATE(1087),
    [sym__r_sgl_dqt_str] = STATE(1453),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__r_sqt_str_val] = STATE(1123),
    [sym__br_sqt_str_val] = STATE(1123),
    [sym__r_sgl_sqt_str_val] = STATE(1227),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(1127),
    [sym__br_sqt_str] = STATE(1129),
    [sym__r_sgl_sqt_str] = STATE(1411),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__r_pln_blk_val] = STATE(1123),
    [sym__br_pln_blk_val] = STATE(1123),
    [sym__r_sgl_pln_blk_val] = STATE(1227),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(1046),
    [sym__br_sgl_pln_blk] = STATE(997),
    [sym__r_mtl_pln_blk] = STATE(1094),
    [sym__br_mtl_pln_blk] = STATE(1095),
    [sym__r_als_val] = STATE(917),
    [sym__br_als_val] = STATE(918),
    [sym__r_als] = STATE(999),
    [sym__br_als] = STATE(1001),
    [sym__r_acr] = STATE(155),
    [sym__br_acr] = STATE(152),
    [aux_sym__drs_doc_repeat1] = STATE(471),
    [sym__eof] = ACTIONS(5),
    [sym__s_dir_yml_bgn] = ACTIONS(7),
    [sym__s_dir_tag_bgn] = ACTIONS(9),
    [sym__s_dir_rsv_bgn] = ACTIONS(11),
    [sym__s_drs_end] = ACTIONS(13),
    [sym__s_doc_end] = ACTIONS(15),
    [sym__r_blk_seq_bgn] = ACTIONS(17),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__r_blk_key_bgn] = ACTIONS(21),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__r_blk_val_bgn] = ACTIONS(25),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__r_blk_lit_bgn] = ACTIONS(29),
    [sym__br_blk_lit_bgn] = ACTIONS(31),
    [sym__r_blk_fld_bgn] = ACTIONS(29),
    [sym__br_blk_fld_bgn] = ACTIONS(31),
    [sym__r_flw_seq_bgn] = ACTIONS(33),
    [sym__br_flw_seq_bgn] = ACTIONS(35),
    [sym__r_flw_map_bgn] = ACTIONS(37),
    [sym__br_flw_map_bgn] = ACTIONS(39),
    [sym__r_dqt_str_bgn] = ACTIONS(41),
    [sym__br_dqt_str_bgn] = ACTIONS(43),
    [sym__r_sqt_str_bgn] = ACTIONS(45),
    [sym__br_sqt_str_bgn] = ACTIONS(47),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(49),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(51),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(49),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(51),
    [sym__r_sgl_pln_int_blk] = ACTIONS(49),
    [sym__br_sgl_pln_int_blk] = ACTIONS(51),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(49),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(51),
    [sym__r_sgl_pln_str_blk] = ACTIONS(49),
    [sym__br_sgl_pln_str_blk] = ACTIONS(51),
    [sym__r_mtl_pln_str_blk] = ACTIONS(53),
    [sym__br_mtl_pln_str_blk] = ACTIONS(55),
    [sym__r_tag] = ACTIONS(57),
    [sym__br_tag] = ACTIONS(59),
    [sym__r_acr_bgn] = ACTIONS(61),
    [sym__br_acr_bgn] = ACTIONS(63),
    [sym__r_als_bgn] = ACTIONS(65),
    [sym__br_als_bgn] = ACTIONS(67),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__r_prp_val] = STATE(311),
    [sym__br_prp_val] = STATE(311),
    [sym__r_sgl_prp_val] = STATE(1227),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__r_prp] = STATE(35),
    [sym__br_prp] = STATE(36),
    [sym__r_sgl_prp] = STATE(308),
    [sym__br_sgl_prp] = STATE(309),
    [sym__r_blk_seq_r_val] = STATE(311),
    [sym__r_blk_seq_br_val] = STATE(311),
    [sym__br_blk_seq_val] = STATE(311),
    [sym__r_blk_seq_spc_val] = STATE(311),
    [sym__br_blk_seq_spc_val] = STATE(311),
    [sym__b_blk_seq_spc_val] = STATE(311),
    [sym__r_blk_seq] = STATE(340),
    [sym__br_blk_seq] = STATE(341),
    [sym__b_blk_seq_spc] = STATE(310),
    [sym__r_blk_seq_itm] = STATE(965),
    [sym__br_blk_seq_itm] = STATE(966),
    [sym__b_blk_seq_itm] = STATE(1041),
    [sym__blk_seq_itm_tal] = STATE(311),
    [sym__r_blk_map_r_val] = STATE(311),
    [sym__r_blk_map_br_val] = STATE(311),
    [sym__br_blk_map_val] = STATE(311),
    [sym__r_blk_map] = STATE(342),
    [sym__br_blk_map] = STATE(343),
    [sym__r_blk_map_itm] = STATE(132),
    [sym__br_blk_map_itm] = STATE(133),
    [sym__r_blk_exp_itm] = STATE(318),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__r_blk_key_itm] = STATE(277),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__r_blk_val_itm] = STATE(327),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__r_blk_imp_itm] = STATE(360),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__blk_exp_itm_tal] = STATE(311),
    [sym__r_blk_str_val] = STATE(311),
    [sym__br_blk_str_val] = STATE(311),
    [sym__r_blk_str] = STATE(344),
    [sym__br_blk_str] = STATE(345),
    [sym__r_flw_seq_val] = STATE(311),
    [sym__br_flw_seq_val] = STATE(311),
    [sym__r_sgl_flw_seq_val] = STATE(1227),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(346),
    [sym__br_flw_seq] = STATE(347),
    [sym__r_sgl_flw_seq] = STATE(1420),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__r_flw_map_val] = STATE(311),
    [sym__br_flw_map_val] = STATE(311),
    [sym__r_sgl_flw_map_val] = STATE(1227),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(348),
    [sym__br_flw_map] = STATE(349),
    [sym__r_sgl_flw_map] = STATE(1442),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__r_dqt_str_val] = STATE(311),
    [sym__br_dqt_str_val] = STATE(311),
    [sym__r_sgl_dqt_str_val] = STATE(1227),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(350),
    [sym__br_dqt_str] = STATE(351),
    [sym__r_sgl_dqt_str] = STATE(1453),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__r_sqt_str_val] = STATE(311),
    [sym__br_sqt_str_val] = STATE(311),
    [sym__r_sgl_sqt_str_val] = STATE(1227),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(352),
    [sym__br_sqt_str] = STATE(353),
    [sym__r_sgl_sqt_str] = STATE(1411),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__r_pln_blk_val] = STATE(311),
    [sym__br_pln_blk_val] = STATE(311),
    [sym__r_sgl_pln_blk_val] = STATE(1227),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(281),
    [sym__br_sgl_pln_blk] = STATE(282),
    [sym__r_mtl_pln_blk] = STATE(356),
    [sym__br_mtl_pln_blk] = STATE(357),
    [sym__r_als_val] = STATE(262),
    [sym__br_als_val] = STATE(263),
    [sym__r_als] = STATE(266),
    [sym__br_als] = STATE(283),
    [sym__r_acr] = STATE(100),
    [sym__br_acr] = STATE(101),
    [aux_sym__r_blk_seq_repeat1] = STATE(1041),
    [sym__r_blk_seq_bgn] = ACTIONS(17),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(69),
    [sym__r_blk_key_bgn] = ACTIONS(21),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__b_blk_key_bgn] = ACTIONS(71),
    [sym__r_blk_val_bgn] = ACTIONS(25),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__b_blk_val_bgn] = ACTIONS(71),
    [sym__r_blk_lit_bgn] = ACTIONS(73),
    [sym__br_blk_lit_bgn] = ACTIONS(75),
    [sym__r_blk_fld_bgn] = ACTIONS(73),
    [sym__br_blk_fld_bgn] = ACTIONS(75),
    [sym__r_flw_seq_bgn] = ACTIONS(77),
    [sym__br_flw_seq_bgn] = ACTIONS(79),
    [sym__b_flw_seq_bgn] = ACTIONS(71),
    [sym__r_flw_map_bgn] = ACTIONS(81),
    [sym__br_flw_map_bgn] = ACTIONS(83),
    [sym__b_flw_map_bgn] = ACTIONS(71),
    [sym__r_dqt_str_bgn] = ACTIONS(85),
    [sym__br_dqt_str_bgn] = ACTIONS(87),
    [sym__b_dqt_str_bgn] = ACTIONS(71),
    [sym__r_sqt_str_bgn] = ACTIONS(89),
    [sym__br_sqt_str_bgn] = ACTIONS(91),
    [sym__b_sqt_str_bgn] = ACTIONS(71),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(93),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(95),
    [sym__b_sgl_pln_nul_blk] = ACTIONS(71),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(93),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(95),
    [sym__b_sgl_pln_bol_blk] = ACTIONS(71),
    [sym__r_sgl_pln_int_blk] = ACTIONS(93),
    [sym__br_sgl_pln_int_blk] = ACTIONS(95),
    [sym__b_sgl_pln_int_blk] = ACTIONS(71),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(93),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(95),
    [sym__b_sgl_pln_flt_blk] = ACTIONS(71),
    [sym__r_sgl_pln_str_blk] = ACTIONS(93),
    [sym__br_sgl_pln_str_blk] = ACTIONS(95),
    [sym__b_sgl_pln_str_blk] = ACTIONS(71),
    [sym__r_mtl_pln_str_blk] = ACTIONS(97),
    [sym__br_mtl_pln_str_blk] = ACTIONS(99),
    [sym__r_tag] = ACTIONS(101),
    [sym__br_tag] = ACTIONS(103),
    [sym__b_tag] = ACTIONS(71),
    [sym__r_acr_bgn] = ACTIONS(105),
    [sym__br_acr_bgn] = ACTIONS(107),
    [sym__b_acr_bgn] = ACTIONS(71),
    [sym__r_als_bgn] = ACTIONS(109),
    [sym__br_als_bgn] = ACTIONS(111),
    [sym__b_als_bgn] = ACTIONS(71),
    [sym__bl] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym__r_prp_val] = STATE(316),
    [sym__br_prp_val] = STATE(316),
    [sym__r_sgl_prp_val] = STATE(1227),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__r_prp] = STATE(35),
    [sym__br_prp] = STATE(36),
    [sym__r_sgl_prp] = STATE(308),
    [sym__br_sgl_prp] = STATE(309),
    [sym__r_blk_seq_r_val] = STATE(316),
    [sym__r_blk_seq_br_val] = STATE(316),
    [sym__br_blk_seq_val] = STATE(316),
    [sym__r_blk_seq_spc_val] = STATE(316),
    [sym__br_blk_seq_spc_val] = STATE(316),
    [sym__b_blk_seq_spc_val] = STATE(316),
    [sym__r_blk_seq] = STATE(340),
    [sym__br_blk_seq] = STATE(341),
    [sym__b_blk_seq_spc] = STATE(310),
    [sym__r_blk_seq_itm] = STATE(965),
    [sym__br_blk_seq_itm] = STATE(966),
    [sym__b_blk_seq_itm] = STATE(1041),
    [sym__blk_seq_itm_tal] = STATE(316),
    [sym__r_blk_map_r_val] = STATE(316),
    [sym__r_blk_map_br_val] = STATE(316),
    [sym__br_blk_map_val] = STATE(316),
    [sym__r_blk_map] = STATE(342),
    [sym__br_blk_map] = STATE(343),
    [sym__r_blk_map_itm] = STATE(132),
    [sym__br_blk_map_itm] = STATE(133),
    [sym__r_blk_exp_itm] = STATE(318),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__r_blk_key_itm] = STATE(277),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__r_blk_val_itm] = STATE(327),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__r_blk_imp_itm] = STATE(360),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__blk_exp_itm_tal] = STATE(316),
    [sym__r_blk_str_val] = STATE(316),
    [sym__br_blk_str_val] = STATE(316),
    [sym__r_blk_str] = STATE(344),
    [sym__br_blk_str] = STATE(345),
    [sym__r_flw_seq_val] = STATE(316),
    [sym__br_flw_seq_val] = STATE(316),
    [sym__r_sgl_flw_seq_val] = STATE(1227),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(346),
    [sym__br_flw_seq] = STATE(347),
    [sym__r_sgl_flw_seq] = STATE(1420),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__r_flw_map_val] = STATE(316),
    [sym__br_flw_map_val] = STATE(316),
    [sym__r_sgl_flw_map_val] = STATE(1227),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(348),
    [sym__br_flw_map] = STATE(349),
    [sym__r_sgl_flw_map] = STATE(1442),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__r_dqt_str_val] = STATE(316),
    [sym__br_dqt_str_val] = STATE(316),
    [sym__r_sgl_dqt_str_val] = STATE(1227),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(350),
    [sym__br_dqt_str] = STATE(351),
    [sym__r_sgl_dqt_str] = STATE(1453),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__r_sqt_str_val] = STATE(316),
    [sym__br_sqt_str_val] = STATE(316),
    [sym__r_sgl_sqt_str_val] = STATE(1227),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(352),
    [sym__br_sqt_str] = STATE(353),
    [sym__r_sgl_sqt_str] = STATE(1411),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__r_pln_blk_val] = STATE(316),
    [sym__br_pln_blk_val] = STATE(316),
    [sym__r_sgl_pln_blk_val] = STATE(1227),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(281),
    [sym__br_sgl_pln_blk] = STATE(282),
    [sym__r_mtl_pln_blk] = STATE(356),
    [sym__br_mtl_pln_blk] = STATE(357),
    [sym__r_als_val] = STATE(262),
    [sym__br_als_val] = STATE(263),
    [sym__r_als] = STATE(266),
    [sym__br_als] = STATE(283),
    [sym__r_acr] = STATE(100),
    [sym__br_acr] = STATE(101),
    [aux_sym__r_blk_seq_repeat1] = STATE(1041),
    [sym__r_blk_seq_bgn] = ACTIONS(17),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(69),
    [sym__r_blk_key_bgn] = ACTIONS(21),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__b_blk_key_bgn] = ACTIONS(113),
    [sym__r_blk_val_bgn] = ACTIONS(25),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__b_blk_val_bgn] = ACTIONS(113),
    [sym__r_blk_lit_bgn] = ACTIONS(73),
    [sym__br_blk_lit_bgn] = ACTIONS(75),
    [sym__r_blk_fld_bgn] = ACTIONS(73),
    [sym__br_blk_fld_bgn] = ACTIONS(75),
    [sym__r_flw_seq_bgn] = ACTIONS(77),
    [sym__br_flw_seq_bgn] = ACTIONS(79),
    [sym__b_flw_seq_bgn] = ACTIONS(113),
    [sym__r_flw_map_bgn] = ACTIONS(81),
    [sym__br_flw_map_bgn] = ACTIONS(83),
    [sym__b_flw_map_bgn] = ACTIONS(113),
    [sym__r_dqt_str_bgn] = ACTIONS(85),
    [sym__br_dqt_str_bgn] = ACTIONS(87),
    [sym__b_dqt_str_bgn] = ACTIONS(113),
    [sym__r_sqt_str_bgn] = ACTIONS(89),
    [sym__br_sqt_str_bgn] = ACTIONS(91),
    [sym__b_sqt_str_bgn] = ACTIONS(113),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(93),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(95),
    [sym__b_sgl_pln_nul_blk] = ACTIONS(113),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(93),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(95),
    [sym__b_sgl_pln_bol_blk] = ACTIONS(113),
    [sym__r_sgl_pln_int_blk] = ACTIONS(93),
    [sym__br_sgl_pln_int_blk] = ACTIONS(95),
    [sym__b_sgl_pln_int_blk] = ACTIONS(113),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(93),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(95),
    [sym__b_sgl_pln_flt_blk] = ACTIONS(113),
    [sym__r_sgl_pln_str_blk] = ACTIONS(93),
    [sym__br_sgl_pln_str_blk] = ACTIONS(95),
    [sym__b_sgl_pln_str_blk] = ACTIONS(113),
    [sym__r_mtl_pln_str_blk] = ACTIONS(97),
    [sym__br_mtl_pln_str_blk] = ACTIONS(99),
    [sym__r_tag] = ACTIONS(101),
    [sym__br_tag] = ACTIONS(103),
    [sym__b_tag] = ACTIONS(113),
    [sym__r_acr_bgn] = ACTIONS(105),
    [sym__br_acr_bgn] = ACTIONS(107),
    [sym__b_acr_bgn] = ACTIONS(113),
    [sym__r_als_bgn] = ACTIONS(109),
    [sym__br_als_bgn] = ACTIONS(111),
    [sym__b_als_bgn] = ACTIONS(113),
    [sym__bl] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__r_prp_val] = STATE(317),
    [sym__br_prp_val] = STATE(317),
    [sym__r_sgl_prp_val] = STATE(1227),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__r_prp] = STATE(35),
    [sym__br_prp] = STATE(36),
    [sym__r_sgl_prp] = STATE(308),
    [sym__br_sgl_prp] = STATE(309),
    [sym__r_blk_seq_r_val] = STATE(317),
    [sym__r_blk_seq_br_val] = STATE(317),
    [sym__br_blk_seq_val] = STATE(317),
    [sym__r_blk_seq_spc_val] = STATE(317),
    [sym__br_blk_seq_spc_val] = STATE(317),
    [sym__b_blk_seq_spc_val] = STATE(317),
    [sym__r_blk_seq] = STATE(340),
    [sym__br_blk_seq] = STATE(341),
    [sym__b_blk_seq_spc] = STATE(310),
    [sym__r_blk_seq_itm] = STATE(965),
    [sym__br_blk_seq_itm] = STATE(966),
    [sym__b_blk_seq_itm] = STATE(1041),
    [sym__blk_seq_itm_tal] = STATE(317),
    [sym__r_blk_map_r_val] = STATE(317),
    [sym__r_blk_map_br_val] = STATE(317),
    [sym__br_blk_map_val] = STATE(317),
    [sym__r_blk_map] = STATE(342),
    [sym__br_blk_map] = STATE(343),
    [sym__r_blk_map_itm] = STATE(132),
    [sym__br_blk_map_itm] = STATE(133),
    [sym__r_blk_exp_itm] = STATE(318),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__r_blk_key_itm] = STATE(277),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__r_blk_val_itm] = STATE(327),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__r_blk_imp_itm] = STATE(360),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__blk_exp_itm_tal] = STATE(317),
    [sym__r_blk_str_val] = STATE(317),
    [sym__br_blk_str_val] = STATE(317),
    [sym__r_blk_str] = STATE(344),
    [sym__br_blk_str] = STATE(345),
    [sym__r_flw_seq_val] = STATE(317),
    [sym__br_flw_seq_val] = STATE(317),
    [sym__r_sgl_flw_seq_val] = STATE(1227),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(346),
    [sym__br_flw_seq] = STATE(347),
    [sym__r_sgl_flw_seq] = STATE(1420),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__r_flw_map_val] = STATE(317),
    [sym__br_flw_map_val] = STATE(317),
    [sym__r_sgl_flw_map_val] = STATE(1227),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(348),
    [sym__br_flw_map] = STATE(349),
    [sym__r_sgl_flw_map] = STATE(1442),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__r_dqt_str_val] = STATE(317),
    [sym__br_dqt_str_val] = STATE(317),
    [sym__r_sgl_dqt_str_val] = STATE(1227),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(350),
    [sym__br_dqt_str] = STATE(351),
    [sym__r_sgl_dqt_str] = STATE(1453),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__r_sqt_str_val] = STATE(317),
    [sym__br_sqt_str_val] = STATE(317),
    [sym__r_sgl_sqt_str_val] = STATE(1227),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(352),
    [sym__br_sqt_str] = STATE(353),
    [sym__r_sgl_sqt_str] = STATE(1411),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__r_pln_blk_val] = STATE(317),
    [sym__br_pln_blk_val] = STATE(317),
    [sym__r_sgl_pln_blk_val] = STATE(1227),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(281),
    [sym__br_sgl_pln_blk] = STATE(282),
    [sym__r_mtl_pln_blk] = STATE(356),
    [sym__br_mtl_pln_blk] = STATE(357),
    [sym__r_als_val] = STATE(262),
    [sym__br_als_val] = STATE(263),
    [sym__r_als] = STATE(266),
    [sym__br_als] = STATE(283),
    [sym__r_acr] = STATE(100),
    [sym__br_acr] = STATE(101),
    [aux_sym__r_blk_seq_repeat1] = STATE(1041),
    [sym__r_blk_seq_bgn] = ACTIONS(17),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(69),
    [sym__r_blk_key_bgn] = ACTIONS(21),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__b_blk_key_bgn] = ACTIONS(115),
    [sym__r_blk_val_bgn] = ACTIONS(25),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__b_blk_val_bgn] = ACTIONS(115),
    [sym__r_blk_lit_bgn] = ACTIONS(73),
    [sym__br_blk_lit_bgn] = ACTIONS(75),
    [sym__r_blk_fld_bgn] = ACTIONS(73),
    [sym__br_blk_fld_bgn] = ACTIONS(75),
    [sym__r_flw_seq_bgn] = ACTIONS(77),
    [sym__br_flw_seq_bgn] = ACTIONS(79),
    [sym__b_flw_seq_bgn] = ACTIONS(115),
    [sym__r_flw_map_bgn] = ACTIONS(81),
    [sym__br_flw_map_bgn] = ACTIONS(83),
    [sym__b_flw_map_bgn] = ACTIONS(115),
    [sym__r_dqt_str_bgn] = ACTIONS(85),
    [sym__br_dqt_str_bgn] = ACTIONS(87),
    [sym__b_dqt_str_bgn] = ACTIONS(115),
    [sym__r_sqt_str_bgn] = ACTIONS(89),
    [sym__br_sqt_str_bgn] = ACTIONS(91),
    [sym__b_sqt_str_bgn] = ACTIONS(115),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(93),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(95),
    [sym__b_sgl_pln_nul_blk] = ACTIONS(115),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(93),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(95),
    [sym__b_sgl_pln_bol_blk] = ACTIONS(115),
    [sym__r_sgl_pln_int_blk] = ACTIONS(93),
    [sym__br_sgl_pln_int_blk] = ACTIONS(95),
    [sym__b_sgl_pln_int_blk] = ACTIONS(115),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(93),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(95),
    [sym__b_sgl_pln_flt_blk] = ACTIONS(115),
    [sym__r_sgl_pln_str_blk] = ACTIONS(93),
    [sym__br_sgl_pln_str_blk] = ACTIONS(95),
    [sym__b_sgl_pln_str_blk] = ACTIONS(115),
    [sym__r_mtl_pln_str_blk] = ACTIONS(97),
    [sym__br_mtl_pln_str_blk] = ACTIONS(99),
    [sym__r_tag] = ACTIONS(101),
    [sym__br_tag] = ACTIONS(103),
    [sym__b_tag] = ACTIONS(115),
    [sym__r_acr_bgn] = ACTIONS(105),
    [sym__br_acr_bgn] = ACTIONS(107),
    [sym__b_acr_bgn] = ACTIONS(115),
    [sym__r_als_bgn] = ACTIONS(109),
    [sym__br_als_bgn] = ACTIONS(111),
    [sym__b_als_bgn] = ACTIONS(115),
    [sym__bl] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__r_prp_val] = STATE(312),
    [sym__br_prp_val] = STATE(312),
    [sym__r_sgl_prp_val] = STATE(1227),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__r_prp] = STATE(35),
    [sym__br_prp] = STATE(36),
    [sym__r_sgl_prp] = STATE(308),
    [sym__br_sgl_prp] = STATE(309),
    [sym__r_blk_seq_r_val] = STATE(312),
    [sym__r_blk_seq_br_val] = STATE(312),
    [sym__br_blk_seq_val] = STATE(312),
    [sym__r_blk_seq_spc_val] = STATE(312),
    [sym__br_blk_seq_spc_val] = STATE(312),
    [sym__b_blk_seq_spc_val] = STATE(312),
    [sym__r_blk_seq] = STATE(340),
    [sym__br_blk_seq] = STATE(341),
    [sym__b_blk_seq_spc] = STATE(310),
    [sym__r_blk_seq_itm] = STATE(965),
    [sym__br_blk_seq_itm] = STATE(966),
    [sym__b_blk_seq_itm] = STATE(1041),
    [sym__blk_seq_itm_tal] = STATE(312),
    [sym__r_blk_map_r_val] = STATE(312),
    [sym__r_blk_map_br_val] = STATE(312),
    [sym__br_blk_map_val] = STATE(312),
    [sym__r_blk_map] = STATE(342),
    [sym__br_blk_map] = STATE(343),
    [sym__r_blk_map_itm] = STATE(132),
    [sym__br_blk_map_itm] = STATE(133),
    [sym__r_blk_exp_itm] = STATE(318),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__r_blk_key_itm] = STATE(277),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__r_blk_val_itm] = STATE(327),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__r_blk_imp_itm] = STATE(360),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__blk_exp_itm_tal] = STATE(312),
    [sym__r_blk_str_val] = STATE(312),
    [sym__br_blk_str_val] = STATE(312),
    [sym__r_blk_str] = STATE(344),
    [sym__br_blk_str] = STATE(345),
    [sym__r_flw_seq_val] = STATE(312),
    [sym__br_flw_seq_val] = STATE(312),
    [sym__r_sgl_flw_seq_val] = STATE(1227),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(346),
    [sym__br_flw_seq] = STATE(347),
    [sym__r_sgl_flw_seq] = STATE(1420),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__r_flw_map_val] = STATE(312),
    [sym__br_flw_map_val] = STATE(312),
    [sym__r_sgl_flw_map_val] = STATE(1227),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(348),
    [sym__br_flw_map] = STATE(349),
    [sym__r_sgl_flw_map] = STATE(1442),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__r_dqt_str_val] = STATE(312),
    [sym__br_dqt_str_val] = STATE(312),
    [sym__r_sgl_dqt_str_val] = STATE(1227),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(350),
    [sym__br_dqt_str] = STATE(351),
    [sym__r_sgl_dqt_str] = STATE(1453),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__r_sqt_str_val] = STATE(312),
    [sym__br_sqt_str_val] = STATE(312),
    [sym__r_sgl_sqt_str_val] = STATE(1227),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(352),
    [sym__br_sqt_str] = STATE(353),
    [sym__r_sgl_sqt_str] = STATE(1411),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__r_pln_blk_val] = STATE(312),
    [sym__br_pln_blk_val] = STATE(312),
    [sym__r_sgl_pln_blk_val] = STATE(1227),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(281),
    [sym__br_sgl_pln_blk] = STATE(282),
    [sym__r_mtl_pln_blk] = STATE(356),
    [sym__br_mtl_pln_blk] = STATE(357),
    [sym__r_als_val] = STATE(262),
    [sym__br_als_val] = STATE(263),
    [sym__r_als] = STATE(266),
    [sym__br_als] = STATE(283),
    [sym__r_acr] = STATE(100),
    [sym__br_acr] = STATE(101),
    [aux_sym__r_blk_seq_repeat1] = STATE(1041),
    [sym__r_blk_seq_bgn] = ACTIONS(17),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(69),
    [sym__r_blk_key_bgn] = ACTIONS(21),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__b_blk_key_bgn] = ACTIONS(117),
    [sym__r_blk_val_bgn] = ACTIONS(25),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__b_blk_val_bgn] = ACTIONS(117),
    [sym__r_blk_lit_bgn] = ACTIONS(73),
    [sym__br_blk_lit_bgn] = ACTIONS(75),
    [sym__r_blk_fld_bgn] = ACTIONS(73),
    [sym__br_blk_fld_bgn] = ACTIONS(75),
    [sym__r_flw_seq_bgn] = ACTIONS(77),
    [sym__br_flw_seq_bgn] = ACTIONS(79),
    [sym__b_flw_seq_bgn] = ACTIONS(117),
    [sym__r_flw_map_bgn] = ACTIONS(81),
    [sym__br_flw_map_bgn] = ACTIONS(83),
    [sym__b_flw_map_bgn] = ACTIONS(117),
    [sym__r_dqt_str_bgn] = ACTIONS(85),
    [sym__br_dqt_str_bgn] = ACTIONS(87),
    [sym__b_dqt_str_bgn] = ACTIONS(117),
    [sym__r_sqt_str_bgn] = ACTIONS(89),
    [sym__br_sqt_str_bgn] = ACTIONS(91),
    [sym__b_sqt_str_bgn] = ACTIONS(117),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(93),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(95),
    [sym__b_sgl_pln_nul_blk] = ACTIONS(117),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(93),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(95),
    [sym__b_sgl_pln_bol_blk] = ACTIONS(117),
    [sym__r_sgl_pln_int_blk] = ACTIONS(93),
    [sym__br_sgl_pln_int_blk] = ACTIONS(95),
    [sym__b_sgl_pln_int_blk] = ACTIONS(117),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(93),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(95),
    [sym__b_sgl_pln_flt_blk] = ACTIONS(117),
    [sym__r_sgl_pln_str_blk] = ACTIONS(93),
    [sym__br_sgl_pln_str_blk] = ACTIONS(95),
    [sym__b_sgl_pln_str_blk] = ACTIONS(117),
    [sym__r_mtl_pln_str_blk] = ACTIONS(97),
    [sym__br_mtl_pln_str_blk] = ACTIONS(99),
    [sym__r_tag] = ACTIONS(101),
    [sym__br_tag] = ACTIONS(103),
    [sym__b_tag] = ACTIONS(117),
    [sym__r_acr_bgn] = ACTIONS(105),
    [sym__br_acr_bgn] = ACTIONS(107),
    [sym__b_acr_bgn] = ACTIONS(117),
    [sym__r_als_bgn] = ACTIONS(109),
    [sym__br_als_bgn] = ACTIONS(111),
    [sym__b_als_bgn] = ACTIONS(117),
    [sym__bl] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__r_prp_val] = STATE(303),
    [sym__br_prp_val] = STATE(303),
    [sym__r_sgl_prp_val] = STATE(1227),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__r_prp] = STATE(35),
    [sym__br_prp] = STATE(36),
    [sym__r_sgl_prp] = STATE(308),
    [sym__br_sgl_prp] = STATE(309),
    [sym__r_blk_seq_r_val] = STATE(303),
    [sym__r_blk_seq_br_val] = STATE(303),
    [sym__br_blk_seq_val] = STATE(303),
    [sym__r_blk_seq_spc_val] = STATE(303),
    [sym__br_blk_seq_spc_val] = STATE(303),
    [sym__b_blk_seq_spc_val] = STATE(303),
    [sym__r_blk_seq] = STATE(340),
    [sym__br_blk_seq] = STATE(341),
    [sym__b_blk_seq_spc] = STATE(310),
    [sym__r_blk_seq_itm] = STATE(965),
    [sym__br_blk_seq_itm] = STATE(966),
    [sym__b_blk_seq_itm] = STATE(1041),
    [sym__blk_seq_itm_tal] = STATE(303),
    [sym__r_blk_map_r_val] = STATE(303),
    [sym__r_blk_map_br_val] = STATE(303),
    [sym__br_blk_map_val] = STATE(303),
    [sym__r_blk_map] = STATE(342),
    [sym__br_blk_map] = STATE(343),
    [sym__r_blk_map_itm] = STATE(132),
    [sym__br_blk_map_itm] = STATE(133),
    [sym__r_blk_exp_itm] = STATE(318),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__r_blk_key_itm] = STATE(277),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__r_blk_val_itm] = STATE(327),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__r_blk_imp_itm] = STATE(360),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__blk_exp_itm_tal] = STATE(303),
    [sym__r_blk_str_val] = STATE(303),
    [sym__br_blk_str_val] = STATE(303),
    [sym__r_blk_str] = STATE(344),
    [sym__br_blk_str] = STATE(345),
    [sym__r_flw_seq_val] = STATE(303),
    [sym__br_flw_seq_val] = STATE(303),
    [sym__r_sgl_flw_seq_val] = STATE(1227),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(346),
    [sym__br_flw_seq] = STATE(347),
    [sym__r_sgl_flw_seq] = STATE(1420),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__r_flw_map_val] = STATE(303),
    [sym__br_flw_map_val] = STATE(303),
    [sym__r_sgl_flw_map_val] = STATE(1227),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(348),
    [sym__br_flw_map] = STATE(349),
    [sym__r_sgl_flw_map] = STATE(1442),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__r_dqt_str_val] = STATE(303),
    [sym__br_dqt_str_val] = STATE(303),
    [sym__r_sgl_dqt_str_val] = STATE(1227),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(350),
    [sym__br_dqt_str] = STATE(351),
    [sym__r_sgl_dqt_str] = STATE(1453),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__r_sqt_str_val] = STATE(303),
    [sym__br_sqt_str_val] = STATE(303),
    [sym__r_sgl_sqt_str_val] = STATE(1227),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(352),
    [sym__br_sqt_str] = STATE(353),
    [sym__r_sgl_sqt_str] = STATE(1411),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__r_pln_blk_val] = STATE(303),
    [sym__br_pln_blk_val] = STATE(303),
    [sym__r_sgl_pln_blk_val] = STATE(1227),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(281),
    [sym__br_sgl_pln_blk] = STATE(282),
    [sym__r_mtl_pln_blk] = STATE(356),
    [sym__br_mtl_pln_blk] = STATE(357),
    [sym__r_als_val] = STATE(262),
    [sym__br_als_val] = STATE(263),
    [sym__r_als] = STATE(266),
    [sym__br_als] = STATE(283),
    [sym__r_acr] = STATE(100),
    [sym__br_acr] = STATE(101),
    [aux_sym__r_blk_seq_repeat1] = STATE(1041),
    [sym__r_blk_seq_bgn] = ACTIONS(17),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(69),
    [sym__r_blk_key_bgn] = ACTIONS(21),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__b_blk_key_bgn] = ACTIONS(119),
    [sym__r_blk_val_bgn] = ACTIONS(25),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__b_blk_val_bgn] = ACTIONS(119),
    [sym__r_blk_lit_bgn] = ACTIONS(73),
    [sym__br_blk_lit_bgn] = ACTIONS(75),
    [sym__r_blk_fld_bgn] = ACTIONS(73),
    [sym__br_blk_fld_bgn] = ACTIONS(75),
    [sym__r_flw_seq_bgn] = ACTIONS(77),
    [sym__br_flw_seq_bgn] = ACTIONS(79),
    [sym__b_flw_seq_bgn] = ACTIONS(119),
    [sym__r_flw_map_bgn] = ACTIONS(81),
    [sym__br_flw_map_bgn] = ACTIONS(83),
    [sym__b_flw_map_bgn] = ACTIONS(119),
    [sym__r_dqt_str_bgn] = ACTIONS(85),
    [sym__br_dqt_str_bgn] = ACTIONS(87),
    [sym__b_dqt_str_bgn] = ACTIONS(119),
    [sym__r_sqt_str_bgn] = ACTIONS(89),
    [sym__br_sqt_str_bgn] = ACTIONS(91),
    [sym__b_sqt_str_bgn] = ACTIONS(119),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(93),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(95),
    [sym__b_sgl_pln_nul_blk] = ACTIONS(119),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(93),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(95),
    [sym__b_sgl_pln_bol_blk] = ACTIONS(119),
    [sym__r_sgl_pln_int_blk] = ACTIONS(93),
    [sym__br_sgl_pln_int_blk] = ACTIONS(95),
    [sym__b_sgl_pln_int_blk] = ACTIONS(119),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(93),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(95),
    [sym__b_sgl_pln_flt_blk] = ACTIONS(119),
    [sym__r_sgl_pln_str_blk] = ACTIONS(93),
    [sym__br_sgl_pln_str_blk] = ACTIONS(95),
    [sym__b_sgl_pln_str_blk] = ACTIONS(119),
    [sym__r_mtl_pln_str_blk] = ACTIONS(97),
    [sym__br_mtl_pln_str_blk] = ACTIONS(99),
    [sym__r_tag] = ACTIONS(101),
    [sym__br_tag] = ACTIONS(103),
    [sym__b_tag] = ACTIONS(119),
    [sym__r_acr_bgn] = ACTIONS(105),
    [sym__br_acr_bgn] = ACTIONS(107),
    [sym__b_acr_bgn] = ACTIONS(119),
    [sym__r_als_bgn] = ACTIONS(109),
    [sym__br_als_bgn] = ACTIONS(111),
    [sym__b_als_bgn] = ACTIONS(119),
    [sym__bl] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__r_prp_val] = STATE(302),
    [sym__br_prp_val] = STATE(302),
    [sym__r_sgl_prp_val] = STATE(1227),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__r_prp] = STATE(35),
    [sym__br_prp] = STATE(36),
    [sym__r_sgl_prp] = STATE(308),
    [sym__br_sgl_prp] = STATE(309),
    [sym__r_blk_seq_r_val] = STATE(302),
    [sym__r_blk_seq_br_val] = STATE(302),
    [sym__br_blk_seq_val] = STATE(302),
    [sym__r_blk_seq_spc_val] = STATE(302),
    [sym__br_blk_seq_spc_val] = STATE(302),
    [sym__b_blk_seq_spc_val] = STATE(302),
    [sym__r_blk_seq] = STATE(340),
    [sym__br_blk_seq] = STATE(341),
    [sym__b_blk_seq_spc] = STATE(310),
    [sym__r_blk_seq_itm] = STATE(965),
    [sym__br_blk_seq_itm] = STATE(966),
    [sym__b_blk_seq_itm] = STATE(1041),
    [sym__blk_seq_itm_tal] = STATE(302),
    [sym__r_blk_map_r_val] = STATE(302),
    [sym__r_blk_map_br_val] = STATE(302),
    [sym__br_blk_map_val] = STATE(302),
    [sym__r_blk_map] = STATE(342),
    [sym__br_blk_map] = STATE(343),
    [sym__r_blk_map_itm] = STATE(132),
    [sym__br_blk_map_itm] = STATE(133),
    [sym__r_blk_exp_itm] = STATE(318),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__r_blk_key_itm] = STATE(277),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__r_blk_val_itm] = STATE(327),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__r_blk_imp_itm] = STATE(360),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__blk_exp_itm_tal] = STATE(302),
    [sym__r_blk_str_val] = STATE(302),
    [sym__br_blk_str_val] = STATE(302),
    [sym__r_blk_str] = STATE(344),
    [sym__br_blk_str] = STATE(345),
    [sym__r_flw_seq_val] = STATE(302),
    [sym__br_flw_seq_val] = STATE(302),
    [sym__r_sgl_flw_seq_val] = STATE(1227),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(346),
    [sym__br_flw_seq] = STATE(347),
    [sym__r_sgl_flw_seq] = STATE(1420),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__r_flw_map_val] = STATE(302),
    [sym__br_flw_map_val] = STATE(302),
    [sym__r_sgl_flw_map_val] = STATE(1227),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(348),
    [sym__br_flw_map] = STATE(349),
    [sym__r_sgl_flw_map] = STATE(1442),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__r_dqt_str_val] = STATE(302),
    [sym__br_dqt_str_val] = STATE(302),
    [sym__r_sgl_dqt_str_val] = STATE(1227),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(350),
    [sym__br_dqt_str] = STATE(351),
    [sym__r_sgl_dqt_str] = STATE(1453),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__r_sqt_str_val] = STATE(302),
    [sym__br_sqt_str_val] = STATE(302),
    [sym__r_sgl_sqt_str_val] = STATE(1227),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(352),
    [sym__br_sqt_str] = STATE(353),
    [sym__r_sgl_sqt_str] = STATE(1411),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__r_pln_blk_val] = STATE(302),
    [sym__br_pln_blk_val] = STATE(302),
    [sym__r_sgl_pln_blk_val] = STATE(1227),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(281),
    [sym__br_sgl_pln_blk] = STATE(282),
    [sym__r_mtl_pln_blk] = STATE(356),
    [sym__br_mtl_pln_blk] = STATE(357),
    [sym__r_als_val] = STATE(262),
    [sym__br_als_val] = STATE(263),
    [sym__r_als] = STATE(266),
    [sym__br_als] = STATE(283),
    [sym__r_acr] = STATE(100),
    [sym__br_acr] = STATE(101),
    [aux_sym__r_blk_seq_repeat1] = STATE(1041),
    [sym__r_blk_seq_bgn] = ACTIONS(17),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(69),
    [sym__r_blk_key_bgn] = ACTIONS(21),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__b_blk_key_bgn] = ACTIONS(121),
    [sym__r_blk_val_bgn] = ACTIONS(25),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__b_blk_val_bgn] = ACTIONS(121),
    [sym__r_blk_lit_bgn] = ACTIONS(73),
    [sym__br_blk_lit_bgn] = ACTIONS(75),
    [sym__r_blk_fld_bgn] = ACTIONS(73),
    [sym__br_blk_fld_bgn] = ACTIONS(75),
    [sym__r_flw_seq_bgn] = ACTIONS(77),
    [sym__br_flw_seq_bgn] = ACTIONS(79),
    [sym__b_flw_seq_bgn] = ACTIONS(121),
    [sym__r_flw_map_bgn] = ACTIONS(81),
    [sym__br_flw_map_bgn] = ACTIONS(83),
    [sym__b_flw_map_bgn] = ACTIONS(121),
    [sym__r_dqt_str_bgn] = ACTIONS(85),
    [sym__br_dqt_str_bgn] = ACTIONS(87),
    [sym__b_dqt_str_bgn] = ACTIONS(121),
    [sym__r_sqt_str_bgn] = ACTIONS(89),
    [sym__br_sqt_str_bgn] = ACTIONS(91),
    [sym__b_sqt_str_bgn] = ACTIONS(121),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(93),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(95),
    [sym__b_sgl_pln_nul_blk] = ACTIONS(121),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(93),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(95),
    [sym__b_sgl_pln_bol_blk] = ACTIONS(121),
    [sym__r_sgl_pln_int_blk] = ACTIONS(93),
    [sym__br_sgl_pln_int_blk] = ACTIONS(95),
    [sym__b_sgl_pln_int_blk] = ACTIONS(121),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(93),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(95),
    [sym__b_sgl_pln_flt_blk] = ACTIONS(121),
    [sym__r_sgl_pln_str_blk] = ACTIONS(93),
    [sym__br_sgl_pln_str_blk] = ACTIONS(95),
    [sym__b_sgl_pln_str_blk] = ACTIONS(121),
    [sym__r_mtl_pln_str_blk] = ACTIONS(97),
    [sym__br_mtl_pln_str_blk] = ACTIONS(99),
    [sym__r_tag] = ACTIONS(101),
    [sym__br_tag] = ACTIONS(103),
    [sym__b_tag] = ACTIONS(121),
    [sym__r_acr_bgn] = ACTIONS(105),
    [sym__br_acr_bgn] = ACTIONS(107),
    [sym__b_acr_bgn] = ACTIONS(121),
    [sym__r_als_bgn] = ACTIONS(109),
    [sym__br_als_bgn] = ACTIONS(111),
    [sym__b_als_bgn] = ACTIONS(121),
    [sym__bl] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__r_prp_val] = STATE(1267),
    [sym__br_prp_val] = STATE(1267),
    [sym__r_sgl_prp_val] = STATE(1227),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__r_prp] = STATE(83),
    [sym__br_prp] = STATE(82),
    [sym__r_sgl_prp] = STATE(308),
    [sym__br_sgl_prp] = STATE(309),
    [sym__r_blk_seq_r_val] = STATE(1267),
    [sym__r_blk_seq_br_val] = STATE(1267),
    [sym__br_blk_seq_val] = STATE(1267),
    [sym__r_blk_seq] = STATE(1386),
    [sym__br_blk_seq] = STATE(1387),
    [sym__r_blk_seq_itm] = STATE(1002),
    [sym__br_blk_seq_itm] = STATE(1003),
    [sym__blk_seq_itm_tal] = STATE(1267),
    [sym__r_blk_map_r_val] = STATE(1267),
    [sym__r_blk_map_br_val] = STATE(1267),
    [sym__br_blk_map_val] = STATE(1267),
    [sym__r_blk_map] = STATE(1388),
    [sym__br_blk_map] = STATE(1389),
    [sym__r_blk_map_itm] = STATE(126),
    [sym__br_blk_map_itm] = STATE(127),
    [sym__r_blk_exp_itm] = STATE(318),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__r_blk_key_itm] = STATE(277),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__r_blk_val_itm] = STATE(327),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__r_blk_imp_itm] = STATE(360),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__r_blk_str_val] = STATE(1267),
    [sym__br_blk_str_val] = STATE(1267),
    [sym__r_blk_str] = STATE(1390),
    [sym__br_blk_str] = STATE(1393),
    [sym__r_flw_seq_val] = STATE(1267),
    [sym__br_flw_seq_val] = STATE(1267),
    [sym__r_sgl_flw_seq_val] = STATE(1227),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(1394),
    [sym__br_flw_seq] = STATE(1395),
    [sym__r_sgl_flw_seq] = STATE(1420),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__r_flw_map_val] = STATE(1267),
    [sym__br_flw_map_val] = STATE(1267),
    [sym__r_sgl_flw_map_val] = STATE(1227),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(1401),
    [sym__br_flw_map] = STATE(1402),
    [sym__r_sgl_flw_map] = STATE(1442),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__r_dqt_str_val] = STATE(1267),
    [sym__br_dqt_str_val] = STATE(1267),
    [sym__r_sgl_dqt_str_val] = STATE(1227),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(1404),
    [sym__br_dqt_str] = STATE(1407),
    [sym__r_sgl_dqt_str] = STATE(1453),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__r_sqt_str_val] = STATE(1267),
    [sym__br_sqt_str_val] = STATE(1267),
    [sym__r_sgl_sqt_str_val] = STATE(1227),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(1217),
    [sym__br_sqt_str] = STATE(1218),
    [sym__r_sgl_sqt_str] = STATE(1411),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__r_pln_blk_val] = STATE(1267),
    [sym__br_pln_blk_val] = STATE(1267),
    [sym__r_sgl_pln_blk_val] = STATE(1227),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(1117),
    [sym__br_sgl_pln_blk] = STATE(1118),
    [sym__r_mtl_pln_blk] = STATE(1220),
    [sym__br_mtl_pln_blk] = STATE(1221),
    [sym__r_als_val] = STATE(967),
    [sym__br_als_val] = STATE(969),
    [sym__r_als] = STATE(1137),
    [sym__br_als] = STATE(1122),
    [sym__r_acr] = STATE(166),
    [sym__br_acr] = STATE(167),
    [sym__r_blk_seq_bgn] = ACTIONS(17),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(123),
    [sym__r_blk_key_bgn] = ACTIONS(21),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__r_blk_val_bgn] = ACTIONS(25),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__r_blk_lit_bgn] = ACTIONS(125),
    [sym__br_blk_lit_bgn] = ACTIONS(127),
    [sym__r_blk_fld_bgn] = ACTIONS(125),
    [sym__br_blk_fld_bgn] = ACTIONS(127),
    [sym__r_flw_seq_bgn] = ACTIONS(129),
    [sym__br_flw_seq_bgn] = ACTIONS(131),
    [sym__r_flw_map_bgn] = ACTIONS(133),
    [sym__br_flw_map_bgn] = ACTIONS(135),
    [sym__r_dqt_str_bgn] = ACTIONS(137),
    [sym__br_dqt_str_bgn] = ACTIONS(139),
    [sym__r_sqt_str_bgn] = ACTIONS(141),
    [sym__br_sqt_str_bgn] = ACTIONS(143),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(145),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(147),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(145),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(147),
    [sym__r_sgl_pln_int_blk] = ACTIONS(145),
    [sym__br_sgl_pln_int_blk] = ACTIONS(147),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(145),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(147),
    [sym__r_sgl_pln_str_blk] = ACTIONS(145),
    [sym__br_sgl_pln_str_blk] = ACTIONS(147),
    [sym__r_mtl_pln_str_blk] = ACTIONS(149),
    [sym__br_mtl_pln_str_blk] = ACTIONS(151),
    [sym__r_tag] = ACTIONS(153),
    [sym__br_tag] = ACTIONS(155),
    [sym__r_acr_bgn] = ACTIONS(157),
    [sym__br_acr_bgn] = ACTIONS(159),
    [sym__r_als_bgn] = ACTIONS(161),
    [sym__br_als_bgn] = ACTIONS(163),
    [sym__bl] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__r_prp_val] = STATE(1268),
    [sym__br_prp_val] = STATE(1268),
    [sym__r_sgl_prp_val] = STATE(1227),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__r_prp] = STATE(83),
    [sym__br_prp] = STATE(82),
    [sym__r_sgl_prp] = STATE(308),
    [sym__br_sgl_prp] = STATE(309),
    [sym__r_blk_seq_r_val] = STATE(1268),
    [sym__r_blk_seq_br_val] = STATE(1268),
    [sym__br_blk_seq_val] = STATE(1268),
    [sym__r_blk_seq] = STATE(1386),
    [sym__br_blk_seq] = STATE(1387),
    [sym__r_blk_seq_itm] = STATE(1002),
    [sym__br_blk_seq_itm] = STATE(1003),
    [sym__blk_seq_itm_tal] = STATE(1268),
    [sym__r_blk_map_r_val] = STATE(1268),
    [sym__r_blk_map_br_val] = STATE(1268),
    [sym__br_blk_map_val] = STATE(1268),
    [sym__r_blk_map] = STATE(1388),
    [sym__br_blk_map] = STATE(1389),
    [sym__r_blk_map_itm] = STATE(126),
    [sym__br_blk_map_itm] = STATE(127),
    [sym__r_blk_exp_itm] = STATE(318),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__r_blk_key_itm] = STATE(277),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__r_blk_val_itm] = STATE(327),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__r_blk_imp_itm] = STATE(360),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__r_blk_str_val] = STATE(1268),
    [sym__br_blk_str_val] = STATE(1268),
    [sym__r_blk_str] = STATE(1390),
    [sym__br_blk_str] = STATE(1393),
    [sym__r_flw_seq_val] = STATE(1268),
    [sym__br_flw_seq_val] = STATE(1268),
    [sym__r_sgl_flw_seq_val] = STATE(1227),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(1394),
    [sym__br_flw_seq] = STATE(1395),
    [sym__r_sgl_flw_seq] = STATE(1420),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__r_flw_map_val] = STATE(1268),
    [sym__br_flw_map_val] = STATE(1268),
    [sym__r_sgl_flw_map_val] = STATE(1227),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(1401),
    [sym__br_flw_map] = STATE(1402),
    [sym__r_sgl_flw_map] = STATE(1442),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__r_dqt_str_val] = STATE(1268),
    [sym__br_dqt_str_val] = STATE(1268),
    [sym__r_sgl_dqt_str_val] = STATE(1227),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(1404),
    [sym__br_dqt_str] = STATE(1407),
    [sym__r_sgl_dqt_str] = STATE(1453),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__r_sqt_str_val] = STATE(1268),
    [sym__br_sqt_str_val] = STATE(1268),
    [sym__r_sgl_sqt_str_val] = STATE(1227),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(1217),
    [sym__br_sqt_str] = STATE(1218),
    [sym__r_sgl_sqt_str] = STATE(1411),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__r_pln_blk_val] = STATE(1268),
    [sym__br_pln_blk_val] = STATE(1268),
    [sym__r_sgl_pln_blk_val] = STATE(1227),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(1117),
    [sym__br_sgl_pln_blk] = STATE(1118),
    [sym__r_mtl_pln_blk] = STATE(1220),
    [sym__br_mtl_pln_blk] = STATE(1221),
    [sym__r_als_val] = STATE(967),
    [sym__br_als_val] = STATE(969),
    [sym__r_als] = STATE(1137),
    [sym__br_als] = STATE(1122),
    [sym__r_acr] = STATE(166),
    [sym__br_acr] = STATE(167),
    [sym__r_blk_seq_bgn] = ACTIONS(17),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(165),
    [sym__r_blk_key_bgn] = ACTIONS(21),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__r_blk_val_bgn] = ACTIONS(25),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__r_blk_lit_bgn] = ACTIONS(125),
    [sym__br_blk_lit_bgn] = ACTIONS(127),
    [sym__r_blk_fld_bgn] = ACTIONS(125),
    [sym__br_blk_fld_bgn] = ACTIONS(127),
    [sym__r_flw_seq_bgn] = ACTIONS(129),
    [sym__br_flw_seq_bgn] = ACTIONS(131),
    [sym__r_flw_map_bgn] = ACTIONS(133),
    [sym__br_flw_map_bgn] = ACTIONS(135),
    [sym__r_dqt_str_bgn] = ACTIONS(137),
    [sym__br_dqt_str_bgn] = ACTIONS(139),
    [sym__r_sqt_str_bgn] = ACTIONS(141),
    [sym__br_sqt_str_bgn] = ACTIONS(143),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(145),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(147),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(145),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(147),
    [sym__r_sgl_pln_int_blk] = ACTIONS(145),
    [sym__br_sgl_pln_int_blk] = ACTIONS(147),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(145),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(147),
    [sym__r_sgl_pln_str_blk] = ACTIONS(145),
    [sym__br_sgl_pln_str_blk] = ACTIONS(147),
    [sym__r_mtl_pln_str_blk] = ACTIONS(149),
    [sym__br_mtl_pln_str_blk] = ACTIONS(151),
    [sym__r_tag] = ACTIONS(153),
    [sym__br_tag] = ACTIONS(155),
    [sym__r_acr_bgn] = ACTIONS(157),
    [sym__br_acr_bgn] = ACTIONS(159),
    [sym__r_als_bgn] = ACTIONS(161),
    [sym__br_als_bgn] = ACTIONS(163),
    [sym__bl] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__r_prp_val] = STATE(1313),
    [sym__br_prp_val] = STATE(1313),
    [sym__r_sgl_prp_val] = STATE(1227),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__r_prp] = STATE(83),
    [sym__br_prp] = STATE(82),
    [sym__r_sgl_prp] = STATE(308),
    [sym__br_sgl_prp] = STATE(309),
    [sym__r_blk_seq_r_val] = STATE(1313),
    [sym__r_blk_seq_br_val] = STATE(1313),
    [sym__br_blk_seq_val] = STATE(1313),
    [sym__r_blk_seq] = STATE(1386),
    [sym__br_blk_seq] = STATE(1387),
    [sym__r_blk_seq_itm] = STATE(1002),
    [sym__br_blk_seq_itm] = STATE(1003),
    [sym__blk_seq_itm_tal] = STATE(1313),
    [sym__r_blk_map_r_val] = STATE(1313),
    [sym__r_blk_map_br_val] = STATE(1313),
    [sym__br_blk_map_val] = STATE(1313),
    [sym__r_blk_map] = STATE(1388),
    [sym__br_blk_map] = STATE(1389),
    [sym__r_blk_map_itm] = STATE(126),
    [sym__br_blk_map_itm] = STATE(127),
    [sym__r_blk_exp_itm] = STATE(318),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__r_blk_key_itm] = STATE(277),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__r_blk_val_itm] = STATE(327),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__r_blk_imp_itm] = STATE(360),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__r_blk_str_val] = STATE(1313),
    [sym__br_blk_str_val] = STATE(1313),
    [sym__r_blk_str] = STATE(1390),
    [sym__br_blk_str] = STATE(1393),
    [sym__r_flw_seq_val] = STATE(1313),
    [sym__br_flw_seq_val] = STATE(1313),
    [sym__r_sgl_flw_seq_val] = STATE(1227),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(1394),
    [sym__br_flw_seq] = STATE(1395),
    [sym__r_sgl_flw_seq] = STATE(1420),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__r_flw_map_val] = STATE(1313),
    [sym__br_flw_map_val] = STATE(1313),
    [sym__r_sgl_flw_map_val] = STATE(1227),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(1401),
    [sym__br_flw_map] = STATE(1402),
    [sym__r_sgl_flw_map] = STATE(1442),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__r_dqt_str_val] = STATE(1313),
    [sym__br_dqt_str_val] = STATE(1313),
    [sym__r_sgl_dqt_str_val] = STATE(1227),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(1404),
    [sym__br_dqt_str] = STATE(1407),
    [sym__r_sgl_dqt_str] = STATE(1453),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__r_sqt_str_val] = STATE(1313),
    [sym__br_sqt_str_val] = STATE(1313),
    [sym__r_sgl_sqt_str_val] = STATE(1227),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(1217),
    [sym__br_sqt_str] = STATE(1218),
    [sym__r_sgl_sqt_str] = STATE(1411),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__r_pln_blk_val] = STATE(1313),
    [sym__br_pln_blk_val] = STATE(1313),
    [sym__r_sgl_pln_blk_val] = STATE(1227),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(1117),
    [sym__br_sgl_pln_blk] = STATE(1118),
    [sym__r_mtl_pln_blk] = STATE(1220),
    [sym__br_mtl_pln_blk] = STATE(1221),
    [sym__r_als_val] = STATE(967),
    [sym__br_als_val] = STATE(969),
    [sym__r_als] = STATE(1137),
    [sym__br_als] = STATE(1122),
    [sym__r_acr] = STATE(166),
    [sym__br_acr] = STATE(167),
    [sym__r_blk_seq_bgn] = ACTIONS(17),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(167),
    [sym__r_blk_key_bgn] = ACTIONS(21),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__r_blk_val_bgn] = ACTIONS(25),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__r_blk_lit_bgn] = ACTIONS(125),
    [sym__br_blk_lit_bgn] = ACTIONS(127),
    [sym__r_blk_fld_bgn] = ACTIONS(125),
    [sym__br_blk_fld_bgn] = ACTIONS(127),
    [sym__r_flw_seq_bgn] = ACTIONS(129),
    [sym__br_flw_seq_bgn] = ACTIONS(131),
    [sym__r_flw_map_bgn] = ACTIONS(133),
    [sym__br_flw_map_bgn] = ACTIONS(135),
    [sym__r_dqt_str_bgn] = ACTIONS(137),
    [sym__br_dqt_str_bgn] = ACTIONS(139),
    [sym__r_sqt_str_bgn] = ACTIONS(141),
    [sym__br_sqt_str_bgn] = ACTIONS(143),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(145),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(147),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(145),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(147),
    [sym__r_sgl_pln_int_blk] = ACTIONS(145),
    [sym__br_sgl_pln_int_blk] = ACTIONS(147),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(145),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(147),
    [sym__r_sgl_pln_str_blk] = ACTIONS(145),
    [sym__br_sgl_pln_str_blk] = ACTIONS(147),
    [sym__r_mtl_pln_str_blk] = ACTIONS(149),
    [sym__br_mtl_pln_str_blk] = ACTIONS(151),
    [sym__r_tag] = ACTIONS(153),
    [sym__br_tag] = ACTIONS(155),
    [sym__r_acr_bgn] = ACTIONS(157),
    [sym__br_acr_bgn] = ACTIONS(159),
    [sym__r_als_bgn] = ACTIONS(161),
    [sym__br_als_bgn] = ACTIONS(163),
    [sym__bl] = ACTIONS(167),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__r_prp_val] = STATE(300),
    [sym__br_prp_val] = STATE(300),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__r_prp] = STATE(35),
    [sym__br_prp] = STATE(36),
    [sym__br_sgl_prp] = STATE(309),
    [sym__r_blk_seq_br_val] = STATE(300),
    [sym__br_blk_seq_val] = STATE(300),
    [sym__r_blk_seq_spc_val] = STATE(300),
    [sym__br_blk_seq_spc_val] = STATE(300),
    [sym__b_blk_seq_spc_val] = STATE(300),
    [sym__br_blk_seq] = STATE(341),
    [sym__b_blk_seq_spc] = STATE(310),
    [sym__br_blk_seq_itm] = STATE(966),
    [sym__b_blk_seq_itm] = STATE(1041),
    [sym__r_blk_map_br_val] = STATE(300),
    [sym__br_blk_map_val] = STATE(300),
    [sym__br_blk_map] = STATE(343),
    [sym__br_blk_map_itm] = STATE(133),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__r_blk_str_val] = STATE(300),
    [sym__br_blk_str_val] = STATE(300),
    [sym__r_blk_str] = STATE(344),
    [sym__br_blk_str] = STATE(345),
    [sym__r_flw_seq_val] = STATE(300),
    [sym__br_flw_seq_val] = STATE(300),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(346),
    [sym__br_flw_seq] = STATE(347),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__r_flw_map_val] = STATE(300),
    [sym__br_flw_map_val] = STATE(300),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(348),
    [sym__br_flw_map] = STATE(349),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__r_dqt_str_val] = STATE(300),
    [sym__br_dqt_str_val] = STATE(300),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(350),
    [sym__br_dqt_str] = STATE(351),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__r_sqt_str_val] = STATE(300),
    [sym__br_sqt_str_val] = STATE(300),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(352),
    [sym__br_sqt_str] = STATE(353),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__r_pln_blk_val] = STATE(300),
    [sym__br_pln_blk_val] = STATE(300),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(356),
    [sym__br_sgl_pln_blk] = STATE(282),
    [sym__r_mtl_pln_blk] = STATE(356),
    [sym__br_mtl_pln_blk] = STATE(357),
    [sym__r_als_val] = STATE(300),
    [sym__br_als_val] = STATE(265),
    [sym__r_als] = STATE(330),
    [sym__br_als] = STATE(283),
    [sym__r_acr] = STATE(104),
    [sym__br_acr] = STATE(101),
    [aux_sym__r_blk_seq_repeat1] = STATE(1041),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(69),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__b_blk_key_bgn] = ACTIONS(169),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__b_blk_val_bgn] = ACTIONS(169),
    [sym__r_blk_lit_bgn] = ACTIONS(73),
    [sym__br_blk_lit_bgn] = ACTIONS(75),
    [sym__r_blk_fld_bgn] = ACTIONS(73),
    [sym__br_blk_fld_bgn] = ACTIONS(75),
    [sym__r_flw_seq_bgn] = ACTIONS(171),
    [sym__br_flw_seq_bgn] = ACTIONS(79),
    [sym__b_flw_seq_bgn] = ACTIONS(169),
    [sym__r_flw_map_bgn] = ACTIONS(173),
    [sym__br_flw_map_bgn] = ACTIONS(83),
    [sym__b_flw_map_bgn] = ACTIONS(169),
    [sym__r_dqt_str_bgn] = ACTIONS(175),
    [sym__br_dqt_str_bgn] = ACTIONS(87),
    [sym__b_dqt_str_bgn] = ACTIONS(169),
    [sym__r_sqt_str_bgn] = ACTIONS(177),
    [sym__br_sqt_str_bgn] = ACTIONS(91),
    [sym__b_sqt_str_bgn] = ACTIONS(169),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(179),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(95),
    [sym__b_sgl_pln_nul_blk] = ACTIONS(169),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(179),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(95),
    [sym__b_sgl_pln_bol_blk] = ACTIONS(169),
    [sym__r_sgl_pln_int_blk] = ACTIONS(179),
    [sym__br_sgl_pln_int_blk] = ACTIONS(95),
    [sym__b_sgl_pln_int_blk] = ACTIONS(169),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(179),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(95),
    [sym__b_sgl_pln_flt_blk] = ACTIONS(169),
    [sym__r_sgl_pln_str_blk] = ACTIONS(179),
    [sym__br_sgl_pln_str_blk] = ACTIONS(95),
    [sym__b_sgl_pln_str_blk] = ACTIONS(169),
    [sym__r_mtl_pln_str_blk] = ACTIONS(97),
    [sym__br_mtl_pln_str_blk] = ACTIONS(99),
    [sym__r_tag] = ACTIONS(181),
    [sym__br_tag] = ACTIONS(103),
    [sym__b_tag] = ACTIONS(169),
    [sym__r_acr_bgn] = ACTIONS(183),
    [sym__br_acr_bgn] = ACTIONS(107),
    [sym__b_acr_bgn] = ACTIONS(169),
    [sym__r_als_bgn] = ACTIONS(185),
    [sym__br_als_bgn] = ACTIONS(111),
    [sym__b_als_bgn] = ACTIONS(169),
    [sym__bl] = ACTIONS(169),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__exp_doc_tal] = STATE(1143),
    [sym__r_prp_val] = STATE(1143),
    [sym__br_prp_val] = STATE(1143),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__r_prp] = STATE(81),
    [sym__br_prp] = STATE(80),
    [sym__br_sgl_prp] = STATE(309),
    [sym__r_blk_seq_br_val] = STATE(1143),
    [sym__br_blk_seq_val] = STATE(1143),
    [sym__br_blk_seq] = STATE(1170),
    [sym__br_blk_seq_itm] = STATE(1048),
    [sym__r_blk_map_br_val] = STATE(1143),
    [sym__br_blk_map_val] = STATE(1143),
    [sym__br_blk_map] = STATE(1200),
    [sym__br_blk_map_itm] = STATE(148),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__r_blk_str_val] = STATE(1143),
    [sym__br_blk_str_val] = STATE(1143),
    [sym__r_blk_str] = STATE(1083),
    [sym__br_blk_str] = STATE(1103),
    [sym__r_flw_seq_val] = STATE(1143),
    [sym__br_flw_seq_val] = STATE(1143),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(1115),
    [sym__br_flw_seq] = STATE(1156),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__r_flw_map_val] = STATE(1143),
    [sym__br_flw_map_val] = STATE(1143),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(1070),
    [sym__br_flw_map] = STATE(1071),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__r_dqt_str_val] = STATE(1143),
    [sym__br_dqt_str_val] = STATE(1143),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(1060),
    [sym__br_dqt_str] = STATE(1087),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__r_sqt_str_val] = STATE(1143),
    [sym__br_sqt_str_val] = STATE(1143),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(1127),
    [sym__br_sqt_str] = STATE(1129),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__r_pln_blk_val] = STATE(1143),
    [sym__br_pln_blk_val] = STATE(1143),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(1094),
    [sym__br_sgl_pln_blk] = STATE(997),
    [sym__r_mtl_pln_blk] = STATE(1094),
    [sym__br_mtl_pln_blk] = STATE(1095),
    [sym__r_als_val] = STATE(1143),
    [sym__br_als_val] = STATE(918),
    [sym__r_als] = STATE(1049),
    [sym__br_als] = STATE(1001),
    [sym__r_acr] = STATE(160),
    [sym__br_acr] = STATE(152),
    [sym__eof] = ACTIONS(187),
    [sym__s_drs_end] = ACTIONS(187),
    [sym__s_doc_end] = ACTIONS(187),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__r_blk_lit_bgn] = ACTIONS(29),
    [sym__br_blk_lit_bgn] = ACTIONS(31),
    [sym__r_blk_fld_bgn] = ACTIONS(29),
    [sym__br_blk_fld_bgn] = ACTIONS(31),
    [sym__r_flw_seq_bgn] = ACTIONS(189),
    [sym__br_flw_seq_bgn] = ACTIONS(35),
    [sym__r_flw_map_bgn] = ACTIONS(191),
    [sym__br_flw_map_bgn] = ACTIONS(39),
    [sym__r_dqt_str_bgn] = ACTIONS(193),
    [sym__br_dqt_str_bgn] = ACTIONS(43),
    [sym__r_sqt_str_bgn] = ACTIONS(195),
    [sym__br_sqt_str_bgn] = ACTIONS(47),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(197),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(51),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(197),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(51),
    [sym__r_sgl_pln_int_blk] = ACTIONS(197),
    [sym__br_sgl_pln_int_blk] = ACTIONS(51),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(197),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(51),
    [sym__r_sgl_pln_str_blk] = ACTIONS(197),
    [sym__br_sgl_pln_str_blk] = ACTIONS(51),
    [sym__r_mtl_pln_str_blk] = ACTIONS(53),
    [sym__br_mtl_pln_str_blk] = ACTIONS(55),
    [sym__r_tag] = ACTIONS(199),
    [sym__br_tag] = ACTIONS(59),
    [sym__r_acr_bgn] = ACTIONS(201),
    [sym__br_acr_bgn] = ACTIONS(63),
    [sym__r_als_bgn] = ACTIONS(203),
    [sym__br_als_bgn] = ACTIONS(67),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_sgl_prp_val] = STATE(1038),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_sgl_prp] = STATE(261),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_sgl_flw_seq_val] = STATE(1045),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_sgl_flw_seq] = STATE(1209),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_sgl_flw_map_val] = STATE(1045),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_sgl_flw_map] = STATE(1210),
    [sym__flw_map_tal] = STATE(1321),
    [sym__sgl_flw_map_tal] = STATE(1422),
    [sym__r_flw_map_dat] = STATE(1183),
    [sym__br_flw_map_dat] = STATE(1183),
    [sym__r_sgl_flw_col_dat] = STATE(1460),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_sgl_flw_col_itm] = STATE(964),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_sgl_flw_exp_par] = STATE(1250),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_sgl_flw_imp_par] = STATE(1251),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1252),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_sgl_dqt_str_val] = STATE(1045),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sgl_dqt_str] = STATE(1213),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sgl_sqt_str_val] = STATE(1045),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_sgl_sqt_str] = STATE(1214),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw_val] = STATE(1038),
    [sym__r_sgl_pln_flw] = STATE(556),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(469),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(197),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(205),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(209),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(213),
    [sym__br_flw_map_end] = ACTIONS(215),
    [sym__b_flw_map_end] = ACTIONS(215),
    [sym__r_flw_key_bgn] = ACTIONS(217),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(221),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(225),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(229),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(241),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_sgl_prp_val] = STATE(1038),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_sgl_prp] = STATE(261),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_sgl_flw_seq_val] = STATE(1045),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_sgl_flw_seq] = STATE(1209),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_sgl_flw_map_val] = STATE(1045),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_sgl_flw_map] = STATE(1210),
    [sym__flw_map_tal] = STATE(879),
    [sym__sgl_flw_map_tal] = STATE(1322),
    [sym__r_flw_map_dat] = STATE(1212),
    [sym__br_flw_map_dat] = STATE(1212),
    [sym__r_sgl_flw_col_dat] = STATE(1449),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_sgl_flw_col_itm] = STATE(964),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_sgl_flw_exp_par] = STATE(1250),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_sgl_flw_imp_par] = STATE(1251),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1252),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_sgl_dqt_str_val] = STATE(1045),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sgl_dqt_str] = STATE(1213),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sgl_sqt_str_val] = STATE(1045),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_sgl_sqt_str] = STATE(1214),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw_val] = STATE(1038),
    [sym__r_sgl_pln_flw] = STATE(556),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(469),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(197),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(205),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(209),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(253),
    [sym__br_flw_map_end] = ACTIONS(255),
    [sym__b_flw_map_end] = ACTIONS(255),
    [sym__r_flw_key_bgn] = ACTIONS(217),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(221),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(225),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(229),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(241),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_sgl_prp_val] = STATE(1038),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_sgl_prp] = STATE(261),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_sgl_flw_seq_val] = STATE(1045),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_sgl_flw_seq] = STATE(1209),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_sgl_flw_map_val] = STATE(1045),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_sgl_flw_map] = STATE(1210),
    [sym__flw_map_tal] = STATE(1133),
    [sym__sgl_flw_map_tal] = STATE(1517),
    [sym__r_flw_map_dat] = STATE(1138),
    [sym__br_flw_map_dat] = STATE(1138),
    [sym__r_sgl_flw_col_dat] = STATE(1516),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_sgl_flw_col_itm] = STATE(964),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_sgl_flw_exp_par] = STATE(1250),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_sgl_flw_imp_par] = STATE(1251),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1252),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_sgl_dqt_str_val] = STATE(1045),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sgl_dqt_str] = STATE(1213),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sgl_sqt_str_val] = STATE(1045),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_sgl_sqt_str] = STATE(1214),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw_val] = STATE(1038),
    [sym__r_sgl_pln_flw] = STATE(556),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(469),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(197),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(205),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(209),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(257),
    [sym__br_flw_map_end] = ACTIONS(259),
    [sym__b_flw_map_end] = ACTIONS(259),
    [sym__r_flw_key_bgn] = ACTIONS(217),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(221),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(225),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(229),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(241),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_sgl_prp_val] = STATE(1038),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_sgl_prp] = STATE(261),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_sgl_flw_seq_val] = STATE(1045),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_sgl_flw_seq] = STATE(1209),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_sgl_flw_map_val] = STATE(1045),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_sgl_flw_map] = STATE(1210),
    [sym__flw_map_tal] = STATE(1076),
    [sym__sgl_flw_map_tal] = STATE(1450),
    [sym__r_flw_map_dat] = STATE(1138),
    [sym__br_flw_map_dat] = STATE(1138),
    [sym__r_sgl_flw_col_dat] = STATE(1516),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_sgl_flw_col_itm] = STATE(964),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_sgl_flw_exp_par] = STATE(1250),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_sgl_flw_imp_par] = STATE(1251),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1252),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_sgl_dqt_str_val] = STATE(1045),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sgl_dqt_str] = STATE(1213),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sgl_sqt_str_val] = STATE(1045),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_sgl_sqt_str] = STATE(1214),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw_val] = STATE(1038),
    [sym__r_sgl_pln_flw] = STATE(556),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(469),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(197),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(205),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(209),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(257),
    [sym__br_flw_map_end] = ACTIONS(261),
    [sym__b_flw_map_end] = ACTIONS(261),
    [sym__r_flw_key_bgn] = ACTIONS(217),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(221),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(225),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(229),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(241),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_sgl_prp_val] = STATE(1038),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_sgl_prp] = STATE(261),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_sgl_flw_seq_val] = STATE(1045),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_sgl_flw_seq] = STATE(1209),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_sgl_flw_map_val] = STATE(1045),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_sgl_flw_map] = STATE(1210),
    [sym__flw_map_tal] = STATE(1258),
    [sym__sgl_flw_map_tal] = STATE(1517),
    [sym__r_flw_map_dat] = STATE(1125),
    [sym__br_flw_map_dat] = STATE(1125),
    [sym__r_sgl_flw_col_dat] = STATE(1516),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_sgl_flw_col_itm] = STATE(964),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_sgl_flw_exp_par] = STATE(1250),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_sgl_flw_imp_par] = STATE(1251),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1252),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_sgl_dqt_str_val] = STATE(1045),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sgl_dqt_str] = STATE(1213),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sgl_sqt_str_val] = STATE(1045),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_sgl_sqt_str] = STATE(1214),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw_val] = STATE(1038),
    [sym__r_sgl_pln_flw] = STATE(556),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(469),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(197),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(205),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(209),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(263),
    [sym__br_flw_map_end] = ACTIONS(265),
    [sym__b_flw_map_end] = ACTIONS(265),
    [sym__r_flw_key_bgn] = ACTIONS(217),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(221),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(225),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(229),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(241),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_sgl_prp_val] = STATE(1038),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_sgl_prp] = STATE(261),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_sgl_flw_seq_val] = STATE(1045),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_sgl_flw_seq] = STATE(1209),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_sgl_flw_map_val] = STATE(1045),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_sgl_flw_map] = STATE(1210),
    [sym__flw_map_tal] = STATE(1259),
    [sym__sgl_flw_map_tal] = STATE(1450),
    [sym__r_flw_map_dat] = STATE(1125),
    [sym__br_flw_map_dat] = STATE(1125),
    [sym__r_sgl_flw_col_dat] = STATE(1516),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_sgl_flw_col_itm] = STATE(964),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_sgl_flw_exp_par] = STATE(1250),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_sgl_flw_imp_par] = STATE(1251),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1252),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_sgl_dqt_str_val] = STATE(1045),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sgl_dqt_str] = STATE(1213),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sgl_sqt_str_val] = STATE(1045),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_sgl_sqt_str] = STATE(1214),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw_val] = STATE(1038),
    [sym__r_sgl_pln_flw] = STATE(556),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(469),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(197),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(205),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(209),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(263),
    [sym__br_flw_map_end] = ACTIONS(267),
    [sym__b_flw_map_end] = ACTIONS(267),
    [sym__r_flw_key_bgn] = ACTIONS(217),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(221),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(225),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(229),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(241),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_sgl_prp_val] = STATE(1038),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_sgl_prp] = STATE(261),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_sgl_flw_seq_val] = STATE(1045),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_sgl_flw_seq] = STATE(1209),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_sgl_flw_map_val] = STATE(1045),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_sgl_flw_map] = STATE(1210),
    [sym__flw_map_tal] = STATE(715),
    [sym__sgl_flw_map_tal] = STATE(1145),
    [sym__r_flw_map_dat] = STATE(1166),
    [sym__br_flw_map_dat] = STATE(1166),
    [sym__r_sgl_flw_col_dat] = STATE(1471),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_sgl_flw_col_itm] = STATE(964),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_sgl_flw_exp_par] = STATE(1250),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_sgl_flw_imp_par] = STATE(1251),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1252),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_sgl_dqt_str_val] = STATE(1045),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sgl_dqt_str] = STATE(1213),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sgl_sqt_str_val] = STATE(1045),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_sgl_sqt_str] = STATE(1214),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw_val] = STATE(1038),
    [sym__r_sgl_pln_flw] = STATE(556),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(469),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(197),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(205),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(209),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(269),
    [sym__br_flw_map_end] = ACTIONS(271),
    [sym__b_flw_map_end] = ACTIONS(271),
    [sym__r_flw_key_bgn] = ACTIONS(217),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(221),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(225),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(229),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(241),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_sgl_prp_val] = STATE(1038),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_sgl_prp] = STATE(261),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_sgl_flw_seq_val] = STATE(1045),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_sgl_flw_seq] = STATE(1209),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_sgl_flw_map_val] = STATE(1045),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_sgl_flw_map] = STATE(1210),
    [sym__flw_map_tal] = STATE(369),
    [sym__sgl_flw_map_tal] = STATE(1517),
    [sym__r_flw_map_dat] = STATE(1152),
    [sym__br_flw_map_dat] = STATE(1152),
    [sym__r_sgl_flw_col_dat] = STATE(1516),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_sgl_flw_col_itm] = STATE(964),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_sgl_flw_exp_par] = STATE(1250),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_sgl_flw_imp_par] = STATE(1251),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1252),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_sgl_dqt_str_val] = STATE(1045),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sgl_dqt_str] = STATE(1213),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sgl_sqt_str_val] = STATE(1045),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_sgl_sqt_str] = STATE(1214),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw_val] = STATE(1038),
    [sym__r_sgl_pln_flw] = STATE(556),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(469),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(197),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(205),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(209),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(273),
    [sym__br_flw_map_end] = ACTIONS(275),
    [sym__b_flw_map_end] = ACTIONS(275),
    [sym__r_flw_key_bgn] = ACTIONS(217),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(221),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(225),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(229),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(241),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_sgl_prp_val] = STATE(1038),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_sgl_prp] = STATE(261),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_sgl_flw_seq_val] = STATE(1045),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_sgl_flw_seq] = STATE(1209),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_sgl_flw_map_val] = STATE(1045),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_sgl_flw_map] = STATE(1210),
    [sym__flw_map_tal] = STATE(831),
    [sym__sgl_flw_map_tal] = STATE(1264),
    [sym__r_flw_map_dat] = STATE(1194),
    [sym__br_flw_map_dat] = STATE(1194),
    [sym__r_sgl_flw_col_dat] = STATE(1527),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_sgl_flw_col_itm] = STATE(964),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_sgl_flw_exp_par] = STATE(1250),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_sgl_flw_imp_par] = STATE(1251),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1252),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_sgl_dqt_str_val] = STATE(1045),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sgl_dqt_str] = STATE(1213),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sgl_sqt_str_val] = STATE(1045),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_sgl_sqt_str] = STATE(1214),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw_val] = STATE(1038),
    [sym__r_sgl_pln_flw] = STATE(556),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(469),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(197),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(205),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(209),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(277),
    [sym__br_flw_map_end] = ACTIONS(279),
    [sym__b_flw_map_end] = ACTIONS(279),
    [sym__r_flw_key_bgn] = ACTIONS(217),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(221),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(225),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(229),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(241),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_sgl_prp_val] = STATE(1038),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_sgl_prp] = STATE(261),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_sgl_flw_seq_val] = STATE(1045),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_sgl_flw_seq] = STATE(1209),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_sgl_flw_map_val] = STATE(1045),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_sgl_flw_map] = STATE(1210),
    [sym__flw_map_tal] = STATE(370),
    [sym__sgl_flw_map_tal] = STATE(1450),
    [sym__r_flw_map_dat] = STATE(1152),
    [sym__br_flw_map_dat] = STATE(1152),
    [sym__r_sgl_flw_col_dat] = STATE(1516),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_sgl_flw_col_itm] = STATE(964),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_sgl_flw_exp_par] = STATE(1250),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_sgl_flw_imp_par] = STATE(1251),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1252),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_sgl_dqt_str_val] = STATE(1045),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sgl_dqt_str] = STATE(1213),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sgl_sqt_str_val] = STATE(1045),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_sgl_sqt_str] = STATE(1214),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw_val] = STATE(1038),
    [sym__r_sgl_pln_flw] = STATE(556),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(469),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(197),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(205),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(209),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(273),
    [sym__br_flw_map_end] = ACTIONS(281),
    [sym__b_flw_map_end] = ACTIONS(281),
    [sym__r_flw_key_bgn] = ACTIONS(217),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(221),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(225),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(229),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(241),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_sgl_prp_val] = STATE(1038),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_sgl_prp] = STATE(261),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_sgl_flw_seq_val] = STATE(1045),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_sgl_flw_seq] = STATE(1209),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_sgl_flw_map_val] = STATE(1045),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_sgl_flw_map] = STATE(1210),
    [sym__flw_map_tal] = STATE(570),
    [sym__sgl_flw_map_tal] = STATE(1064),
    [sym__r_flw_map_dat] = STATE(1173),
    [sym__br_flw_map_dat] = STATE(1173),
    [sym__r_sgl_flw_col_dat] = STATE(1476),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_sgl_flw_col_itm] = STATE(964),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_sgl_flw_exp_par] = STATE(1250),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_sgl_flw_imp_par] = STATE(1251),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1252),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_sgl_dqt_str_val] = STATE(1045),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sgl_dqt_str] = STATE(1213),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sgl_sqt_str_val] = STATE(1045),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_sgl_sqt_str] = STATE(1214),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw_val] = STATE(1038),
    [sym__r_sgl_pln_flw] = STATE(556),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(469),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(197),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(205),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(209),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(283),
    [sym__br_flw_map_end] = ACTIONS(285),
    [sym__b_flw_map_end] = ACTIONS(285),
    [sym__r_flw_key_bgn] = ACTIONS(217),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(221),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(225),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(229),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(241),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_sgl_prp_val] = STATE(976),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_sgl_prp] = STATE(264),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_sgl_flw_seq_val] = STATE(1025),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_sgl_flw_seq] = STATE(1110),
    [sym__flw_seq_tal] = STATE(1109),
    [sym__sgl_flw_seq_tal] = STATE(1416),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_sgl_flw_map_val] = STATE(1025),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_sgl_flw_map] = STATE(1113),
    [sym__r_flw_seq_dat] = STATE(1058),
    [sym__br_flw_seq_dat] = STATE(1058),
    [sym__r_sgl_flw_col_dat] = STATE(1459),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_sgl_flw_col_itm] = STATE(986),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_sgl_flw_exp_par] = STATE(1225),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_sgl_flw_imp_par] = STATE(1240),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1253),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_sgl_dqt_str_val] = STATE(1025),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sgl_dqt_str] = STATE(1114),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sgl_sqt_str_val] = STATE(1025),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_sgl_sqt_str] = STATE(1116),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw_val] = STATE(976),
    [sym__r_sgl_pln_flw] = STATE(747),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(538),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(209),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(287),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(291),
    [sym__br_flw_seq_end] = ACTIONS(293),
    [sym__b_flw_seq_end] = ACTIONS(293),
    [sym__r_flw_map_bgn] = ACTIONS(295),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(299),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(303),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(307),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(311),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(323),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_sgl_prp_val] = STATE(976),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_sgl_prp] = STATE(264),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_sgl_flw_seq_val] = STATE(1025),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_sgl_flw_seq] = STATE(1110),
    [sym__flw_seq_tal] = STATE(1131),
    [sym__sgl_flw_seq_tal] = STATE(1423),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_sgl_flw_map_val] = STATE(1025),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_sgl_flw_map] = STATE(1113),
    [sym__r_flw_seq_dat] = STATE(1058),
    [sym__br_flw_seq_dat] = STATE(1058),
    [sym__r_sgl_flw_col_dat] = STATE(1459),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_sgl_flw_col_itm] = STATE(986),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_sgl_flw_exp_par] = STATE(1225),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_sgl_flw_imp_par] = STATE(1240),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1253),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_sgl_dqt_str_val] = STATE(1025),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sgl_dqt_str] = STATE(1114),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sgl_sqt_str_val] = STATE(1025),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_sgl_sqt_str] = STATE(1116),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw_val] = STATE(976),
    [sym__r_sgl_pln_flw] = STATE(747),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(538),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(209),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(287),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(291),
    [sym__br_flw_seq_end] = ACTIONS(335),
    [sym__b_flw_seq_end] = ACTIONS(335),
    [sym__r_flw_map_bgn] = ACTIONS(295),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(299),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(303),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(307),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(311),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(323),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_sgl_prp_val] = STATE(976),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_sgl_prp] = STATE(264),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_sgl_flw_seq_val] = STATE(1025),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_sgl_flw_seq] = STATE(1110),
    [sym__flw_seq_tal] = STATE(1247),
    [sym__sgl_flw_seq_tal] = STATE(1423),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_sgl_flw_map_val] = STATE(1025),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_sgl_flw_map] = STATE(1113),
    [sym__r_flw_seq_dat] = STATE(1124),
    [sym__br_flw_seq_dat] = STATE(1124),
    [sym__r_sgl_flw_col_dat] = STATE(1459),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_sgl_flw_col_itm] = STATE(986),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_sgl_flw_exp_par] = STATE(1225),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_sgl_flw_imp_par] = STATE(1240),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1253),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_sgl_dqt_str_val] = STATE(1025),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sgl_dqt_str] = STATE(1114),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sgl_sqt_str_val] = STATE(1025),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_sgl_sqt_str] = STATE(1116),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw_val] = STATE(976),
    [sym__r_sgl_pln_flw] = STATE(747),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(538),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(209),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(287),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(337),
    [sym__br_flw_seq_end] = ACTIONS(339),
    [sym__b_flw_seq_end] = ACTIONS(339),
    [sym__r_flw_map_bgn] = ACTIONS(295),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(299),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(303),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(307),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(311),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(323),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_sgl_prp_val] = STATE(976),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_sgl_prp] = STATE(264),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_sgl_flw_seq_val] = STATE(1025),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_sgl_flw_seq] = STATE(1110),
    [sym__flw_seq_tal] = STATE(1256),
    [sym__sgl_flw_seq_tal] = STATE(1416),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_sgl_flw_map_val] = STATE(1025),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_sgl_flw_map] = STATE(1113),
    [sym__r_flw_seq_dat] = STATE(1124),
    [sym__br_flw_seq_dat] = STATE(1124),
    [sym__r_sgl_flw_col_dat] = STATE(1459),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_sgl_flw_col_itm] = STATE(986),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_sgl_flw_exp_par] = STATE(1225),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_sgl_flw_imp_par] = STATE(1240),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1253),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_sgl_dqt_str_val] = STATE(1025),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sgl_dqt_str] = STATE(1114),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sgl_sqt_str_val] = STATE(1025),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_sgl_sqt_str] = STATE(1116),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw_val] = STATE(976),
    [sym__r_sgl_pln_flw] = STATE(747),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(538),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(209),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(287),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(337),
    [sym__br_flw_seq_end] = ACTIONS(341),
    [sym__b_flw_seq_end] = ACTIONS(341),
    [sym__r_flw_map_bgn] = ACTIONS(295),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(299),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(303),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(307),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(311),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(323),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_sgl_prp_val] = STATE(976),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_sgl_prp] = STATE(264),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_sgl_flw_seq_val] = STATE(1025),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_sgl_flw_seq] = STATE(1110),
    [sym__flw_seq_tal] = STATE(366),
    [sym__sgl_flw_seq_tal] = STATE(1423),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_sgl_flw_map_val] = STATE(1025),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_sgl_flw_map] = STATE(1113),
    [sym__r_flw_seq_dat] = STATE(1151),
    [sym__br_flw_seq_dat] = STATE(1151),
    [sym__r_sgl_flw_col_dat] = STATE(1459),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_sgl_flw_col_itm] = STATE(986),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_sgl_flw_exp_par] = STATE(1225),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_sgl_flw_imp_par] = STATE(1240),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1253),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_sgl_dqt_str_val] = STATE(1025),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sgl_dqt_str] = STATE(1114),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sgl_sqt_str_val] = STATE(1025),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_sgl_sqt_str] = STATE(1116),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw_val] = STATE(976),
    [sym__r_sgl_pln_flw] = STATE(747),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(538),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(209),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(287),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(343),
    [sym__br_flw_seq_end] = ACTIONS(345),
    [sym__b_flw_seq_end] = ACTIONS(345),
    [sym__r_flw_map_bgn] = ACTIONS(295),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(299),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(303),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(307),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(311),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(323),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_sgl_prp_val] = STATE(976),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_sgl_prp] = STATE(264),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_sgl_flw_seq_val] = STATE(1025),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_sgl_flw_seq] = STATE(1110),
    [sym__flw_seq_tal] = STATE(712),
    [sym__sgl_flw_seq_tal] = STATE(1139),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_sgl_flw_map_val] = STATE(1025),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_sgl_flw_map] = STATE(1113),
    [sym__r_flw_seq_dat] = STATE(1165),
    [sym__br_flw_seq_dat] = STATE(1165),
    [sym__r_sgl_flw_col_dat] = STATE(1468),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_sgl_flw_col_itm] = STATE(986),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_sgl_flw_exp_par] = STATE(1225),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_sgl_flw_imp_par] = STATE(1240),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1253),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_sgl_dqt_str_val] = STATE(1025),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sgl_dqt_str] = STATE(1114),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sgl_sqt_str_val] = STATE(1025),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_sgl_sqt_str] = STATE(1116),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw_val] = STATE(976),
    [sym__r_sgl_pln_flw] = STATE(747),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(538),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(209),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(287),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(347),
    [sym__br_flw_seq_end] = ACTIONS(349),
    [sym__b_flw_seq_end] = ACTIONS(349),
    [sym__r_flw_map_bgn] = ACTIONS(295),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(299),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(303),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(307),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(311),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(323),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_sgl_prp_val] = STATE(976),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_sgl_prp] = STATE(264),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_sgl_flw_seq_val] = STATE(1025),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_sgl_flw_seq] = STATE(1110),
    [sym__flw_seq_tal] = STATE(367),
    [sym__sgl_flw_seq_tal] = STATE(1416),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_sgl_flw_map_val] = STATE(1025),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_sgl_flw_map] = STATE(1113),
    [sym__r_flw_seq_dat] = STATE(1151),
    [sym__br_flw_seq_dat] = STATE(1151),
    [sym__r_sgl_flw_col_dat] = STATE(1459),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_sgl_flw_col_itm] = STATE(986),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_sgl_flw_exp_par] = STATE(1225),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_sgl_flw_imp_par] = STATE(1240),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1253),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_sgl_dqt_str_val] = STATE(1025),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sgl_dqt_str] = STATE(1114),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sgl_sqt_str_val] = STATE(1025),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_sgl_sqt_str] = STATE(1116),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw_val] = STATE(976),
    [sym__r_sgl_pln_flw] = STATE(747),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(538),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(209),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(287),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(343),
    [sym__br_flw_seq_end] = ACTIONS(351),
    [sym__b_flw_seq_end] = ACTIONS(351),
    [sym__r_flw_map_bgn] = ACTIONS(295),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(299),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(303),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(307),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(311),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(323),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_sgl_prp_val] = STATE(976),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_sgl_prp] = STATE(264),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_sgl_flw_seq_val] = STATE(1025),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_sgl_flw_seq] = STATE(1110),
    [sym__flw_seq_tal] = STATE(1316),
    [sym__sgl_flw_seq_tal] = STATE(1509),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_sgl_flw_map_val] = STATE(1025),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_sgl_flw_map] = STATE(1113),
    [sym__r_flw_seq_dat] = STATE(1182),
    [sym__br_flw_seq_dat] = STATE(1182),
    [sym__r_sgl_flw_col_dat] = STATE(1457),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_sgl_flw_col_itm] = STATE(986),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_sgl_flw_exp_par] = STATE(1225),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_sgl_flw_imp_par] = STATE(1240),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1253),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_sgl_dqt_str_val] = STATE(1025),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sgl_dqt_str] = STATE(1114),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sgl_sqt_str_val] = STATE(1025),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_sgl_sqt_str] = STATE(1116),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw_val] = STATE(976),
    [sym__r_sgl_pln_flw] = STATE(747),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(538),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(209),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(287),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(353),
    [sym__br_flw_seq_end] = ACTIONS(355),
    [sym__b_flw_seq_end] = ACTIONS(355),
    [sym__r_flw_map_bgn] = ACTIONS(295),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(299),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(303),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(307),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(311),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(323),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_sgl_prp_val] = STATE(976),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_sgl_prp] = STATE(264),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_sgl_flw_seq_val] = STATE(1025),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_sgl_flw_seq] = STATE(1110),
    [sym__flw_seq_tal] = STATE(828),
    [sym__sgl_flw_seq_tal] = STATE(1257),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_sgl_flw_map_val] = STATE(1025),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_sgl_flw_map] = STATE(1113),
    [sym__r_flw_seq_dat] = STATE(1193),
    [sym__br_flw_seq_dat] = STATE(1193),
    [sym__r_sgl_flw_col_dat] = STATE(1525),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_sgl_flw_col_itm] = STATE(986),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_sgl_flw_exp_par] = STATE(1225),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_sgl_flw_imp_par] = STATE(1240),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1253),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_sgl_dqt_str_val] = STATE(1025),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sgl_dqt_str] = STATE(1114),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sgl_sqt_str_val] = STATE(1025),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_sgl_sqt_str] = STATE(1116),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw_val] = STATE(976),
    [sym__r_sgl_pln_flw] = STATE(747),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(538),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(209),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(287),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(357),
    [sym__br_flw_seq_end] = ACTIONS(359),
    [sym__b_flw_seq_end] = ACTIONS(359),
    [sym__r_flw_map_bgn] = ACTIONS(295),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(299),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(303),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(307),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(311),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(323),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_sgl_prp_val] = STATE(976),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_sgl_prp] = STATE(264),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_sgl_flw_seq_val] = STATE(1025),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_sgl_flw_seq] = STATE(1110),
    [sym__flw_seq_tal] = STATE(566),
    [sym__sgl_flw_seq_tal] = STATE(1050),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_sgl_flw_map_val] = STATE(1025),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_sgl_flw_map] = STATE(1113),
    [sym__r_flw_seq_dat] = STATE(1172),
    [sym__br_flw_seq_dat] = STATE(1172),
    [sym__r_sgl_flw_col_dat] = STATE(1473),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_sgl_flw_col_itm] = STATE(986),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_sgl_flw_exp_par] = STATE(1225),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_sgl_flw_imp_par] = STATE(1240),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1253),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_sgl_dqt_str_val] = STATE(1025),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sgl_dqt_str] = STATE(1114),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sgl_sqt_str_val] = STATE(1025),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_sgl_sqt_str] = STATE(1116),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw_val] = STATE(976),
    [sym__r_sgl_pln_flw] = STATE(747),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(538),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(209),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(287),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(361),
    [sym__br_flw_seq_end] = ACTIONS(363),
    [sym__b_flw_seq_end] = ACTIONS(363),
    [sym__r_flw_map_bgn] = ACTIONS(295),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(299),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(303),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(307),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(311),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(323),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_sgl_prp_val] = STATE(976),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_sgl_prp] = STATE(264),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_sgl_flw_seq_val] = STATE(1025),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_sgl_flw_seq] = STATE(1110),
    [sym__flw_seq_tal] = STATE(784),
    [sym__sgl_flw_seq_tal] = STATE(1317),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_sgl_flw_map_val] = STATE(1025),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_sgl_flw_map] = STATE(1113),
    [sym__r_flw_seq_dat] = STATE(1211),
    [sym__br_flw_seq_dat] = STATE(1211),
    [sym__r_sgl_flw_col_dat] = STATE(1447),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_sgl_flw_col_itm] = STATE(986),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_sgl_flw_exp_par] = STATE(1225),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_sgl_flw_imp_par] = STATE(1240),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_sgl_flw_njl_ann_par] = STATE(1253),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_sgl_dqt_str_val] = STATE(1025),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sgl_dqt_str] = STATE(1114),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sgl_sqt_str_val] = STATE(1025),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_sgl_sqt_str] = STATE(1116),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw_val] = STATE(976),
    [sym__r_sgl_pln_flw] = STATE(747),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(538),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(209),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(287),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(365),
    [sym__br_flw_seq_end] = ACTIONS(367),
    [sym__b_flw_seq_end] = ACTIONS(367),
    [sym__r_flw_map_bgn] = ACTIONS(295),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(299),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(303),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(307),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(311),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(323),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__br_sgl_prp] = STATE(309),
    [sym__br_blk_seq] = STATE(379),
    [sym__b_blk_seq_spc] = STATE(338),
    [sym__br_blk_seq_itm] = STATE(966),
    [sym__b_blk_seq_itm] = STATE(1041),
    [sym__br_blk_map] = STATE(380),
    [sym__br_blk_map_itm] = STATE(133),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__r_blk_str] = STATE(381),
    [sym__br_blk_str] = STATE(381),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(382),
    [sym__br_flw_seq] = STATE(382),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(383),
    [sym__br_flw_map] = STATE(383),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(384),
    [sym__br_dqt_str] = STATE(384),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(385),
    [sym__br_sqt_str] = STATE(385),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(386),
    [sym__br_sgl_pln_blk] = STATE(267),
    [sym__r_mtl_pln_blk] = STATE(386),
    [sym__br_mtl_pln_blk] = STATE(386),
    [sym__br_als_val] = STATE(1237),
    [sym__br_als] = STATE(1487),
    [sym__br_acr] = STATE(424),
    [aux_sym__r_blk_seq_repeat1] = STATE(1041),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(69),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__b_blk_key_bgn] = ACTIONS(369),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__b_blk_val_bgn] = ACTIONS(369),
    [sym__r_blk_lit_bgn] = ACTIONS(73),
    [sym__br_blk_lit_bgn] = ACTIONS(75),
    [sym__r_blk_fld_bgn] = ACTIONS(73),
    [sym__br_blk_fld_bgn] = ACTIONS(75),
    [sym__r_flw_seq_bgn] = ACTIONS(171),
    [sym__br_flw_seq_bgn] = ACTIONS(79),
    [sym__b_flw_seq_bgn] = ACTIONS(369),
    [sym__r_flw_map_bgn] = ACTIONS(173),
    [sym__br_flw_map_bgn] = ACTIONS(83),
    [sym__b_flw_map_bgn] = ACTIONS(369),
    [sym__r_dqt_str_bgn] = ACTIONS(175),
    [sym__br_dqt_str_bgn] = ACTIONS(87),
    [sym__b_dqt_str_bgn] = ACTIONS(369),
    [sym__r_sqt_str_bgn] = ACTIONS(177),
    [sym__br_sqt_str_bgn] = ACTIONS(91),
    [sym__b_sqt_str_bgn] = ACTIONS(369),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(179),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(95),
    [sym__b_sgl_pln_nul_blk] = ACTIONS(369),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(179),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(95),
    [sym__b_sgl_pln_bol_blk] = ACTIONS(369),
    [sym__r_sgl_pln_int_blk] = ACTIONS(179),
    [sym__br_sgl_pln_int_blk] = ACTIONS(95),
    [sym__b_sgl_pln_int_blk] = ACTIONS(369),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(179),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(95),
    [sym__b_sgl_pln_flt_blk] = ACTIONS(369),
    [sym__r_sgl_pln_str_blk] = ACTIONS(179),
    [sym__br_sgl_pln_str_blk] = ACTIONS(95),
    [sym__b_sgl_pln_str_blk] = ACTIONS(369),
    [sym__r_mtl_pln_str_blk] = ACTIONS(97),
    [sym__br_mtl_pln_str_blk] = ACTIONS(99),
    [sym__br_tag] = ACTIONS(371),
    [sym__b_tag] = ACTIONS(369),
    [sym__br_acr_bgn] = ACTIONS(373),
    [sym__b_acr_bgn] = ACTIONS(369),
    [sym__br_als_bgn] = ACTIONS(375),
    [sym__b_als_bgn] = ACTIONS(369),
    [sym__bl] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__br_sgl_prp] = STATE(309),
    [sym__br_blk_seq] = STATE(388),
    [sym__b_blk_seq_spc] = STATE(291),
    [sym__br_blk_seq_itm] = STATE(966),
    [sym__b_blk_seq_itm] = STATE(1041),
    [sym__br_blk_map] = STATE(389),
    [sym__br_blk_map_itm] = STATE(133),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__r_blk_str] = STATE(390),
    [sym__br_blk_str] = STATE(390),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(378),
    [sym__br_flw_seq] = STATE(378),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(339),
    [sym__br_flw_map] = STATE(339),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(295),
    [sym__br_dqt_str] = STATE(295),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(355),
    [sym__br_sqt_str] = STATE(355),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(335),
    [sym__br_sgl_pln_blk] = STATE(268),
    [sym__r_mtl_pln_blk] = STATE(335),
    [sym__br_mtl_pln_blk] = STATE(335),
    [sym__br_als_val] = STATE(1237),
    [sym__br_als] = STATE(1487),
    [sym__br_acr] = STATE(424),
    [aux_sym__r_blk_seq_repeat1] = STATE(1041),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(69),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__b_blk_key_bgn] = ACTIONS(377),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__b_blk_val_bgn] = ACTIONS(377),
    [sym__r_blk_lit_bgn] = ACTIONS(73),
    [sym__br_blk_lit_bgn] = ACTIONS(75),
    [sym__r_blk_fld_bgn] = ACTIONS(73),
    [sym__br_blk_fld_bgn] = ACTIONS(75),
    [sym__r_flw_seq_bgn] = ACTIONS(171),
    [sym__br_flw_seq_bgn] = ACTIONS(79),
    [sym__b_flw_seq_bgn] = ACTIONS(377),
    [sym__r_flw_map_bgn] = ACTIONS(173),
    [sym__br_flw_map_bgn] = ACTIONS(83),
    [sym__b_flw_map_bgn] = ACTIONS(377),
    [sym__r_dqt_str_bgn] = ACTIONS(175),
    [sym__br_dqt_str_bgn] = ACTIONS(87),
    [sym__b_dqt_str_bgn] = ACTIONS(377),
    [sym__r_sqt_str_bgn] = ACTIONS(177),
    [sym__br_sqt_str_bgn] = ACTIONS(91),
    [sym__b_sqt_str_bgn] = ACTIONS(377),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(179),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(95),
    [sym__b_sgl_pln_nul_blk] = ACTIONS(377),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(179),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(95),
    [sym__b_sgl_pln_bol_blk] = ACTIONS(377),
    [sym__r_sgl_pln_int_blk] = ACTIONS(179),
    [sym__br_sgl_pln_int_blk] = ACTIONS(95),
    [sym__b_sgl_pln_int_blk] = ACTIONS(377),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(179),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(95),
    [sym__b_sgl_pln_flt_blk] = ACTIONS(377),
    [sym__r_sgl_pln_str_blk] = ACTIONS(179),
    [sym__br_sgl_pln_str_blk] = ACTIONS(95),
    [sym__b_sgl_pln_str_blk] = ACTIONS(377),
    [sym__r_mtl_pln_str_blk] = ACTIONS(97),
    [sym__br_mtl_pln_str_blk] = ACTIONS(99),
    [sym__br_tag] = ACTIONS(371),
    [sym__b_tag] = ACTIONS(377),
    [sym__br_acr_bgn] = ACTIONS(373),
    [sym__b_acr_bgn] = ACTIONS(377),
    [sym__br_als_bgn] = ACTIONS(375),
    [sym__b_als_bgn] = ACTIONS(377),
    [sym__bl] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym__doc_w_bgn_w_end_seq] = STATE(1456),
    [sym__doc_w_bgn_wo_end_seq] = STATE(1456),
    [sym__doc_wo_bgn_w_end_seq] = STATE(1456),
    [sym__doc_wo_bgn_wo_end_seq] = STATE(1456),
    [sym__doc_w_bgn_w_end] = STATE(37),
    [sym__doc_w_bgn_wo_end] = STATE(472),
    [sym__doc_wo_bgn_w_end] = STATE(38),
    [sym__doc_wo_bgn_wo_end] = STATE(479),
    [sym__drs_doc] = STATE(1167),
    [sym__exp_doc] = STATE(1155),
    [sym__imp_doc] = STATE(1168),
    [sym__drs_doc_end] = STATE(38),
    [sym__exp_doc_end] = STATE(37),
    [sym__imp_doc_end] = STATE(38),
    [sym__doc_end] = STATE(37),
    [sym__s_dir] = STATE(471),
    [sym__s_dir_yml] = STATE(471),
    [sym__s_dir_tag] = STATE(471),
    [sym__s_dir_rsv] = STATE(471),
    [sym__br_prp_val] = STATE(1169),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__br_prp] = STATE(80),
    [sym__br_sgl_prp] = STATE(309),
    [sym__br_blk_seq_val] = STATE(1169),
    [sym__br_blk_seq] = STATE(1170),
    [sym__br_blk_seq_itm] = STATE(1048),
    [sym__br_blk_map_val] = STATE(1169),
    [sym__br_blk_map] = STATE(1200),
    [sym__br_blk_map_itm] = STATE(148),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__br_blk_str_val] = STATE(1169),
    [sym__br_blk_str] = STATE(1103),
    [sym__br_flw_seq_val] = STATE(1169),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__br_flw_seq] = STATE(1156),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__br_flw_map_val] = STATE(1169),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__br_flw_map] = STATE(1071),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__br_dqt_str_val] = STATE(1169),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__br_dqt_str] = STATE(1087),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__br_sqt_str_val] = STATE(1169),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__br_sqt_str] = STATE(1129),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__br_pln_blk_val] = STATE(1169),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__br_sgl_pln_blk] = STATE(997),
    [sym__br_mtl_pln_blk] = STATE(1095),
    [sym__br_als_val] = STATE(939),
    [sym__br_als] = STATE(1001),
    [sym__br_acr] = STATE(152),
    [aux_sym__drs_doc_repeat1] = STATE(471),
    [sym__eof] = ACTIONS(379),
    [sym__s_dir_yml_bgn] = ACTIONS(7),
    [sym__s_dir_tag_bgn] = ACTIONS(9),
    [sym__s_dir_rsv_bgn] = ACTIONS(11),
    [sym__s_drs_end] = ACTIONS(13),
    [sym__s_doc_end] = ACTIONS(15),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__br_blk_lit_bgn] = ACTIONS(31),
    [sym__br_blk_fld_bgn] = ACTIONS(31),
    [sym__br_flw_seq_bgn] = ACTIONS(35),
    [sym__br_flw_map_bgn] = ACTIONS(39),
    [sym__br_dqt_str_bgn] = ACTIONS(43),
    [sym__br_sqt_str_bgn] = ACTIONS(47),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(51),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(51),
    [sym__br_sgl_pln_int_blk] = ACTIONS(51),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(51),
    [sym__br_sgl_pln_str_blk] = ACTIONS(51),
    [sym__br_mtl_pln_str_blk] = ACTIONS(55),
    [sym__br_tag] = ACTIONS(59),
    [sym__br_acr_bgn] = ACTIONS(63),
    [sym__br_als_bgn] = ACTIONS(67),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym__doc_w_bgn_w_end_seq] = STATE(1489),
    [sym__doc_w_bgn_wo_end_seq] = STATE(1489),
    [sym__doc_wo_bgn_w_end_seq] = STATE(1489),
    [sym__doc_wo_bgn_wo_end_seq] = STATE(1489),
    [sym__doc_w_bgn_w_end] = STATE(37),
    [sym__doc_w_bgn_wo_end] = STATE(472),
    [sym__doc_wo_bgn_w_end] = STATE(38),
    [sym__doc_wo_bgn_wo_end] = STATE(479),
    [sym__drs_doc] = STATE(1167),
    [sym__exp_doc] = STATE(1155),
    [sym__imp_doc] = STATE(1168),
    [sym__drs_doc_end] = STATE(38),
    [sym__exp_doc_end] = STATE(37),
    [sym__imp_doc_end] = STATE(38),
    [sym__doc_end] = STATE(37),
    [sym__s_dir] = STATE(471),
    [sym__s_dir_yml] = STATE(471),
    [sym__s_dir_tag] = STATE(471),
    [sym__s_dir_rsv] = STATE(471),
    [sym__br_prp_val] = STATE(1169),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__br_prp] = STATE(80),
    [sym__br_sgl_prp] = STATE(309),
    [sym__br_blk_seq_val] = STATE(1169),
    [sym__br_blk_seq] = STATE(1170),
    [sym__br_blk_seq_itm] = STATE(1048),
    [sym__br_blk_map_val] = STATE(1169),
    [sym__br_blk_map] = STATE(1200),
    [sym__br_blk_map_itm] = STATE(148),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__br_blk_str_val] = STATE(1169),
    [sym__br_blk_str] = STATE(1103),
    [sym__br_flw_seq_val] = STATE(1169),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__br_flw_seq] = STATE(1156),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__br_flw_map_val] = STATE(1169),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__br_flw_map] = STATE(1071),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__br_dqt_str_val] = STATE(1169),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__br_dqt_str] = STATE(1087),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__br_sqt_str_val] = STATE(1169),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__br_sqt_str] = STATE(1129),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__br_pln_blk_val] = STATE(1169),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__br_sgl_pln_blk] = STATE(997),
    [sym__br_mtl_pln_blk] = STATE(1095),
    [sym__br_als_val] = STATE(939),
    [sym__br_als] = STATE(1001),
    [sym__br_acr] = STATE(152),
    [aux_sym__drs_doc_repeat1] = STATE(471),
    [sym__eof] = ACTIONS(381),
    [sym__s_dir_yml_bgn] = ACTIONS(7),
    [sym__s_dir_tag_bgn] = ACTIONS(9),
    [sym__s_dir_rsv_bgn] = ACTIONS(11),
    [sym__s_drs_end] = ACTIONS(13),
    [sym__s_doc_end] = ACTIONS(15),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__br_blk_lit_bgn] = ACTIONS(31),
    [sym__br_blk_fld_bgn] = ACTIONS(31),
    [sym__br_flw_seq_bgn] = ACTIONS(35),
    [sym__br_flw_map_bgn] = ACTIONS(39),
    [sym__br_dqt_str_bgn] = ACTIONS(43),
    [sym__br_sqt_str_bgn] = ACTIONS(47),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(51),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(51),
    [sym__br_sgl_pln_int_blk] = ACTIONS(51),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(51),
    [sym__br_sgl_pln_str_blk] = ACTIONS(51),
    [sym__br_mtl_pln_str_blk] = ACTIONS(55),
    [sym__br_tag] = ACTIONS(59),
    [sym__br_acr_bgn] = ACTIONS(63),
    [sym__br_als_bgn] = ACTIONS(67),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym__doc_w_bgn_w_end_seq] = STATE(1428),
    [sym__doc_w_bgn_wo_end_seq] = STATE(1428),
    [sym__doc_wo_bgn_w_end_seq] = STATE(1428),
    [sym__doc_wo_bgn_wo_end_seq] = STATE(1428),
    [sym__doc_w_bgn_w_end] = STATE(37),
    [sym__doc_w_bgn_wo_end] = STATE(472),
    [sym__doc_wo_bgn_w_end] = STATE(38),
    [sym__doc_wo_bgn_wo_end] = STATE(479),
    [sym__drs_doc] = STATE(1167),
    [sym__exp_doc] = STATE(1155),
    [sym__imp_doc] = STATE(1168),
    [sym__drs_doc_end] = STATE(38),
    [sym__exp_doc_end] = STATE(37),
    [sym__imp_doc_end] = STATE(38),
    [sym__doc_end] = STATE(37),
    [sym__s_dir] = STATE(471),
    [sym__s_dir_yml] = STATE(471),
    [sym__s_dir_tag] = STATE(471),
    [sym__s_dir_rsv] = STATE(471),
    [sym__br_prp_val] = STATE(1169),
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__br_prp] = STATE(80),
    [sym__br_sgl_prp] = STATE(309),
    [sym__br_blk_seq_val] = STATE(1169),
    [sym__br_blk_seq] = STATE(1170),
    [sym__br_blk_seq_itm] = STATE(1048),
    [sym__br_blk_map_val] = STATE(1169),
    [sym__br_blk_map] = STATE(1200),
    [sym__br_blk_map_itm] = STATE(148),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__br_blk_str_val] = STATE(1169),
    [sym__br_blk_str] = STATE(1103),
    [sym__br_flw_seq_val] = STATE(1169),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__br_flw_seq] = STATE(1156),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__br_flw_map_val] = STATE(1169),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__br_flw_map] = STATE(1071),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__br_dqt_str_val] = STATE(1169),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__br_dqt_str] = STATE(1087),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__br_sqt_str_val] = STATE(1169),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__br_sqt_str] = STATE(1129),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__br_pln_blk_val] = STATE(1169),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__br_sgl_pln_blk] = STATE(997),
    [sym__br_mtl_pln_blk] = STATE(1095),
    [sym__br_als_val] = STATE(939),
    [sym__br_als] = STATE(1001),
    [sym__br_acr] = STATE(152),
    [aux_sym__drs_doc_repeat1] = STATE(471),
    [sym__eof] = ACTIONS(383),
    [sym__s_dir_yml_bgn] = ACTIONS(7),
    [sym__s_dir_tag_bgn] = ACTIONS(9),
    [sym__s_dir_rsv_bgn] = ACTIONS(11),
    [sym__s_drs_end] = ACTIONS(13),
    [sym__s_doc_end] = ACTIONS(15),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__br_blk_lit_bgn] = ACTIONS(31),
    [sym__br_blk_fld_bgn] = ACTIONS(31),
    [sym__br_flw_seq_bgn] = ACTIONS(35),
    [sym__br_flw_map_bgn] = ACTIONS(39),
    [sym__br_dqt_str_bgn] = ACTIONS(43),
    [sym__br_sqt_str_bgn] = ACTIONS(47),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(51),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(51),
    [sym__br_sgl_pln_int_blk] = ACTIONS(51),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(51),
    [sym__br_sgl_pln_str_blk] = ACTIONS(51),
    [sym__br_mtl_pln_str_blk] = ACTIONS(55),
    [sym__br_tag] = ACTIONS(59),
    [sym__br_acr_bgn] = ACTIONS(63),
    [sym__br_als_bgn] = ACTIONS(67),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym__r_prp_val] = STATE(981),
    [sym__br_prp_val] = STATE(984),
    [sym__r_sgl_prp_val] = STATE(1239),
    [sym__r_prp] = STATE(163),
    [sym__br_prp] = STATE(168),
    [sym__r_sgl_prp] = STATE(365),
    [sym__r_flw_seq_val] = STATE(1031),
    [sym__br_flw_seq_val] = STATE(1035),
    [sym__r_sgl_flw_seq_val] = STATE(1242),
    [sym__r_flw_seq] = STATE(1282),
    [sym__br_flw_seq] = STATE(1283),
    [sym__r_sgl_flw_seq] = STATE(1506),
    [sym__r_flw_map_val] = STATE(1031),
    [sym__br_flw_map_val] = STATE(1035),
    [sym__r_sgl_flw_map_val] = STATE(1242),
    [sym__r_flw_map] = STATE(1302),
    [sym__br_flw_map] = STATE(1304),
    [sym__r_sgl_flw_map] = STATE(1534),
    [sym__r_flw_imp_r_par] = STATE(924),
    [sym__r_flw_imp_br_par] = STATE(925),
    [sym__br_flw_imp_r_par] = STATE(926),
    [sym__br_flw_imp_br_par] = STATE(927),
    [sym__r_sgl_flw_imp_par] = STATE(1312),
    [sym__r_dqt_str_val] = STATE(1031),
    [sym__br_dqt_str_val] = STATE(1035),
    [sym__r_sgl_dqt_str_val] = STATE(1242),
    [sym__r_dqt_str] = STATE(1306),
    [sym__br_dqt_str] = STATE(1307),
    [sym__r_sgl_dqt_str] = STATE(1463),
    [sym__r_sqt_str_val] = STATE(1031),
    [sym__br_sqt_str_val] = STATE(1035),
    [sym__r_sgl_sqt_str_val] = STATE(1242),
    [sym__r_sqt_str] = STATE(1309),
    [sym__br_sqt_str] = STATE(1310),
    [sym__r_sgl_sqt_str] = STATE(1467),
    [sym__r_pln_flw_val] = STATE(981),
    [sym__br_pln_flw_val] = STATE(984),
    [sym__r_sgl_pln_flw_val] = STATE(1239),
    [sym__r_sgl_pln_flw] = STATE(1243),
    [sym__br_sgl_pln_flw] = STATE(1345),
    [sym__r_mtl_pln_flw] = STATE(1222),
    [sym__br_mtl_pln_flw] = STATE(1345),
    [sym__r_als_val] = STATE(928),
    [sym__br_als_val] = STATE(984),
    [sym__r_als] = STATE(1246),
    [sym__br_als] = STATE(1272),
    [sym__r_acr] = STATE(249),
    [sym__br_acr] = STATE(246),
    [sym__r_flw_seq_bgn] = ACTIONS(385),
    [sym__br_flw_seq_bgn] = ACTIONS(387),
    [sym__r_flw_map_bgn] = ACTIONS(389),
    [sym__br_flw_map_bgn] = ACTIONS(391),
    [sym__r_flw_map_end] = ACTIONS(393),
    [sym__br_flw_map_end] = ACTIONS(396),
    [sym__b_flw_map_end] = ACTIONS(396),
    [sym__r_flw_sep_bgn] = ACTIONS(393),
    [sym__br_flw_sep_bgn] = ACTIONS(396),
    [sym__r_dqt_str_bgn] = ACTIONS(398),
    [sym__br_dqt_str_bgn] = ACTIONS(400),
    [sym__r_sqt_str_bgn] = ACTIONS(402),
    [sym__br_sqt_str_bgn] = ACTIONS(404),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(406),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(408),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(406),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(408),
    [sym__r_sgl_pln_int_flw] = ACTIONS(406),
    [sym__br_sgl_pln_int_flw] = ACTIONS(408),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(406),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(408),
    [sym__r_sgl_pln_str_flw] = ACTIONS(406),
    [sym__br_sgl_pln_str_flw] = ACTIONS(408),
    [sym__r_mtl_pln_str_flw] = ACTIONS(410),
    [sym__br_mtl_pln_str_flw] = ACTIONS(412),
    [sym__r_tag] = ACTIONS(414),
    [sym__br_tag] = ACTIONS(416),
    [sym__r_acr_bgn] = ACTIONS(418),
    [sym__br_acr_bgn] = ACTIONS(420),
    [sym__r_als_bgn] = ACTIONS(422),
    [sym__br_als_bgn] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym__r_prp_val] = STATE(980),
    [sym__br_prp_val] = STATE(991),
    [sym__r_sgl_prp_val] = STATE(1359),
    [sym__r_prp] = STATE(163),
    [sym__br_prp] = STATE(168),
    [sym__r_sgl_prp] = STATE(365),
    [sym__r_flw_seq_val] = STATE(1009),
    [sym__br_flw_seq_val] = STATE(1018),
    [sym__r_sgl_flw_seq_val] = STATE(1244),
    [sym__r_flw_seq] = STATE(1282),
    [sym__br_flw_seq] = STATE(1283),
    [sym__r_sgl_flw_seq] = STATE(1506),
    [sym__r_flw_map_val] = STATE(1009),
    [sym__br_flw_map_val] = STATE(1018),
    [sym__r_sgl_flw_map_val] = STATE(1244),
    [sym__r_flw_map] = STATE(1302),
    [sym__br_flw_map] = STATE(1304),
    [sym__r_sgl_flw_map] = STATE(1534),
    [sym__r_flw_imp_r_par] = STATE(948),
    [sym__r_flw_imp_br_par] = STATE(953),
    [sym__br_flw_imp_r_par] = STATE(960),
    [sym__br_flw_imp_br_par] = STATE(804),
    [sym__r_sgl_flw_imp_par] = STATE(1292),
    [sym__r_dqt_str_val] = STATE(1009),
    [sym__br_dqt_str_val] = STATE(1018),
    [sym__r_sgl_dqt_str_val] = STATE(1244),
    [sym__r_dqt_str] = STATE(1306),
    [sym__br_dqt_str] = STATE(1307),
    [sym__r_sgl_dqt_str] = STATE(1463),
    [sym__r_sqt_str_val] = STATE(1009),
    [sym__br_sqt_str_val] = STATE(1018),
    [sym__r_sgl_sqt_str_val] = STATE(1244),
    [sym__r_sqt_str] = STATE(1309),
    [sym__br_sqt_str] = STATE(1310),
    [sym__r_sgl_sqt_str] = STATE(1467),
    [sym__r_pln_flw_val] = STATE(980),
    [sym__br_pln_flw_val] = STATE(991),
    [sym__r_sgl_pln_flw_val] = STATE(1359),
    [sym__r_sgl_pln_flw] = STATE(1243),
    [sym__br_sgl_pln_flw] = STATE(1345),
    [sym__r_mtl_pln_flw] = STATE(1222),
    [sym__br_mtl_pln_flw] = STATE(1345),
    [sym__r_als_val] = STATE(805),
    [sym__br_als_val] = STATE(991),
    [sym__r_als] = STATE(1246),
    [sym__br_als] = STATE(1272),
    [sym__r_acr] = STATE(249),
    [sym__br_acr] = STATE(246),
    [sym__r_flw_seq_bgn] = ACTIONS(385),
    [sym__br_flw_seq_bgn] = ACTIONS(387),
    [sym__r_flw_seq_end] = ACTIONS(393),
    [sym__br_flw_seq_end] = ACTIONS(396),
    [sym__b_flw_seq_end] = ACTIONS(396),
    [sym__r_flw_map_bgn] = ACTIONS(389),
    [sym__br_flw_map_bgn] = ACTIONS(391),
    [sym__r_flw_sep_bgn] = ACTIONS(393),
    [sym__br_flw_sep_bgn] = ACTIONS(396),
    [sym__r_dqt_str_bgn] = ACTIONS(398),
    [sym__br_dqt_str_bgn] = ACTIONS(400),
    [sym__r_sqt_str_bgn] = ACTIONS(402),
    [sym__br_sqt_str_bgn] = ACTIONS(404),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(406),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(408),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(406),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(408),
    [sym__r_sgl_pln_int_flw] = ACTIONS(406),
    [sym__br_sgl_pln_int_flw] = ACTIONS(408),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(406),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(408),
    [sym__r_sgl_pln_str_flw] = ACTIONS(406),
    [sym__br_sgl_pln_str_flw] = ACTIONS(408),
    [sym__r_mtl_pln_str_flw] = ACTIONS(410),
    [sym__br_mtl_pln_str_flw] = ACTIONS(412),
    [sym__r_tag] = ACTIONS(414),
    [sym__br_tag] = ACTIONS(416),
    [sym__r_acr_bgn] = ACTIONS(418),
    [sym__br_acr_bgn] = ACTIONS(420),
    [sym__r_als_bgn] = ACTIONS(422),
    [sym__br_als_bgn] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(716),
    [sym__r_flw_map_dat] = STATE(1166),
    [sym__br_flw_map_dat] = STATE(1166),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(430),
    [sym__br_flw_map_end] = ACTIONS(430),
    [sym__b_flw_map_end] = ACTIONS(430),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(879),
    [sym__r_flw_map_dat] = STATE(1212),
    [sym__br_flw_map_dat] = STATE(1212),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(255),
    [sym__br_flw_map_end] = ACTIONS(255),
    [sym__b_flw_map_end] = ACTIONS(255),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(1133),
    [sym__r_flw_map_dat] = STATE(1138),
    [sym__br_flw_map_dat] = STATE(1138),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(259),
    [sym__br_flw_map_end] = ACTIONS(259),
    [sym__b_flw_map_end] = ACTIONS(259),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(571),
    [sym__r_flw_map_dat] = STATE(1173),
    [sym__br_flw_map_dat] = STATE(1173),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(442),
    [sym__br_flw_map_end] = ACTIONS(442),
    [sym__b_flw_map_end] = ACTIONS(442),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(570),
    [sym__r_flw_map_dat] = STATE(1173),
    [sym__br_flw_map_dat] = STATE(1173),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(285),
    [sym__br_flw_map_end] = ACTIONS(285),
    [sym__b_flw_map_end] = ACTIONS(285),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(715),
    [sym__r_flw_map_dat] = STATE(1166),
    [sym__br_flw_map_dat] = STATE(1166),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(271),
    [sym__br_flw_map_end] = ACTIONS(271),
    [sym__b_flw_map_end] = ACTIONS(271),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(1323),
    [sym__r_flw_map_dat] = STATE(1183),
    [sym__br_flw_map_dat] = STATE(1183),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(444),
    [sym__br_flw_map_end] = ACTIONS(444),
    [sym__b_flw_map_end] = ACTIONS(444),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(1321),
    [sym__r_flw_map_dat] = STATE(1183),
    [sym__br_flw_map_dat] = STATE(1183),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(215),
    [sym__br_flw_map_end] = ACTIONS(215),
    [sym__b_flw_map_end] = ACTIONS(215),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(1258),
    [sym__r_flw_map_dat] = STATE(1125),
    [sym__br_flw_map_dat] = STATE(1125),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(265),
    [sym__br_flw_map_end] = ACTIONS(265),
    [sym__b_flw_map_end] = ACTIONS(265),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(369),
    [sym__r_flw_map_dat] = STATE(1152),
    [sym__br_flw_map_dat] = STATE(1152),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(275),
    [sym__br_flw_map_end] = ACTIONS(275),
    [sym__b_flw_map_end] = ACTIONS(275),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(832),
    [sym__r_flw_map_dat] = STATE(1194),
    [sym__br_flw_map_dat] = STATE(1194),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(446),
    [sym__br_flw_map_end] = ACTIONS(446),
    [sym__b_flw_map_end] = ACTIONS(446),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(880),
    [sym__r_flw_map_dat] = STATE(1212),
    [sym__br_flw_map_dat] = STATE(1212),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(448),
    [sym__br_flw_map_end] = ACTIONS(448),
    [sym__b_flw_map_end] = ACTIONS(448),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__flw_map_tal] = STATE(831),
    [sym__r_flw_map_dat] = STATE(1194),
    [sym__br_flw_map_dat] = STATE(1194),
    [sym__r_flw_map_itm] = STATE(670),
    [sym__br_flw_map_itm] = STATE(671),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(279),
    [sym__br_flw_map_end] = ACTIONS(279),
    [sym__b_flw_map_end] = ACTIONS(279),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(713),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1165),
    [sym__br_flw_seq_dat] = STATE(1165),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(452),
    [sym__br_flw_seq_end] = ACTIONS(452),
    [sym__b_flw_seq_end] = ACTIONS(452),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym__r_prp_val] = STATE(934),
    [sym__br_prp_val] = STATE(934),
    [sym__r_sgl_prp_val] = STATE(1319),
    [sym__r_prp] = STATE(116),
    [sym__br_prp] = STATE(120),
    [sym__r_sgl_prp] = STATE(276),
    [sym__r_flw_seq_val] = STATE(934),
    [sym__br_flw_seq_val] = STATE(934),
    [sym__r_sgl_flw_seq_val] = STATE(1319),
    [sym__r_flw_seq] = STATE(865),
    [sym__br_flw_seq] = STATE(866),
    [sym__r_sgl_flw_seq] = STATE(1301),
    [sym__r_flw_map_val] = STATE(934),
    [sym__br_flw_map_val] = STATE(934),
    [sym__r_sgl_flw_map_val] = STATE(1319),
    [sym__r_flw_map] = STATE(867),
    [sym__br_flw_map] = STATE(868),
    [sym__r_sgl_flw_map] = STATE(1305),
    [sym__flw_ann_par_tal] = STATE(934),
    [sym__sgl_flw_ann_par_tal] = STATE(1319),
    [sym__r_dqt_str_val] = STATE(934),
    [sym__br_dqt_str_val] = STATE(934),
    [sym__r_sgl_dqt_str_val] = STATE(1319),
    [sym__r_dqt_str] = STATE(869),
    [sym__br_dqt_str] = STATE(870),
    [sym__r_sgl_dqt_str] = STATE(1308),
    [sym__r_sqt_str_val] = STATE(934),
    [sym__br_sqt_str_val] = STATE(934),
    [sym__r_sgl_sqt_str_val] = STATE(1319),
    [sym__r_sqt_str] = STATE(871),
    [sym__br_sqt_str] = STATE(872),
    [sym__r_sgl_sqt_str] = STATE(1311),
    [sym__r_pln_flw_val] = STATE(934),
    [sym__br_pln_flw_val] = STATE(934),
    [sym__r_sgl_pln_flw_val] = STATE(1319),
    [sym__r_sgl_pln_flw] = STATE(801),
    [sym__br_sgl_pln_flw] = STATE(802),
    [sym__r_mtl_pln_flw] = STATE(803),
    [sym__br_mtl_pln_flw] = STATE(802),
    [sym__r_als_val] = STATE(935),
    [sym__br_als_val] = STATE(934),
    [sym__r_als] = STATE(913),
    [sym__br_als] = STATE(914),
    [sym__r_acr] = STATE(219),
    [sym__br_acr] = STATE(211),
    [sym__r_flw_seq_bgn] = ACTIONS(466),
    [sym__br_flw_seq_bgn] = ACTIONS(468),
    [sym__r_flw_map_bgn] = ACTIONS(470),
    [sym__br_flw_map_bgn] = ACTIONS(472),
    [sym__r_flw_map_end] = ACTIONS(474),
    [sym__br_flw_map_end] = ACTIONS(477),
    [sym__b_flw_map_end] = ACTIONS(477),
    [sym__r_flw_sep_bgn] = ACTIONS(474),
    [sym__br_flw_sep_bgn] = ACTIONS(477),
    [sym__r_dqt_str_bgn] = ACTIONS(479),
    [sym__br_dqt_str_bgn] = ACTIONS(481),
    [sym__r_sqt_str_bgn] = ACTIONS(483),
    [sym__br_sqt_str_bgn] = ACTIONS(485),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(487),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(489),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(487),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(489),
    [sym__r_sgl_pln_int_flw] = ACTIONS(487),
    [sym__br_sgl_pln_int_flw] = ACTIONS(489),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(487),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(489),
    [sym__r_sgl_pln_str_flw] = ACTIONS(487),
    [sym__br_sgl_pln_str_flw] = ACTIONS(489),
    [sym__r_mtl_pln_str_flw] = ACTIONS(491),
    [sym__br_mtl_pln_str_flw] = ACTIONS(493),
    [sym__r_tag] = ACTIONS(495),
    [sym__br_tag] = ACTIONS(497),
    [sym__r_acr_bgn] = ACTIONS(499),
    [sym__br_acr_bgn] = ACTIONS(501),
    [sym__r_als_bgn] = ACTIONS(503),
    [sym__br_als_bgn] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(1131),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1058),
    [sym__br_flw_seq_dat] = STATE(1058),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(335),
    [sym__br_flw_seq_end] = ACTIONS(335),
    [sym__b_flw_seq_end] = ACTIONS(335),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(568),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1172),
    [sym__br_flw_seq_dat] = STATE(1172),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(507),
    [sym__br_flw_seq_end] = ACTIONS(507),
    [sym__b_flw_seq_end] = ACTIONS(507),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym__r_prp_val] = STATE(810),
    [sym__br_prp_val] = STATE(810),
    [sym__r_sgl_prp_val] = STATE(1379),
    [sym__r_prp] = STATE(118),
    [sym__br_prp] = STATE(119),
    [sym__r_sgl_prp] = STATE(274),
    [sym__r_flw_seq_val] = STATE(810),
    [sym__br_flw_seq_val] = STATE(810),
    [sym__r_sgl_flw_seq_val] = STATE(1379),
    [sym__r_flw_seq] = STATE(817),
    [sym__br_flw_seq] = STATE(818),
    [sym__r_sgl_flw_seq] = STATE(1219),
    [sym__r_flw_map_val] = STATE(810),
    [sym__br_flw_map_val] = STATE(810),
    [sym__r_sgl_flw_map_val] = STATE(1379),
    [sym__r_flw_map] = STATE(819),
    [sym__br_flw_map] = STATE(820),
    [sym__r_sgl_flw_map] = STATE(1223),
    [sym__flw_ann_par_tal] = STATE(810),
    [sym__sgl_flw_ann_par_tal] = STATE(1379),
    [sym__r_dqt_str_val] = STATE(810),
    [sym__br_dqt_str_val] = STATE(810),
    [sym__r_sgl_dqt_str_val] = STATE(1379),
    [sym__r_dqt_str] = STATE(821),
    [sym__br_dqt_str] = STATE(822),
    [sym__r_sgl_dqt_str] = STATE(1224),
    [sym__r_sqt_str_val] = STATE(810),
    [sym__br_sqt_str_val] = STATE(810),
    [sym__r_sgl_sqt_str_val] = STATE(1379),
    [sym__r_sqt_str] = STATE(823),
    [sym__br_sqt_str] = STATE(824),
    [sym__r_sgl_sqt_str] = STATE(1228),
    [sym__r_pln_flw_val] = STATE(810),
    [sym__br_pln_flw_val] = STATE(810),
    [sym__r_sgl_pln_flw_val] = STATE(1379),
    [sym__r_sgl_pln_flw] = STATE(785),
    [sym__br_sgl_pln_flw] = STATE(786),
    [sym__r_mtl_pln_flw] = STATE(792),
    [sym__br_mtl_pln_flw] = STATE(786),
    [sym__r_als_val] = STATE(919),
    [sym__br_als_val] = STATE(810),
    [sym__r_als] = STATE(873),
    [sym__br_als] = STATE(874),
    [sym__r_acr] = STATE(218),
    [sym__br_acr] = STATE(220),
    [sym__r_flw_seq_bgn] = ACTIONS(509),
    [sym__br_flw_seq_bgn] = ACTIONS(511),
    [sym__r_flw_seq_end] = ACTIONS(474),
    [sym__br_flw_seq_end] = ACTIONS(477),
    [sym__b_flw_seq_end] = ACTIONS(477),
    [sym__r_flw_map_bgn] = ACTIONS(513),
    [sym__br_flw_map_bgn] = ACTIONS(515),
    [sym__r_flw_sep_bgn] = ACTIONS(474),
    [sym__br_flw_sep_bgn] = ACTIONS(477),
    [sym__r_dqt_str_bgn] = ACTIONS(517),
    [sym__br_dqt_str_bgn] = ACTIONS(519),
    [sym__r_sqt_str_bgn] = ACTIONS(521),
    [sym__br_sqt_str_bgn] = ACTIONS(523),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(525),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(527),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(525),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(527),
    [sym__r_sgl_pln_int_flw] = ACTIONS(525),
    [sym__br_sgl_pln_int_flw] = ACTIONS(527),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(525),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(527),
    [sym__r_sgl_pln_str_flw] = ACTIONS(525),
    [sym__br_sgl_pln_str_flw] = ACTIONS(527),
    [sym__r_mtl_pln_str_flw] = ACTIONS(529),
    [sym__br_mtl_pln_str_flw] = ACTIONS(531),
    [sym__r_tag] = ACTIONS(533),
    [sym__br_tag] = ACTIONS(535),
    [sym__r_acr_bgn] = ACTIONS(537),
    [sym__br_acr_bgn] = ACTIONS(539),
    [sym__r_als_bgn] = ACTIONS(541),
    [sym__br_als_bgn] = ACTIONS(543),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(566),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1172),
    [sym__br_flw_seq_dat] = STATE(1172),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(363),
    [sym__br_flw_seq_end] = ACTIONS(363),
    [sym__b_flw_seq_end] = ACTIONS(363),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(712),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1165),
    [sym__br_flw_seq_dat] = STATE(1165),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(349),
    [sym__br_flw_seq_end] = ACTIONS(349),
    [sym__b_flw_seq_end] = ACTIONS(349),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(1318),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1182),
    [sym__br_flw_seq_dat] = STATE(1182),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(545),
    [sym__br_flw_seq_end] = ACTIONS(545),
    [sym__b_flw_seq_end] = ACTIONS(545),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(366),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1151),
    [sym__br_flw_seq_dat] = STATE(1151),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(345),
    [sym__br_flw_seq_end] = ACTIONS(345),
    [sym__b_flw_seq_end] = ACTIONS(345),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(829),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1193),
    [sym__br_flw_seq_dat] = STATE(1193),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(547),
    [sym__br_flw_seq_end] = ACTIONS(547),
    [sym__b_flw_seq_end] = ACTIONS(547),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(1316),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1182),
    [sym__br_flw_seq_dat] = STATE(1182),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(355),
    [sym__br_flw_seq_end] = ACTIONS(355),
    [sym__b_flw_seq_end] = ACTIONS(355),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(1247),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1124),
    [sym__br_flw_seq_dat] = STATE(1124),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(339),
    [sym__br_flw_seq_end] = ACTIONS(339),
    [sym__b_flw_seq_end] = ACTIONS(339),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(877),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1211),
    [sym__br_flw_seq_dat] = STATE(1211),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(549),
    [sym__br_flw_seq_end] = ACTIONS(549),
    [sym__b_flw_seq_end] = ACTIONS(549),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(828),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1193),
    [sym__br_flw_seq_dat] = STATE(1193),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(359),
    [sym__br_flw_seq_end] = ACTIONS(359),
    [sym__b_flw_seq_end] = ACTIONS(359),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__flw_seq_tal] = STATE(784),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_dat] = STATE(1211),
    [sym__br_flw_seq_dat] = STATE(1211),
    [sym__r_flw_seq_itm] = STATE(649),
    [sym__br_flw_seq_itm] = STATE(661),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(367),
    [sym__br_flw_seq_end] = ACTIONS(367),
    [sym__b_flw_seq_end] = ACTIONS(367),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_flw_map_itm] = STATE(875),
    [sym__br_flw_map_itm] = STATE(875),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(551),
    [sym__br_flw_map_end] = ACTIONS(551),
    [sym__b_flw_map_end] = ACTIONS(551),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_flw_map_itm] = STATE(875),
    [sym__br_flw_map_itm] = STATE(875),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(553),
    [sym__br_flw_map_end] = ACTIONS(553),
    [sym__b_flw_map_end] = ACTIONS(553),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_flw_map_itm] = STATE(875),
    [sym__br_flw_map_itm] = STATE(875),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(555),
    [sym__br_flw_map_end] = ACTIONS(555),
    [sym__b_flw_map_end] = ACTIONS(555),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_flw_map_itm] = STATE(875),
    [sym__br_flw_map_itm] = STATE(875),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_map_end] = ACTIONS(557),
    [sym__br_flw_map_end] = ACTIONS(557),
    [sym__b_flw_map_end] = ACTIONS(557),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_itm] = STATE(825),
    [sym__br_flw_seq_itm] = STATE(825),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(559),
    [sym__br_flw_seq_end] = ACTIONS(559),
    [sym__b_flw_seq_end] = ACTIONS(559),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_itm] = STATE(825),
    [sym__br_flw_seq_itm] = STATE(825),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(561),
    [sym__br_flw_seq_end] = ACTIONS(561),
    [sym__b_flw_seq_end] = ACTIONS(561),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_itm] = STATE(825),
    [sym__br_flw_seq_itm] = STATE(825),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(563),
    [sym__br_flw_seq_end] = ACTIONS(563),
    [sym__b_flw_seq_end] = ACTIONS(563),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_itm] = STATE(825),
    [sym__br_flw_seq_itm] = STATE(825),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_seq_end] = ACTIONS(565),
    [sym__br_flw_seq_end] = ACTIONS(565),
    [sym__b_flw_seq_end] = ACTIONS(565),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym__r_prp_val] = STATE(492),
    [sym__br_prp_val] = STATE(493),
    [sym__r_prp] = STATE(112),
    [sym__br_prp] = STATE(113),
    [sym__r_flw_seq_val] = STATE(497),
    [sym__br_flw_seq_val] = STATE(529),
    [sym__r_flw_seq] = STATE(623),
    [sym__br_flw_seq] = STATE(540),
    [sym__r_flw_map_val] = STATE(497),
    [sym__br_flw_map_val] = STATE(529),
    [sym__r_flw_map] = STATE(542),
    [sym__br_flw_map] = STATE(545),
    [sym__r_flw_map_itm] = STATE(875),
    [sym__br_flw_map_itm] = STATE(875),
    [sym__r_flw_exp_par] = STATE(814),
    [sym__br_flw_exp_par] = STATE(815),
    [sym__r_flw_imp_r_par] = STATE(826),
    [sym__r_flw_imp_br_par] = STATE(839),
    [sym__br_flw_imp_r_par] = STATE(840),
    [sym__br_flw_imp_br_par] = STATE(841),
    [sym__r_flw_njl_ann_par] = STATE(887),
    [sym__br_flw_njl_ann_par] = STATE(888),
    [sym__r_dqt_str_val] = STATE(497),
    [sym__br_dqt_str_val] = STATE(529),
    [sym__r_dqt_str] = STATE(547),
    [sym__br_dqt_str] = STATE(548),
    [sym__r_sqt_str_val] = STATE(497),
    [sym__br_sqt_str_val] = STATE(529),
    [sym__r_sqt_str] = STATE(549),
    [sym__br_sqt_str] = STATE(550),
    [sym__r_pln_flw_val] = STATE(492),
    [sym__br_pln_flw_val] = STATE(493),
    [sym__r_sgl_pln_flw] = STATE(564),
    [sym__br_sgl_pln_flw] = STATE(563),
    [sym__r_mtl_pln_flw] = STATE(564),
    [sym__br_mtl_pln_flw] = STATE(563),
    [sym__r_als_val] = STATE(492),
    [sym__br_als_val] = STATE(493),
    [sym__r_als] = STATE(638),
    [sym__br_als] = STATE(551),
    [sym__r_acr] = STATE(195),
    [sym__br_acr] = STATE(201),
    [sym__r_flw_seq_bgn] = ACTIONS(426),
    [sym__br_flw_seq_bgn] = ACTIONS(207),
    [sym__r_flw_map_bgn] = ACTIONS(428),
    [sym__br_flw_map_bgn] = ACTIONS(211),
    [sym__r_flw_key_bgn] = ACTIONS(432),
    [sym__br_flw_key_bgn] = ACTIONS(219),
    [sym__r_flw_njv_bgn] = ACTIONS(434),
    [sym__br_flw_njv_bgn] = ACTIONS(223),
    [sym__r_dqt_str_bgn] = ACTIONS(436),
    [sym__br_dqt_str_bgn] = ACTIONS(227),
    [sym__r_sqt_str_bgn] = ACTIONS(438),
    [sym__br_sqt_str_bgn] = ACTIONS(231),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(233),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(235),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(233),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(235),
    [sym__r_sgl_pln_int_flw] = ACTIONS(233),
    [sym__br_sgl_pln_int_flw] = ACTIONS(235),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(233),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(235),
    [sym__r_sgl_pln_str_flw] = ACTIONS(233),
    [sym__br_sgl_pln_str_flw] = ACTIONS(235),
    [sym__r_mtl_pln_str_flw] = ACTIONS(237),
    [sym__br_mtl_pln_str_flw] = ACTIONS(239),
    [sym__r_tag] = ACTIONS(440),
    [sym__br_tag] = ACTIONS(243),
    [sym__r_acr_bgn] = ACTIONS(245),
    [sym__br_acr_bgn] = ACTIONS(247),
    [sym__r_als_bgn] = ACTIONS(249),
    [sym__br_als_bgn] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym__r_prp_val] = STATE(674),
    [sym__br_prp_val] = STATE(672),
    [sym__r_prp] = STATE(114),
    [sym__br_prp] = STATE(115),
    [sym__r_flw_seq_val] = STATE(554),
    [sym__br_flw_seq_val] = STATE(645),
    [sym__r_flw_seq] = STATE(702),
    [sym__br_flw_seq] = STATE(703),
    [sym__r_flw_map_val] = STATE(554),
    [sym__br_flw_map_val] = STATE(645),
    [sym__r_flw_map] = STATE(704),
    [sym__br_flw_map] = STATE(705),
    [sym__r_flw_seq_itm] = STATE(825),
    [sym__br_flw_seq_itm] = STATE(825),
    [sym__r_flw_exp_par] = STATE(789),
    [sym__br_flw_exp_par] = STATE(790),
    [sym__r_flw_imp_r_par] = STATE(791),
    [sym__br_flw_imp_r_par] = STATE(795),
    [sym__r_flw_njl_ann_par] = STATE(799),
    [sym__br_flw_njl_ann_par] = STATE(800),
    [sym__r_dqt_str_val] = STATE(554),
    [sym__br_dqt_str_val] = STATE(645),
    [sym__r_dqt_str] = STATE(706),
    [sym__br_dqt_str] = STATE(707),
    [sym__r_sqt_str_val] = STATE(554),
    [sym__br_sqt_str_val] = STATE(645),
    [sym__r_sqt_str] = STATE(708),
    [sym__br_sqt_str] = STATE(709),
    [sym__r_pln_flw_val] = STATE(674),
    [sym__br_pln_flw_val] = STATE(672),
    [sym__r_sgl_pln_flw] = STATE(749),
    [sym__br_sgl_pln_flw] = STATE(748),
    [sym__r_mtl_pln_flw] = STATE(749),
    [sym__br_mtl_pln_flw] = STATE(748),
    [sym__r_als_val] = STATE(674),
    [sym__br_als_val] = STATE(672),
    [sym__r_als] = STATE(746),
    [sym__br_als] = STATE(710),
    [sym__r_acr] = STATE(208),
    [sym__br_acr] = STATE(210),
    [sym__r_flw_seq_bgn] = ACTIONS(450),
    [sym__br_flw_seq_bgn] = ACTIONS(289),
    [sym__r_flw_map_bgn] = ACTIONS(454),
    [sym__br_flw_map_bgn] = ACTIONS(297),
    [sym__r_flw_key_bgn] = ACTIONS(456),
    [sym__br_flw_key_bgn] = ACTIONS(301),
    [sym__r_flw_njv_bgn] = ACTIONS(458),
    [sym__br_flw_njv_bgn] = ACTIONS(305),
    [sym__r_dqt_str_bgn] = ACTIONS(460),
    [sym__br_dqt_str_bgn] = ACTIONS(309),
    [sym__r_sqt_str_bgn] = ACTIONS(462),
    [sym__br_sqt_str_bgn] = ACTIONS(313),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(315),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(317),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(315),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(317),
    [sym__r_sgl_pln_int_flw] = ACTIONS(315),
    [sym__br_sgl_pln_int_flw] = ACTIONS(317),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(315),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(317),
    [sym__r_sgl_pln_str_flw] = ACTIONS(315),
    [sym__br_sgl_pln_str_flw] = ACTIONS(317),
    [sym__r_mtl_pln_str_flw] = ACTIONS(319),
    [sym__br_mtl_pln_str_flw] = ACTIONS(321),
    [sym__r_tag] = ACTIONS(464),
    [sym__br_tag] = ACTIONS(325),
    [sym__r_acr_bgn] = ACTIONS(327),
    [sym__br_acr_bgn] = ACTIONS(329),
    [sym__r_als_bgn] = ACTIONS(331),
    [sym__br_als_bgn] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__br_sgl_prp] = STATE(309),
    [sym__br_blk_seq] = STATE(1201),
    [sym__br_blk_seq_itm] = STATE(1048),
    [sym__br_blk_map] = STATE(1202),
    [sym__br_blk_map_itm] = STATE(148),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__r_blk_str] = STATE(1203),
    [sym__br_blk_str] = STATE(1203),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(1204),
    [sym__br_flw_seq] = STATE(1204),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(1205),
    [sym__br_flw_map] = STATE(1205),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(1206),
    [sym__br_dqt_str] = STATE(1206),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(1207),
    [sym__br_sqt_str] = STATE(1207),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(1208),
    [sym__br_sgl_pln_blk] = STATE(1040),
    [sym__r_mtl_pln_blk] = STATE(1208),
    [sym__br_mtl_pln_blk] = STATE(1208),
    [sym__br_als_val] = STATE(1237),
    [sym__br_als] = STATE(1487),
    [sym__br_acr] = STATE(424),
    [sym__eof] = ACTIONS(377),
    [sym__s_drs_end] = ACTIONS(377),
    [sym__s_doc_end] = ACTIONS(377),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__r_blk_lit_bgn] = ACTIONS(29),
    [sym__br_blk_lit_bgn] = ACTIONS(31),
    [sym__r_blk_fld_bgn] = ACTIONS(29),
    [sym__br_blk_fld_bgn] = ACTIONS(31),
    [sym__r_flw_seq_bgn] = ACTIONS(189),
    [sym__br_flw_seq_bgn] = ACTIONS(35),
    [sym__r_flw_map_bgn] = ACTIONS(191),
    [sym__br_flw_map_bgn] = ACTIONS(39),
    [sym__r_dqt_str_bgn] = ACTIONS(193),
    [sym__br_dqt_str_bgn] = ACTIONS(43),
    [sym__r_sqt_str_bgn] = ACTIONS(195),
    [sym__br_sqt_str_bgn] = ACTIONS(47),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(197),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(51),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(197),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(51),
    [sym__r_sgl_pln_int_blk] = ACTIONS(197),
    [sym__br_sgl_pln_int_blk] = ACTIONS(51),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(197),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(51),
    [sym__r_sgl_pln_str_blk] = ACTIONS(197),
    [sym__br_sgl_pln_str_blk] = ACTIONS(51),
    [sym__r_mtl_pln_str_blk] = ACTIONS(53),
    [sym__br_mtl_pln_str_blk] = ACTIONS(55),
    [sym__br_tag] = ACTIONS(371),
    [sym__br_acr_bgn] = ACTIONS(373),
    [sym__br_als_bgn] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__br_sgl_prp] = STATE(309),
    [sym__br_blk_seq] = STATE(1177),
    [sym__br_blk_seq_itm] = STATE(1048),
    [sym__br_blk_map] = STATE(1185),
    [sym__br_blk_map_itm] = STATE(148),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__r_blk_str] = STATE(1186),
    [sym__br_blk_str] = STATE(1186),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(1188),
    [sym__br_flw_seq] = STATE(1188),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(1191),
    [sym__br_flw_map] = STATE(1191),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(1192),
    [sym__br_dqt_str] = STATE(1192),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(1197),
    [sym__br_sqt_str] = STATE(1197),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(1199),
    [sym__br_sgl_pln_blk] = STATE(1037),
    [sym__r_mtl_pln_blk] = STATE(1199),
    [sym__br_mtl_pln_blk] = STATE(1199),
    [sym__br_als_val] = STATE(1237),
    [sym__br_als] = STATE(1487),
    [sym__br_acr] = STATE(424),
    [sym__eof] = ACTIONS(369),
    [sym__s_drs_end] = ACTIONS(369),
    [sym__s_doc_end] = ACTIONS(369),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__r_blk_lit_bgn] = ACTIONS(29),
    [sym__br_blk_lit_bgn] = ACTIONS(31),
    [sym__r_blk_fld_bgn] = ACTIONS(29),
    [sym__br_blk_fld_bgn] = ACTIONS(31),
    [sym__r_flw_seq_bgn] = ACTIONS(189),
    [sym__br_flw_seq_bgn] = ACTIONS(35),
    [sym__r_flw_map_bgn] = ACTIONS(191),
    [sym__br_flw_map_bgn] = ACTIONS(39),
    [sym__r_dqt_str_bgn] = ACTIONS(193),
    [sym__br_dqt_str_bgn] = ACTIONS(43),
    [sym__r_sqt_str_bgn] = ACTIONS(195),
    [sym__br_sqt_str_bgn] = ACTIONS(47),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(197),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(51),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(197),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(51),
    [sym__r_sgl_pln_int_blk] = ACTIONS(197),
    [sym__br_sgl_pln_int_blk] = ACTIONS(51),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(197),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(51),
    [sym__r_sgl_pln_str_blk] = ACTIONS(197),
    [sym__br_sgl_pln_str_blk] = ACTIONS(51),
    [sym__r_mtl_pln_str_blk] = ACTIONS(53),
    [sym__br_mtl_pln_str_blk] = ACTIONS(55),
    [sym__br_tag] = ACTIONS(371),
    [sym__br_acr_bgn] = ACTIONS(373),
    [sym__br_als_bgn] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__br_sgl_prp] = STATE(309),
    [sym__br_blk_seq] = STATE(1284),
    [sym__br_blk_seq_itm] = STATE(1003),
    [sym__br_blk_map] = STATE(1285),
    [sym__br_blk_map_itm] = STATE(127),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__r_blk_str] = STATE(1286),
    [sym__br_blk_str] = STATE(1286),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(1287),
    [sym__br_flw_seq] = STATE(1287),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(1288),
    [sym__br_flw_map] = STATE(1288),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(1289),
    [sym__br_dqt_str] = STATE(1289),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(1290),
    [sym__br_sqt_str] = STATE(1290),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(1291),
    [sym__br_sgl_pln_blk] = STATE(1160),
    [sym__r_mtl_pln_blk] = STATE(1291),
    [sym__br_mtl_pln_blk] = STATE(1291),
    [sym__br_als_val] = STATE(1237),
    [sym__br_als] = STATE(1487),
    [sym__br_acr] = STATE(424),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(377),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__r_blk_lit_bgn] = ACTIONS(125),
    [sym__br_blk_lit_bgn] = ACTIONS(127),
    [sym__r_blk_fld_bgn] = ACTIONS(125),
    [sym__br_blk_fld_bgn] = ACTIONS(127),
    [sym__r_flw_seq_bgn] = ACTIONS(567),
    [sym__br_flw_seq_bgn] = ACTIONS(131),
    [sym__r_flw_map_bgn] = ACTIONS(569),
    [sym__br_flw_map_bgn] = ACTIONS(135),
    [sym__r_dqt_str_bgn] = ACTIONS(571),
    [sym__br_dqt_str_bgn] = ACTIONS(139),
    [sym__r_sqt_str_bgn] = ACTIONS(573),
    [sym__br_sqt_str_bgn] = ACTIONS(143),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(575),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(147),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(575),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(147),
    [sym__r_sgl_pln_int_blk] = ACTIONS(575),
    [sym__br_sgl_pln_int_blk] = ACTIONS(147),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(575),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(147),
    [sym__r_sgl_pln_str_blk] = ACTIONS(575),
    [sym__br_sgl_pln_str_blk] = ACTIONS(147),
    [sym__r_mtl_pln_str_blk] = ACTIONS(149),
    [sym__br_mtl_pln_str_blk] = ACTIONS(151),
    [sym__br_tag] = ACTIONS(371),
    [sym__br_acr_bgn] = ACTIONS(373),
    [sym__br_als_bgn] = ACTIONS(375),
    [sym__bl] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym__br_sgl_prp_val] = STATE(1237),
    [sym__br_sgl_prp] = STATE(309),
    [sym__br_blk_seq] = STATE(1273),
    [sym__br_blk_seq_itm] = STATE(1003),
    [sym__br_blk_map] = STATE(1274),
    [sym__br_blk_map_itm] = STATE(127),
    [sym__br_blk_exp_itm] = STATE(319),
    [sym__br_blk_key_itm] = STATE(278),
    [sym__br_blk_val_itm] = STATE(328),
    [sym__br_blk_imp_itm] = STATE(364),
    [sym__r_blk_str] = STATE(1275),
    [sym__br_blk_str] = STATE(1275),
    [sym__br_sgl_flw_seq_val] = STATE(1237),
    [sym__r_flw_seq] = STATE(1276),
    [sym__br_flw_seq] = STATE(1276),
    [sym__br_sgl_flw_seq] = STATE(1551),
    [sym__br_sgl_flw_map_val] = STATE(1237),
    [sym__r_flw_map] = STATE(1277),
    [sym__br_flw_map] = STATE(1277),
    [sym__br_sgl_flw_map] = STATE(1514),
    [sym__br_sgl_dqt_str_val] = STATE(1237),
    [sym__r_dqt_str] = STATE(1278),
    [sym__br_dqt_str] = STATE(1278),
    [sym__br_sgl_dqt_str] = STATE(1446),
    [sym__br_sgl_sqt_str_val] = STATE(1237),
    [sym__r_sqt_str] = STATE(1279),
    [sym__br_sqt_str] = STATE(1279),
    [sym__br_sgl_sqt_str] = STATE(1417),
    [sym__br_sgl_pln_blk_val] = STATE(1237),
    [sym__r_sgl_pln_blk] = STATE(1280),
    [sym__br_sgl_pln_blk] = STATE(1159),
    [sym__r_mtl_pln_blk] = STATE(1280),
    [sym__br_mtl_pln_blk] = STATE(1280),
    [sym__br_als_val] = STATE(1237),
    [sym__br_als] = STATE(1487),
    [sym__br_acr] = STATE(424),
    [sym__br_blk_seq_bgn] = ACTIONS(19),
    [sym__b_blk_seq_bgn] = ACTIONS(369),
    [sym__br_blk_key_bgn] = ACTIONS(23),
    [sym__br_blk_val_bgn] = ACTIONS(27),
    [sym__r_blk_lit_bgn] = ACTIONS(125),
    [sym__br_blk_lit_bgn] = ACTIONS(127),
    [sym__r_blk_fld_bgn] = ACTIONS(125),
    [sym__br_blk_fld_bgn] = ACTIONS(127),
    [sym__r_flw_seq_bgn] = ACTIONS(567),
    [sym__br_flw_seq_bgn] = ACTIONS(131),
    [sym__r_flw_map_bgn] = ACTIONS(569),
    [sym__br_flw_map_bgn] = ACTIONS(135),
    [sym__r_dqt_str_bgn] = ACTIONS(571),
    [sym__br_dqt_str_bgn] = ACTIONS(139),
    [sym__r_sqt_str_bgn] = ACTIONS(573),
    [sym__br_sqt_str_bgn] = ACTIONS(143),
    [sym__r_sgl_pln_nul_blk] = ACTIONS(575),
    [sym__br_sgl_pln_nul_blk] = ACTIONS(147),
    [sym__r_sgl_pln_bol_blk] = ACTIONS(575),
    [sym__br_sgl_pln_bol_blk] = ACTIONS(147),
    [sym__r_sgl_pln_int_blk] = ACTIONS(575),
    [sym__br_sgl_pln_int_blk] = ACTIONS(147),
    [sym__r_sgl_pln_flt_blk] = ACTIONS(575),
    [sym__br_sgl_pln_flt_blk] = ACTIONS(147),
    [sym__r_sgl_pln_str_blk] = ACTIONS(575),
    [sym__br_sgl_pln_str_blk] = ACTIONS(147),
    [sym__r_mtl_pln_str_blk] = ACTIONS(149),
    [sym__br_mtl_pln_str_blk] = ACTIONS(151),
    [sym__br_tag] = ACTIONS(371),
    [sym__br_acr_bgn] = ACTIONS(373),
    [sym__br_als_bgn] = ACTIONS(375),
    [sym__bl] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym__r_prp_val] = STATE(981),
    [sym__br_prp_val] = STATE(984),
    [sym__r_prp] = STATE(163),
    [sym__br_prp] = STATE(168),
    [sym__r_flw_seq_val] = STATE(1031),
    [sym__br_flw_seq_val] = STATE(1035),
    [sym__r_flw_seq] = STATE(1282),
    [sym__br_flw_seq] = STATE(1283),
    [sym__r_flw_map_val] = STATE(1031),
    [sym__br_flw_map_val] = STATE(1035),
    [sym__r_flw_map] = STATE(1302),
    [sym__br_flw_map] = STATE(1304),
    [sym__r_flw_imp_r_par] = STATE(924),
    [sym__r_flw_imp_br_par] = STATE(925),
    [sym__br_flw_imp_r_par] = STATE(926),
    [sym__br_flw_imp_br_par] = STATE(927),
    [sym__r_dqt_str_val] = STATE(1031),
    [sym__br_dqt_str_val] = STATE(1035),
    [sym__r_dqt_str] = STATE(1306),
    [sym__br_dqt_str] = STATE(1307),
    [sym__r_sqt_str_val] = STATE(1031),
    [sym__br_sqt_str_val] = STATE(1035),
    [sym__r_sqt_str] = STATE(1309),
    [sym__br_sqt_str] = STATE(1310),
    [sym__r_pln_flw_val] = STATE(981),
    [sym__br_pln_flw_val] = STATE(984),
    [sym__r_sgl_pln_flw] = STATE(1222),
    [sym__br_sgl_pln_flw] = STATE(1345),
    [sym__r_mtl_pln_flw] = STATE(1222),
    [sym__br_mtl_pln_flw] = STATE(1345),
    [sym__r_als_val] = STATE(981),
    [sym__br_als_val] = STATE(984),
    [sym__r_als] = STATE(1246),
    [sym__br_als] = STATE(1272),
    [sym__r_acr] = STATE(245),
    [sym__br_acr] = STATE(246),
    [sym__r_flw_seq_bgn] = ACTIONS(577),
    [sym__br_flw_seq_bgn] = ACTIONS(387),
    [sym__r_flw_map_bgn] = ACTIONS(579),
    [sym__br_flw_map_bgn] = ACTIONS(391),
    [sym__r_flw_map_end] = ACTIONS(396),
    [sym__br_flw_map_end] = ACTIONS(396),
    [sym__b_flw_map_end] = ACTIONS(396),
    [sym__r_flw_sep_bgn] = ACTIONS(396),
    [sym__br_flw_sep_bgn] = ACTIONS(396),
    [sym__r_dqt_str_bgn] = ACTIONS(581),
    [sym__br_dqt_str_bgn] = ACTIONS(400),
    [sym__r_sqt_str_bgn] = ACTIONS(583),
    [sym__br_sqt_str_bgn] = ACTIONS(404),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(406),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(408),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(406),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(408),
    [sym__r_sgl_pln_int_flw] = ACTIONS(406),
    [sym__br_sgl_pln_int_flw] = ACTIONS(408),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(406),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(408),
    [sym__r_sgl_pln_str_flw] = ACTIONS(406),
    [sym__br_sgl_pln_str_flw] = ACTIONS(408),
    [sym__r_mtl_pln_str_flw] = ACTIONS(410),
    [sym__br_mtl_pln_str_flw] = ACTIONS(412),
    [sym__r_tag] = ACTIONS(585),
    [sym__br_tag] = ACTIONS(416),
    [sym__r_acr_bgn] = ACTIONS(418),
    [sym__br_acr_bgn] = ACTIONS(420),
    [sym__r_als_bgn] = ACTIONS(422),
    [sym__br_als_bgn] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym__r_prp_val] = STATE(981),
    [sym__br_prp_val] = STATE(984),
    [sym__r_prp] = STATE(163),
    [sym__br_prp] = STATE(168),
    [sym__r_flw_seq_val] = STATE(1031),
    [sym__br_flw_seq_val] = STATE(1035),
    [sym__r_flw_seq] = STATE(1282),
    [sym__br_flw_seq] = STATE(1283),
    [sym__r_flw_map_val] = STATE(1031),
    [sym__br_flw_map_val] = STATE(1035),
    [sym__r_flw_map] = STATE(1302),
    [sym__br_flw_map] = STATE(1304),
    [sym__r_flw_imp_r_par] = STATE(929),
    [sym__r_flw_imp_br_par] = STATE(931),
    [sym__br_flw_imp_r_par] = STATE(932),
    [sym__br_flw_imp_br_par] = STATE(933),
    [sym__r_dqt_str_val] = STATE(1031),
    [sym__br_dqt_str_val] = STATE(1035),
    [sym__r_dqt_str] = STATE(1306),
    [sym__br_dqt_str] = STATE(1307),
    [sym__r_sqt_str_val] = STATE(1031),
    [sym__br_sqt_str_val] = STATE(1035),
    [sym__r_sqt_str] = STATE(1309),
    [sym__br_sqt_str] = STATE(1310),
    [sym__r_pln_flw_val] = STATE(981),
    [sym__br_pln_flw_val] = STATE(984),
    [sym__r_sgl_pln_flw] = STATE(1222),
    [sym__br_sgl_pln_flw] = STATE(1345),
    [sym__r_mtl_pln_flw] = STATE(1222),
    [sym__br_mtl_pln_flw] = STATE(1345),
    [sym__r_als_val] = STATE(981),
    [sym__br_als_val] = STATE(984),
    [sym__r_als] = STATE(1246),
    [sym__br_als] = STATE(1272),
    [sym__r_acr] = STATE(245),
    [sym__br_acr] = STATE(246),
    [sym__r_flw_seq_bgn] = ACTIONS(577),
    [sym__br_flw_seq_bgn] = ACTIONS(387),
    [sym__r_flw_map_bgn] = ACTIONS(579),
    [sym__br_flw_map_bgn] = ACTIONS(391),
    [sym__r_flw_map_end] = ACTIONS(587),
    [sym__br_flw_map_end] = ACTIONS(587),
    [sym__b_flw_map_end] = ACTIONS(587),
    [sym__r_flw_sep_bgn] = ACTIONS(587),
    [sym__br_flw_sep_bgn] = ACTIONS(587),
    [sym__r_dqt_str_bgn] = ACTIONS(581),
    [sym__br_dqt_str_bgn] = ACTIONS(400),
    [sym__r_sqt_str_bgn] = ACTIONS(583),
    [sym__br_sqt_str_bgn] = ACTIONS(404),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(406),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(408),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(406),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(408),
    [sym__r_sgl_pln_int_flw] = ACTIONS(406),
    [sym__br_sgl_pln_int_flw] = ACTIONS(408),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(406),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(408),
    [sym__r_sgl_pln_str_flw] = ACTIONS(406),
    [sym__br_sgl_pln_str_flw] = ACTIONS(408),
    [sym__r_mtl_pln_str_flw] = ACTIONS(410),
    [sym__br_mtl_pln_str_flw] = ACTIONS(412),
    [sym__r_tag] = ACTIONS(585),
    [sym__br_tag] = ACTIONS(416),
    [sym__r_acr_bgn] = ACTIONS(418),
    [sym__br_acr_bgn] = ACTIONS(420),
    [sym__r_als_bgn] = ACTIONS(422),
    [sym__br_als_bgn] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym__r_prp_val] = STATE(980),
    [sym__br_prp_val] = STATE(991),
    [sym__r_prp] = STATE(163),
    [sym__br_prp] = STATE(168),
    [sym__r_flw_seq_val] = STATE(1009),
    [sym__br_flw_seq_val] = STATE(1018),
    [sym__r_flw_seq] = STATE(1282),
    [sym__br_flw_seq] = STATE(1283),
    [sym__r_flw_map_val] = STATE(1009),
    [sym__br_flw_map_val] = STATE(1018),
    [sym__r_flw_map] = STATE(1302),
    [sym__br_flw_map] = STATE(1304),
    [sym__r_flw_imp_r_par] = STATE(948),
    [sym__r_flw_imp_br_par] = STATE(953),
    [sym__br_flw_imp_r_par] = STATE(960),
    [sym__br_flw_imp_br_par] = STATE(804),
    [sym__r_dqt_str_val] = STATE(1009),
    [sym__br_dqt_str_val] = STATE(1018),
    [sym__r_dqt_str] = STATE(1306),
    [sym__br_dqt_str] = STATE(1307),
    [sym__r_sqt_str_val] = STATE(1009),
    [sym__br_sqt_str_val] = STATE(1018),
    [sym__r_sqt_str] = STATE(1309),
    [sym__br_sqt_str] = STATE(1310),
    [sym__r_pln_flw_val] = STATE(980),
    [sym__br_pln_flw_val] = STATE(991),
    [sym__r_sgl_pln_flw] = STATE(1222),
    [sym__br_sgl_pln_flw] = STATE(1345),
    [sym__r_mtl_pln_flw] = STATE(1222),
    [sym__br_mtl_pln_flw] = STATE(1345),
    [sym__r_als_val] = STATE(980),
    [sym__br_als_val] = STATE(991),
    [sym__r_als] = STATE(1246),
    [sym__br_als] = STATE(1272),
    [sym__r_acr] = STATE(245),
    [sym__br_acr] = STATE(246),
    [sym__r_flw_seq_bgn] = ACTIONS(577),
    [sym__br_flw_seq_bgn] = ACTIONS(387),
    [sym__r_flw_seq_end] = ACTIONS(396),
    [sym__br_flw_seq_end] = ACTIONS(396),
    [sym__b_flw_seq_end] = ACTIONS(396),
    [sym__r_flw_map_bgn] = ACTIONS(579),
    [sym__br_flw_map_bgn] = ACTIONS(391),
    [sym__r_flw_sep_bgn] = ACTIONS(396),
    [sym__br_flw_sep_bgn] = ACTIONS(396),
    [sym__r_dqt_str_bgn] = ACTIONS(581),
    [sym__br_dqt_str_bgn] = ACTIONS(400),
    [sym__r_sqt_str_bgn] = ACTIONS(583),
    [sym__br_sqt_str_bgn] = ACTIONS(404),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(406),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(408),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(406),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(408),
    [sym__r_sgl_pln_int_flw] = ACTIONS(406),
    [sym__br_sgl_pln_int_flw] = ACTIONS(408),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(406),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(408),
    [sym__r_sgl_pln_str_flw] = ACTIONS(406),
    [sym__br_sgl_pln_str_flw] = ACTIONS(408),
    [sym__r_mtl_pln_str_flw] = ACTIONS(410),
    [sym__br_mtl_pln_str_flw] = ACTIONS(412),
    [sym__r_tag] = ACTIONS(585),
    [sym__br_tag] = ACTIONS(416),
    [sym__r_acr_bgn] = ACTIONS(418),
    [sym__br_acr_bgn] = ACTIONS(420),
    [sym__r_als_bgn] = ACTIONS(422),
    [sym__br_als_bgn] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym__r_prp_val] = STATE(980),
    [sym__br_prp_val] = STATE(991),
    [sym__r_prp] = STATE(163),
    [sym__br_prp] = STATE(168),
    [sym__r_flw_seq_val] = STATE(1009),
    [sym__br_flw_seq_val] = STATE(1018),
    [sym__r_flw_seq] = STATE(1282),
    [sym__br_flw_seq] = STATE(1283),
    [sym__r_flw_map_val] = STATE(1009),
    [sym__br_flw_map_val] = STATE(1018),
    [sym__r_flw_map] = STATE(1302),
    [sym__br_flw_map] = STATE(1304),
    [sym__r_flw_imp_r_par] = STATE(806),
    [sym__r_flw_imp_br_par] = STATE(807),
    [sym__br_flw_imp_r_par] = STATE(808),
    [sym__br_flw_imp_br_par] = STATE(809),
    [sym__r_dqt_str_val] = STATE(1009),
    [sym__br_dqt_str_val] = STATE(1018),
    [sym__r_dqt_str] = STATE(1306),
    [sym__br_dqt_str] = STATE(1307),
    [sym__r_sqt_str_val] = STATE(1009),
    [sym__br_sqt_str_val] = STATE(1018),
    [sym__r_sqt_str] = STATE(1309),
    [sym__br_sqt_str] = STATE(1310),
    [sym__r_pln_flw_val] = STATE(980),
    [sym__br_pln_flw_val] = STATE(991),
    [sym__r_sgl_pln_flw] = STATE(1222),
    [sym__br_sgl_pln_flw] = STATE(1345),
    [sym__r_mtl_pln_flw] = STATE(1222),
    [sym__br_mtl_pln_flw] = STATE(1345),
    [sym__r_als_val] = STATE(980),
    [sym__br_als_val] = STATE(991),
    [sym__r_als] = STATE(1246),
    [sym__br_als] = STATE(1272),
    [sym__r_acr] = STATE(245),
    [sym__br_acr] = STATE(246),
    [sym__r_flw_seq_bgn] = ACTIONS(577),
    [sym__br_flw_seq_bgn] = ACTIONS(387),
    [sym__r_flw_seq_end] = ACTIONS(587),
    [sym__br_flw_seq_end] = ACTIONS(587),
    [sym__b_flw_seq_end] = ACTIONS(587),
    [sym__r_flw_map_bgn] = ACTIONS(579),
    [sym__br_flw_map_bgn] = ACTIONS(391),
    [sym__r_flw_sep_bgn] = ACTIONS(587),
    [sym__br_flw_sep_bgn] = ACTIONS(587),
    [sym__r_dqt_str_bgn] = ACTIONS(581),
    [sym__br_dqt_str_bgn] = ACTIONS(400),
    [sym__r_sqt_str_bgn] = ACTIONS(583),
    [sym__br_sqt_str_bgn] = ACTIONS(404),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(406),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(408),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(406),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(408),
    [sym__r_sgl_pln_int_flw] = ACTIONS(406),
    [sym__br_sgl_pln_int_flw] = ACTIONS(408),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(406),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(408),
    [sym__r_sgl_pln_str_flw] = ACTIONS(406),
    [sym__br_sgl_pln_str_flw] = ACTIONS(408),
    [sym__r_mtl_pln_str_flw] = ACTIONS(410),
    [sym__br_mtl_pln_str_flw] = ACTIONS(412),
    [sym__r_tag] = ACTIONS(585),
    [sym__br_tag] = ACTIONS(416),
    [sym__r_acr_bgn] = ACTIONS(418),
    [sym__br_acr_bgn] = ACTIONS(420),
    [sym__r_als_bgn] = ACTIONS(422),
    [sym__br_als_bgn] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [sym__r_prp_val] = STATE(920),
    [sym__br_prp_val] = STATE(920),
    [sym__r_prp] = STATE(118),
    [sym__br_prp] = STATE(119),
    [sym__r_flw_seq_val] = STATE(920),
    [sym__br_flw_seq_val] = STATE(920),
    [sym__r_flw_seq] = STATE(817),
    [sym__br_flw_seq] = STATE(818),
    [sym__r_flw_map_val] = STATE(920),
    [sym__br_flw_map_val] = STATE(920),
    [sym__r_flw_map] = STATE(819),
    [sym__br_flw_map] = STATE(820),
    [sym__flw_ann_par_tal] = STATE(920),
    [sym__r_dqt_str_val] = STATE(920),
    [sym__br_dqt_str_val] = STATE(920),
    [sym__r_dqt_str] = STATE(821),
    [sym__br_dqt_str] = STATE(822),
    [sym__r_sqt_str_val] = STATE(920),
    [sym__br_sqt_str_val] = STATE(920),
    [sym__r_sqt_str] = STATE(823),
    [sym__br_sqt_str] = STATE(824),
    [sym__r_pln_flw_val] = STATE(920),
    [sym__br_pln_flw_val] = STATE(920),
    [sym__r_sgl_pln_flw] = STATE(792),
    [sym__br_sgl_pln_flw] = STATE(786),
    [sym__r_mtl_pln_flw] = STATE(792),
    [sym__br_mtl_pln_flw] = STATE(786),
    [sym__r_als_val] = STATE(920),
    [sym__br_als_val] = STATE(920),
    [sym__r_als] = STATE(873),
    [sym__br_als] = STATE(874),
    [sym__r_acr] = STATE(215),
    [sym__br_acr] = STATE(220),
    [sym__r_flw_seq_bgn] = ACTIONS(589),
    [sym__br_flw_seq_bgn] = ACTIONS(511),
    [sym__r_flw_seq_end] = ACTIONS(591),
    [sym__br_flw_seq_end] = ACTIONS(591),
    [sym__b_flw_seq_end] = ACTIONS(591),
    [sym__r_flw_map_bgn] = ACTIONS(593),
    [sym__br_flw_map_bgn] = ACTIONS(515),
    [sym__r_flw_sep_bgn] = ACTIONS(591),
    [sym__br_flw_sep_bgn] = ACTIONS(591),
    [sym__r_dqt_str_bgn] = ACTIONS(595),
    [sym__br_dqt_str_bgn] = ACTIONS(519),
    [sym__r_sqt_str_bgn] = ACTIONS(597),
    [sym__br_sqt_str_bgn] = ACTIONS(523),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(525),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(527),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(525),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(527),
    [sym__r_sgl_pln_int_flw] = ACTIONS(525),
    [sym__br_sgl_pln_int_flw] = ACTIONS(527),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(525),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(527),
    [sym__r_sgl_pln_str_flw] = ACTIONS(525),
    [sym__br_sgl_pln_str_flw] = ACTIONS(527),
    [sym__r_mtl_pln_str_flw] = ACTIONS(529),
    [sym__br_mtl_pln_str_flw] = ACTIONS(531),
    [sym__r_tag] = ACTIONS(599),
    [sym__br_tag] = ACTIONS(535),
    [sym__r_acr_bgn] = ACTIONS(537),
    [sym__br_acr_bgn] = ACTIONS(539),
    [sym__r_als_bgn] = ACTIONS(541),
    [sym__br_als_bgn] = ACTIONS(543),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym__r_prp_val] = STATE(936),
    [sym__br_prp_val] = STATE(936),
    [sym__r_prp] = STATE(116),
    [sym__br_prp] = STATE(120),
    [sym__r_flw_seq_val] = STATE(936),
    [sym__br_flw_seq_val] = STATE(936),
    [sym__r_flw_seq] = STATE(865),
    [sym__br_flw_seq] = STATE(866),
    [sym__r_flw_map_val] = STATE(936),
    [sym__br_flw_map_val] = STATE(936),
    [sym__r_flw_map] = STATE(867),
    [sym__br_flw_map] = STATE(868),
    [sym__flw_ann_par_tal] = STATE(936),
    [sym__r_dqt_str_val] = STATE(936),
    [sym__br_dqt_str_val] = STATE(936),
    [sym__r_dqt_str] = STATE(869),
    [sym__br_dqt_str] = STATE(870),
    [sym__r_sqt_str_val] = STATE(936),
    [sym__br_sqt_str_val] = STATE(936),
    [sym__r_sqt_str] = STATE(871),
    [sym__br_sqt_str] = STATE(872),
    [sym__r_pln_flw_val] = STATE(936),
    [sym__br_pln_flw_val] = STATE(936),
    [sym__r_sgl_pln_flw] = STATE(803),
    [sym__br_sgl_pln_flw] = STATE(802),
    [sym__r_mtl_pln_flw] = STATE(803),
    [sym__br_mtl_pln_flw] = STATE(802),
    [sym__r_als_val] = STATE(936),
    [sym__br_als_val] = STATE(936),
    [sym__r_als] = STATE(913),
    [sym__br_als] = STATE(914),
    [sym__r_acr] = STATE(217),
    [sym__br_acr] = STATE(211),
    [sym__r_flw_seq_bgn] = ACTIONS(601),
    [sym__br_flw_seq_bgn] = ACTIONS(468),
    [sym__r_flw_map_bgn] = ACTIONS(603),
    [sym__br_flw_map_bgn] = ACTIONS(472),
    [sym__r_flw_map_end] = ACTIONS(591),
    [sym__br_flw_map_end] = ACTIONS(591),
    [sym__b_flw_map_end] = ACTIONS(591),
    [sym__r_flw_sep_bgn] = ACTIONS(591),
    [sym__br_flw_sep_bgn] = ACTIONS(591),
    [sym__r_dqt_str_bgn] = ACTIONS(605),
    [sym__br_dqt_str_bgn] = ACTIONS(481),
    [sym__r_sqt_str_bgn] = ACTIONS(607),
    [sym__br_sqt_str_bgn] = ACTIONS(485),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(487),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(489),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(487),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(489),
    [sym__r_sgl_pln_int_flw] = ACTIONS(487),
    [sym__br_sgl_pln_int_flw] = ACTIONS(489),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(487),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(489),
    [sym__r_sgl_pln_str_flw] = ACTIONS(487),
    [sym__br_sgl_pln_str_flw] = ACTIONS(489),
    [sym__r_mtl_pln_str_flw] = ACTIONS(491),
    [sym__br_mtl_pln_str_flw] = ACTIONS(493),
    [sym__r_tag] = ACTIONS(609),
    [sym__br_tag] = ACTIONS(497),
    [sym__r_acr_bgn] = ACTIONS(499),
    [sym__br_acr_bgn] = ACTIONS(501),
    [sym__r_als_bgn] = ACTIONS(503),
    [sym__br_als_bgn] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym__r_prp_val] = STATE(934),
    [sym__br_prp_val] = STATE(934),
    [sym__r_prp] = STATE(116),
    [sym__br_prp] = STATE(120),
    [sym__r_flw_seq_val] = STATE(934),
    [sym__br_flw_seq_val] = STATE(934),
    [sym__r_flw_seq] = STATE(865),
    [sym__br_flw_seq] = STATE(866),
    [sym__r_flw_map_val] = STATE(934),
    [sym__br_flw_map_val] = STATE(934),
    [sym__r_flw_map] = STATE(867),
    [sym__br_flw_map] = STATE(868),
    [sym__flw_ann_par_tal] = STATE(934),
    [sym__r_dqt_str_val] = STATE(934),
    [sym__br_dqt_str_val] = STATE(934),
    [sym__r_dqt_str] = STATE(869),
    [sym__br_dqt_str] = STATE(870),
    [sym__r_sqt_str_val] = STATE(934),
    [sym__br_sqt_str_val] = STATE(934),
    [sym__r_sqt_str] = STATE(871),
    [sym__br_sqt_str] = STATE(872),
    [sym__r_pln_flw_val] = STATE(934),
    [sym__br_pln_flw_val] = STATE(934),
    [sym__r_sgl_pln_flw] = STATE(803),
    [sym__br_sgl_pln_flw] = STATE(802),
    [sym__r_mtl_pln_flw] = STATE(803),
    [sym__br_mtl_pln_flw] = STATE(802),
    [sym__r_als_val] = STATE(934),
    [sym__br_als_val] = STATE(934),
    [sym__r_als] = STATE(913),
    [sym__br_als] = STATE(914),
    [sym__r_acr] = STATE(217),
    [sym__br_acr] = STATE(211),
    [sym__r_flw_seq_bgn] = ACTIONS(601),
    [sym__br_flw_seq_bgn] = ACTIONS(468),
    [sym__r_flw_map_bgn] = ACTIONS(603),
    [sym__br_flw_map_bgn] = ACTIONS(472),
    [sym__r_flw_map_end] = ACTIONS(477),
    [sym__br_flw_map_end] = ACTIONS(477),
    [sym__b_flw_map_end] = ACTIONS(477),
    [sym__r_flw_sep_bgn] = ACTIONS(477),
    [sym__br_flw_sep_bgn] = ACTIONS(477),
    [sym__r_dqt_str_bgn] = ACTIONS(605),
    [sym__br_dqt_str_bgn] = ACTIONS(481),
    [sym__r_sqt_str_bgn] = ACTIONS(607),
    [sym__br_sqt_str_bgn] = ACTIONS(485),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(487),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(489),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(487),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(489),
    [sym__r_sgl_pln_int_flw] = ACTIONS(487),
    [sym__br_sgl_pln_int_flw] = ACTIONS(489),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(487),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(489),
    [sym__r_sgl_pln_str_flw] = ACTIONS(487),
    [sym__br_sgl_pln_str_flw] = ACTIONS(489),
    [sym__r_mtl_pln_str_flw] = ACTIONS(491),
    [sym__br_mtl_pln_str_flw] = ACTIONS(493),
    [sym__r_tag] = ACTIONS(609),
    [sym__br_tag] = ACTIONS(497),
    [sym__r_acr_bgn] = ACTIONS(499),
    [sym__br_acr_bgn] = ACTIONS(501),
    [sym__r_als_bgn] = ACTIONS(503),
    [sym__br_als_bgn] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym__r_prp_val] = STATE(951),
    [sym__br_prp_val] = STATE(951),
    [sym__r_prp] = STATE(116),
    [sym__br_prp] = STATE(120),
    [sym__r_flw_seq_val] = STATE(951),
    [sym__br_flw_seq_val] = STATE(951),
    [sym__r_flw_seq] = STATE(865),
    [sym__br_flw_seq] = STATE(866),
    [sym__r_flw_map_val] = STATE(951),
    [sym__br_flw_map_val] = STATE(951),
    [sym__r_flw_map] = STATE(867),
    [sym__br_flw_map] = STATE(868),
    [sym__flw_ann_par_tal] = STATE(951),
    [sym__r_dqt_str_val] = STATE(951),
    [sym__br_dqt_str_val] = STATE(951),
    [sym__r_dqt_str] = STATE(869),
    [sym__br_dqt_str] = STATE(870),
    [sym__r_sqt_str_val] = STATE(951),
    [sym__br_sqt_str_val] = STATE(951),
    [sym__r_sqt_str] = STATE(871),
    [sym__br_sqt_str] = STATE(872),
    [sym__r_pln_flw_val] = STATE(951),
    [sym__br_pln_flw_val] = STATE(951),
    [sym__r_sgl_pln_flw] = STATE(803),
    [sym__br_sgl_pln_flw] = STATE(802),
    [sym__r_mtl_pln_flw] = STATE(803),
    [sym__br_mtl_pln_flw] = STATE(802),
    [sym__r_als_val] = STATE(951),
    [sym__br_als_val] = STATE(951),
    [sym__r_als] = STATE(913),
    [sym__br_als] = STATE(914),
    [sym__r_acr] = STATE(217),
    [sym__br_acr] = STATE(211),
    [sym__r_flw_seq_bgn] = ACTIONS(601),
    [sym__br_flw_seq_bgn] = ACTIONS(468),
    [sym__r_flw_map_bgn] = ACTIONS(603),
    [sym__br_flw_map_bgn] = ACTIONS(472),
    [sym__r_flw_map_end] = ACTIONS(611),
    [sym__br_flw_map_end] = ACTIONS(611),
    [sym__b_flw_map_end] = ACTIONS(611),
    [sym__r_flw_sep_bgn] = ACTIONS(611),
    [sym__br_flw_sep_bgn] = ACTIONS(611),
    [sym__r_dqt_str_bgn] = ACTIONS(605),
    [sym__br_dqt_str_bgn] = ACTIONS(481),
    [sym__r_sqt_str_bgn] = ACTIONS(607),
    [sym__br_sqt_str_bgn] = ACTIONS(485),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(487),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(489),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(487),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(489),
    [sym__r_sgl_pln_int_flw] = ACTIONS(487),
    [sym__br_sgl_pln_int_flw] = ACTIONS(489),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(487),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(489),
    [sym__r_sgl_pln_str_flw] = ACTIONS(487),
    [sym__br_sgl_pln_str_flw] = ACTIONS(489),
    [sym__r_mtl_pln_str_flw] = ACTIONS(491),
    [sym__br_mtl_pln_str_flw] = ACTIONS(493),
    [sym__r_tag] = ACTIONS(609),
    [sym__br_tag] = ACTIONS(497),
    [sym__r_acr_bgn] = ACTIONS(499),
    [sym__br_acr_bgn] = ACTIONS(501),
    [sym__r_als_bgn] = ACTIONS(503),
    [sym__br_als_bgn] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym__r_prp_val] = STATE(954),
    [sym__br_prp_val] = STATE(954),
    [sym__r_prp] = STATE(118),
    [sym__br_prp] = STATE(119),
    [sym__r_flw_seq_val] = STATE(954),
    [sym__br_flw_seq_val] = STATE(954),
    [sym__r_flw_seq] = STATE(817),
    [sym__br_flw_seq] = STATE(818),
    [sym__r_flw_map_val] = STATE(954),
    [sym__br_flw_map_val] = STATE(954),
    [sym__r_flw_map] = STATE(819),
    [sym__br_flw_map] = STATE(820),
    [sym__flw_ann_par_tal] = STATE(954),
    [sym__r_dqt_str_val] = STATE(954),
    [sym__br_dqt_str_val] = STATE(954),
    [sym__r_dqt_str] = STATE(821),
    [sym__br_dqt_str] = STATE(822),
    [sym__r_sqt_str_val] = STATE(954),
    [sym__br_sqt_str_val] = STATE(954),
    [sym__r_sqt_str] = STATE(823),
    [sym__br_sqt_str] = STATE(824),
    [sym__r_pln_flw_val] = STATE(954),
    [sym__br_pln_flw_val] = STATE(954),
    [sym__r_sgl_pln_flw] = STATE(792),
    [sym__br_sgl_pln_flw] = STATE(786),
    [sym__r_mtl_pln_flw] = STATE(792),
    [sym__br_mtl_pln_flw] = STATE(786),
    [sym__r_als_val] = STATE(954),
    [sym__br_als_val] = STATE(954),
    [sym__r_als] = STATE(873),
    [sym__br_als] = STATE(874),
    [sym__r_acr] = STATE(215),
    [sym__br_acr] = STATE(220),
    [sym__r_flw_seq_bgn] = ACTIONS(589),
    [sym__br_flw_seq_bgn] = ACTIONS(511),
    [sym__r_flw_seq_end] = ACTIONS(613),
    [sym__br_flw_seq_end] = ACTIONS(613),
    [sym__b_flw_seq_end] = ACTIONS(613),
    [sym__r_flw_map_bgn] = ACTIONS(593),
    [sym__br_flw_map_bgn] = ACTIONS(515),
    [sym__r_flw_sep_bgn] = ACTIONS(613),
    [sym__br_flw_sep_bgn] = ACTIONS(613),
    [sym__r_dqt_str_bgn] = ACTIONS(595),
    [sym__br_dqt_str_bgn] = ACTIONS(519),
    [sym__r_sqt_str_bgn] = ACTIONS(597),
    [sym__br_sqt_str_bgn] = ACTIONS(523),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(525),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(527),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(525),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(527),
    [sym__r_sgl_pln_int_flw] = ACTIONS(525),
    [sym__br_sgl_pln_int_flw] = ACTIONS(527),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(525),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(527),
    [sym__r_sgl_pln_str_flw] = ACTIONS(525),
    [sym__br_sgl_pln_str_flw] = ACTIONS(527),
    [sym__r_mtl_pln_str_flw] = ACTIONS(529),
    [sym__br_mtl_pln_str_flw] = ACTIONS(531),
    [sym__r_tag] = ACTIONS(599),
    [sym__br_tag] = ACTIONS(535),
    [sym__r_acr_bgn] = ACTIONS(537),
    [sym__br_acr_bgn] = ACTIONS(539),
    [sym__r_als_bgn] = ACTIONS(541),
    [sym__br_als_bgn] = ACTIONS(543),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym__r_prp_val] = STATE(810),
    [sym__br_prp_val] = STATE(810),
    [sym__r_prp] = STATE(118),
    [sym__br_prp] = STATE(119),
    [sym__r_flw_seq_val] = STATE(810),
    [sym__br_flw_seq_val] = STATE(810),
    [sym__r_flw_seq] = STATE(817),
    [sym__br_flw_seq] = STATE(818),
    [sym__r_flw_map_val] = STATE(810),
    [sym__br_flw_map_val] = STATE(810),
    [sym__r_flw_map] = STATE(819),
    [sym__br_flw_map] = STATE(820),
    [sym__flw_ann_par_tal] = STATE(810),
    [sym__r_dqt_str_val] = STATE(810),
    [sym__br_dqt_str_val] = STATE(810),
    [sym__r_dqt_str] = STATE(821),
    [sym__br_dqt_str] = STATE(822),
    [sym__r_sqt_str_val] = STATE(810),
    [sym__br_sqt_str_val] = STATE(810),
    [sym__r_sqt_str] = STATE(823),
    [sym__br_sqt_str] = STATE(824),
    [sym__r_pln_flw_val] = STATE(810),
    [sym__br_pln_flw_val] = STATE(810),
    [sym__r_sgl_pln_flw] = STATE(792),
    [sym__br_sgl_pln_flw] = STATE(786),
    [sym__r_mtl_pln_flw] = STATE(792),
    [sym__br_mtl_pln_flw] = STATE(786),
    [sym__r_als_val] = STATE(810),
    [sym__br_als_val] = STATE(810),
    [sym__r_als] = STATE(873),
    [sym__br_als] = STATE(874),
    [sym__r_acr] = STATE(215),
    [sym__br_acr] = STATE(220),
    [sym__r_flw_seq_bgn] = ACTIONS(589),
    [sym__br_flw_seq_bgn] = ACTIONS(511),
    [sym__r_flw_seq_end] = ACTIONS(477),
    [sym__br_flw_seq_end] = ACTIONS(477),
    [sym__b_flw_seq_end] = ACTIONS(477),
    [sym__r_flw_map_bgn] = ACTIONS(593),
    [sym__br_flw_map_bgn] = ACTIONS(515),
    [sym__r_flw_sep_bgn] = ACTIONS(477),
    [sym__br_flw_sep_bgn] = ACTIONS(477),
    [sym__r_dqt_str_bgn] = ACTIONS(595),
    [sym__br_dqt_str_bgn] = ACTIONS(519),
    [sym__r_sqt_str_bgn] = ACTIONS(597),
    [sym__br_sqt_str_bgn] = ACTIONS(523),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(525),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(527),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(525),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(527),
    [sym__r_sgl_pln_int_flw] = ACTIONS(525),
    [sym__br_sgl_pln_int_flw] = ACTIONS(527),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(525),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(527),
    [sym__r_sgl_pln_str_flw] = ACTIONS(525),
    [sym__br_sgl_pln_str_flw] = ACTIONS(527),
    [sym__r_mtl_pln_str_flw] = ACTIONS(529),
    [sym__br_mtl_pln_str_flw] = ACTIONS(531),
    [sym__r_tag] = ACTIONS(599),
    [sym__br_tag] = ACTIONS(535),
    [sym__r_acr_bgn] = ACTIONS(537),
    [sym__br_acr_bgn] = ACTIONS(539),
    [sym__r_als_bgn] = ACTIONS(541),
    [sym__br_als_bgn] = ACTIONS(543),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym__r_prp_val] = STATE(864),
    [sym__br_prp_val] = STATE(864),
    [sym__r_prp] = STATE(116),
    [sym__br_prp] = STATE(120),
    [sym__r_flw_seq_val] = STATE(864),
    [sym__br_flw_seq_val] = STATE(864),
    [sym__r_flw_seq] = STATE(865),
    [sym__br_flw_seq] = STATE(866),
    [sym__r_flw_map_val] = STATE(864),
    [sym__br_flw_map_val] = STATE(864),
    [sym__r_flw_map] = STATE(867),
    [sym__br_flw_map] = STATE(868),
    [sym__flw_ann_par_tal] = STATE(864),
    [sym__r_dqt_str_val] = STATE(864),
    [sym__br_dqt_str_val] = STATE(864),
    [sym__r_dqt_str] = STATE(869),
    [sym__br_dqt_str] = STATE(870),
    [sym__r_sqt_str_val] = STATE(864),
    [sym__br_sqt_str_val] = STATE(864),
    [sym__r_sqt_str] = STATE(871),
    [sym__br_sqt_str] = STATE(872),
    [sym__r_pln_flw_val] = STATE(864),
    [sym__br_pln_flw_val] = STATE(864),
    [sym__r_sgl_pln_flw] = STATE(803),
    [sym__br_sgl_pln_flw] = STATE(802),
    [sym__r_mtl_pln_flw] = STATE(803),
    [sym__br_mtl_pln_flw] = STATE(802),
    [sym__r_als_val] = STATE(864),
    [sym__br_als_val] = STATE(864),
    [sym__r_als] = STATE(913),
    [sym__br_als] = STATE(914),
    [sym__r_acr] = STATE(217),
    [sym__br_acr] = STATE(211),
    [sym__r_flw_seq_bgn] = ACTIONS(601),
    [sym__br_flw_seq_bgn] = ACTIONS(468),
    [sym__r_flw_map_bgn] = ACTIONS(603),
    [sym__br_flw_map_bgn] = ACTIONS(472),
    [sym__r_flw_map_end] = ACTIONS(613),
    [sym__br_flw_map_end] = ACTIONS(613),
    [sym__b_flw_map_end] = ACTIONS(613),
    [sym__r_flw_sep_bgn] = ACTIONS(613),
    [sym__br_flw_sep_bgn] = ACTIONS(613),
    [sym__r_dqt_str_bgn] = ACTIONS(605),
    [sym__br_dqt_str_bgn] = ACTIONS(481),
    [sym__r_sqt_str_bgn] = ACTIONS(607),
    [sym__br_sqt_str_bgn] = ACTIONS(485),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(487),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(489),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(487),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(489),
    [sym__r_sgl_pln_int_flw] = ACTIONS(487),
    [sym__br_sgl_pln_int_flw] = ACTIONS(489),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(487),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(489),
    [sym__r_sgl_pln_str_flw] = ACTIONS(487),
    [sym__br_sgl_pln_str_flw] = ACTIONS(489),
    [sym__r_mtl_pln_str_flw] = ACTIONS(491),
    [sym__br_mtl_pln_str_flw] = ACTIONS(493),
    [sym__r_tag] = ACTIONS(609),
    [sym__br_tag] = ACTIONS(497),
    [sym__r_acr_bgn] = ACTIONS(499),
    [sym__br_acr_bgn] = ACTIONS(501),
    [sym__r_als_bgn] = ACTIONS(503),
    [sym__br_als_bgn] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym__r_prp_val] = STATE(816),
    [sym__br_prp_val] = STATE(816),
    [sym__r_prp] = STATE(118),
    [sym__br_prp] = STATE(119),
    [sym__r_flw_seq_val] = STATE(816),
    [sym__br_flw_seq_val] = STATE(816),
    [sym__r_flw_seq] = STATE(817),
    [sym__br_flw_seq] = STATE(818),
    [sym__r_flw_map_val] = STATE(816),
    [sym__br_flw_map_val] = STATE(816),
    [sym__r_flw_map] = STATE(819),
    [sym__br_flw_map] = STATE(820),
    [sym__flw_ann_par_tal] = STATE(816),
    [sym__r_dqt_str_val] = STATE(816),
    [sym__br_dqt_str_val] = STATE(816),
    [sym__r_dqt_str] = STATE(821),
    [sym__br_dqt_str] = STATE(822),
    [sym__r_sqt_str_val] = STATE(816),
    [sym__br_sqt_str_val] = STATE(816),
    [sym__r_sqt_str] = STATE(823),
    [sym__br_sqt_str] = STATE(824),
    [sym__r_pln_flw_val] = STATE(816),
    [sym__br_pln_flw_val] = STATE(816),
    [sym__r_sgl_pln_flw] = STATE(792),
    [sym__br_sgl_pln_flw] = STATE(786),
    [sym__r_mtl_pln_flw] = STATE(792),
    [sym__br_mtl_pln_flw] = STATE(786),
    [sym__r_als_val] = STATE(816),
    [sym__br_als_val] = STATE(816),
    [sym__r_als] = STATE(873),
    [sym__br_als] = STATE(874),
    [sym__r_acr] = STATE(215),
    [sym__br_acr] = STATE(220),
    [sym__r_flw_seq_bgn] = ACTIONS(589),
    [sym__br_flw_seq_bgn] = ACTIONS(511),
    [sym__r_flw_seq_end] = ACTIONS(611),
    [sym__br_flw_seq_end] = ACTIONS(611),
    [sym__b_flw_seq_end] = ACTIONS(611),
    [sym__r_flw_map_bgn] = ACTIONS(593),
    [sym__br_flw_map_bgn] = ACTIONS(515),
    [sym__r_flw_sep_bgn] = ACTIONS(611),
    [sym__br_flw_sep_bgn] = ACTIONS(611),
    [sym__r_dqt_str_bgn] = ACTIONS(595),
    [sym__br_dqt_str_bgn] = ACTIONS(519),
    [sym__r_sqt_str_bgn] = ACTIONS(597),
    [sym__br_sqt_str_bgn] = ACTIONS(523),
    [sym__r_sgl_pln_nul_flw] = ACTIONS(525),
    [sym__br_sgl_pln_nul_flw] = ACTIONS(527),
    [sym__r_sgl_pln_bol_flw] = ACTIONS(525),
    [sym__br_sgl_pln_bol_flw] = ACTIONS(527),
    [sym__r_sgl_pln_int_flw] = ACTIONS(525),
    [sym__br_sgl_pln_int_flw] = ACTIONS(527),
    [sym__r_sgl_pln_flt_flw] = ACTIONS(525),
    [sym__br_sgl_pln_flt_flw] = ACTIONS(527),
    [sym__r_sgl_pln_str_flw] = ACTIONS(525),
    [sym__br_sgl_pln_str_flw] = ACTIONS(527),
    [sym__r_mtl_pln_str_flw] = ACTIONS(529),
    [sym__br_mtl_pln_str_flw] = ACTIONS(531),
    [sym__r_tag] = ACTIONS(599),
    [sym__br_tag] = ACTIONS(535),
    [sym__r_acr_bgn] = ACTIONS(537),
    [sym__br_acr_bgn] = ACTIONS(539),
    [sym__r_als_bgn] = ACTIONS(541),
    [sym__br_als_bgn] = ACTIONS(543),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(622), 1,
      sym__r_acr_bgn,
    ACTIONS(624), 1,
      sym__br_acr_bgn,
    STATE(103), 1,
      sym__r_acr,
    STATE(110), 1,
      sym__br_acr,
    ACTIONS(619), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(615), 36,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [68] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym__r_acr_bgn,
    ACTIONS(629), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(634), 1,
      sym__br_acr_bgn,
    STATE(105), 1,
      sym__r_acr,
    STATE(111), 1,
      sym__br_acr,
    ACTIONS(631), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(627), 36,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [136] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      sym__br_acr_bgn,
    ACTIONS(637), 1,
      sym__r_acr_bgn,
    STATE(110), 2,
      sym__r_acr,
      sym__br_acr,
    ACTIONS(615), 45,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 48,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__r_tag,
      sym__br_tag,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [251] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(641), 1,
      sym__r_tag,
    ACTIONS(643), 1,
      sym__br_tag,
    ACTIONS(619), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(615), 36,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [313] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(646), 1,
      sym__r_tag,
    ACTIONS(648), 1,
      sym__br_tag,
    ACTIONS(631), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(627), 36,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 48,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__r_tag,
      sym__br_tag,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(657), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(653), 37,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 1,
      sym__br_tag,
    ACTIONS(660), 1,
      sym__r_tag,
    ACTIONS(615), 45,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(664), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(666), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(662), 37,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 47,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 47,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__r_tag,
      sym__br_tag,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 46,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 46,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 46,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 46,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__b_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__b_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__b_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__b_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__b_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__b_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__b_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__b_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__b_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__b_tag,
      sym__br_acr_bgn,
      sym__b_acr_bgn,
      sym__br_als_bgn,
      sym__b_als_bgn,
      sym__bl,
  [914] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      sym__br_flw_seq_bgn,
    ACTIONS(211), 1,
      sym__br_flw_map_bgn,
    ACTIONS(227), 1,
      sym__br_dqt_str_bgn,
    ACTIONS(231), 1,
      sym__br_sqt_str_bgn,
    ACTIONS(237), 1,
      sym__r_mtl_pln_str_flw,
    ACTIONS(239), 1,
      sym__br_mtl_pln_str_flw,
    ACTIONS(426), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(428), 1,
      sym__r_flw_map_bgn,
    ACTIONS(436), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(438), 1,
      sym__r_sqt_str_bgn,
    STATE(594), 2,
      sym__r_flw_seq,
      sym__br_flw_seq,
    STATE(595), 2,
      sym__r_flw_map,
      sym__br_flw_map,
    STATE(596), 2,
      sym__r_dqt_str,
      sym__br_dqt_str,
    STATE(597), 2,
      sym__r_sqt_str,
      sym__br_sqt_str,
    STATE(637), 4,
      sym__r_sgl_pln_flw,
      sym__br_sgl_pln_flw,
      sym__r_mtl_pln_flw,
      sym__br_mtl_pln_flw,
    ACTIONS(233), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(235), 5,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
    ACTIONS(369), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [993] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      sym__br_flw_seq_bgn,
    ACTIONS(211), 1,
      sym__br_flw_map_bgn,
    ACTIONS(227), 1,
      sym__br_dqt_str_bgn,
    ACTIONS(231), 1,
      sym__br_sqt_str_bgn,
    ACTIONS(237), 1,
      sym__r_mtl_pln_str_flw,
    ACTIONS(239), 1,
      sym__br_mtl_pln_str_flw,
    ACTIONS(426), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(428), 1,
      sym__r_flw_map_bgn,
    ACTIONS(436), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(438), 1,
      sym__r_sqt_str_bgn,
    STATE(598), 2,
      sym__r_flw_seq,
      sym__br_flw_seq,
    STATE(599), 2,
      sym__r_flw_map,
      sym__br_flw_map,
    STATE(600), 2,
      sym__r_dqt_str,
      sym__br_dqt_str,
    STATE(601), 2,
      sym__r_sqt_str,
      sym__br_sqt_str,
    STATE(639), 4,
      sym__r_sgl_pln_flw,
      sym__br_sgl_pln_flw,
      sym__r_mtl_pln_flw,
      sym__br_mtl_pln_flw,
    ACTIONS(233), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(235), 5,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
    ACTIONS(377), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [1072] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      sym__br_flw_seq_bgn,
    ACTIONS(297), 1,
      sym__br_flw_map_bgn,
    ACTIONS(309), 1,
      sym__br_dqt_str_bgn,
    ACTIONS(313), 1,
      sym__br_sqt_str_bgn,
    ACTIONS(319), 1,
      sym__r_mtl_pln_str_flw,
    ACTIONS(321), 1,
      sym__br_mtl_pln_str_flw,
    ACTIONS(450), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(454), 1,
      sym__r_flw_map_bgn,
    ACTIONS(460), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(462), 1,
      sym__r_sqt_str_bgn,
    STATE(724), 2,
      sym__r_flw_seq,
      sym__br_flw_seq,
    STATE(725), 2,
      sym__r_flw_map,
      sym__br_flw_map,
    STATE(726), 2,
      sym__r_dqt_str,
      sym__br_dqt_str,
    STATE(727), 2,
      sym__r_sqt_str,
      sym__br_sqt_str,
    STATE(700), 4,
      sym__r_sgl_pln_flw,
      sym__br_sgl_pln_flw,
      sym__r_mtl_pln_flw,
      sym__br_mtl_pln_flw,
    ACTIONS(315), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(317), 5,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
    ACTIONS(369), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [1150] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      sym__br_flw_seq_bgn,
    ACTIONS(297), 1,
      sym__br_flw_map_bgn,
    ACTIONS(309), 1,
      sym__br_dqt_str_bgn,
    ACTIONS(313), 1,
      sym__br_sqt_str_bgn,
    ACTIONS(319), 1,
      sym__r_mtl_pln_str_flw,
    ACTIONS(321), 1,
      sym__br_mtl_pln_str_flw,
    ACTIONS(450), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(454), 1,
      sym__r_flw_map_bgn,
    ACTIONS(460), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(462), 1,
      sym__r_sqt_str_bgn,
    STATE(728), 2,
      sym__r_flw_seq,
      sym__br_flw_seq,
    STATE(729), 2,
      sym__r_flw_map,
      sym__br_flw_map,
    STATE(730), 2,
      sym__r_dqt_str,
      sym__br_dqt_str,
    STATE(731), 2,
      sym__r_sqt_str,
      sym__br_sqt_str,
    STATE(701), 4,
      sym__r_sgl_pln_flw,
      sym__br_sgl_pln_flw,
      sym__r_mtl_pln_flw,
      sym__br_mtl_pln_flw,
    ACTIONS(315), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(317), 5,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
    ACTIONS(377), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [1228] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 1,
      sym__br_flw_seq_bgn,
    ACTIONS(472), 1,
      sym__br_flw_map_bgn,
    ACTIONS(481), 1,
      sym__br_dqt_str_bgn,
    ACTIONS(485), 1,
      sym__br_sqt_str_bgn,
    ACTIONS(491), 1,
      sym__r_mtl_pln_str_flw,
    ACTIONS(493), 1,
      sym__br_mtl_pln_str_flw,
    ACTIONS(601), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(603), 1,
      sym__r_flw_map_bgn,
    ACTIONS(605), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(607), 1,
      sym__r_sqt_str_bgn,
    STATE(892), 2,
      sym__r_flw_seq,
      sym__br_flw_seq,
    STATE(893), 2,
      sym__r_flw_map,
      sym__br_flw_map,
    STATE(894), 2,
      sym__r_dqt_str,
      sym__br_dqt_str,
    STATE(895), 2,
      sym__r_sqt_str,
      sym__br_sqt_str,
    STATE(811), 4,
      sym__r_sgl_pln_flw,
      sym__br_sgl_pln_flw,
      sym__r_mtl_pln_flw,
      sym__br_mtl_pln_flw,
    ACTIONS(369), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    ACTIONS(487), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(489), 5,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
  [1305] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(669), 1,
      sym__r_acr_bgn,
    ACTIONS(671), 1,
      sym__br_acr_bgn,
    STATE(170), 1,
      sym__r_acr,
    STATE(176), 1,
      sym__br_acr,
    ACTIONS(619), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(615), 23,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_als_bgn,
  [1360] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(511), 1,
      sym__br_flw_seq_bgn,
    ACTIONS(515), 1,
      sym__br_flw_map_bgn,
    ACTIONS(519), 1,
      sym__br_dqt_str_bgn,
    ACTIONS(523), 1,
      sym__br_sqt_str_bgn,
    ACTIONS(529), 1,
      sym__r_mtl_pln_str_flw,
    ACTIONS(531), 1,
      sym__br_mtl_pln_str_flw,
    ACTIONS(589), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(593), 1,
      sym__r_flw_map_bgn,
    ACTIONS(595), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(597), 1,
      sym__r_sqt_str_bgn,
    STATE(842), 2,
      sym__r_flw_seq,
      sym__br_flw_seq,
    STATE(843), 2,
      sym__r_flw_map,
      sym__br_flw_map,
    STATE(844), 2,
      sym__r_dqt_str,
      sym__br_dqt_str,
    STATE(845), 2,
      sym__r_sqt_str,
      sym__br_sqt_str,
    STATE(930), 4,
      sym__r_sgl_pln_flw,
      sym__br_sgl_pln_flw,
      sym__r_mtl_pln_flw,
      sym__br_mtl_pln_flw,
    ACTIONS(369), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    ACTIONS(525), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(527), 5,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
  [1437] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(511), 1,
      sym__br_flw_seq_bgn,
    ACTIONS(515), 1,
      sym__br_flw_map_bgn,
    ACTIONS(519), 1,
      sym__br_dqt_str_bgn,
    ACTIONS(523), 1,
      sym__br_sqt_str_bgn,
    ACTIONS(529), 1,
      sym__r_mtl_pln_str_flw,
    ACTIONS(531), 1,
      sym__br_mtl_pln_str_flw,
    ACTIONS(589), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(593), 1,
      sym__r_flw_map_bgn,
    ACTIONS(595), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(597), 1,
      sym__r_sqt_str_bgn,
    STATE(846), 2,
      sym__r_flw_seq,
      sym__br_flw_seq,
    STATE(847), 2,
      sym__r_flw_map,
      sym__br_flw_map,
    STATE(848), 2,
      sym__r_dqt_str,
      sym__br_dqt_str,
    STATE(849), 2,
      sym__r_sqt_str,
      sym__br_sqt_str,
    STATE(942), 4,
      sym__r_sgl_pln_flw,
      sym__br_sgl_pln_flw,
      sym__r_mtl_pln_flw,
      sym__br_mtl_pln_flw,
    ACTIONS(377), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    ACTIONS(525), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(527), 5,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
  [1514] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 1,
      sym__br_flw_seq_bgn,
    ACTIONS(472), 1,
      sym__br_flw_map_bgn,
    ACTIONS(481), 1,
      sym__br_dqt_str_bgn,
    ACTIONS(485), 1,
      sym__br_sqt_str_bgn,
    ACTIONS(491), 1,
      sym__r_mtl_pln_str_flw,
    ACTIONS(493), 1,
      sym__br_mtl_pln_str_flw,
    ACTIONS(601), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(603), 1,
      sym__r_flw_map_bgn,
    ACTIONS(605), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(607), 1,
      sym__r_sqt_str_bgn,
    STATE(896), 2,
      sym__r_flw_seq,
      sym__br_flw_seq,
    STATE(897), 2,
      sym__r_flw_map,
      sym__br_flw_map,
    STATE(898), 2,
      sym__r_dqt_str,
      sym__br_dqt_str,
    STATE(899), 2,
      sym__r_sqt_str,
      sym__br_sqt_str,
    STATE(812), 4,
      sym__r_sgl_pln_flw,
      sym__br_sgl_pln_flw,
      sym__r_mtl_pln_flw,
      sym__br_mtl_pln_flw,
    ACTIONS(377), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    ACTIONS(487), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(489), 5,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
  [1591] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(669), 1,
      sym__r_acr_bgn,
    ACTIONS(674), 1,
      sym__br_acr_bgn,
    STATE(161), 1,
      sym__r_acr,
    STATE(171), 1,
      sym__br_acr,
    ACTIONS(631), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(627), 23,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_als_bgn,
  [1646] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      sym__b_blk_key_bgn,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    ACTIONS(681), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(683), 1,
      sym__b_flw_map_bgn,
    ACTIONS(685), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(687), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(691), 1,
      sym__b_tag,
    ACTIONS(693), 1,
      sym__b_acr_bgn,
    ACTIONS(695), 1,
      sym__b_als_bgn,
    ACTIONS(697), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(144), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(689), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [1736] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(699), 1,
      sym__b_blk_key_bgn,
    ACTIONS(702), 1,
      sym__b_blk_val_bgn,
    ACTIONS(705), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(708), 1,
      sym__b_flw_map_bgn,
    ACTIONS(711), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(714), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(720), 1,
      sym__b_tag,
    ACTIONS(723), 1,
      sym__b_acr_bgn,
    ACTIONS(726), 1,
      sym__b_als_bgn,
    ACTIONS(729), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(123), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(717), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [1826] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(731), 1,
      sym__r_acr_bgn,
    ACTIONS(733), 1,
      sym__br_acr_bgn,
    STATE(177), 1,
      sym__r_acr,
    STATE(181), 1,
      sym__br_acr,
    ACTIONS(619), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(615), 22,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_als_bgn,
      sym__bl,
  [1880] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(731), 1,
      sym__r_acr_bgn,
    ACTIONS(736), 1,
      sym__br_acr_bgn,
    STATE(172), 1,
      sym__r_acr,
    STATE(180), 1,
      sym__br_acr,
    ACTIONS(631), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(627), 22,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_als_bgn,
      sym__bl,
  [1934] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      sym__b_blk_key_bgn,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    ACTIONS(681), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(683), 1,
      sym__b_flw_map_bgn,
    ACTIONS(685), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(687), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(691), 1,
      sym__b_tag,
    ACTIONS(693), 1,
      sym__b_acr_bgn,
    ACTIONS(695), 1,
      sym__b_als_bgn,
    ACTIONS(739), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(130), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(689), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [2024] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      sym__b_blk_key_bgn,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    ACTIONS(681), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(683), 1,
      sym__b_flw_map_bgn,
    ACTIONS(685), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(687), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(691), 1,
      sym__b_tag,
    ACTIONS(693), 1,
      sym__b_acr_bgn,
    ACTIONS(695), 1,
      sym__b_als_bgn,
    ACTIONS(741), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(131), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(689), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [2114] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(745), 1,
      sym__r_flw_seq_end,
    ACTIONS(747), 1,
      sym__r_flw_map_bgn,
    ACTIONS(749), 1,
      sym__r_flw_key_bgn,
    ACTIONS(751), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(753), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(755), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(759), 1,
      sym__r_tag,
    ACTIONS(761), 1,
      sym__r_acr_bgn,
    ACTIONS(763), 1,
      sym__r_als_bgn,
    STATE(264), 1,
      sym__r_sgl_prp,
    STATE(398), 1,
      sym__r_acr,
    STATE(986), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1097), 1,
      sym__r_als,
    STATE(1110), 1,
      sym__r_sgl_flw_seq,
    STATE(1113), 1,
      sym__r_sgl_flw_map,
    STATE(1114), 1,
      sym__r_sgl_dqt_str,
    STATE(1116), 1,
      sym__r_sgl_sqt_str,
    STATE(1132), 1,
      sym__r_sgl_pln_flw,
    STATE(1139), 1,
      sym__sgl_flw_seq_tal,
    STATE(1225), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1240), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1253), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1468), 1,
      sym__r_sgl_flw_col_dat,
    STATE(976), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1025), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(757), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [2208] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(767), 1,
      sym__r_flw_map_bgn,
    ACTIONS(769), 1,
      sym__r_flw_map_end,
    ACTIONS(771), 1,
      sym__r_flw_key_bgn,
    ACTIONS(773), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(775), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(777), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(781), 1,
      sym__r_tag,
    ACTIONS(783), 1,
      sym__r_acr_bgn,
    ACTIONS(785), 1,
      sym__r_als_bgn,
    STATE(261), 1,
      sym__r_sgl_prp,
    STATE(395), 1,
      sym__r_acr,
    STATE(964), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1100), 1,
      sym__r_als,
    STATE(1145), 1,
      sym__sgl_flw_map_tal,
    STATE(1187), 1,
      sym__r_sgl_pln_flw,
    STATE(1209), 1,
      sym__r_sgl_flw_seq,
    STATE(1210), 1,
      sym__r_sgl_flw_map,
    STATE(1213), 1,
      sym__r_sgl_dqt_str,
    STATE(1214), 1,
      sym__r_sgl_sqt_str,
    STATE(1250), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1251), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1252), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1471), 1,
      sym__r_sgl_flw_col_dat,
    STATE(1038), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1045), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(779), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [2302] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      sym__b_blk_key_bgn,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    ACTIONS(681), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(683), 1,
      sym__b_flw_map_bgn,
    ACTIONS(685), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(687), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(691), 1,
      sym__b_tag,
    ACTIONS(693), 1,
      sym__b_acr_bgn,
    ACTIONS(695), 1,
      sym__b_als_bgn,
    ACTIONS(787), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(123), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(689), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [2392] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      sym__b_blk_key_bgn,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    ACTIONS(681), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(683), 1,
      sym__b_flw_map_bgn,
    ACTIONS(685), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(687), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(691), 1,
      sym__b_tag,
    ACTIONS(693), 1,
      sym__b_acr_bgn,
    ACTIONS(695), 1,
      sym__b_als_bgn,
    ACTIONS(789), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(123), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(689), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [2482] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      sym__b_blk_key_bgn,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    ACTIONS(681), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(683), 1,
      sym__b_flw_map_bgn,
    ACTIONS(685), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(687), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(691), 1,
      sym__b_tag,
    ACTIONS(693), 1,
      sym__b_acr_bgn,
    ACTIONS(695), 1,
      sym__b_als_bgn,
    ACTIONS(791), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(138), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(689), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [2572] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      sym__b_blk_key_bgn,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    ACTIONS(681), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(683), 1,
      sym__b_flw_map_bgn,
    ACTIONS(685), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(687), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(691), 1,
      sym__b_tag,
    ACTIONS(693), 1,
      sym__b_acr_bgn,
    ACTIONS(695), 1,
      sym__b_als_bgn,
    ACTIONS(793), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(139), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(689), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [2662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      sym__br_acr_bgn,
    ACTIONS(795), 1,
      sym__r_acr_bgn,
    STATE(176), 2,
      sym__r_acr,
      sym__br_acr,
    ACTIONS(615), 32,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_als_bgn,
  [2710] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(767), 1,
      sym__r_flw_map_bgn,
    ACTIONS(771), 1,
      sym__r_flw_key_bgn,
    ACTIONS(773), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(775), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(777), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(781), 1,
      sym__r_tag,
    ACTIONS(783), 1,
      sym__r_acr_bgn,
    ACTIONS(785), 1,
      sym__r_als_bgn,
    ACTIONS(797), 1,
      sym__r_flw_map_end,
    STATE(261), 1,
      sym__r_sgl_prp,
    STATE(395), 1,
      sym__r_acr,
    STATE(964), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1100), 1,
      sym__r_als,
    STATE(1187), 1,
      sym__r_sgl_pln_flw,
    STATE(1209), 1,
      sym__r_sgl_flw_seq,
    STATE(1210), 1,
      sym__r_sgl_flw_map,
    STATE(1213), 1,
      sym__r_sgl_dqt_str,
    STATE(1214), 1,
      sym__r_sgl_sqt_str,
    STATE(1250), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1251), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1252), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1516), 1,
      sym__r_sgl_flw_col_dat,
    STATE(1517), 1,
      sym__sgl_flw_map_tal,
    STATE(1038), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1045), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(779), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [2804] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(747), 1,
      sym__r_flw_map_bgn,
    ACTIONS(749), 1,
      sym__r_flw_key_bgn,
    ACTIONS(751), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(753), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(755), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(759), 1,
      sym__r_tag,
    ACTIONS(761), 1,
      sym__r_acr_bgn,
    ACTIONS(763), 1,
      sym__r_als_bgn,
    ACTIONS(799), 1,
      sym__r_flw_seq_end,
    STATE(264), 1,
      sym__r_sgl_prp,
    STATE(398), 1,
      sym__r_acr,
    STATE(986), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1050), 1,
      sym__sgl_flw_seq_tal,
    STATE(1097), 1,
      sym__r_als,
    STATE(1110), 1,
      sym__r_sgl_flw_seq,
    STATE(1113), 1,
      sym__r_sgl_flw_map,
    STATE(1114), 1,
      sym__r_sgl_dqt_str,
    STATE(1116), 1,
      sym__r_sgl_sqt_str,
    STATE(1132), 1,
      sym__r_sgl_pln_flw,
    STATE(1225), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1240), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1253), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1473), 1,
      sym__r_sgl_flw_col_dat,
    STATE(976), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1025), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(757), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [2898] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(767), 1,
      sym__r_flw_map_bgn,
    ACTIONS(771), 1,
      sym__r_flw_key_bgn,
    ACTIONS(773), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(775), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(777), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(781), 1,
      sym__r_tag,
    ACTIONS(783), 1,
      sym__r_acr_bgn,
    ACTIONS(785), 1,
      sym__r_als_bgn,
    ACTIONS(801), 1,
      sym__r_flw_map_end,
    STATE(261), 1,
      sym__r_sgl_prp,
    STATE(395), 1,
      sym__r_acr,
    STATE(964), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1064), 1,
      sym__sgl_flw_map_tal,
    STATE(1100), 1,
      sym__r_als,
    STATE(1187), 1,
      sym__r_sgl_pln_flw,
    STATE(1209), 1,
      sym__r_sgl_flw_seq,
    STATE(1210), 1,
      sym__r_sgl_flw_map,
    STATE(1213), 1,
      sym__r_sgl_dqt_str,
    STATE(1214), 1,
      sym__r_sgl_sqt_str,
    STATE(1250), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1251), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1252), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1476), 1,
      sym__r_sgl_flw_col_dat,
    STATE(1038), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1045), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(779), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [2992] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      sym__b_blk_key_bgn,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    ACTIONS(681), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(683), 1,
      sym__b_flw_map_bgn,
    ACTIONS(685), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(687), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(691), 1,
      sym__b_tag,
    ACTIONS(693), 1,
      sym__b_acr_bgn,
    ACTIONS(695), 1,
      sym__b_als_bgn,
    ACTIONS(803), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(123), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(689), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [3082] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      sym__b_blk_key_bgn,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    ACTIONS(681), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(683), 1,
      sym__b_flw_map_bgn,
    ACTIONS(685), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(687), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(691), 1,
      sym__b_tag,
    ACTIONS(693), 1,
      sym__b_acr_bgn,
    ACTIONS(695), 1,
      sym__b_als_bgn,
    ACTIONS(805), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(123), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(689), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [3172] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(747), 1,
      sym__r_flw_map_bgn,
    ACTIONS(749), 1,
      sym__r_flw_key_bgn,
    ACTIONS(751), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(753), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(755), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(759), 1,
      sym__r_tag,
    ACTIONS(761), 1,
      sym__r_acr_bgn,
    ACTIONS(763), 1,
      sym__r_als_bgn,
    ACTIONS(807), 1,
      sym__r_flw_seq_end,
    STATE(264), 1,
      sym__r_sgl_prp,
    STATE(398), 1,
      sym__r_acr,
    STATE(986), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1097), 1,
      sym__r_als,
    STATE(1110), 1,
      sym__r_sgl_flw_seq,
    STATE(1113), 1,
      sym__r_sgl_flw_map,
    STATE(1114), 1,
      sym__r_sgl_dqt_str,
    STATE(1116), 1,
      sym__r_sgl_sqt_str,
    STATE(1132), 1,
      sym__r_sgl_pln_flw,
    STATE(1225), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1240), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1253), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1445), 1,
      sym__sgl_flw_seq_tal,
    STATE(1459), 1,
      sym__r_sgl_flw_col_dat,
    STATE(976), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1025), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(757), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [3266] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(767), 1,
      sym__r_flw_map_bgn,
    ACTIONS(771), 1,
      sym__r_flw_key_bgn,
    ACTIONS(773), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(775), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(777), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(781), 1,
      sym__r_tag,
    ACTIONS(783), 1,
      sym__r_acr_bgn,
    ACTIONS(785), 1,
      sym__r_als_bgn,
    ACTIONS(809), 1,
      sym__r_flw_map_end,
    STATE(261), 1,
      sym__r_sgl_prp,
    STATE(395), 1,
      sym__r_acr,
    STATE(964), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1100), 1,
      sym__r_als,
    STATE(1187), 1,
      sym__r_sgl_pln_flw,
    STATE(1209), 1,
      sym__r_sgl_flw_seq,
    STATE(1210), 1,
      sym__r_sgl_flw_map,
    STATE(1213), 1,
      sym__r_sgl_dqt_str,
    STATE(1214), 1,
      sym__r_sgl_sqt_str,
    STATE(1250), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1251), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1252), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1496), 1,
      sym__sgl_flw_map_tal,
    STATE(1516), 1,
      sym__r_sgl_flw_col_dat,
    STATE(1038), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1045), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(779), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [3360] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(747), 1,
      sym__r_flw_map_bgn,
    ACTIONS(749), 1,
      sym__r_flw_key_bgn,
    ACTIONS(751), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(753), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(755), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(759), 1,
      sym__r_tag,
    ACTIONS(761), 1,
      sym__r_acr_bgn,
    ACTIONS(763), 1,
      sym__r_als_bgn,
    ACTIONS(811), 1,
      sym__r_flw_seq_end,
    STATE(264), 1,
      sym__r_sgl_prp,
    STATE(398), 1,
      sym__r_acr,
    STATE(986), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1097), 1,
      sym__r_als,
    STATE(1110), 1,
      sym__r_sgl_flw_seq,
    STATE(1113), 1,
      sym__r_sgl_flw_map,
    STATE(1114), 1,
      sym__r_sgl_dqt_str,
    STATE(1116), 1,
      sym__r_sgl_sqt_str,
    STATE(1132), 1,
      sym__r_sgl_pln_flw,
    STATE(1225), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1240), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1253), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1457), 1,
      sym__r_sgl_flw_col_dat,
    STATE(1509), 1,
      sym__sgl_flw_seq_tal,
    STATE(976), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1025), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(757), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [3454] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(767), 1,
      sym__r_flw_map_bgn,
    ACTIONS(771), 1,
      sym__r_flw_key_bgn,
    ACTIONS(773), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(775), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(777), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(781), 1,
      sym__r_tag,
    ACTIONS(783), 1,
      sym__r_acr_bgn,
    ACTIONS(785), 1,
      sym__r_als_bgn,
    ACTIONS(813), 1,
      sym__r_flw_map_end,
    STATE(261), 1,
      sym__r_sgl_prp,
    STATE(395), 1,
      sym__r_acr,
    STATE(964), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1100), 1,
      sym__r_als,
    STATE(1187), 1,
      sym__r_sgl_pln_flw,
    STATE(1209), 1,
      sym__r_sgl_flw_seq,
    STATE(1210), 1,
      sym__r_sgl_flw_map,
    STATE(1213), 1,
      sym__r_sgl_dqt_str,
    STATE(1214), 1,
      sym__r_sgl_sqt_str,
    STATE(1250), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1251), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1252), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1422), 1,
      sym__sgl_flw_map_tal,
    STATE(1460), 1,
      sym__r_sgl_flw_col_dat,
    STATE(1038), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1045), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(779), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [3548] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      sym__b_blk_key_bgn,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    ACTIONS(681), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(683), 1,
      sym__b_flw_map_bgn,
    ACTIONS(685), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(687), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(691), 1,
      sym__b_tag,
    ACTIONS(693), 1,
      sym__b_acr_bgn,
    ACTIONS(695), 1,
      sym__b_als_bgn,
    ACTIONS(815), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(123), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(689), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [3638] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(747), 1,
      sym__r_flw_map_bgn,
    ACTIONS(749), 1,
      sym__r_flw_key_bgn,
    ACTIONS(751), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(753), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(755), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(759), 1,
      sym__r_tag,
    ACTIONS(761), 1,
      sym__r_acr_bgn,
    ACTIONS(763), 1,
      sym__r_als_bgn,
    ACTIONS(817), 1,
      sym__r_flw_seq_end,
    STATE(264), 1,
      sym__r_sgl_prp,
    STATE(398), 1,
      sym__r_acr,
    STATE(986), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1097), 1,
      sym__r_als,
    STATE(1110), 1,
      sym__r_sgl_flw_seq,
    STATE(1113), 1,
      sym__r_sgl_flw_map,
    STATE(1114), 1,
      sym__r_sgl_dqt_str,
    STATE(1116), 1,
      sym__r_sgl_sqt_str,
    STATE(1132), 1,
      sym__r_sgl_pln_flw,
    STATE(1225), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1240), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1253), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1257), 1,
      sym__sgl_flw_seq_tal,
    STATE(1525), 1,
      sym__r_sgl_flw_col_dat,
    STATE(976), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1025), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(757), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [3732] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(767), 1,
      sym__r_flw_map_bgn,
    ACTIONS(771), 1,
      sym__r_flw_key_bgn,
    ACTIONS(773), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(775), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(777), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(781), 1,
      sym__r_tag,
    ACTIONS(783), 1,
      sym__r_acr_bgn,
    ACTIONS(785), 1,
      sym__r_als_bgn,
    ACTIONS(819), 1,
      sym__r_flw_map_end,
    STATE(261), 1,
      sym__r_sgl_prp,
    STATE(395), 1,
      sym__r_acr,
    STATE(964), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1100), 1,
      sym__r_als,
    STATE(1187), 1,
      sym__r_sgl_pln_flw,
    STATE(1209), 1,
      sym__r_sgl_flw_seq,
    STATE(1210), 1,
      sym__r_sgl_flw_map,
    STATE(1213), 1,
      sym__r_sgl_dqt_str,
    STATE(1214), 1,
      sym__r_sgl_sqt_str,
    STATE(1250), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1251), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1252), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1264), 1,
      sym__sgl_flw_map_tal,
    STATE(1527), 1,
      sym__r_sgl_flw_col_dat,
    STATE(1038), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1045), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(779), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [3826] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      sym__b_blk_key_bgn,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    ACTIONS(681), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(683), 1,
      sym__b_flw_map_bgn,
    ACTIONS(685), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(687), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(691), 1,
      sym__b_tag,
    ACTIONS(693), 1,
      sym__b_acr_bgn,
    ACTIONS(695), 1,
      sym__b_als_bgn,
    ACTIONS(821), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(123), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(689), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [3916] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 1,
      sym__b_blk_key_bgn,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    ACTIONS(681), 1,
      sym__b_flw_seq_bgn,
    ACTIONS(683), 1,
      sym__b_flw_map_bgn,
    ACTIONS(685), 1,
      sym__b_dqt_str_bgn,
    ACTIONS(687), 1,
      sym__b_sqt_str_bgn,
    ACTIONS(691), 1,
      sym__b_tag,
    ACTIONS(693), 1,
      sym__b_acr_bgn,
    ACTIONS(695), 1,
      sym__b_als_bgn,
    ACTIONS(823), 1,
      sym__bl,
    STATE(279), 1,
      sym__b_blk_key_itm,
    STATE(322), 1,
      sym__b_sgl_prp,
    STATE(323), 1,
      sym__b_blk_exp_itm,
    STATE(325), 1,
      sym__b_blk_val_itm,
    STATE(326), 1,
      sym__b_blk_imp_itm,
    STATE(454), 1,
      sym__b_acr,
    STATE(1412), 1,
      sym__b_als,
    STATE(1464), 1,
      sym__b_sgl_dqt_str,
    STATE(1493), 1,
      sym__b_sgl_flw_seq,
    STATE(1502), 1,
      sym__b_sgl_flw_map,
    STATE(1520), 1,
      sym__b_sgl_sqt_str,
    STATE(1532), 1,
      sym__b_sgl_pln_blk,
    STATE(147), 2,
      sym__b_blk_map_itm,
      aux_sym__r_blk_map_repeat1,
    ACTIONS(689), 5,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
    STATE(1299), 7,
      sym__b_sgl_prp_val,
      sym__b_sgl_flw_seq_val,
      sym__b_sgl_flw_map_val,
      sym__b_sgl_dqt_str_val,
      sym__b_sgl_sqt_str_val,
      sym__b_sgl_pln_blk_val,
      sym__b_als_val,
  [4006] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(747), 1,
      sym__r_flw_map_bgn,
    ACTIONS(749), 1,
      sym__r_flw_key_bgn,
    ACTIONS(751), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(753), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(755), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(759), 1,
      sym__r_tag,
    ACTIONS(761), 1,
      sym__r_acr_bgn,
    ACTIONS(763), 1,
      sym__r_als_bgn,
    ACTIONS(825), 1,
      sym__r_flw_seq_end,
    STATE(264), 1,
      sym__r_sgl_prp,
    STATE(398), 1,
      sym__r_acr,
    STATE(986), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1097), 1,
      sym__r_als,
    STATE(1110), 1,
      sym__r_sgl_flw_seq,
    STATE(1113), 1,
      sym__r_sgl_flw_map,
    STATE(1114), 1,
      sym__r_sgl_dqt_str,
    STATE(1116), 1,
      sym__r_sgl_sqt_str,
    STATE(1132), 1,
      sym__r_sgl_pln_flw,
    STATE(1225), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1240), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1253), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1317), 1,
      sym__sgl_flw_seq_tal,
    STATE(1447), 1,
      sym__r_sgl_flw_col_dat,
    STATE(976), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1025), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(757), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [4100] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(767), 1,
      sym__r_flw_map_bgn,
    ACTIONS(771), 1,
      sym__r_flw_key_bgn,
    ACTIONS(773), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(775), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(777), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(781), 1,
      sym__r_tag,
    ACTIONS(783), 1,
      sym__r_acr_bgn,
    ACTIONS(785), 1,
      sym__r_als_bgn,
    ACTIONS(827), 1,
      sym__r_flw_map_end,
    STATE(261), 1,
      sym__r_sgl_prp,
    STATE(395), 1,
      sym__r_acr,
    STATE(964), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1100), 1,
      sym__r_als,
    STATE(1187), 1,
      sym__r_sgl_pln_flw,
    STATE(1209), 1,
      sym__r_sgl_flw_seq,
    STATE(1210), 1,
      sym__r_sgl_flw_map,
    STATE(1213), 1,
      sym__r_sgl_dqt_str,
    STATE(1214), 1,
      sym__r_sgl_sqt_str,
    STATE(1250), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1251), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1252), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1322), 1,
      sym__sgl_flw_map_tal,
    STATE(1449), 1,
      sym__r_sgl_flw_col_dat,
    STATE(1038), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1045), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(779), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [4194] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(747), 1,
      sym__r_flw_map_bgn,
    ACTIONS(749), 1,
      sym__r_flw_key_bgn,
    ACTIONS(751), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(753), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(755), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(759), 1,
      sym__r_tag,
    ACTIONS(761), 1,
      sym__r_acr_bgn,
    ACTIONS(763), 1,
      sym__r_als_bgn,
    ACTIONS(829), 1,
      sym__r_flw_seq_end,
    STATE(264), 1,
      sym__r_sgl_prp,
    STATE(398), 1,
      sym__r_acr,
    STATE(986), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1097), 1,
      sym__r_als,
    STATE(1110), 1,
      sym__r_sgl_flw_seq,
    STATE(1113), 1,
      sym__r_sgl_flw_map,
    STATE(1114), 1,
      sym__r_sgl_dqt_str,
    STATE(1116), 1,
      sym__r_sgl_sqt_str,
    STATE(1132), 1,
      sym__r_sgl_pln_flw,
    STATE(1225), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1240), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1253), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1423), 1,
      sym__sgl_flw_seq_tal,
    STATE(1459), 1,
      sym__r_sgl_flw_col_dat,
    STATE(976), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1025), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(757), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [4288] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(831), 1,
      sym__r_tag,
    ACTIONS(833), 1,
      sym__br_tag,
    ACTIONS(631), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(627), 23,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [4337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 35,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__r_tag,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [4378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 35,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__r_tag,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [4419] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(836), 1,
      sym__r_tag,
    ACTIONS(838), 1,
      sym__br_tag,
    ACTIONS(619), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(615), 23,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [4468] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(747), 1,
      sym__r_flw_map_bgn,
    ACTIONS(749), 1,
      sym__r_flw_key_bgn,
    ACTIONS(751), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(753), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(755), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(759), 1,
      sym__r_tag,
    ACTIONS(761), 1,
      sym__r_acr_bgn,
    ACTIONS(763), 1,
      sym__r_als_bgn,
    ACTIONS(841), 1,
      sym__r_flw_seq_end,
    STATE(264), 1,
      sym__r_sgl_prp,
    STATE(398), 1,
      sym__r_acr,
    STATE(1097), 1,
      sym__r_als,
    STATE(1110), 1,
      sym__r_sgl_flw_seq,
    STATE(1113), 1,
      sym__r_sgl_flw_map,
    STATE(1114), 1,
      sym__r_sgl_dqt_str,
    STATE(1116), 1,
      sym__r_sgl_sqt_str,
    STATE(1132), 1,
      sym__r_sgl_pln_flw,
    STATE(1225), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1240), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1245), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1253), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(976), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1025), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(757), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [4556] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(767), 1,
      sym__r_flw_map_bgn,
    ACTIONS(771), 1,
      sym__r_flw_key_bgn,
    ACTIONS(773), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(775), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(777), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(781), 1,
      sym__r_tag,
    ACTIONS(783), 1,
      sym__r_acr_bgn,
    ACTIONS(785), 1,
      sym__r_als_bgn,
    ACTIONS(843), 1,
      sym__r_flw_map_end,
    STATE(261), 1,
      sym__r_sgl_prp,
    STATE(395), 1,
      sym__r_acr,
    STATE(1100), 1,
      sym__r_als,
    STATE(1187), 1,
      sym__r_sgl_pln_flw,
    STATE(1209), 1,
      sym__r_sgl_flw_seq,
    STATE(1210), 1,
      sym__r_sgl_flw_map,
    STATE(1213), 1,
      sym__r_sgl_dqt_str,
    STATE(1214), 1,
      sym__r_sgl_sqt_str,
    STATE(1250), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1251), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1252), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1372), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1038), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1045), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(779), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [4644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 34,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [4684] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(747), 1,
      sym__r_flw_map_bgn,
    ACTIONS(749), 1,
      sym__r_flw_key_bgn,
    ACTIONS(751), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(753), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(755), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(759), 1,
      sym__r_tag,
    ACTIONS(761), 1,
      sym__r_acr_bgn,
    ACTIONS(763), 1,
      sym__r_als_bgn,
    ACTIONS(843), 1,
      sym__r_flw_seq_end,
    STATE(264), 1,
      sym__r_sgl_prp,
    STATE(398), 1,
      sym__r_acr,
    STATE(1097), 1,
      sym__r_als,
    STATE(1110), 1,
      sym__r_sgl_flw_seq,
    STATE(1113), 1,
      sym__r_sgl_flw_map,
    STATE(1114), 1,
      sym__r_sgl_dqt_str,
    STATE(1116), 1,
      sym__r_sgl_sqt_str,
    STATE(1132), 1,
      sym__r_sgl_pln_flw,
    STATE(1225), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1240), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1245), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1253), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(976), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1025), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(757), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [4772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(838), 1,
      sym__br_tag,
    ACTIONS(845), 1,
      sym__r_tag,
    ACTIONS(615), 32,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [4816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(664), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(666), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(662), 24,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [4860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 34,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__r_tag,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
      sym__bl,
  [4900] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(387), 1,
      sym__br_flw_seq_bgn,
    ACTIONS(391), 1,
      sym__br_flw_map_bgn,
    ACTIONS(400), 1,
      sym__br_dqt_str_bgn,
    ACTIONS(404), 1,
      sym__br_sqt_str_bgn,
    ACTIONS(410), 1,
      sym__r_mtl_pln_str_flw,
    ACTIONS(412), 1,
      sym__br_mtl_pln_str_flw,
    ACTIONS(577), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(579), 1,
      sym__r_flw_map_bgn,
    ACTIONS(581), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(583), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(369), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
    STATE(1338), 2,
      sym__r_flw_seq,
      sym__br_flw_seq,
    STATE(1339), 2,
      sym__r_flw_map,
      sym__br_flw_map,
    STATE(1340), 2,
      sym__r_dqt_str,
      sym__br_dqt_str,
    STATE(1341), 2,
      sym__r_sqt_str,
      sym__br_sqt_str,
    STATE(1398), 4,
      sym__r_sgl_pln_flw,
      sym__br_sgl_pln_flw,
      sym__r_mtl_pln_flw,
      sym__br_mtl_pln_flw,
    ACTIONS(406), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(408), 5,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
  [4974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 34,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__r_tag,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [5014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 34,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__r_tag,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
      sym__bl,
  [5054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(847), 1,
      sym__r_tag,
    ACTIONS(849), 1,
      sym__br_tag,
    ACTIONS(619), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(615), 22,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_acr_bgn,
      sym__br_als_bgn,
      sym__bl,
  [5102] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(852), 1,
      sym__r_tag,
    ACTIONS(854), 1,
      sym__br_tag,
    ACTIONS(631), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(627), 22,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_acr_bgn,
      sym__br_als_bgn,
      sym__bl,
  [5150] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(387), 1,
      sym__br_flw_seq_bgn,
    ACTIONS(391), 1,
      sym__br_flw_map_bgn,
    ACTIONS(400), 1,
      sym__br_dqt_str_bgn,
    ACTIONS(404), 1,
      sym__br_sqt_str_bgn,
    ACTIONS(410), 1,
      sym__r_mtl_pln_str_flw,
    ACTIONS(412), 1,
      sym__br_mtl_pln_str_flw,
    ACTIONS(577), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(579), 1,
      sym__r_flw_map_bgn,
    ACTIONS(581), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(583), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(377), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
    STATE(1342), 2,
      sym__r_flw_seq,
      sym__br_flw_seq,
    STATE(1343), 2,
      sym__r_flw_map,
      sym__br_flw_map,
    STATE(1346), 2,
      sym__r_dqt_str,
      sym__br_dqt_str,
    STATE(1349), 2,
      sym__r_sqt_str,
      sym__br_sqt_str,
    STATE(1400), 4,
      sym__r_sgl_pln_flw,
      sym__br_sgl_pln_flw,
      sym__r_mtl_pln_flw,
      sym__br_mtl_pln_flw,
    ACTIONS(406), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(408), 5,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
  [5224] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(767), 1,
      sym__r_flw_map_bgn,
    ACTIONS(771), 1,
      sym__r_flw_key_bgn,
    ACTIONS(773), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(775), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(777), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(781), 1,
      sym__r_tag,
    ACTIONS(783), 1,
      sym__r_acr_bgn,
    ACTIONS(785), 1,
      sym__r_als_bgn,
    ACTIONS(841), 1,
      sym__r_flw_map_end,
    STATE(261), 1,
      sym__r_sgl_prp,
    STATE(395), 1,
      sym__r_acr,
    STATE(1100), 1,
      sym__r_als,
    STATE(1187), 1,
      sym__r_sgl_pln_flw,
    STATE(1209), 1,
      sym__r_sgl_flw_seq,
    STATE(1210), 1,
      sym__r_sgl_flw_map,
    STATE(1213), 1,
      sym__r_sgl_dqt_str,
    STATE(1214), 1,
      sym__r_sgl_sqt_str,
    STATE(1250), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1251), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1252), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1372), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1038), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1045), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(779), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [5312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(657), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(653), 24,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [5356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 33,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [5395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(664), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(666), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(662), 23,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
      sym__bl,
  [5438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 33,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
      sym__bl,
  [5477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 33,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [5516] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(747), 1,
      sym__r_flw_map_bgn,
    ACTIONS(749), 1,
      sym__r_flw_key_bgn,
    ACTIONS(751), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(753), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(755), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(759), 1,
      sym__r_tag,
    ACTIONS(761), 1,
      sym__r_acr_bgn,
    ACTIONS(763), 1,
      sym__r_als_bgn,
    STATE(264), 1,
      sym__r_sgl_prp,
    STATE(398), 1,
      sym__r_acr,
    STATE(1097), 1,
      sym__r_als,
    STATE(1110), 1,
      sym__r_sgl_flw_seq,
    STATE(1113), 1,
      sym__r_sgl_flw_map,
    STATE(1114), 1,
      sym__r_sgl_dqt_str,
    STATE(1116), 1,
      sym__r_sgl_sqt_str,
    STATE(1132), 1,
      sym__r_sgl_pln_flw,
    STATE(1225), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1240), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1245), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1253), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(976), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1025), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(757), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [5601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 33,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [5640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(657), 9,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
    ACTIONS(653), 23,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
      sym__bl,
  [5683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 33,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [5722] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(767), 1,
      sym__r_flw_map_bgn,
    ACTIONS(771), 1,
      sym__r_flw_key_bgn,
    ACTIONS(773), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(775), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(777), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(781), 1,
      sym__r_tag,
    ACTIONS(783), 1,
      sym__r_acr_bgn,
    ACTIONS(785), 1,
      sym__r_als_bgn,
    STATE(261), 1,
      sym__r_sgl_prp,
    STATE(395), 1,
      sym__r_acr,
    STATE(1100), 1,
      sym__r_als,
    STATE(1187), 1,
      sym__r_sgl_pln_flw,
    STATE(1209), 1,
      sym__r_sgl_flw_seq,
    STATE(1210), 1,
      sym__r_sgl_flw_map,
    STATE(1213), 1,
      sym__r_sgl_dqt_str,
    STATE(1214), 1,
      sym__r_sgl_sqt_str,
    STATE(1250), 1,
      sym__r_sgl_flw_exp_par,
    STATE(1251), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1252), 1,
      sym__r_sgl_flw_njl_ann_par,
    STATE(1372), 1,
      sym__r_sgl_flw_col_itm,
    STATE(1038), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1045), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(779), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [5807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 32,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
      sym__bl,
  [5845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 32,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
      sym__bl,
  [5883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 32,
      sym__br_blk_seq_bgn,
      sym__b_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__r_blk_lit_bgn,
      sym__br_blk_lit_bgn,
      sym__r_blk_fld_bgn,
      sym__br_blk_fld_bgn,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__br_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__br_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__br_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__br_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__br_sgl_pln_str_blk,
      sym__r_mtl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
      sym__bl,
  [5921] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      sym__r_acr_bgn,
    ACTIONS(859), 1,
      sym__br_acr_bgn,
    STATE(212), 1,
      sym__r_acr,
    STATE(213), 1,
      sym__br_acr,
    ACTIONS(619), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(615), 15,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_flw_njv_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [5968] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      sym__r_acr_bgn,
    ACTIONS(859), 1,
      sym__br_acr_bgn,
    STATE(213), 2,
      sym__r_acr,
      sym__br_acr,
    ACTIONS(615), 27,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [6011] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      sym__r_acr_bgn,
    ACTIONS(859), 1,
      sym__br_acr_bgn,
    STATE(214), 2,
      sym__r_acr,
      sym__br_acr,
    ACTIONS(627), 27,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [6054] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(861), 1,
      sym__r_acr_bgn,
    ACTIONS(863), 1,
      sym__br_acr_bgn,
    STATE(226), 1,
      sym__r_acr,
    STATE(231), 1,
      sym__br_acr,
    ACTIONS(619), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(615), 14,
      sym__br_flw_seq_bgn,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_map_bgn,
      sym__br_flw_sep_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [6100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(861), 1,
      sym__r_acr_bgn,
    ACTIONS(863), 1,
      sym__br_acr_bgn,
    STATE(231), 2,
      sym__r_acr,
      sym__br_acr,
    ACTIONS(615), 26,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [6142] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(865), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(869), 1,
      sym__r_flw_map_bgn,
    ACTIONS(871), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(873), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(877), 1,
      sym__r_tag,
    ACTIONS(879), 1,
      sym__r_acr_bgn,
    ACTIONS(881), 1,
      sym__r_als_bgn,
    STATE(365), 1,
      sym__r_sgl_prp,
    STATE(455), 1,
      sym__r_acr,
    STATE(1292), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1455), 1,
      sym__r_als,
    STATE(1463), 1,
      sym__r_sgl_dqt_str,
    STATE(1467), 1,
      sym__r_sgl_sqt_str,
    STATE(1506), 1,
      sym__r_sgl_flw_seq,
    STATE(1518), 1,
      sym__r_sgl_pln_flw,
    STATE(1534), 1,
      sym__r_sgl_flw_map,
    ACTIONS(867), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    STATE(1359), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1244), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(875), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [6216] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(885), 1,
      sym__r_flw_map_bgn,
    ACTIONS(889), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(891), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(895), 1,
      sym__r_tag,
    ACTIONS(897), 1,
      sym__r_acr_bgn,
    ACTIONS(899), 1,
      sym__r_als_bgn,
    STATE(276), 1,
      sym__r_sgl_prp,
    STATE(405), 1,
      sym__r_acr,
    STATE(1301), 1,
      sym__r_sgl_flw_seq,
    STATE(1305), 1,
      sym__r_sgl_flw_map,
    STATE(1308), 1,
      sym__r_sgl_dqt_str,
    STATE(1311), 1,
      sym__r_sgl_sqt_str,
    STATE(1336), 1,
      sym__r_sgl_pln_flw,
    STATE(1353), 1,
      sym__r_als,
    ACTIONS(887), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    ACTIONS(893), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    STATE(1319), 8,
      sym__r_sgl_prp_val,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__sgl_flw_ann_par_tal,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
  [6286] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(885), 1,
      sym__r_flw_map_bgn,
    ACTIONS(889), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(891), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(895), 1,
      sym__r_tag,
    ACTIONS(897), 1,
      sym__r_acr_bgn,
    ACTIONS(899), 1,
      sym__r_als_bgn,
    STATE(276), 1,
      sym__r_sgl_prp,
    STATE(405), 1,
      sym__r_acr,
    STATE(1301), 1,
      sym__r_sgl_flw_seq,
    STATE(1305), 1,
      sym__r_sgl_flw_map,
    STATE(1308), 1,
      sym__r_sgl_dqt_str,
    STATE(1311), 1,
      sym__r_sgl_sqt_str,
    STATE(1336), 1,
      sym__r_sgl_pln_flw,
    STATE(1353), 1,
      sym__r_als,
    ACTIONS(901), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    ACTIONS(893), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    STATE(1371), 8,
      sym__r_sgl_prp_val,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__sgl_flw_ann_par_tal,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
  [6356] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(865), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(869), 1,
      sym__r_flw_map_bgn,
    ACTIONS(871), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(873), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(877), 1,
      sym__r_tag,
    ACTIONS(879), 1,
      sym__r_acr_bgn,
    ACTIONS(881), 1,
      sym__r_als_bgn,
    STATE(365), 1,
      sym__r_sgl_prp,
    STATE(455), 1,
      sym__r_acr,
    STATE(1312), 1,
      sym__r_sgl_flw_imp_par,
    STATE(1455), 1,
      sym__r_als,
    STATE(1463), 1,
      sym__r_sgl_dqt_str,
    STATE(1467), 1,
      sym__r_sgl_sqt_str,
    STATE(1506), 1,
      sym__r_sgl_flw_seq,
    STATE(1518), 1,
      sym__r_sgl_pln_flw,
    STATE(1534), 1,
      sym__r_sgl_flw_map,
    ACTIONS(867), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    STATE(1239), 3,
      sym__r_sgl_prp_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
    STATE(1242), 4,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
    ACTIONS(875), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [6430] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(861), 1,
      sym__r_acr_bgn,
    ACTIONS(863), 1,
      sym__br_acr_bgn,
    STATE(227), 2,
      sym__r_acr,
      sym__br_acr,
    ACTIONS(627), 26,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [6472] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(903), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(905), 1,
      sym__r_flw_map_bgn,
    ACTIONS(907), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(909), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(913), 1,
      sym__r_tag,
    ACTIONS(915), 1,
      sym__r_acr_bgn,
    ACTIONS(917), 1,
      sym__r_als_bgn,
    STATE(274), 1,
      sym__r_sgl_prp,
    STATE(401), 1,
      sym__r_acr,
    STATE(1219), 1,
      sym__r_sgl_flw_seq,
    STATE(1223), 1,
      sym__r_sgl_flw_map,
    STATE(1224), 1,
      sym__r_sgl_dqt_str,
    STATE(1228), 1,
      sym__r_sgl_sqt_str,
    STATE(1326), 1,
      sym__r_sgl_pln_flw,
    STATE(1348), 1,
      sym__r_als,
    ACTIONS(887), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    ACTIONS(911), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    STATE(1379), 8,
      sym__r_sgl_prp_val,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__sgl_flw_ann_par_tal,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
  [6542] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(903), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(905), 1,
      sym__r_flw_map_bgn,
    ACTIONS(907), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(909), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(913), 1,
      sym__r_tag,
    ACTIONS(915), 1,
      sym__r_acr_bgn,
    ACTIONS(917), 1,
      sym__r_als_bgn,
    STATE(274), 1,
      sym__r_sgl_prp,
    STATE(401), 1,
      sym__r_acr,
    STATE(1219), 1,
      sym__r_sgl_flw_seq,
    STATE(1223), 1,
      sym__r_sgl_flw_map,
    STATE(1224), 1,
      sym__r_sgl_dqt_str,
    STATE(1228), 1,
      sym__r_sgl_sqt_str,
    STATE(1326), 1,
      sym__r_sgl_pln_flw,
    STATE(1348), 1,
      sym__r_als,
    ACTIONS(901), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    ACTIONS(911), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    STATE(1327), 8,
      sym__r_sgl_prp_val,
      sym__r_sgl_flw_seq_val,
      sym__r_sgl_flw_map_val,
      sym__sgl_flw_ann_par_tal,
      sym__r_sgl_dqt_str_val,
      sym__r_sgl_sqt_str_val,
      sym__r_sgl_pln_flw_val,
      sym__r_als_val,
  [6612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(919), 2,
      sym__r_tag,
      sym__br_tag,
    ACTIONS(615), 27,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [6649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(921), 1,
      sym__r_acr_bgn,
    ACTIONS(923), 1,
      sym__br_acr_bgn,
    STATE(242), 2,
      sym__r_acr,
      sym__br_acr,
    ACTIONS(627), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [6690] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(919), 1,
      sym__br_tag,
    ACTIONS(925), 1,
      sym__r_tag,
    ACTIONS(619), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(615), 15,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_flw_njv_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [6731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(927), 1,
      sym__r_acr_bgn,
    ACTIONS(929), 1,
      sym__br_acr_bgn,
    STATE(239), 2,
      sym__r_acr,
      sym__br_acr,
    ACTIONS(615), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [6772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 29,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
      sym__r_tag,
      sym__br_tag,
  [6807] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(921), 1,
      sym__r_acr_bgn,
    ACTIONS(923), 1,
      sym__br_acr_bgn,
    STATE(241), 2,
      sym__r_acr,
      sym__br_acr,
    ACTIONS(615), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [6848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(931), 2,
      sym__r_tag,
      sym__br_tag,
    ACTIONS(627), 27,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [6885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 29,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
      sym__r_tag,
      sym__br_tag,
  [6920] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(927), 1,
      sym__r_acr_bgn,
    ACTIONS(929), 1,
      sym__br_acr_bgn,
    STATE(236), 1,
      sym__r_acr,
    STATE(239), 1,
      sym__br_acr,
    ACTIONS(619), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(615), 14,
      sym__br_flw_seq_bgn,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_map_bgn,
      sym__br_flw_sep_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [6965] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(921), 1,
      sym__r_acr_bgn,
    ACTIONS(923), 1,
      sym__br_acr_bgn,
    STATE(240), 1,
      sym__r_acr,
    STATE(241), 1,
      sym__br_acr,
    ACTIONS(619), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(615), 14,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(927), 1,
      sym__r_acr_bgn,
    ACTIONS(929), 1,
      sym__br_acr_bgn,
    STATE(238), 2,
      sym__r_acr,
      sym__br_acr,
    ACTIONS(627), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 28,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
      sym__r_tag,
      sym__br_tag,
  [7085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 28,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
      sym__r_tag,
      sym__br_tag,
  [7119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(933), 2,
      sym__r_tag,
      sym__br_tag,
    ACTIONS(615), 26,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7155] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(933), 1,
      sym__br_tag,
    ACTIONS(935), 1,
      sym__r_tag,
    ACTIONS(619), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(615), 14,
      sym__br_flw_seq_bgn,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_map_bgn,
      sym__br_flw_sep_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(937), 2,
      sym__r_tag,
      sym__br_tag,
    ACTIONS(627), 26,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 2,
      sym__r_tag,
      sym__br_tag,
    ACTIONS(627), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(653), 15,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_flw_njv_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 27,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 27,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(941), 2,
      sym__r_tag,
      sym__br_tag,
    ACTIONS(615), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 27,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 2,
      sym__r_tag,
      sym__br_tag,
    ACTIONS(615), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym__br_tag,
    ACTIONS(945), 1,
      sym__r_tag,
    ACTIONS(619), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(615), 14,
      sym__br_flw_seq_bgn,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_map_bgn,
      sym__br_flw_sep_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      sym__br_tag,
    ACTIONS(947), 1,
      sym__r_tag,
    ACTIONS(619), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(615), 14,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(949), 2,
      sym__r_tag,
      sym__br_tag,
    ACTIONS(627), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 27,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 27,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
      sym__r_tag,
      sym__br_tag,
  [7649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 27,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
      sym__r_tag,
      sym__br_tag,
  [7682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 27,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
      sym__r_tag,
      sym__br_tag,
  [7715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 27,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
      sym__r_tag,
      sym__br_tag,
  [7748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(653), 14,
      sym__br_flw_seq_bgn,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_map_bgn,
      sym__br_flw_sep_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 26,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 26,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 26,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7878] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(951), 1,
      sym__r_acr_bgn,
    ACTIONS(953), 1,
      sym__br_acr_bgn,
    STATE(260), 2,
      sym__r_acr,
      sym__br_acr,
    ACTIONS(627), 22,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 26,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7948] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(951), 1,
      sym__r_acr_bgn,
    ACTIONS(953), 1,
      sym__br_acr_bgn,
    STATE(259), 2,
      sym__r_acr,
      sym__br_acr,
    ACTIONS(615), 22,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [7986] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(951), 1,
      sym__r_acr_bgn,
    ACTIONS(953), 1,
      sym__br_acr_bgn,
    STATE(258), 1,
      sym__r_acr,
    STATE(259), 1,
      sym__br_acr,
    ACTIONS(619), 10,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(615), 12,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_flw_njv_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(653), 14,
      sym__br_flw_seq_bgn,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_map_bgn,
      sym__br_flw_sep_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(653), 14,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 25,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(955), 24,
      sym__eof,
      sym__s_dir_yml_bgn,
      sym__s_dir_tag_bgn,
      sym__s_dir_rsv_bgn,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__br_blk_lit_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [8372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 2,
      sym__r_tag,
      sym__br_tag,
    ACTIONS(615), 22,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(959), 2,
      sym__r_tag,
      sym__br_tag,
    ACTIONS(627), 22,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 24,
      sym__eof,
      sym__s_dir_yml_bgn,
      sym__s_dir_tag_bgn,
      sym__s_dir_rsv_bgn,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__br_blk_lit_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [8466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 24,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
      sym__r_tag,
      sym__br_tag,
  [8496] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      sym__br_tag,
    ACTIONS(963), 1,
      sym__r_tag,
    ACTIONS(619), 10,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(615), 12,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_flw_njv_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(965), 24,
      sym__eof,
      sym__s_dir_yml_bgn,
      sym__s_dir_tag_bgn,
      sym__s_dir_rsv_bgn,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__br_blk_lit_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [8562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 24,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
      sym__r_tag,
      sym__br_tag,
  [8592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(955), 24,
      sym__eof,
      sym__s_dir_yml_bgn,
      sym__s_dir_tag_bgn,
      sym__s_dir_rsv_bgn,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__br_blk_lit_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [8622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(967), 24,
      sym__eof,
      sym__s_dir_yml_bgn,
      sym__s_dir_tag_bgn,
      sym__s_dir_rsv_bgn,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__br_blk_lit_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [8652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 24,
      sym__eof,
      sym__s_dir_yml_bgn,
      sym__s_dir_tag_bgn,
      sym__s_dir_rsv_bgn,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__br_blk_lit_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [8682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(967), 24,
      sym__eof,
      sym__s_dir_yml_bgn,
      sym__s_dir_tag_bgn,
      sym__s_dir_rsv_bgn,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__br_blk_seq_bgn,
      sym__br_blk_key_bgn,
      sym__br_blk_val_bgn,
      sym__br_blk_lit_bgn,
      sym__br_blk_fld_bgn,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_blk,
      sym__br_sgl_pln_bol_blk,
      sym__br_sgl_pln_int_blk,
      sym__br_sgl_pln_flt_blk,
      sym__br_sgl_pln_str_blk,
      sym__br_mtl_pln_str_blk,
      sym__br_tag,
      sym__br_acr_bgn,
      sym__br_als_bgn,
  [8712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 22,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 22,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 10,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
    ACTIONS(653), 12,
      sym__br_flw_seq_bgn,
      sym__br_flw_map_bgn,
      sym__br_flw_njv_bgn,
      sym__br_dqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__br_sgl_pln_nul_flw,
      sym__br_sgl_pln_bol_flw,
      sym__br_sgl_pln_int_flw,
      sym__br_sgl_pln_flt_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 22,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(662), 22,
      sym__r_flw_seq_bgn,
      sym__br_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__br_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__br_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__br_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__br_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__br_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__br_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__br_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__br_sgl_pln_str_flw,
      sym__r_mtl_pln_str_flw,
      sym__br_mtl_pln_str_flw,
  [8854] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(767), 1,
      sym__r_flw_map_bgn,
    ACTIONS(775), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(777), 1,
      sym__r_sqt_str_bgn,
    STATE(1051), 1,
      sym__r_sgl_flw_seq,
    STATE(1052), 1,
      sym__r_sgl_flw_map,
    STATE(1053), 1,
      sym__r_sgl_dqt_str,
    STATE(1054), 1,
      sym__r_sgl_sqt_str,
    STATE(1171), 1,
      sym__r_sgl_pln_flw,
    ACTIONS(971), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
    ACTIONS(779), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [8897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      sym__r_blk_imp_bgn,
    STATE(332), 1,
      sym__blk_imp_itm_tal,
    ACTIONS(973), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [8924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      sym__r_blk_imp_bgn,
    STATE(334), 1,
      sym__blk_imp_itm_tal,
    ACTIONS(973), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [8951] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(747), 1,
      sym__r_flw_map_bgn,
    ACTIONS(753), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(755), 1,
      sym__r_sqt_str_bgn,
    STATE(1084), 1,
      sym__r_sgl_pln_flw,
    STATE(1161), 1,
      sym__r_sgl_flw_seq,
    STATE(1162), 1,
      sym__r_sgl_flw_map,
    STATE(1163), 1,
      sym__r_sgl_dqt_str,
    STATE(1164), 1,
      sym__r_sgl_sqt_str,
    ACTIONS(971), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
    ACTIONS(757), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [8994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      sym__r_blk_imp_bgn,
    STATE(334), 1,
      sym__blk_imp_itm_tal,
    ACTIONS(977), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 16,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(983), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(981), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(983), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(985), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(989), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(987), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(993), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(991), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(995), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(999), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 16,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9209] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(903), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(905), 1,
      sym__r_flw_map_bgn,
    ACTIONS(907), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(909), 1,
      sym__r_sqt_str_bgn,
    STATE(1231), 1,
      sym__r_sgl_flw_seq,
    STATE(1232), 1,
      sym__r_sgl_flw_map,
    STATE(1233), 1,
      sym__r_sgl_dqt_str,
    STATE(1234), 1,
      sym__r_sgl_sqt_str,
    STATE(1269), 1,
      sym__r_sgl_pln_flw,
    ACTIONS(971), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    ACTIONS(911), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [9251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 16,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9273] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(885), 1,
      sym__r_flw_map_bgn,
    ACTIONS(889), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(891), 1,
      sym__r_sqt_str_bgn,
    STATE(1236), 1,
      sym__r_sgl_pln_flw,
    STATE(1354), 1,
      sym__r_sgl_flw_seq,
    STATE(1357), 1,
      sym__r_sgl_flw_map,
    STATE(1358), 1,
      sym__r_sgl_dqt_str,
    STATE(1360), 1,
      sym__r_sgl_sqt_str,
    ACTIONS(971), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    ACTIONS(893), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [9315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    STATE(329), 1,
      sym__b_blk_val_itm,
    ACTIONS(1007), 14,
      sym__b_blk_key_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    STATE(331), 1,
      sym__b_blk_val_itm,
    ACTIONS(1009), 14,
      sym__b_blk_key_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 1,
      sym__b_blk_val_bgn,
    STATE(306), 1,
      sym__b_blk_val_itm,
    ACTIONS(1011), 14,
      sym__b_blk_key_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1013), 16,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1015), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(983), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1019), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 16,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1025), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1023), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1027), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1031), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1035), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1039), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1045), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1043), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 16,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__r_blk_imp_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1049), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1051), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1055), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1069), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1071), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1073), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1075), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1077), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [9987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10008] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1081), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(1083), 1,
      sym__r_flw_map_bgn,
    ACTIONS(1085), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(1087), 1,
      sym__r_sqt_str_bgn,
    STATE(1521), 1,
      sym__r_sgl_flw_seq,
    STATE(1523), 1,
      sym__r_sgl_flw_map,
    STATE(1524), 1,
      sym__r_sgl_dqt_str,
    STATE(1528), 1,
      sym__r_sgl_sqt_str,
    STATE(1529), 1,
      sym__r_sgl_pln_blk,
    ACTIONS(1089), 5,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
  [10049] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1081), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(1083), 1,
      sym__r_flw_map_bgn,
    ACTIONS(1085), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(1087), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(1091), 1,
      sym__r_blk_imp_bgn,
    STATE(1530), 1,
      sym__r_sgl_flw_seq,
    STATE(1531), 1,
      sym__r_sgl_flw_map,
    STATE(1533), 1,
      sym__r_sgl_dqt_str,
    STATE(1536), 1,
      sym__r_sgl_sqt_str,
    STATE(1537), 1,
      sym__r_sgl_pln_blk,
    ACTIONS(1089), 5,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
  [10090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1095), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1097), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1101), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1103), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1109), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10342] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1081), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(1083), 1,
      sym__r_flw_map_bgn,
    ACTIONS(1085), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(1087), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(1115), 1,
      sym__r_blk_imp_bgn,
    STATE(1415), 1,
      sym__r_sgl_dqt_str,
    STATE(1418), 1,
      sym__r_sgl_sqt_str,
    STATE(1419), 1,
      sym__r_sgl_pln_blk,
    STATE(1491), 1,
      sym__r_sgl_flw_seq,
    STATE(1492), 1,
      sym__r_sgl_flw_map,
    ACTIONS(1089), 5,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
  [10383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1121), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1123), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1125), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1127), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1101), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1133), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1137), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1139), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1141), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1149), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [10992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1019), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1171), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1109), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11265] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(865), 1,
      sym__r_flw_seq_bgn,
    ACTIONS(869), 1,
      sym__r_flw_map_bgn,
    ACTIONS(871), 1,
      sym__r_dqt_str_bgn,
    ACTIONS(873), 1,
      sym__r_sqt_str_bgn,
    ACTIONS(971), 1,
      sym__r_flw_njv_bgn,
    STATE(1466), 1,
      sym__r_sgl_flw_map,
    STATE(1469), 1,
      sym__r_sgl_dqt_str,
    STATE(1470), 1,
      sym__r_sgl_pln_flw,
    STATE(1482), 1,
      sym__r_sgl_sqt_str,
    STATE(1535), 1,
      sym__r_sgl_flw_seq,
    ACTIONS(875), 5,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [11306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1179), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(999), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1187), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1195), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1197), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1205), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1207), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1209), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1211), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1213), 15,
      sym__b_blk_key_bgn,
      sym__b_blk_val_bgn,
      sym__b_flw_seq_bgn,
      sym__b_flw_map_bgn,
      sym__b_dqt_str_bgn,
      sym__b_sqt_str_bgn,
      sym__b_sgl_pln_nul_blk,
      sym__b_sgl_pln_bol_blk,
      sym__b_sgl_pln_int_blk,
      sym__b_sgl_pln_flt_blk,
      sym__b_sgl_pln_str_blk,
      sym__b_tag,
      sym__b_acr_bgn,
      sym__b_als_bgn,
      sym__bl,
  [11852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1215), 1,
      sym__r_acr_bgn,
    STATE(404), 1,
      sym__r_acr,
    ACTIONS(617), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [11876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 1,
      sym__r_acr_bgn,
    STATE(410), 1,
      sym__r_acr,
    ACTIONS(617), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [11900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      sym__r_acr_bgn,
    STATE(417), 1,
      sym__r_acr,
    ACTIONS(617), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [11923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      sym__r_tag,
    ACTIONS(617), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [11944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 13,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__r_tag,
  [11963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 13,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__r_tag,
  [11982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 1,
      sym__r_tag,
    ACTIONS(617), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [12003] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1225), 1,
      sym__r_acr_bgn,
    STATE(433), 1,
      sym__r_acr,
    ACTIONS(617), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [12026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__r_tag,
  [12044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 1,
      sym__r_tag,
    ACTIONS(617), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [12064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [12082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [12100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [12118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 1,
      sym__r_tag,
    ACTIONS(617), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [12138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1233), 1,
      sym__r_acr_bgn,
    STATE(473), 1,
      sym__r_acr,
    ACTIONS(1231), 10,
      sym__r_blk_imp_bgn,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
  [12160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1233), 1,
      sym__r_acr_bgn,
    STATE(470), 1,
      sym__r_acr,
    ACTIONS(629), 10,
      sym__r_blk_imp_bgn,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
  [12182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      sym__r_acr_bgn,
    STATE(477), 1,
      sym__r_acr,
    ACTIONS(617), 10,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [12204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__r_tag,
  [12222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 12,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [12240] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1243), 1,
      sym__br_dqt_esc_nwl,
    STATE(456), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1237), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1245), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(633), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12269] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1251), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1253), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(686), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12298] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1259), 1,
      sym__br_dqt_esc_nwl,
    STATE(419), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1255), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1261), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(609), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12327] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1263), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1265), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1267), 1,
      sym__r_dqt_str_end,
    ACTIONS(1269), 1,
      sym__br_dqt_str_end,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(650), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12358] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1271), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1273), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1275), 1,
      sym__r_dqt_str_end,
    ACTIONS(1277), 1,
      sym__br_dqt_str_end,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(652), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12389] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1281), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1283), 1,
      sym__br_dqt_esc_nwl,
    STATE(421), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1279), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1285), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(579), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [12435] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1289), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1291), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(587), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12464] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1293), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1295), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1297), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(619), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12493] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1299), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1301), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1303), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(685), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12522] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1305), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1307), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1309), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(589), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12551] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1313), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1315), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1317), 1,
      sym__r_dqt_str_end,
    ACTIONS(1319), 1,
      sym__br_dqt_str_end,
    STATE(427), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1311), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(543), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12582] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1323), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1325), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1327), 1,
      sym__r_dqt_str_end,
    ACTIONS(1329), 1,
      sym__br_dqt_str_end,
    STATE(428), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1321), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(546), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1331), 1,
      sym__r_tag,
    ACTIONS(629), 10,
      sym__r_blk_imp_bgn,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
  [12632] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1337), 1,
      sym__br_dqt_esc_nwl,
    STATE(430), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1333), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1339), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(607), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1345), 1,
      sym__br_dqt_esc_nwl,
    STATE(431), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1341), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1347), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(635), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12690] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1351), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1353), 1,
      sym__r_dqt_str_end,
    ACTIONS(1355), 1,
      sym__br_dqt_str_end,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(557), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12721] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1357), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1359), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1361), 1,
      sym__r_dqt_str_end,
    ACTIONS(1363), 1,
      sym__br_dqt_str_end,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(559), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12752] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1369), 1,
      sym__br_dqt_esc_nwl,
    STATE(420), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1365), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1371), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(629), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12781] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1373), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1375), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1377), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(617), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12810] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1379), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1381), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1383), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(643), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12839] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1387), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1389), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1391), 1,
      sym__r_dqt_str_end,
    ACTIONS(1393), 1,
      sym__br_dqt_str_end,
    STATE(438), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1385), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(577), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [12887] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1397), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1399), 1,
      sym__br_dqt_esc_nwl,
    STATE(440), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1395), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1401), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(627), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12916] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1299), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1301), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1303), 1,
      sym__br_dqt_str_end,
    ACTIONS(1403), 1,
      sym__r_dqt_str_end,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(685), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 11,
      sym__r_blk_imp_bgn,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__r_tag,
  [12964] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1407), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1409), 1,
      sym__br_dqt_esc_nwl,
    STATE(441), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1405), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1411), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(659), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [12993] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1289), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1291), 1,
      sym__br_dqt_str_end,
    ACTIONS(1413), 1,
      sym__r_dqt_str_end,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(587), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13024] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1369), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1371), 1,
      sym__br_dqt_str_end,
    ACTIONS(1417), 1,
      sym__r_dqt_str_end,
    STATE(435), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1415), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(629), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13055] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1263), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1265), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1269), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(650), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13084] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1421), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1423), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(666), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
      sym__r_tag,
  [13130] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1337), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1339), 1,
      sym__br_dqt_str_end,
    ACTIONS(1427), 1,
      sym__r_dqt_str_end,
    STATE(449), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1425), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(607), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13161] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1431), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1433), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1435), 1,
      sym__r_dqt_str_end,
    ACTIONS(1437), 1,
      sym__br_dqt_str_end,
    STATE(463), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1429), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(647), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_seq_end,
      sym__r_flw_map_bgn,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [13209] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1313), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1315), 1,
      sym__br_dqt_esc_nwl,
    STATE(450), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1319), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    ACTIONS(1439), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(543), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 11,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [13255] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1443), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1445), 1,
      sym__br_dqt_esc_nwl,
    STATE(451), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1441), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1447), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(682), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13284] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1373), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1375), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1377), 1,
      sym__br_dqt_str_end,
    ACTIONS(1449), 1,
      sym__r_dqt_str_end,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(617), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13315] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1351), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1355), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(557), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13344] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1451), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1453), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1455), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(688), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13373] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1243), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1245), 1,
      sym__br_dqt_str_end,
    ACTIONS(1459), 1,
      sym__r_dqt_str_end,
    STATE(453), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1457), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(633), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13404] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1463), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1465), 1,
      sym__r_dqt_str_end,
    ACTIONS(1467), 1,
      sym__br_dqt_str_end,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(641), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1469), 1,
      sym__r_tag,
    ACTIONS(1231), 10,
      sym__r_blk_imp_bgn,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
  [13454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym__r_tag,
    ACTIONS(617), 10,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [13473] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1463), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1467), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(641), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13502] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1397), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1399), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1401), 1,
      sym__br_dqt_str_end,
    ACTIONS(1475), 1,
      sym__r_dqt_str_end,
    STATE(414), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1473), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(627), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13533] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1479), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1481), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1483), 1,
      sym__r_dqt_str_end,
    ACTIONS(1485), 1,
      sym__br_dqt_str_end,
    STATE(415), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1477), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(630), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13564] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1489), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1491), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1493), 1,
      sym__r_dqt_str_end,
    ACTIONS(1495), 1,
      sym__br_dqt_str_end,
    STATE(461), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1487), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(657), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13595] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1489), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1491), 1,
      sym__br_dqt_esc_nwl,
    STATE(462), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1495), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    ACTIONS(1497), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(657), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13624] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1501), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1503), 1,
      sym__r_dqt_str_end,
    ACTIONS(1505), 1,
      sym__br_dqt_str_end,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(664), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13655] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1501), 1,
      sym__br_dqt_esc_nwl,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1505), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(664), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13684] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1507), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1509), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1511), 1,
      sym__r_dqt_str_end,
    ACTIONS(1513), 1,
      sym__br_dqt_str_end,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(582), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13715] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1519), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1521), 1,
      sym__r_dqt_str_end,
    ACTIONS(1523), 1,
      sym__br_dqt_str_end,
    STATE(467), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1515), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(680), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13746] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1387), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1389), 1,
      sym__br_dqt_esc_nwl,
    STATE(418), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1393), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    ACTIONS(1525), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(577), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13775] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1519), 1,
      sym__br_dqt_esc_nwl,
    STATE(412), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1523), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    ACTIONS(1527), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(680), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13804] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 1,
      sym__r_dqt_esc_nwl,
    ACTIONS(1251), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1253), 1,
      sym__br_dqt_str_end,
    ACTIONS(1529), 1,
      sym__r_dqt_str_end,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1247), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    STATE(686), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [13835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1531), 11,
      sym__r_blk_imp_bgn,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
      sym__r_tag,
  [13852] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(223), 1,
      sym__br_flw_njv_bgn,
    STATE(793), 1,
      sym__br_flw_njl_ann_par,
    STATE(943), 1,
      sym__r_flw_njl_ann_par,
    STATE(1337), 1,
      sym__r_sgl_flw_njl_ann_par,
    ACTIONS(1533), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    ACTIONS(1536), 3,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
  [13880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(664), 10,
      sym__r_blk_imp_bgn,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
  [13896] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym__s_dir_yml_bgn,
    ACTIONS(9), 1,
      sym__s_dir_tag_bgn,
    ACTIONS(11), 1,
      sym__s_dir_rsv_bgn,
    ACTIONS(13), 1,
      sym__s_drs_end,
    STATE(1085), 1,
      sym__exp_doc,
    STATE(512), 5,
      sym__s_dir,
      sym__s_dir_yml,
      sym__s_dir_tag,
      sym__s_dir_rsv,
      aux_sym__drs_doc_repeat1,
  [13922] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      sym__s_drs_end,
    ACTIONS(15), 1,
      sym__s_doc_end,
    ACTIONS(1538), 1,
      sym__eof,
    STATE(472), 1,
      sym__doc_w_bgn_wo_end,
    STATE(1155), 1,
      sym__exp_doc,
    STATE(1526), 2,
      sym__doc_w_bgn_w_end_seq,
      sym__doc_w_bgn_wo_end_seq,
    STATE(37), 3,
      sym__doc_w_bgn_w_end,
      sym__exp_doc_end,
      sym__doc_end,
  [13950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 10,
      sym__r_blk_imp_bgn,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
  [13966] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      sym__s_drs_end,
    ACTIONS(383), 1,
      sym__eof,
    ACTIONS(1542), 1,
      sym__s_doc_end,
    STATE(472), 1,
      sym__doc_w_bgn_wo_end,
    STATE(1155), 1,
      sym__exp_doc,
    STATE(1428), 2,
      sym__doc_w_bgn_w_end_seq,
      sym__doc_w_bgn_wo_end_seq,
    STATE(37), 3,
      sym__doc_w_bgn_w_end,
      sym__exp_doc_end,
      sym__doc_end,
  [13994] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      sym__s_drs_end,
    ACTIONS(383), 1,
      sym__eof,
    ACTIONS(1544), 1,
      sym__s_doc_end,
    STATE(472), 1,
      sym__doc_w_bgn_wo_end,
    STATE(1155), 1,
      sym__exp_doc,
    STATE(1428), 2,
      sym__doc_w_bgn_w_end_seq,
      sym__doc_w_bgn_wo_end_seq,
    STATE(37), 3,
      sym__doc_w_bgn_w_end,
      sym__exp_doc_end,
      sym__doc_end,
  [14022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 10,
      sym__r_blk_imp_bgn,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_blk,
      sym__r_sgl_pln_bol_blk,
      sym__r_sgl_pln_int_blk,
      sym__r_sgl_pln_flt_blk,
      sym__r_sgl_pln_str_blk,
  [14038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 10,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [14054] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      sym__s_drs_end,
    ACTIONS(383), 1,
      sym__eof,
    ACTIONS(1546), 1,
      sym__s_doc_end,
    STATE(472), 1,
      sym__doc_w_bgn_wo_end,
    STATE(1155), 1,
      sym__exp_doc,
    STATE(1428), 2,
      sym__doc_w_bgn_w_end_seq,
      sym__doc_w_bgn_wo_end_seq,
    STATE(37), 3,
      sym__doc_w_bgn_w_end,
      sym__exp_doc_end,
      sym__doc_end,
  [14082] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      sym__s_drs_end,
    ACTIONS(15), 1,
      sym__s_doc_end,
    ACTIONS(1548), 1,
      sym__eof,
    STATE(472), 1,
      sym__doc_w_bgn_wo_end,
    STATE(1155), 1,
      sym__exp_doc,
    STATE(1490), 2,
      sym__doc_w_bgn_w_end_seq,
      sym__doc_w_bgn_wo_end_seq,
    STATE(37), 3,
      sym__doc_w_bgn_w_end,
      sym__exp_doc_end,
      sym__doc_end,
  [14110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 10,
      sym__r_flw_seq_bgn,
      sym__r_flw_map_bgn,
      sym__r_flw_njv_bgn,
      sym__r_dqt_str_bgn,
      sym__r_sqt_str_bgn,
      sym__r_sgl_pln_nul_flw,
      sym__r_sgl_pln_bol_flw,
      sym__r_sgl_pln_int_flw,
      sym__r_sgl_pln_flt_flw,
      sym__r_sgl_pln_str_flw,
  [14126] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1554), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(759), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(502), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1556), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1558), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(766), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14172] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 1,
      sym__br_sqt_str_end,
    ACTIONS(1560), 1,
      sym__r_sqt_str_end,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    STATE(759), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14197] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 1,
      sym__r_sqt_str_end,
    ACTIONS(1566), 1,
      sym__br_sqt_str_end,
    STATE(537), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1562), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(757), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14222] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(495), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1568), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1570), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(761), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14245] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 1,
      sym__r_sqt_str_end,
    ACTIONS(1574), 1,
      sym__br_sqt_str_end,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    STATE(760), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14270] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      sym__br_sqt_str_end,
    ACTIONS(1578), 1,
      sym__r_sqt_str_end,
    STATE(533), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1576), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(761), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14295] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1580), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(771), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14318] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(496), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1582), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1584), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(781), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14341] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      sym__r_sqt_str_end,
    ACTIONS(1590), 1,
      sym__br_sqt_str_end,
    STATE(535), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1586), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(762), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14366] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      sym__br_sqt_str_end,
    ACTIONS(1592), 1,
      sym__r_sqt_str_end,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    STATE(771), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14391] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(223), 1,
      sym__br_flw_njv_bgn,
    ACTIONS(434), 1,
      sym__r_flw_njv_bgn,
    STATE(937), 1,
      sym__r_flw_njl_ann_par,
    STATE(956), 1,
      sym__br_flw_njl_ann_par,
    ACTIONS(1536), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [14414] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(223), 1,
      sym__br_flw_njv_bgn,
    ACTIONS(434), 1,
      sym__r_flw_njv_bgn,
    STATE(938), 1,
      sym__r_flw_njl_ann_par,
    STATE(961), 1,
      sym__br_flw_njl_ann_par,
    ACTIONS(1594), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [14437] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1596), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(776), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14460] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1598), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(763), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14483] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1600), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(741), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14506] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 1,
      sym__r_flw_jsv_bgn,
    ACTIONS(1604), 1,
      sym__br_flw_jsv_bgn,
    STATE(787), 1,
      sym__br_flw_jsl_ann_par,
    STATE(940), 1,
      sym__r_flw_jsl_ann_par,
    ACTIONS(1536), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [14529] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      sym__r_dqt_esc_nwl,
    STATE(507), 1,
      aux_sym__br_mtl_dqt_ctn_repeat1,
    ACTIONS(1606), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1608), 5,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_nwl,
      sym__br_dqt_esc_seq,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
  [14550] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(505), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1612), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1614), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(754), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14573] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 1,
      sym__r_sqt_str_end,
    ACTIONS(1620), 1,
      sym__br_sqt_str_end,
    STATE(506), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1616), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(773), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(501), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(1622), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1625), 6,
      sym__br_dqt_str_ctn,
      sym__r_dqt_esc_nwl,
      sym__br_dqt_esc_nwl,
      sym__br_dqt_esc_seq,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
  [14617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1627), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(768), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14640] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1631), 1,
      sym__r_sqt_str_end,
    ACTIONS(1633), 1,
      sym__br_sqt_str_end,
    STATE(520), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1629), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(765), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14665] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(510), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1620), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    ACTIONS(1635), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(773), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1637), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(750), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14711] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1639), 1,
      sym__r_sqt_str_end,
    ACTIONS(1641), 1,
      sym__br_sqt_str_end,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    STATE(775), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(507), 1,
      aux_sym__br_mtl_dqt_ctn_repeat1,
    ACTIONS(1643), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1646), 6,
      sym__br_dqt_str_ctn,
      sym__r_dqt_esc_nwl,
      sym__br_dqt_esc_nwl,
      sym__br_dqt_esc_seq,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
  [14755] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 1,
      sym__r_sqt_str_end,
    ACTIONS(1652), 1,
      sym__br_sqt_str_end,
    STATE(491), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1648), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(769), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14780] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(481), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1654), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1656), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(755), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14803] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1641), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(775), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14826] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1658), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(767), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14849] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1660), 1,
      sym__s_dir_yml_bgn,
    ACTIONS(1663), 1,
      sym__s_dir_tag_bgn,
    ACTIONS(1666), 1,
      sym__s_dir_rsv_bgn,
    ACTIONS(1669), 1,
      sym__s_drs_end,
    STATE(512), 5,
      sym__s_dir,
      sym__s_dir_yml,
      sym__s_dir_tag,
      sym__s_dir_rsv,
      aux_sym__drs_doc_repeat1,
  [14872] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(488), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1652), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    ACTIONS(1671), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(769), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14895] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(530), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1673), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1675), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(693), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14918] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 1,
      sym__r_sqt_str_end,
    ACTIONS(1681), 1,
      sym__br_sqt_str_end,
    STATE(521), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1677), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(777), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14943] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1656), 1,
      sym__br_sqt_str_end,
    ACTIONS(1685), 1,
      sym__r_sqt_str_end,
    STATE(483), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1683), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(755), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14968] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1689), 1,
      sym__r_sqt_str_end,
    ACTIONS(1691), 1,
      sym__br_sqt_str_end,
    STATE(486), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1687), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(756), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [14993] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 1,
      sym__br_sqt_str_end,
    ACTIONS(1695), 1,
      sym__r_sqt_str_end,
    STATE(531), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1693), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(754), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15018] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(524), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1681), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    ACTIONS(1697), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(777), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15041] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1658), 1,
      sym__br_sqt_str_end,
    ACTIONS(1699), 1,
      sym__r_sqt_str_end,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    STATE(767), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15066] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 1,
      sym__r_sqt_str_end,
    ACTIONS(1703), 1,
      sym__br_sqt_str_end,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    STATE(778), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1705), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(772), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      sym__r_dqt_esc_nwl,
    STATE(498), 1,
      aux_sym__br_mtl_dqt_ctn_repeat1,
    ACTIONS(1707), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
    ACTIONS(1709), 5,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_nwl,
      sym__br_dqt_esc_seq,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
  [15135] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1703), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(778), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15158] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(494), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1713), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1715), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(774), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15181] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(511), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1633), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    ACTIONS(1717), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(765), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15204] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(522), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1719), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1721), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(770), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15227] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1725), 1,
      sym__r_sqt_str_end,
    ACTIONS(1727), 1,
      sym__br_sqt_str_end,
    STATE(534), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1723), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(780), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15252] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 1,
      sym__r_flw_jsv_bgn,
    ACTIONS(1604), 1,
      sym__br_flw_jsv_bgn,
    STATE(788), 1,
      sym__br_flw_jsl_ann_par,
    STATE(941), 1,
      sym__r_flw_jsl_ann_par,
    ACTIONS(1594), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [15275] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1729), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(779), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15298] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1637), 1,
      sym__br_sqt_str_end,
    ACTIONS(1731), 1,
      sym__r_sqt_str_end,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    STATE(750), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(536), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1727), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    ACTIONS(1733), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    STATE(780), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15346] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 1,
      sym__br_sqt_str_end,
    ACTIONS(1735), 1,
      sym__r_sqt_str_end,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    STATE(763), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15371] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1737), 1,
      sym__r_sqt_str_end,
    ACTIONS(1739), 1,
      sym__br_sqt_str_end,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    STATE(782), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15396] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1741), 1,
      sym__r_sqt_str_end,
    ACTIONS(1743), 1,
      sym__br_sqt_str_end,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    STATE(764), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15421] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1739), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(782), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15444] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1745), 1,
      sym__r_sqt_str_end,
    ACTIONS(1747), 1,
      sym__br_sqt_str_end,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1550), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    STATE(752), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [15469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      sym__r_flw_njv_bgn,
    STATE(922), 1,
      sym__r_flw_njl_ann_par,
    STATE(1335), 1,
      sym__r_sgl_flw_njl_ann_par,
    ACTIONS(1749), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    ACTIONS(1752), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
  [15491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1756), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [15523] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1355), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(557), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [15555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1355), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1359), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1363), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(559), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [15606] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1363), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [15638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [15651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [15664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [15677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [15690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1760), 2,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    STATE(552), 2,
      sym__flw_seq_dat_rpt,
      aux_sym__r_flw_seq_dat_repeat1,
    ACTIONS(1758), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [15707] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1763), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1765), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(584), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1767), 1,
      sym__r_flw_jsv_bgn,
    STATE(950), 1,
      sym__r_flw_jsl_ann_par,
    ACTIONS(1752), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [15743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1769), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
    ACTIONS(1023), 4,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_flw_jsv_bgn,
  [15758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1772), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
    ACTIONS(1775), 4,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_flw_njv_bgn,
  [15773] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1777), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1779), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1777), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(561), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1781), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1783), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1781), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(562), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1785), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1787), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [15900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1775), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [15913] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1794), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1791), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1797), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [15932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [15945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1801), 2,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    STATE(567), 2,
      sym__flw_map_dat_rpt,
      aux_sym__r_flw_map_dat_repeat1,
    ACTIONS(1799), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [15962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [15975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
    ACTIONS(1027), 4,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_flw_jsv_bgn,
  [15990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1807), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
    ACTIONS(1031), 4,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_flw_jsv_bgn,
  [16031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1291), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(587), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1810), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
    ACTIONS(1039), 4,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_flw_jsv_bgn,
  [16091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1291), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16110] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1307), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1309), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(589), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1309), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1813), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1815), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1813), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(585), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16212] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1817), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1819), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(586), 1,
      aux_sym__br_mtl_sqt_ctn_repeat1,
    ACTIONS(1821), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1824), 4,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
  [16267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1826), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1828), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1826), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(591), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16305] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1830), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16324] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1832), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1830), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(592), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16343] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1834), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1836), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [16394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1197), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1377), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(617), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1838), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
    ACTIONS(987), 4,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_flw_jsv_bgn,
  [16571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1377), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1295), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1297), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(619), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16609] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1297), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1841), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
    ACTIONS(995), 4,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
      sym__br_flw_jsv_bgn,
  [16656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(999), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(586), 1,
      aux_sym__br_mtl_sqt_ctn_repeat1,
    ACTIONS(1844), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1846), 4,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
  [16699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(615), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(1848), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1851), 4,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
  [16716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1853), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1855), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1853), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(621), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16767] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1857), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16786] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1857), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(622), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16805] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1861), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1863), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1149), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1213), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1265), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1269), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(650), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [16901] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1269), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16920] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1273), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1277), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(652), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1303), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16958] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1277), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1467), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(641), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [16996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [17009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1467), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17028] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1381), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1383), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(643), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1383), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [17079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1865), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [17092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [17105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [17118] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1509), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1513), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(582), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1869), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17156] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1869), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(539), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1873), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17194] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1875), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1873), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(646), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1767), 1,
      sym__r_flw_jsv_bgn,
    STATE(952), 1,
      sym__r_flw_jsl_ann_par,
    ACTIONS(1877), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [17230] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1879), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17249] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1513), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(614), 1,
      aux_sym__br_mtl_sqt_ctn_repeat1,
    ACTIONS(1881), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
    ACTIONS(1883), 4,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
  [17285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1887), 2,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    STATE(660), 2,
      sym__flw_seq_dat_rpt,
      aux_sym__r_flw_seq_dat_repeat1,
    ACTIONS(1885), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [17302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1889), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1889), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(654), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17340] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1893), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1895), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1893), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(656), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17378] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1897), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1501), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1505), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(664), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1899), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17435] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1505), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1423), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(666), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1423), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 2,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    STATE(552), 2,
      sym__flw_seq_dat_rpt,
      aux_sym__r_flw_seq_dat_repeat1,
    ACTIONS(559), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [17509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1905), 2,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    STATE(663), 2,
      sym__flw_seq_dat_rpt,
      aux_sym__r_flw_seq_dat_repeat1,
    ACTIONS(1903), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [17526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [17539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 2,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    STATE(552), 2,
      sym__flw_seq_dat_rpt,
      aux_sym__r_flw_seq_dat_repeat1,
    ACTIONS(561), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [17556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1909), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1911), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1909), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(668), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17594] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1913), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1913), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(669), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1917), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1919), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1923), 2,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    STATE(673), 2,
      sym__flw_map_dat_rpt,
      aux_sym__r_flw_map_dat_repeat1,
    ACTIONS(1921), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [17687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1927), 2,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    STATE(675), 2,
      sym__flw_map_dat_rpt,
      aux_sym__r_flw_map_dat_repeat1,
    ACTIONS(1925), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [17704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(458), 1,
      sym__r_flw_njv_bgn,
    STATE(923), 1,
      sym__r_flw_njl_ann_par,
    ACTIONS(1877), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [17721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 2,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    STATE(567), 2,
      sym__flw_map_dat_rpt,
      aux_sym__r_flw_map_dat_repeat1,
    ACTIONS(551), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [17738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(458), 1,
      sym__r_flw_njv_bgn,
    STATE(921), 1,
      sym__r_flw_njl_ann_par,
    ACTIONS(1752), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [17755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 2,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
    STATE(567), 2,
      sym__flw_map_dat_rpt,
      aux_sym__r_flw_map_dat_repeat1,
    ACTIONS(555), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [17772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1301), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1303), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(685), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [17804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1253), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(686), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [17836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1253), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17855] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1453), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1455), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(688), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1455), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1937), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [17906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1939), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [17919] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1765), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17938] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1941), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17957] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1941), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(690), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1945), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [17995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1945), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(691), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [18014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1949), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [18033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      sym__br_dqt_esc_nwl,
    ACTIONS(1239), 2,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_seq,
    ACTIONS(1951), 2,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
    STATE(565), 2,
      sym__br_mtl_dqt_ctn,
      aux_sym__r_dqt_str_repeat1,
  [18052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1055), 7,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [18065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1729), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1955), 1,
      sym__r_dir_rsv_prm,
    STATE(758), 1,
      aux_sym__s_dir_rsv_repeat1,
    ACTIONS(1953), 4,
      sym__s_dir_yml_bgn,
      sym__s_dir_tag_bgn,
      sym__s_dir_rsv_bgn,
      sym__s_drs_end,
  [18097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [18109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [18121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1937), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [18133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1959), 1,
      sym__r_dir_rsv_prm,
    STATE(698), 1,
      aux_sym__s_dir_rsv_repeat1,
    ACTIONS(1957), 4,
      sym__s_dir_yml_bgn,
      sym__s_dir_tag_bgn,
      sym__s_dir_rsv_bgn,
      sym__s_drs_end,
  [18149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1939), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [18161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1865), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [18173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [18185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1149), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [18293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
    ACTIONS(1769), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
    ACTIONS(1804), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
    ACTIONS(1807), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
    ACTIONS(1810), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [18457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1197), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
    ACTIONS(1838), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
    ACTIONS(1841), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(999), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1962), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1213), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [18729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [18741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1772), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
    ACTIONS(1775), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
  [18755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [18767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1775), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [18779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1964), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1966), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1969), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1971), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [18839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1637), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18855] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1554), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1574), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1747), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 1,
      sym__r_dir_rsv_prm,
    STATE(698), 1,
      aux_sym__s_dir_rsv_repeat1,
    ACTIONS(1973), 4,
      sym__s_dir_yml_bgn,
      sym__s_dir_tag_bgn,
      sym__s_dir_rsv_bgn,
      sym__s_drs_end,
  [18919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1977), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1979), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1598), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1743), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1981), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [18999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1983), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1658), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1627), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1985), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1987), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1580), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1705), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1989), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1991), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1641), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1596), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1993), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1995), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1703), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1997), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1999), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1739), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(1600), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 2,
      sym__br_sqt_str_ctn,
      sym__br_sqt_esc_sqt,
    ACTIONS(2001), 2,
      sym__r_sqt_str_end,
      sym__br_sqt_str_end,
    STATE(751), 2,
      sym__br_mtl_sqt_ctn,
      aux_sym__r_sqt_str_repeat1,
  [19303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1055), 6,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [19315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1772), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    ACTIONS(1775), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
  [19339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2007), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2009), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2007), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1775), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1608), 5,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_nwl,
      sym__br_dqt_esc_seq,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
  [19438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2009), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1937), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1939), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2013), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1772), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    ACTIONS(1775), 3,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
  [19517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1775), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19550] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(305), 1,
      sym__br_flw_njv_bgn,
    STATE(922), 1,
      sym__r_flw_njl_ann_par,
    STATE(949), 1,
      sym__br_flw_njl_ann_par,
    STATE(1335), 1,
      sym__r_sgl_flw_njl_ann_par,
  [19569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2019), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1865), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1149), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1769), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    ACTIONS(1023), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
  [19813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    ACTIONS(1027), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
  [19848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1807), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    ACTIONS(1031), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
  [19883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1810), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    ACTIONS(1039), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
  [19918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1197), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [19995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1838), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    ACTIONS(987), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
  [20107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1841), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    ACTIONS(995), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
  [20131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(999), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1055), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1213), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1149), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1769), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    ACTIONS(1023), 3,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
  [20364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    ACTIONS(1027), 3,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
  [20388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1807), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    ACTIONS(1031), 3,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
  [20423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1810), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    ACTIONS(1039), 3,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
  [20458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2037), 5,
      sym__br_dqt_str_ctn,
      sym__br_dqt_esc_nwl,
      sym__br_dqt_esc_seq,
      sym__r_dqt_str_end,
      sym__br_dqt_str_end,
  [20513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1197), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1838), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    ACTIONS(987), 3,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
  [20658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1841), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    ACTIONS(995), 3,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
  [20682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(999), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1055), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1213), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      sym__r_blk_imp_bgn,
    STATE(332), 1,
      sym__blk_imp_itm_tal,
    ACTIONS(2039), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [20829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      sym__r_blk_imp_bgn,
    STATE(334), 1,
      sym__blk_imp_itm_tal,
    ACTIONS(2039), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [20844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2041), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
    ACTIONS(2044), 3,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__br_flw_sep_bgn,
  [20857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2046), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2050), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20945] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(223), 1,
      sym__br_flw_njv_bgn,
    STATE(793), 1,
      sym__br_flw_njl_ann_par,
    STATE(943), 1,
      sym__r_flw_njl_ann_par,
    STATE(1337), 1,
      sym__r_sgl_flw_njl_ann_par,
  [20964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1865), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [20997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2019), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2041), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
    ACTIONS(2044), 3,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__br_flw_sep_bgn,
  [21043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2046), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2050), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      sym__r_blk_imp_bgn,
    STATE(334), 1,
      sym__blk_imp_itm_tal,
    ACTIONS(2052), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [21091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2050), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2050), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1937), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1939), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 5,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 5,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__br_flw_sep_bgn,
  [21344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2054), 1,
      sym__r_flw_seq_end,
    ACTIONS(2056), 1,
      sym__r_flw_sep_bgn,
    STATE(963), 2,
      sym__sgl_flw_col_dat_rpt,
      aux_sym__r_sgl_flw_col_dat_repeat1,
  [21358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2059), 1,
      sym__r_flw_map_end,
    ACTIONS(2061), 1,
      sym__r_flw_sep_bgn,
    STATE(1012), 2,
      sym__sgl_flw_col_dat_rpt,
      aux_sym__r_sgl_flw_col_dat_repeat1,
  [21372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2063), 1,
      sym__bl,
    STATE(973), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [21386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2065), 1,
      sym__bl,
    STATE(974), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [21400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      sym__r_blk_imp_bgn,
    STATE(332), 1,
      sym__blk_imp_itm_tal,
    ACTIONS(973), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [21414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2067), 4,
      sym__s_dir_yml_bgn,
      sym__s_dir_tag_bgn,
      sym__s_dir_rsv_bgn,
      sym__s_drs_end,
  [21424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      sym__r_blk_imp_bgn,
    STATE(334), 1,
      sym__blk_imp_itm_tal,
    ACTIONS(973), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [21438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2071), 1,
      sym__r_dqt_str_end,
    STATE(1014), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2069), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [21452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2075), 1,
      sym__r_dqt_str_end,
    STATE(977), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2073), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [21466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2079), 1,
      sym__r_sqt_str_end,
    STATE(978), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2077), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [21480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2081), 1,
      sym__bl,
    STATE(979), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [21494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2083), 1,
      sym__bl,
    STATE(979), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [21508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2087), 1,
      sym__r_sqt_str_end,
    STATE(1029), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2085), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [21522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      sym__r_flw_njv_bgn,
    STATE(1226), 1,
      sym__r_sgl_flw_njl_ann_par,
    ACTIONS(2089), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [21536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2093), 1,
      sym__r_dqt_str_end,
    STATE(1023), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2091), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [21550] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2097), 1,
      sym__r_sqt_str_end,
    STATE(1024), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2095), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [21564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2099), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2102), 1,
      sym__bl,
    STATE(979), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [21578] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(305), 1,
      sym__br_flw_njv_bgn,
    ACTIONS(458), 1,
      sym__r_flw_njv_bgn,
    STATE(921), 1,
      sym__r_flw_njl_ann_par,
    STATE(944), 1,
      sym__br_flw_njl_ann_par,
  [21594] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(223), 1,
      sym__br_flw_njv_bgn,
    ACTIONS(434), 1,
      sym__r_flw_njv_bgn,
    STATE(937), 1,
      sym__r_flw_njl_ann_par,
    STATE(956), 1,
      sym__br_flw_njl_ann_par,
  [21610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 1,
      sym__r_dqt_str_end,
    STATE(993), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2104), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [21624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2110), 1,
      sym__r_sqt_str_end,
    STATE(994), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2108), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [21638] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(223), 1,
      sym__br_flw_njv_bgn,
    ACTIONS(434), 1,
      sym__r_flw_njv_bgn,
    STATE(938), 1,
      sym__r_flw_njl_ann_par,
    STATE(961), 1,
      sym__br_flw_njl_ann_par,
  [21654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(999), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [21666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2059), 1,
      sym__r_flw_seq_end,
    ACTIONS(2112), 1,
      sym__r_flw_sep_bgn,
    STATE(1016), 2,
      sym__sgl_flw_col_dat_rpt,
      aux_sym__r_sgl_flw_col_dat_repeat1,
  [21680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(995), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [21692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1027), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [21704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(989), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(987), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [21716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(993), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(991), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [21728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(305), 1,
      sym__br_flw_njv_bgn,
    ACTIONS(458), 1,
      sym__r_flw_njv_bgn,
    STATE(923), 1,
      sym__r_flw_njl_ann_par,
    STATE(945), 1,
      sym__br_flw_njl_ann_par,
  [21744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2114), 1,
      sym__r_dqt_str_end,
    STATE(1023), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2091), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [21758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2116), 1,
      sym__r_dqt_str_end,
    STATE(1023), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2091), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [21772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2118), 1,
      sym__r_sqt_str_end,
    STATE(1024), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2095), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [21786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2120), 1,
      sym__bl,
    STATE(979), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [21800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1031), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [21812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(983), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1019), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [21824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2122), 1,
      sym__bl,
    STATE(979), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [21838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 4,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__r_blk_imp_bgn,
  [21848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1035), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [21860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 4,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__r_blk_imp_bgn,
  [21870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2124), 1,
      sym__bl,
    STATE(1022), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [21884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2126), 1,
      sym__bl,
    STATE(1026), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [21898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2128), 1,
      sym__bl,
    STATE(998), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [21912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1039), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [21924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 1,
      sym__r_dqt_str_end,
    STATE(1023), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2091), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [21938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2132), 1,
      sym__r_sqt_str_end,
    STATE(1024), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2095), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [21952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1045), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1043), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [21964] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1767), 1,
      sym__r_flw_jsv_bgn,
    ACTIONS(2134), 1,
      sym__br_flw_jsv_bgn,
    STATE(946), 1,
      sym__br_flw_jsl_ann_par,
    STATE(950), 1,
      sym__r_flw_jsl_ann_par,
  [21980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      sym__r_dqt_str_end,
    STATE(1020), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2136), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [21994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2142), 1,
      sym__r_sqt_str_end,
    STATE(1021), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2140), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [22008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(841), 1,
      sym__r_flw_map_end,
    ACTIONS(2144), 1,
      sym__r_flw_sep_bgn,
    STATE(1034), 2,
      sym__sgl_flw_col_dat_rpt,
      aux_sym__r_sgl_flw_col_dat_repeat1,
  [22022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2146), 1,
      sym__r_sqt_str_end,
    STATE(1024), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2095), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [22036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym__r_dqt_str_end,
    STATE(1023), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2091), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [22050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2150), 4,
      sym__s_dir_yml_bgn,
      sym__s_dir_tag_bgn,
      sym__s_dir_rsv_bgn,
      sym__s_drs_end,
  [22060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(841), 1,
      sym__r_flw_seq_end,
    ACTIONS(2152), 1,
      sym__r_flw_sep_bgn,
    STATE(963), 2,
      sym__sgl_flw_col_dat_rpt,
      aux_sym__r_sgl_flw_col_dat_repeat1,
  [22074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2156), 1,
      sym__r_dqt_str_end,
    STATE(1006), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2154), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [22088] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1767), 1,
      sym__r_flw_jsv_bgn,
    ACTIONS(2134), 1,
      sym__br_flw_jsv_bgn,
    STATE(947), 1,
      sym__br_flw_jsl_ann_par,
    STATE(952), 1,
      sym__r_flw_jsl_ann_par,
  [22104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2160), 1,
      sym__r_sqt_str_end,
    STATE(1007), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2158), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [22118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2162), 1,
      sym__r_dqt_str_end,
    STATE(1023), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2091), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [22132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      sym__r_sqt_str_end,
    STATE(1024), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2095), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [22146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2166), 1,
      sym__bl,
    STATE(979), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [22160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 1,
      sym__r_dqt_str_end,
    STATE(1023), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2168), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [22174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1851), 1,
      sym__r_sqt_str_end,
    STATE(1024), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2171), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [22188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2174), 1,
      sym__r_flw_jsv_bgn,
    STATE(1235), 1,
      sym__r_sgl_flw_jsl_ann_par,
    ACTIONS(2089), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [22202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2176), 1,
      sym__bl,
    STATE(979), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [22216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      sym__r_dqt_str_end,
    STATE(1032), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2178), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [22230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2184), 1,
      sym__r_sqt_str_end,
    STATE(1033), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2182), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [22244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 1,
      sym__r_sqt_str_end,
    STATE(1024), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2095), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [22258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 4,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__r_blk_imp_bgn,
  [22268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 1,
      sym__r_flw_jsv_bgn,
    ACTIONS(1604), 1,
      sym__br_flw_jsv_bgn,
    STATE(787), 1,
      sym__br_flw_jsl_ann_par,
    STATE(940), 1,
      sym__r_flw_jsl_ann_par,
  [22284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2188), 1,
      sym__r_dqt_str_end,
    STATE(1023), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2091), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [22298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      sym__r_sqt_str_end,
    STATE(1024), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2095), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [22312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2054), 1,
      sym__r_flw_map_end,
    ACTIONS(2192), 1,
      sym__r_flw_sep_bgn,
    STATE(1034), 2,
      sym__sgl_flw_col_dat_rpt,
      aux_sym__r_sgl_flw_col_dat_repeat1,
  [22326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 1,
      sym__r_flw_jsv_bgn,
    ACTIONS(1604), 1,
      sym__br_flw_jsv_bgn,
    STATE(788), 1,
      sym__br_flw_jsl_ann_par,
    STATE(941), 1,
      sym__r_flw_jsl_ann_par,
  [22342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1013), 4,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__r_blk_imp_bgn,
  [22352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(983), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(981), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22364] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(773), 1,
      sym__r_flw_njv_bgn,
    STATE(1409), 1,
      sym__r_sgl_flw_njl_ann_par,
    ACTIONS(2089), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [22378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 4,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__r_blk_imp_bgn,
  [22388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(983), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(985), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2195), 1,
      sym__bl,
    STATE(979), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [22414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2199), 1,
      sym__r_dqt_str_end,
    STATE(992), 1,
      aux_sym__r_sgl_dqt_ctn,
    ACTIONS(2197), 2,
      sym__r_dqt_str_ctn,
      sym__r_dqt_esc_seq,
  [22428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      sym__r_sqt_str_end,
    STATE(1013), 1,
      aux_sym__r_sgl_sqt_ctn,
    ACTIONS(2201), 2,
      sym__r_sqt_str_ctn,
      sym__r_sqt_esc_sqt,
  [22442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 4,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
      sym__r_blk_imp_bgn,
  [22452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      sym__r_flw_jsv_bgn,
    STATE(1332), 1,
      sym__r_sgl_flw_jsl_ann_par,
    ACTIONS(2089), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [22466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1015), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1025), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1023), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      sym__b_blk_seq_bgn,
    ACTIONS(2207), 1,
      sym__bl,
    STATE(995), 2,
      sym__b_blk_seq_itm,
      aux_sym__r_blk_seq_repeat1,
  [22504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2209), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [22522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [22531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [22540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [22549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [22558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1075), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2222), 1,
      sym__bl,
    STATE(1056), 1,
      aux_sym__r_blk_str_repeat1,
  [22580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2224), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [22598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [22607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [22625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [22634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [22652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2234), 1,
      sym__bl,
    STATE(1056), 1,
      aux_sym__r_blk_str_repeat1,
  [22674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [22683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [22692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1051), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(989), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [22728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [22746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [22773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2238), 1,
      sym__bl,
    STATE(1089), 1,
      aux_sym__r_blk_str_repeat1,
  [22786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 3,
      sym__b_blk_seq_bgn,
      sym__r_blk_imp_bgn,
      sym__bl,
  [22795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2240), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2242), 1,
      sym__bl,
    STATE(1066), 1,
      aux_sym__r_blk_str_repeat1,
  [22817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [22844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2246), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1171), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2248), 1,
      sym__bl,
    STATE(1056), 1,
      aux_sym__r_blk_str_repeat1,
  [22893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(999), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1179), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1055), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1019), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1213), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [22965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [22974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [22983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [22992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [23001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1013), 3,
      sym__b_blk_seq_bgn,
      sym__r_blk_imp_bgn,
      sym__bl,
  [23055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2252), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2254), 1,
      sym__bl,
    STATE(1120), 1,
      aux_sym__r_blk_str_repeat1,
  [23095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2258), 1,
      sym__bl,
    STATE(1121), 1,
      aux_sym__r_blk_str_repeat1,
  [23108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1149), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1015), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(983), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1019), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2266), 1,
      sym__bl,
    STATE(1056), 1,
      aux_sym__r_blk_str_repeat1,
  [23188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2268), 1,
      sym__bl,
    STATE(1056), 1,
      aux_sym__r_blk_str_repeat1,
  [23201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 3,
      sym__b_blk_seq_bgn,
      sym__r_blk_imp_bgn,
      sym__bl,
  [23210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2272), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [23228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [23237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1025), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1023), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [23302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 3,
      sym__b_blk_seq_bgn,
      sym__r_blk_imp_bgn,
      sym__bl,
  [23347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [23356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2209), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2280), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2282), 1,
      sym__bl,
    STATE(1147), 1,
      aux_sym__r_blk_str_repeat1,
  [23378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2286), 1,
      sym__bl,
    STATE(1148), 1,
      aux_sym__r_blk_str_repeat1,
  [23391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1027), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1031), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2290), 1,
      sym__bl,
    STATE(1056), 1,
      aux_sym__r_blk_str_repeat1,
  [23453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      sym__br_blk_str_ctn,
    ACTIONS(2292), 1,
      sym__bl,
    STATE(1056), 1,
      aux_sym__r_blk_str_repeat1,
  [23466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1035), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1039), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2294), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [23497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [23506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1045), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(1043), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1137), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2300), 1,
      sym__s_doc_end,
    ACTIONS(2298), 2,
      sym__eof,
      sym__s_drs_end,
  [23537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 3,
      sym__b_blk_seq_bgn,
      sym__r_blk_imp_bgn,
      sym__bl,
  [23564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(983), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(981), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(983), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(985), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [23631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [23640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2308), 1,
      sym__s_doc_end,
    ACTIONS(2306), 2,
      sym__eof,
      sym__s_drs_end,
  [23651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2310), 1,
      sym__s_doc_end,
    ACTIONS(2306), 2,
      sym__eof,
      sym__s_drs_end,
  [23662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2052), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1139), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [23689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2312), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [23698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2314), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [23707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1141), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1205), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(989), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(987), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(993), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(991), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(995), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2316), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [23794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [23803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      sym__r_blk_imp_bgn,
    ACTIONS(999), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [23814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1195), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_njv_bgn,
  [23841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1197), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [23895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2322), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [23904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(989), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 3,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [23922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 3,
      sym__b_blk_seq_bgn,
      sym__r_blk_imp_bgn,
      sym__bl,
  [23940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1207), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1209), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1211), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [23994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [24003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [24012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [24021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [24030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [24039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [24048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2324), 3,
      sym__r_flw_seq_end,
      sym__br_flw_seq_end,
      sym__b_flw_seq_end,
  [24057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2326), 3,
      sym__r_flw_map_end,
      sym__br_flw_map_end,
      sym__b_flw_map_end,
  [24066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [24075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 3,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
      sym__r_flw_jsv_bgn,
  [24084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1187), 3,
      sym__eof,
      sym__s_drs_end,
      sym__s_doc_end,
  [24093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [24101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1019), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1775), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [24149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2328), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      sym__r_blk_imp_bgn,
    STATE(313), 1,
      sym__blk_imp_itm_tal,
  [24191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1171), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      sym__r_blk_imp_bgn,
    STATE(314), 1,
      sym__blk_imp_itm_tal,
  [24273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(773), 1,
      sym__r_flw_njv_bgn,
    STATE(1409), 1,
      sym__r_sgl_flw_njl_ann_par,
  [24291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2328), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      sym__r_flw_jsv_bgn,
    STATE(1332), 1,
      sym__r_sgl_flw_jsl_ann_par,
  [24317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1772), 1,
      sym__r_flw_njv_bgn,
    ACTIONS(1775), 1,
      sym__br_flw_njv_bgn,
  [24327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2174), 1,
      sym__r_flw_jsv_bgn,
    STATE(1235), 1,
      sym__r_sgl_flw_jsl_ann_par,
  [24337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [24353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [24369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2328), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2328), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [24417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2209), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1937), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [24481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1939), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [24489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2336), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2338), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(989), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [24561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1195), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1197), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1149), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1207), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1209), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1211), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2340), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [24729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1179), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      sym__r_blk_imp_bgn,
    STATE(304), 1,
      sym__blk_imp_itm_tal,
  [24779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1075), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2340), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [24891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 1,
      sym__br_flw_jsv_bgn,
    ACTIONS(1769), 1,
      sym__r_flw_jsv_bgn,
  [24901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [24909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2209), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2344), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      sym__br_flw_jsv_bgn,
    ACTIONS(1804), 1,
      sym__r_flw_jsv_bgn,
  [24951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [24967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [24983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 1,
      sym__br_flw_jsv_bgn,
    ACTIONS(1807), 1,
      sym__r_flw_jsv_bgn,
  [24993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [25001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2346), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [25009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1031), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 1,
      sym__br_flw_jsv_bgn,
    ACTIONS(1810), 1,
      sym__r_flw_jsv_bgn,
  [25035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [25075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1197), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [25155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [25179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [25211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(999), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      sym__r_flw_njv_bgn,
    STATE(1226), 1,
      sym__r_sgl_flw_njl_ann_par,
  [25269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1187), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1205), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1051), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 1,
      sym__br_flw_jsv_bgn,
    ACTIONS(1838), 1,
      sym__r_flw_jsv_bgn,
  [25359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2346), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 1,
      sym__br_flw_jsv_bgn,
    ACTIONS(1841), 1,
      sym__r_flw_jsv_bgn,
  [25393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1055), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1213), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2344), 2,
      sym__r_flw_seq_end,
      sym__r_flw_sep_bgn,
  [25433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(999), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1137), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1139), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1141), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1149), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1055), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1865), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [25585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1213), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 2,
      sym__r_flw_njv_bgn,
      sym__br_flw_njv_bgn,
  [25601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(989), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 2,
      sym__b_blk_seq_bgn,
      sym__bl,
  [25657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 2,
      sym__r_flw_jsv_bgn,
      sym__br_flw_jsv_bgn,
  [25665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 2,
      sym__r_flw_map_end,
      sym__r_flw_sep_bgn,
  [25673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2348), 1,
      sym__r_acr_ctn,
  [25680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 1,
      sym__r_blk_imp_bgn,
  [25687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 1,
      sym__r_blk_imp_bgn,
  [25694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 1,
      sym__r_blk_imp_bgn,
  [25701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      sym__r_flw_jsv_bgn,
  [25708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      sym__r_blk_imp_bgn,
  [25715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2354), 1,
      sym__r_blk_imp_bgn,
  [25722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 1,
      sym__r_blk_imp_bgn,
  [25729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2358), 1,
      sym__r_blk_imp_bgn,
  [25736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2360), 1,
      sym__r_blk_imp_bgn,
  [25743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 1,
      sym__r_blk_imp_bgn,
  [25750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(989), 1,
      sym__r_blk_imp_bgn,
  [25757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      sym__r_flw_jsv_bgn,
  [25764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2209), 1,
      sym__r_blk_imp_bgn,
  [25771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 1,
      sym__r_blk_imp_bgn,
  [25778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 1,
      sym__r_blk_imp_bgn,
  [25785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      ts_builtin_sym_end,
  [25792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      sym__r_dir_yml_ver,
  [25799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2366), 1,
      sym__eof,
  [25806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2368), 1,
      ts_builtin_sym_end,
  [25813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2370), 1,
      sym__r_acr_ctn,
  [25820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2372), 1,
      sym__r_acr_ctn,
  [25827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      sym__r_als_ctn,
  [25834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2376), 1,
      sym__r_acr_ctn,
  [25841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2378), 1,
      sym__r_acr_ctn,
  [25848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2380), 1,
      sym__r_als_ctn,
  [25855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2382), 1,
      sym__r_als_ctn,
  [25862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2384), 1,
      sym__r_als_ctn,
  [25869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2386), 1,
      sym__r_acr_ctn,
  [25876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2388), 1,
      sym__r_acr_ctn,
  [25883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2390), 1,
      sym__r_als_ctn,
  [25890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2392), 1,
      sym__r_als_ctn,
  [25897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 1,
      sym__r_blk_imp_bgn,
  [25904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2394), 1,
      sym__r_blk_imp_bgn,
  [25911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 1,
      sym__r_blk_imp_bgn,
  [25918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 1,
      sym__r_blk_imp_bgn,
  [25925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 1,
      sym__r_blk_imp_bgn,
  [25932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2402), 1,
      sym__r_flw_seq_end,
  [25939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 1,
      sym__r_flw_jsv_bgn,
  [25946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 1,
      sym__r_flw_map_end,
  [25953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      sym__r_blk_imp_bgn,
  [25960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 1,
      sym__r_flw_jsv_bgn,
  [25967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2408), 1,
      ts_builtin_sym_end,
  [25974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 1,
      sym__r_blk_imp_bgn,
  [25981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      sym__r_dir_tag_pfx,
  [25988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 1,
      sym__r_flw_njv_bgn,
  [25995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2412), 1,
      sym__eof,
  [26002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 1,
      sym__r_flw_seq_end,
  [26009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 1,
      sym__r_flw_jsv_bgn,
  [26016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      sym__r_flw_seq_end,
  [26023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 1,
      sym__r_flw_map_end,
  [26030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 1,
      sym__r_blk_imp_bgn,
  [26037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      sym__r_flw_njv_bgn,
  [26044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 1,
      sym__r_flw_jsv_bgn,
  [26051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      sym__r_blk_imp_bgn,
  [26058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      ts_builtin_sym_end,
  [26065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      sym__r_flw_jsv_bgn,
  [26072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 1,
      sym__r_flw_jsv_bgn,
  [26079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2426), 1,
      sym__r_flw_seq_end,
  [26086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      sym__r_flw_jsv_bgn,
  [26093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      sym__r_flw_njv_bgn,
  [26100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      sym__r_flw_map_end,
  [26107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2430), 1,
      sym__r_acr_ctn,
  [26114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2432), 1,
      sym__r_flw_seq_end,
  [26121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      sym__r_als_ctn,
  [26128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 1,
      sym__r_flw_njv_bgn,
  [26135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      sym__r_flw_map_end,
  [26142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 1,
      sym__r_blk_imp_bgn,
  [26149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 1,
      sym__r_acr_ctn,
  [26156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      sym__r_acr_ctn,
  [26163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 1,
      sym__r_als_ctn,
  [26170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 1,
      sym__r_als_ctn,
  [26177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 1,
      sym__r_flw_jsv_bgn,
  [26184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      sym__r_acr_ctn,
  [26191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2448), 1,
      sym__r_acr_ctn,
  [26198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      sym__r_blk_imp_bgn,
  [26205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      sym__r_als_ctn,
  [26212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1021), 1,
      sym__r_blk_imp_bgn,
  [26219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 1,
      sym__r_als_ctn,
  [26226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 1,
      sym__eof,
  [26233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 1,
      sym__eof,
  [26240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2460), 1,
      sym__r_blk_imp_bgn,
  [26247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2462), 1,
      sym__r_blk_imp_bgn,
  [26254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2464), 1,
      sym__r_blk_imp_bgn,
  [26261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 1,
      sym__r_als_ctn,
  [26268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(989), 1,
      sym__r_flw_jsv_bgn,
  [26275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2468), 1,
      sym__r_blk_imp_bgn,
  [26282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 1,
      sym__r_blk_imp_bgn,
  [26289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      sym__r_acr_ctn,
  [26296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 1,
      sym__r_blk_imp_bgn,
  [26303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 1,
      sym__r_blk_imp_bgn,
  [26310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      sym__r_blk_imp_bgn,
  [26317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2476), 1,
      sym__r_blk_imp_bgn,
  [26324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 1,
      sym__r_acr_ctn,
  [26331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2480), 1,
      sym__r_als_ctn,
  [26338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      sym__r_als_ctn,
  [26345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 1,
      sym__r_flw_jsv_bgn,
  [26352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 1,
      sym__r_flw_jsv_bgn,
  [26359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 1,
      sym__r_als_ctn,
  [26366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2209), 1,
      sym__r_flw_jsv_bgn,
  [26373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      sym__r_acr_ctn,
  [26380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      sym__r_acr_ctn,
  [26387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 1,
      sym__r_als_ctn,
  [26394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 1,
      sym__r_als_ctn,
  [26401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2494), 1,
      sym__r_blk_imp_bgn,
  [26408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2496), 1,
      sym__r_dir_tag_hdl,
  [26415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2498), 1,
      sym__r_flw_map_end,
  [26422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      sym__r_blk_imp_bgn,
  [26429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 1,
      sym__r_flw_njv_bgn,
  [26436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 1,
      sym__r_acr_ctn,
  [26443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2502), 1,
      sym__r_blk_imp_bgn,
  [26450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      sym__r_blk_imp_bgn,
  [26457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      sym__r_blk_imp_bgn,
  [26464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      sym__r_blk_imp_bgn,
  [26471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      sym__r_blk_imp_bgn,
  [26478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 1,
      sym__r_flw_seq_end,
  [26485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2506), 1,
      sym__eof,
  [26492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 1,
      sym__r_flw_map_end,
  [26499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 1,
      sym__r_blk_imp_bgn,
  [26506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 1,
      sym__r_blk_imp_bgn,
  [26513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2512), 1,
      sym__r_blk_imp_bgn,
  [26520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 1,
      sym__r_blk_imp_bgn,
  [26527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2516), 1,
      sym__r_blk_imp_bgn,
  [26534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2518), 1,
      sym__r_blk_imp_bgn,
  [26541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 1,
      sym__r_flw_jsv_bgn,
  [26548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      sym__r_flw_jsv_bgn,
  [26555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      sym__r_blk_imp_bgn,
  [26562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 1,
      sym__r_blk_imp_bgn,
  [26569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 1,
      sym__r_acr_ctn,
  [26576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym__r_acr_ctn,
  [26583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2528), 1,
      sym__r_als_ctn,
  [26590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2530), 1,
      sym__r_als_ctn,
  [26597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2532), 1,
      sym__r_acr_ctn,
  [26604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2534), 1,
      sym__r_acr_ctn,
  [26611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 1,
      sym__r_als_ctn,
  [26618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      sym__r_acr_ctn,
  [26625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 1,
      sym__r_acr_ctn,
  [26632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      sym__r_als_ctn,
  [26639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      sym__r_acr_ctn,
  [26646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      sym__r_acr_ctn,
  [26653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      sym__r_als_ctn,
  [26660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 1,
      sym__r_blk_imp_bgn,
  [26667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2552), 1,
      sym__r_acr_ctn,
  [26674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      sym__r_als_ctn,
  [26681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2556), 1,
      sym__r_acr_ctn,
  [26688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2558), 1,
      sym__r_acr_ctn,
  [26695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2560), 1,
      sym__r_als_ctn,
  [26702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      sym__r_acr_ctn,
  [26709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      sym__r_acr_ctn,
  [26716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2566), 1,
      sym__r_als_ctn,
  [26723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2568), 1,
      sym__r_acr_ctn,
  [26730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      sym__r_acr_ctn,
  [26737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 1,
      sym__r_acr_ctn,
  [26744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2574), 1,
      sym__r_acr_ctn,
  [26751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym__r_acr_ctn,
  [26758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 1,
      sym__r_acr_ctn,
  [26765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 1,
      sym__r_acr_ctn,
  [26772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 1,
      sym__r_acr_ctn,
  [26779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      sym__r_acr_ctn,
  [26786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      sym__r_acr_ctn,
  [26793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      sym__r_acr_ctn,
  [26800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2590), 1,
      sym__r_acr_ctn,
  [26807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      sym__r_acr_ctn,
  [26814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 1,
      sym__r_acr_ctn,
  [26821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      sym__r_acr_ctn,
  [26828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 1,
      sym__r_acr_ctn,
  [26835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2600), 1,
      sym__r_acr_ctn,
  [26842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 1,
      sym__r_acr_ctn,
  [26849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 1,
      sym__r_acr_ctn,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(96)] = 0,
  [SMALL_STATE(97)] = 68,
  [SMALL_STATE(98)] = 136,
  [SMALL_STATE(99)] = 197,
  [SMALL_STATE(100)] = 251,
  [SMALL_STATE(101)] = 313,
  [SMALL_STATE(102)] = 375,
  [SMALL_STATE(103)] = 429,
  [SMALL_STATE(104)] = 486,
  [SMALL_STATE(105)] = 543,
  [SMALL_STATE(106)] = 600,
  [SMALL_STATE(107)] = 653,
  [SMALL_STATE(108)] = 706,
  [SMALL_STATE(109)] = 758,
  [SMALL_STATE(110)] = 810,
  [SMALL_STATE(111)] = 862,
  [SMALL_STATE(112)] = 914,
  [SMALL_STATE(113)] = 993,
  [SMALL_STATE(114)] = 1072,
  [SMALL_STATE(115)] = 1150,
  [SMALL_STATE(116)] = 1228,
  [SMALL_STATE(117)] = 1305,
  [SMALL_STATE(118)] = 1360,
  [SMALL_STATE(119)] = 1437,
  [SMALL_STATE(120)] = 1514,
  [SMALL_STATE(121)] = 1591,
  [SMALL_STATE(122)] = 1646,
  [SMALL_STATE(123)] = 1736,
  [SMALL_STATE(124)] = 1826,
  [SMALL_STATE(125)] = 1880,
  [SMALL_STATE(126)] = 1934,
  [SMALL_STATE(127)] = 2024,
  [SMALL_STATE(128)] = 2114,
  [SMALL_STATE(129)] = 2208,
  [SMALL_STATE(130)] = 2302,
  [SMALL_STATE(131)] = 2392,
  [SMALL_STATE(132)] = 2482,
  [SMALL_STATE(133)] = 2572,
  [SMALL_STATE(134)] = 2662,
  [SMALL_STATE(135)] = 2710,
  [SMALL_STATE(136)] = 2804,
  [SMALL_STATE(137)] = 2898,
  [SMALL_STATE(138)] = 2992,
  [SMALL_STATE(139)] = 3082,
  [SMALL_STATE(140)] = 3172,
  [SMALL_STATE(141)] = 3266,
  [SMALL_STATE(142)] = 3360,
  [SMALL_STATE(143)] = 3454,
  [SMALL_STATE(144)] = 3548,
  [SMALL_STATE(145)] = 3638,
  [SMALL_STATE(146)] = 3732,
  [SMALL_STATE(147)] = 3826,
  [SMALL_STATE(148)] = 3916,
  [SMALL_STATE(149)] = 4006,
  [SMALL_STATE(150)] = 4100,
  [SMALL_STATE(151)] = 4194,
  [SMALL_STATE(152)] = 4288,
  [SMALL_STATE(153)] = 4337,
  [SMALL_STATE(154)] = 4378,
  [SMALL_STATE(155)] = 4419,
  [SMALL_STATE(156)] = 4468,
  [SMALL_STATE(157)] = 4556,
  [SMALL_STATE(158)] = 4644,
  [SMALL_STATE(159)] = 4684,
  [SMALL_STATE(160)] = 4772,
  [SMALL_STATE(161)] = 4816,
  [SMALL_STATE(162)] = 4860,
  [SMALL_STATE(163)] = 4900,
  [SMALL_STATE(164)] = 4974,
  [SMALL_STATE(165)] = 5014,
  [SMALL_STATE(166)] = 5054,
  [SMALL_STATE(167)] = 5102,
  [SMALL_STATE(168)] = 5150,
  [SMALL_STATE(169)] = 5224,
  [SMALL_STATE(170)] = 5312,
  [SMALL_STATE(171)] = 5356,
  [SMALL_STATE(172)] = 5395,
  [SMALL_STATE(173)] = 5438,
  [SMALL_STATE(174)] = 5477,
  [SMALL_STATE(175)] = 5516,
  [SMALL_STATE(176)] = 5601,
  [SMALL_STATE(177)] = 5640,
  [SMALL_STATE(178)] = 5683,
  [SMALL_STATE(179)] = 5722,
  [SMALL_STATE(180)] = 5807,
  [SMALL_STATE(181)] = 5845,
  [SMALL_STATE(182)] = 5883,
  [SMALL_STATE(183)] = 5921,
  [SMALL_STATE(184)] = 5968,
  [SMALL_STATE(185)] = 6011,
  [SMALL_STATE(186)] = 6054,
  [SMALL_STATE(187)] = 6100,
  [SMALL_STATE(188)] = 6142,
  [SMALL_STATE(189)] = 6216,
  [SMALL_STATE(190)] = 6286,
  [SMALL_STATE(191)] = 6356,
  [SMALL_STATE(192)] = 6430,
  [SMALL_STATE(193)] = 6472,
  [SMALL_STATE(194)] = 6542,
  [SMALL_STATE(195)] = 6612,
  [SMALL_STATE(196)] = 6649,
  [SMALL_STATE(197)] = 6690,
  [SMALL_STATE(198)] = 6731,
  [SMALL_STATE(199)] = 6772,
  [SMALL_STATE(200)] = 6807,
  [SMALL_STATE(201)] = 6848,
  [SMALL_STATE(202)] = 6885,
  [SMALL_STATE(203)] = 6920,
  [SMALL_STATE(204)] = 6965,
  [SMALL_STATE(205)] = 7010,
  [SMALL_STATE(206)] = 7051,
  [SMALL_STATE(207)] = 7085,
  [SMALL_STATE(208)] = 7119,
  [SMALL_STATE(209)] = 7155,
  [SMALL_STATE(210)] = 7195,
  [SMALL_STATE(211)] = 7231,
  [SMALL_STATE(212)] = 7266,
  [SMALL_STATE(213)] = 7301,
  [SMALL_STATE(214)] = 7334,
  [SMALL_STATE(215)] = 7367,
  [SMALL_STATE(216)] = 7402,
  [SMALL_STATE(217)] = 7435,
  [SMALL_STATE(218)] = 7470,
  [SMALL_STATE(219)] = 7509,
  [SMALL_STATE(220)] = 7548,
  [SMALL_STATE(221)] = 7583,
  [SMALL_STATE(222)] = 7616,
  [SMALL_STATE(223)] = 7649,
  [SMALL_STATE(224)] = 7682,
  [SMALL_STATE(225)] = 7715,
  [SMALL_STATE(226)] = 7748,
  [SMALL_STATE(227)] = 7782,
  [SMALL_STATE(228)] = 7814,
  [SMALL_STATE(229)] = 7846,
  [SMALL_STATE(230)] = 7878,
  [SMALL_STATE(231)] = 7916,
  [SMALL_STATE(232)] = 7948,
  [SMALL_STATE(233)] = 7986,
  [SMALL_STATE(234)] = 8028,
  [SMALL_STATE(235)] = 8059,
  [SMALL_STATE(236)] = 8090,
  [SMALL_STATE(237)] = 8123,
  [SMALL_STATE(238)] = 8154,
  [SMALL_STATE(239)] = 8185,
  [SMALL_STATE(240)] = 8216,
  [SMALL_STATE(241)] = 8249,
  [SMALL_STATE(242)] = 8280,
  [SMALL_STATE(243)] = 8311,
  [SMALL_STATE(244)] = 8342,
  [SMALL_STATE(245)] = 8372,
  [SMALL_STATE(246)] = 8404,
  [SMALL_STATE(247)] = 8436,
  [SMALL_STATE(248)] = 8466,
  [SMALL_STATE(249)] = 8496,
  [SMALL_STATE(250)] = 8532,
  [SMALL_STATE(251)] = 8562,
  [SMALL_STATE(252)] = 8592,
  [SMALL_STATE(253)] = 8622,
  [SMALL_STATE(254)] = 8652,
  [SMALL_STATE(255)] = 8682,
  [SMALL_STATE(256)] = 8712,
  [SMALL_STATE(257)] = 8740,
  [SMALL_STATE(258)] = 8768,
  [SMALL_STATE(259)] = 8798,
  [SMALL_STATE(260)] = 8826,
  [SMALL_STATE(261)] = 8854,
  [SMALL_STATE(262)] = 8897,
  [SMALL_STATE(263)] = 8924,
  [SMALL_STATE(264)] = 8951,
  [SMALL_STATE(265)] = 8994,
  [SMALL_STATE(266)] = 9021,
  [SMALL_STATE(267)] = 9043,
  [SMALL_STATE(268)] = 9067,
  [SMALL_STATE(269)] = 9091,
  [SMALL_STATE(270)] = 9115,
  [SMALL_STATE(271)] = 9139,
  [SMALL_STATE(272)] = 9163,
  [SMALL_STATE(273)] = 9187,
  [SMALL_STATE(274)] = 9209,
  [SMALL_STATE(275)] = 9251,
  [SMALL_STATE(276)] = 9273,
  [SMALL_STATE(277)] = 9315,
  [SMALL_STATE(278)] = 9341,
  [SMALL_STATE(279)] = 9367,
  [SMALL_STATE(280)] = 9393,
  [SMALL_STATE(281)] = 9415,
  [SMALL_STATE(282)] = 9439,
  [SMALL_STATE(283)] = 9463,
  [SMALL_STATE(284)] = 9485,
  [SMALL_STATE(285)] = 9509,
  [SMALL_STATE(286)] = 9533,
  [SMALL_STATE(287)] = 9557,
  [SMALL_STATE(288)] = 9581,
  [SMALL_STATE(289)] = 9605,
  [SMALL_STATE(290)] = 9629,
  [SMALL_STATE(291)] = 9651,
  [SMALL_STATE(292)] = 9672,
  [SMALL_STATE(293)] = 9693,
  [SMALL_STATE(294)] = 9714,
  [SMALL_STATE(295)] = 9735,
  [SMALL_STATE(296)] = 9756,
  [SMALL_STATE(297)] = 9777,
  [SMALL_STATE(298)] = 9798,
  [SMALL_STATE(299)] = 9819,
  [SMALL_STATE(300)] = 9840,
  [SMALL_STATE(301)] = 9861,
  [SMALL_STATE(302)] = 9882,
  [SMALL_STATE(303)] = 9903,
  [SMALL_STATE(304)] = 9924,
  [SMALL_STATE(305)] = 9945,
  [SMALL_STATE(306)] = 9966,
  [SMALL_STATE(307)] = 9987,
  [SMALL_STATE(308)] = 10008,
  [SMALL_STATE(309)] = 10049,
  [SMALL_STATE(310)] = 10090,
  [SMALL_STATE(311)] = 10111,
  [SMALL_STATE(312)] = 10132,
  [SMALL_STATE(313)] = 10153,
  [SMALL_STATE(314)] = 10174,
  [SMALL_STATE(315)] = 10195,
  [SMALL_STATE(316)] = 10216,
  [SMALL_STATE(317)] = 10237,
  [SMALL_STATE(318)] = 10258,
  [SMALL_STATE(319)] = 10279,
  [SMALL_STATE(320)] = 10300,
  [SMALL_STATE(321)] = 10321,
  [SMALL_STATE(322)] = 10342,
  [SMALL_STATE(323)] = 10383,
  [SMALL_STATE(324)] = 10404,
  [SMALL_STATE(325)] = 10425,
  [SMALL_STATE(326)] = 10446,
  [SMALL_STATE(327)] = 10467,
  [SMALL_STATE(328)] = 10488,
  [SMALL_STATE(329)] = 10509,
  [SMALL_STATE(330)] = 10530,
  [SMALL_STATE(331)] = 10551,
  [SMALL_STATE(332)] = 10572,
  [SMALL_STATE(333)] = 10593,
  [SMALL_STATE(334)] = 10614,
  [SMALL_STATE(335)] = 10635,
  [SMALL_STATE(336)] = 10656,
  [SMALL_STATE(337)] = 10677,
  [SMALL_STATE(338)] = 10698,
  [SMALL_STATE(339)] = 10719,
  [SMALL_STATE(340)] = 10740,
  [SMALL_STATE(341)] = 10761,
  [SMALL_STATE(342)] = 10782,
  [SMALL_STATE(343)] = 10803,
  [SMALL_STATE(344)] = 10824,
  [SMALL_STATE(345)] = 10845,
  [SMALL_STATE(346)] = 10866,
  [SMALL_STATE(347)] = 10887,
  [SMALL_STATE(348)] = 10908,
  [SMALL_STATE(349)] = 10929,
  [SMALL_STATE(350)] = 10950,
  [SMALL_STATE(351)] = 10971,
  [SMALL_STATE(352)] = 10992,
  [SMALL_STATE(353)] = 11013,
  [SMALL_STATE(354)] = 11034,
  [SMALL_STATE(355)] = 11055,
  [SMALL_STATE(356)] = 11076,
  [SMALL_STATE(357)] = 11097,
  [SMALL_STATE(358)] = 11118,
  [SMALL_STATE(359)] = 11139,
  [SMALL_STATE(360)] = 11160,
  [SMALL_STATE(361)] = 11181,
  [SMALL_STATE(362)] = 11202,
  [SMALL_STATE(363)] = 11223,
  [SMALL_STATE(364)] = 11244,
  [SMALL_STATE(365)] = 11265,
  [SMALL_STATE(366)] = 11306,
  [SMALL_STATE(367)] = 11327,
  [SMALL_STATE(368)] = 11348,
  [SMALL_STATE(369)] = 11369,
  [SMALL_STATE(370)] = 11390,
  [SMALL_STATE(371)] = 11411,
  [SMALL_STATE(372)] = 11432,
  [SMALL_STATE(373)] = 11453,
  [SMALL_STATE(374)] = 11474,
  [SMALL_STATE(375)] = 11495,
  [SMALL_STATE(376)] = 11516,
  [SMALL_STATE(377)] = 11537,
  [SMALL_STATE(378)] = 11558,
  [SMALL_STATE(379)] = 11579,
  [SMALL_STATE(380)] = 11600,
  [SMALL_STATE(381)] = 11621,
  [SMALL_STATE(382)] = 11642,
  [SMALL_STATE(383)] = 11663,
  [SMALL_STATE(384)] = 11684,
  [SMALL_STATE(385)] = 11705,
  [SMALL_STATE(386)] = 11726,
  [SMALL_STATE(387)] = 11747,
  [SMALL_STATE(388)] = 11768,
  [SMALL_STATE(389)] = 11789,
  [SMALL_STATE(390)] = 11810,
  [SMALL_STATE(391)] = 11831,
  [SMALL_STATE(392)] = 11852,
  [SMALL_STATE(393)] = 11876,
  [SMALL_STATE(394)] = 11900,
  [SMALL_STATE(395)] = 11923,
  [SMALL_STATE(396)] = 11944,
  [SMALL_STATE(397)] = 11963,
  [SMALL_STATE(398)] = 11982,
  [SMALL_STATE(399)] = 12003,
  [SMALL_STATE(400)] = 12026,
  [SMALL_STATE(401)] = 12044,
  [SMALL_STATE(402)] = 12064,
  [SMALL_STATE(403)] = 12082,
  [SMALL_STATE(404)] = 12100,
  [SMALL_STATE(405)] = 12118,
  [SMALL_STATE(406)] = 12138,
  [SMALL_STATE(407)] = 12160,
  [SMALL_STATE(408)] = 12182,
  [SMALL_STATE(409)] = 12204,
  [SMALL_STATE(410)] = 12222,
  [SMALL_STATE(411)] = 12240,
  [SMALL_STATE(412)] = 12269,
  [SMALL_STATE(413)] = 12298,
  [SMALL_STATE(414)] = 12327,
  [SMALL_STATE(415)] = 12358,
  [SMALL_STATE(416)] = 12389,
  [SMALL_STATE(417)] = 12418,
  [SMALL_STATE(418)] = 12435,
  [SMALL_STATE(419)] = 12464,
  [SMALL_STATE(420)] = 12493,
  [SMALL_STATE(421)] = 12522,
  [SMALL_STATE(422)] = 12551,
  [SMALL_STATE(423)] = 12582,
  [SMALL_STATE(424)] = 12613,
  [SMALL_STATE(425)] = 12632,
  [SMALL_STATE(426)] = 12661,
  [SMALL_STATE(427)] = 12690,
  [SMALL_STATE(428)] = 12721,
  [SMALL_STATE(429)] = 12752,
  [SMALL_STATE(430)] = 12781,
  [SMALL_STATE(431)] = 12810,
  [SMALL_STATE(432)] = 12839,
  [SMALL_STATE(433)] = 12870,
  [SMALL_STATE(434)] = 12887,
  [SMALL_STATE(435)] = 12916,
  [SMALL_STATE(436)] = 12947,
  [SMALL_STATE(437)] = 12964,
  [SMALL_STATE(438)] = 12993,
  [SMALL_STATE(439)] = 13024,
  [SMALL_STATE(440)] = 13055,
  [SMALL_STATE(441)] = 13084,
  [SMALL_STATE(442)] = 13113,
  [SMALL_STATE(443)] = 13130,
  [SMALL_STATE(444)] = 13161,
  [SMALL_STATE(445)] = 13192,
  [SMALL_STATE(446)] = 13209,
  [SMALL_STATE(447)] = 13238,
  [SMALL_STATE(448)] = 13255,
  [SMALL_STATE(449)] = 13284,
  [SMALL_STATE(450)] = 13315,
  [SMALL_STATE(451)] = 13344,
  [SMALL_STATE(452)] = 13373,
  [SMALL_STATE(453)] = 13404,
  [SMALL_STATE(454)] = 13435,
  [SMALL_STATE(455)] = 13454,
  [SMALL_STATE(456)] = 13473,
  [SMALL_STATE(457)] = 13502,
  [SMALL_STATE(458)] = 13533,
  [SMALL_STATE(459)] = 13564,
  [SMALL_STATE(460)] = 13595,
  [SMALL_STATE(461)] = 13624,
  [SMALL_STATE(462)] = 13655,
  [SMALL_STATE(463)] = 13684,
  [SMALL_STATE(464)] = 13715,
  [SMALL_STATE(465)] = 13746,
  [SMALL_STATE(466)] = 13775,
  [SMALL_STATE(467)] = 13804,
  [SMALL_STATE(468)] = 13835,
  [SMALL_STATE(469)] = 13852,
  [SMALL_STATE(470)] = 13880,
  [SMALL_STATE(471)] = 13896,
  [SMALL_STATE(472)] = 13922,
  [SMALL_STATE(473)] = 13950,
  [SMALL_STATE(474)] = 13966,
  [SMALL_STATE(475)] = 13994,
  [SMALL_STATE(476)] = 14022,
  [SMALL_STATE(477)] = 14038,
  [SMALL_STATE(478)] = 14054,
  [SMALL_STATE(479)] = 14082,
  [SMALL_STATE(480)] = 14110,
  [SMALL_STATE(481)] = 14126,
  [SMALL_STATE(482)] = 14149,
  [SMALL_STATE(483)] = 14172,
  [SMALL_STATE(484)] = 14197,
  [SMALL_STATE(485)] = 14222,
  [SMALL_STATE(486)] = 14245,
  [SMALL_STATE(487)] = 14270,
  [SMALL_STATE(488)] = 14295,
  [SMALL_STATE(489)] = 14318,
  [SMALL_STATE(490)] = 14341,
  [SMALL_STATE(491)] = 14366,
  [SMALL_STATE(492)] = 14391,
  [SMALL_STATE(493)] = 14414,
  [SMALL_STATE(494)] = 14437,
  [SMALL_STATE(495)] = 14460,
  [SMALL_STATE(496)] = 14483,
  [SMALL_STATE(497)] = 14506,
  [SMALL_STATE(498)] = 14529,
  [SMALL_STATE(499)] = 14550,
  [SMALL_STATE(500)] = 14573,
  [SMALL_STATE(501)] = 14598,
  [SMALL_STATE(502)] = 14617,
  [SMALL_STATE(503)] = 14640,
  [SMALL_STATE(504)] = 14665,
  [SMALL_STATE(505)] = 14688,
  [SMALL_STATE(506)] = 14711,
  [SMALL_STATE(507)] = 14736,
  [SMALL_STATE(508)] = 14755,
  [SMALL_STATE(509)] = 14780,
  [SMALL_STATE(510)] = 14803,
  [SMALL_STATE(511)] = 14826,
  [SMALL_STATE(512)] = 14849,
  [SMALL_STATE(513)] = 14872,
  [SMALL_STATE(514)] = 14895,
  [SMALL_STATE(515)] = 14918,
  [SMALL_STATE(516)] = 14943,
  [SMALL_STATE(517)] = 14968,
  [SMALL_STATE(518)] = 14993,
  [SMALL_STATE(519)] = 15018,
  [SMALL_STATE(520)] = 15041,
  [SMALL_STATE(521)] = 15066,
  [SMALL_STATE(522)] = 15091,
  [SMALL_STATE(523)] = 15114,
  [SMALL_STATE(524)] = 15135,
  [SMALL_STATE(525)] = 15158,
  [SMALL_STATE(526)] = 15181,
  [SMALL_STATE(527)] = 15204,
  [SMALL_STATE(528)] = 15227,
  [SMALL_STATE(529)] = 15252,
  [SMALL_STATE(530)] = 15275,
  [SMALL_STATE(531)] = 15298,
  [SMALL_STATE(532)] = 15323,
  [SMALL_STATE(533)] = 15346,
  [SMALL_STATE(534)] = 15371,
  [SMALL_STATE(535)] = 15396,
  [SMALL_STATE(536)] = 15421,
  [SMALL_STATE(537)] = 15444,
  [SMALL_STATE(538)] = 15469,
  [SMALL_STATE(539)] = 15491,
  [SMALL_STATE(540)] = 15510,
  [SMALL_STATE(541)] = 15523,
  [SMALL_STATE(542)] = 15542,
  [SMALL_STATE(543)] = 15555,
  [SMALL_STATE(544)] = 15574,
  [SMALL_STATE(545)] = 15593,
  [SMALL_STATE(546)] = 15606,
  [SMALL_STATE(547)] = 15625,
  [SMALL_STATE(548)] = 15638,
  [SMALL_STATE(549)] = 15651,
  [SMALL_STATE(550)] = 15664,
  [SMALL_STATE(551)] = 15677,
  [SMALL_STATE(552)] = 15690,
  [SMALL_STATE(553)] = 15707,
  [SMALL_STATE(554)] = 15726,
  [SMALL_STATE(555)] = 15743,
  [SMALL_STATE(556)] = 15758,
  [SMALL_STATE(557)] = 15773,
  [SMALL_STATE(558)] = 15792,
  [SMALL_STATE(559)] = 15811,
  [SMALL_STATE(560)] = 15830,
  [SMALL_STATE(561)] = 15849,
  [SMALL_STATE(562)] = 15868,
  [SMALL_STATE(563)] = 15887,
  [SMALL_STATE(564)] = 15900,
  [SMALL_STATE(565)] = 15913,
  [SMALL_STATE(566)] = 15932,
  [SMALL_STATE(567)] = 15945,
  [SMALL_STATE(568)] = 15962,
  [SMALL_STATE(569)] = 15975,
  [SMALL_STATE(570)] = 15990,
  [SMALL_STATE(571)] = 16003,
  [SMALL_STATE(572)] = 16016,
  [SMALL_STATE(573)] = 16031,
  [SMALL_STATE(574)] = 16044,
  [SMALL_STATE(575)] = 16057,
  [SMALL_STATE(576)] = 16076,
  [SMALL_STATE(577)] = 16091,
  [SMALL_STATE(578)] = 16110,
  [SMALL_STATE(579)] = 16129,
  [SMALL_STATE(580)] = 16148,
  [SMALL_STATE(581)] = 16161,
  [SMALL_STATE(582)] = 16174,
  [SMALL_STATE(583)] = 16193,
  [SMALL_STATE(584)] = 16212,
  [SMALL_STATE(585)] = 16231,
  [SMALL_STATE(586)] = 16250,
  [SMALL_STATE(587)] = 16267,
  [SMALL_STATE(588)] = 16286,
  [SMALL_STATE(589)] = 16305,
  [SMALL_STATE(590)] = 16324,
  [SMALL_STATE(591)] = 16343,
  [SMALL_STATE(592)] = 16362,
  [SMALL_STATE(593)] = 16381,
  [SMALL_STATE(594)] = 16394,
  [SMALL_STATE(595)] = 16407,
  [SMALL_STATE(596)] = 16420,
  [SMALL_STATE(597)] = 16433,
  [SMALL_STATE(598)] = 16446,
  [SMALL_STATE(599)] = 16459,
  [SMALL_STATE(600)] = 16472,
  [SMALL_STATE(601)] = 16485,
  [SMALL_STATE(602)] = 16498,
  [SMALL_STATE(603)] = 16511,
  [SMALL_STATE(604)] = 16524,
  [SMALL_STATE(605)] = 16537,
  [SMALL_STATE(606)] = 16556,
  [SMALL_STATE(607)] = 16571,
  [SMALL_STATE(608)] = 16590,
  [SMALL_STATE(609)] = 16609,
  [SMALL_STATE(610)] = 16628,
  [SMALL_STATE(611)] = 16641,
  [SMALL_STATE(612)] = 16656,
  [SMALL_STATE(613)] = 16669,
  [SMALL_STATE(614)] = 16682,
  [SMALL_STATE(615)] = 16699,
  [SMALL_STATE(616)] = 16716,
  [SMALL_STATE(617)] = 16729,
  [SMALL_STATE(618)] = 16748,
  [SMALL_STATE(619)] = 16767,
  [SMALL_STATE(620)] = 16786,
  [SMALL_STATE(621)] = 16805,
  [SMALL_STATE(622)] = 16824,
  [SMALL_STATE(623)] = 16843,
  [SMALL_STATE(624)] = 16856,
  [SMALL_STATE(625)] = 16869,
  [SMALL_STATE(626)] = 16888,
  [SMALL_STATE(627)] = 16901,
  [SMALL_STATE(628)] = 16920,
  [SMALL_STATE(629)] = 16939,
  [SMALL_STATE(630)] = 16958,
  [SMALL_STATE(631)] = 16977,
  [SMALL_STATE(632)] = 16996,
  [SMALL_STATE(633)] = 17009,
  [SMALL_STATE(634)] = 17028,
  [SMALL_STATE(635)] = 17047,
  [SMALL_STATE(636)] = 17066,
  [SMALL_STATE(637)] = 17079,
  [SMALL_STATE(638)] = 17092,
  [SMALL_STATE(639)] = 17105,
  [SMALL_STATE(640)] = 17118,
  [SMALL_STATE(641)] = 17137,
  [SMALL_STATE(642)] = 17156,
  [SMALL_STATE(643)] = 17175,
  [SMALL_STATE(644)] = 17194,
  [SMALL_STATE(645)] = 17213,
  [SMALL_STATE(646)] = 17230,
  [SMALL_STATE(647)] = 17249,
  [SMALL_STATE(648)] = 17268,
  [SMALL_STATE(649)] = 17285,
  [SMALL_STATE(650)] = 17302,
  [SMALL_STATE(651)] = 17321,
  [SMALL_STATE(652)] = 17340,
  [SMALL_STATE(653)] = 17359,
  [SMALL_STATE(654)] = 17378,
  [SMALL_STATE(655)] = 17397,
  [SMALL_STATE(656)] = 17416,
  [SMALL_STATE(657)] = 17435,
  [SMALL_STATE(658)] = 17454,
  [SMALL_STATE(659)] = 17473,
  [SMALL_STATE(660)] = 17492,
  [SMALL_STATE(661)] = 17509,
  [SMALL_STATE(662)] = 17526,
  [SMALL_STATE(663)] = 17539,
  [SMALL_STATE(664)] = 17556,
  [SMALL_STATE(665)] = 17575,
  [SMALL_STATE(666)] = 17594,
  [SMALL_STATE(667)] = 17613,
  [SMALL_STATE(668)] = 17632,
  [SMALL_STATE(669)] = 17651,
  [SMALL_STATE(670)] = 17670,
  [SMALL_STATE(671)] = 17687,
  [SMALL_STATE(672)] = 17704,
  [SMALL_STATE(673)] = 17721,
  [SMALL_STATE(674)] = 17738,
  [SMALL_STATE(675)] = 17755,
  [SMALL_STATE(676)] = 17772,
  [SMALL_STATE(677)] = 17791,
  [SMALL_STATE(678)] = 17804,
  [SMALL_STATE(679)] = 17823,
  [SMALL_STATE(680)] = 17836,
  [SMALL_STATE(681)] = 17855,
  [SMALL_STATE(682)] = 17874,
  [SMALL_STATE(683)] = 17893,
  [SMALL_STATE(684)] = 17906,
  [SMALL_STATE(685)] = 17919,
  [SMALL_STATE(686)] = 17938,
  [SMALL_STATE(687)] = 17957,
  [SMALL_STATE(688)] = 17976,
  [SMALL_STATE(689)] = 17995,
  [SMALL_STATE(690)] = 18014,
  [SMALL_STATE(691)] = 18033,
  [SMALL_STATE(692)] = 18052,
  [SMALL_STATE(693)] = 18065,
  [SMALL_STATE(694)] = 18081,
  [SMALL_STATE(695)] = 18097,
  [SMALL_STATE(696)] = 18109,
  [SMALL_STATE(697)] = 18121,
  [SMALL_STATE(698)] = 18133,
  [SMALL_STATE(699)] = 18149,
  [SMALL_STATE(700)] = 18161,
  [SMALL_STATE(701)] = 18173,
  [SMALL_STATE(702)] = 18185,
  [SMALL_STATE(703)] = 18197,
  [SMALL_STATE(704)] = 18209,
  [SMALL_STATE(705)] = 18221,
  [SMALL_STATE(706)] = 18233,
  [SMALL_STATE(707)] = 18245,
  [SMALL_STATE(708)] = 18257,
  [SMALL_STATE(709)] = 18269,
  [SMALL_STATE(710)] = 18281,
  [SMALL_STATE(711)] = 18293,
  [SMALL_STATE(712)] = 18307,
  [SMALL_STATE(713)] = 18319,
  [SMALL_STATE(714)] = 18331,
  [SMALL_STATE(715)] = 18345,
  [SMALL_STATE(716)] = 18357,
  [SMALL_STATE(717)] = 18369,
  [SMALL_STATE(718)] = 18383,
  [SMALL_STATE(719)] = 18395,
  [SMALL_STATE(720)] = 18407,
  [SMALL_STATE(721)] = 18421,
  [SMALL_STATE(722)] = 18433,
  [SMALL_STATE(723)] = 18445,
  [SMALL_STATE(724)] = 18457,
  [SMALL_STATE(725)] = 18469,
  [SMALL_STATE(726)] = 18481,
  [SMALL_STATE(727)] = 18493,
  [SMALL_STATE(728)] = 18505,
  [SMALL_STATE(729)] = 18517,
  [SMALL_STATE(730)] = 18529,
  [SMALL_STATE(731)] = 18541,
  [SMALL_STATE(732)] = 18553,
  [SMALL_STATE(733)] = 18565,
  [SMALL_STATE(734)] = 18577,
  [SMALL_STATE(735)] = 18589,
  [SMALL_STATE(736)] = 18603,
  [SMALL_STATE(737)] = 18615,
  [SMALL_STATE(738)] = 18629,
  [SMALL_STATE(739)] = 18641,
  [SMALL_STATE(740)] = 18653,
  [SMALL_STATE(741)] = 18665,
  [SMALL_STATE(742)] = 18681,
  [SMALL_STATE(743)] = 18693,
  [SMALL_STATE(744)] = 18705,
  [SMALL_STATE(745)] = 18717,
  [SMALL_STATE(746)] = 18729,
  [SMALL_STATE(747)] = 18741,
  [SMALL_STATE(748)] = 18755,
  [SMALL_STATE(749)] = 18767,
  [SMALL_STATE(750)] = 18779,
  [SMALL_STATE(751)] = 18795,
  [SMALL_STATE(752)] = 18811,
  [SMALL_STATE(753)] = 18827,
  [SMALL_STATE(754)] = 18839,
  [SMALL_STATE(755)] = 18855,
  [SMALL_STATE(756)] = 18871,
  [SMALL_STATE(757)] = 18887,
  [SMALL_STATE(758)] = 18903,
  [SMALL_STATE(759)] = 18919,
  [SMALL_STATE(760)] = 18935,
  [SMALL_STATE(761)] = 18951,
  [SMALL_STATE(762)] = 18967,
  [SMALL_STATE(763)] = 18983,
  [SMALL_STATE(764)] = 18999,
  [SMALL_STATE(765)] = 19015,
  [SMALL_STATE(766)] = 19031,
  [SMALL_STATE(767)] = 19047,
  [SMALL_STATE(768)] = 19063,
  [SMALL_STATE(769)] = 19079,
  [SMALL_STATE(770)] = 19095,
  [SMALL_STATE(771)] = 19111,
  [SMALL_STATE(772)] = 19127,
  [SMALL_STATE(773)] = 19143,
  [SMALL_STATE(774)] = 19159,
  [SMALL_STATE(775)] = 19175,
  [SMALL_STATE(776)] = 19191,
  [SMALL_STATE(777)] = 19207,
  [SMALL_STATE(778)] = 19223,
  [SMALL_STATE(779)] = 19239,
  [SMALL_STATE(780)] = 19255,
  [SMALL_STATE(781)] = 19271,
  [SMALL_STATE(782)] = 19287,
  [SMALL_STATE(783)] = 19303,
  [SMALL_STATE(784)] = 19315,
  [SMALL_STATE(785)] = 19326,
  [SMALL_STATE(786)] = 19339,
  [SMALL_STATE(787)] = 19350,
  [SMALL_STATE(788)] = 19361,
  [SMALL_STATE(789)] = 19372,
  [SMALL_STATE(790)] = 19383,
  [SMALL_STATE(791)] = 19394,
  [SMALL_STATE(792)] = 19405,
  [SMALL_STATE(793)] = 19416,
  [SMALL_STATE(794)] = 19427,
  [SMALL_STATE(795)] = 19438,
  [SMALL_STATE(796)] = 19449,
  [SMALL_STATE(797)] = 19460,
  [SMALL_STATE(798)] = 19471,
  [SMALL_STATE(799)] = 19482,
  [SMALL_STATE(800)] = 19493,
  [SMALL_STATE(801)] = 19504,
  [SMALL_STATE(802)] = 19517,
  [SMALL_STATE(803)] = 19528,
  [SMALL_STATE(804)] = 19539,
  [SMALL_STATE(805)] = 19550,
  [SMALL_STATE(806)] = 19569,
  [SMALL_STATE(807)] = 19580,
  [SMALL_STATE(808)] = 19591,
  [SMALL_STATE(809)] = 19602,
  [SMALL_STATE(810)] = 19613,
  [SMALL_STATE(811)] = 19624,
  [SMALL_STATE(812)] = 19635,
  [SMALL_STATE(813)] = 19646,
  [SMALL_STATE(814)] = 19657,
  [SMALL_STATE(815)] = 19668,
  [SMALL_STATE(816)] = 19679,
  [SMALL_STATE(817)] = 19690,
  [SMALL_STATE(818)] = 19701,
  [SMALL_STATE(819)] = 19712,
  [SMALL_STATE(820)] = 19723,
  [SMALL_STATE(821)] = 19734,
  [SMALL_STATE(822)] = 19745,
  [SMALL_STATE(823)] = 19756,
  [SMALL_STATE(824)] = 19767,
  [SMALL_STATE(825)] = 19778,
  [SMALL_STATE(826)] = 19789,
  [SMALL_STATE(827)] = 19800,
  [SMALL_STATE(828)] = 19813,
  [SMALL_STATE(829)] = 19824,
  [SMALL_STATE(830)] = 19835,
  [SMALL_STATE(831)] = 19848,
  [SMALL_STATE(832)] = 19859,
  [SMALL_STATE(833)] = 19870,
  [SMALL_STATE(834)] = 19883,
  [SMALL_STATE(835)] = 19894,
  [SMALL_STATE(836)] = 19905,
  [SMALL_STATE(837)] = 19918,
  [SMALL_STATE(838)] = 19929,
  [SMALL_STATE(839)] = 19940,
  [SMALL_STATE(840)] = 19951,
  [SMALL_STATE(841)] = 19962,
  [SMALL_STATE(842)] = 19973,
  [SMALL_STATE(843)] = 19984,
  [SMALL_STATE(844)] = 19995,
  [SMALL_STATE(845)] = 20006,
  [SMALL_STATE(846)] = 20017,
  [SMALL_STATE(847)] = 20028,
  [SMALL_STATE(848)] = 20039,
  [SMALL_STATE(849)] = 20050,
  [SMALL_STATE(850)] = 20061,
  [SMALL_STATE(851)] = 20072,
  [SMALL_STATE(852)] = 20083,
  [SMALL_STATE(853)] = 20094,
  [SMALL_STATE(854)] = 20107,
  [SMALL_STATE(855)] = 20118,
  [SMALL_STATE(856)] = 20131,
  [SMALL_STATE(857)] = 20142,
  [SMALL_STATE(858)] = 20153,
  [SMALL_STATE(859)] = 20164,
  [SMALL_STATE(860)] = 20175,
  [SMALL_STATE(861)] = 20186,
  [SMALL_STATE(862)] = 20197,
  [SMALL_STATE(863)] = 20208,
  [SMALL_STATE(864)] = 20219,
  [SMALL_STATE(865)] = 20230,
  [SMALL_STATE(866)] = 20241,
  [SMALL_STATE(867)] = 20252,
  [SMALL_STATE(868)] = 20263,
  [SMALL_STATE(869)] = 20274,
  [SMALL_STATE(870)] = 20285,
  [SMALL_STATE(871)] = 20296,
  [SMALL_STATE(872)] = 20307,
  [SMALL_STATE(873)] = 20318,
  [SMALL_STATE(874)] = 20329,
  [SMALL_STATE(875)] = 20340,
  [SMALL_STATE(876)] = 20351,
  [SMALL_STATE(877)] = 20364,
  [SMALL_STATE(878)] = 20375,
  [SMALL_STATE(879)] = 20388,
  [SMALL_STATE(880)] = 20399,
  [SMALL_STATE(881)] = 20410,
  [SMALL_STATE(882)] = 20423,
  [SMALL_STATE(883)] = 20434,
  [SMALL_STATE(884)] = 20445,
  [SMALL_STATE(885)] = 20458,
  [SMALL_STATE(886)] = 20469,
  [SMALL_STATE(887)] = 20480,
  [SMALL_STATE(888)] = 20491,
  [SMALL_STATE(889)] = 20502,
  [SMALL_STATE(890)] = 20513,
  [SMALL_STATE(891)] = 20524,
  [SMALL_STATE(892)] = 20535,
  [SMALL_STATE(893)] = 20546,
  [SMALL_STATE(894)] = 20557,
  [SMALL_STATE(895)] = 20568,
  [SMALL_STATE(896)] = 20579,
  [SMALL_STATE(897)] = 20590,
  [SMALL_STATE(898)] = 20601,
  [SMALL_STATE(899)] = 20612,
  [SMALL_STATE(900)] = 20623,
  [SMALL_STATE(901)] = 20634,
  [SMALL_STATE(902)] = 20645,
  [SMALL_STATE(903)] = 20658,
  [SMALL_STATE(904)] = 20669,
  [SMALL_STATE(905)] = 20682,
  [SMALL_STATE(906)] = 20693,
  [SMALL_STATE(907)] = 20704,
  [SMALL_STATE(908)] = 20715,
  [SMALL_STATE(909)] = 20726,
  [SMALL_STATE(910)] = 20737,
  [SMALL_STATE(911)] = 20748,
  [SMALL_STATE(912)] = 20759,
  [SMALL_STATE(913)] = 20770,
  [SMALL_STATE(914)] = 20781,
  [SMALL_STATE(915)] = 20792,
  [SMALL_STATE(916)] = 20803,
  [SMALL_STATE(917)] = 20814,
  [SMALL_STATE(918)] = 20829,
  [SMALL_STATE(919)] = 20844,
  [SMALL_STATE(920)] = 20857,
  [SMALL_STATE(921)] = 20868,
  [SMALL_STATE(922)] = 20879,
  [SMALL_STATE(923)] = 20890,
  [SMALL_STATE(924)] = 20901,
  [SMALL_STATE(925)] = 20912,
  [SMALL_STATE(926)] = 20923,
  [SMALL_STATE(927)] = 20934,
  [SMALL_STATE(928)] = 20945,
  [SMALL_STATE(929)] = 20964,
  [SMALL_STATE(930)] = 20975,
  [SMALL_STATE(931)] = 20986,
  [SMALL_STATE(932)] = 20997,
  [SMALL_STATE(933)] = 21008,
  [SMALL_STATE(934)] = 21019,
  [SMALL_STATE(935)] = 21030,
  [SMALL_STATE(936)] = 21043,
  [SMALL_STATE(937)] = 21054,
  [SMALL_STATE(938)] = 21065,
  [SMALL_STATE(939)] = 21076,
  [SMALL_STATE(940)] = 21091,
  [SMALL_STATE(941)] = 21102,
  [SMALL_STATE(942)] = 21113,
  [SMALL_STATE(943)] = 21124,
  [SMALL_STATE(944)] = 21135,
  [SMALL_STATE(945)] = 21146,
  [SMALL_STATE(946)] = 21157,
  [SMALL_STATE(947)] = 21168,
  [SMALL_STATE(948)] = 21179,
  [SMALL_STATE(949)] = 21190,
  [SMALL_STATE(950)] = 21201,
  [SMALL_STATE(951)] = 21212,
  [SMALL_STATE(952)] = 21223,
  [SMALL_STATE(953)] = 21234,
  [SMALL_STATE(954)] = 21245,
  [SMALL_STATE(955)] = 21256,
  [SMALL_STATE(956)] = 21267,
  [SMALL_STATE(957)] = 21278,
  [SMALL_STATE(958)] = 21289,
  [SMALL_STATE(959)] = 21300,
  [SMALL_STATE(960)] = 21311,
  [SMALL_STATE(961)] = 21322,
  [SMALL_STATE(962)] = 21333,
  [SMALL_STATE(963)] = 21344,
  [SMALL_STATE(964)] = 21358,
  [SMALL_STATE(965)] = 21372,
  [SMALL_STATE(966)] = 21386,
  [SMALL_STATE(967)] = 21400,
  [SMALL_STATE(968)] = 21414,
  [SMALL_STATE(969)] = 21424,
  [SMALL_STATE(970)] = 21438,
  [SMALL_STATE(971)] = 21452,
  [SMALL_STATE(972)] = 21466,
  [SMALL_STATE(973)] = 21480,
  [SMALL_STATE(974)] = 21494,
  [SMALL_STATE(975)] = 21508,
  [SMALL_STATE(976)] = 21522,
  [SMALL_STATE(977)] = 21536,
  [SMALL_STATE(978)] = 21550,
  [SMALL_STATE(979)] = 21564,
  [SMALL_STATE(980)] = 21578,
  [SMALL_STATE(981)] = 21594,
  [SMALL_STATE(982)] = 21610,
  [SMALL_STATE(983)] = 21624,
  [SMALL_STATE(984)] = 21638,
  [SMALL_STATE(985)] = 21654,
  [SMALL_STATE(986)] = 21666,
  [SMALL_STATE(987)] = 21680,
  [SMALL_STATE(988)] = 21692,
  [SMALL_STATE(989)] = 21704,
  [SMALL_STATE(990)] = 21716,
  [SMALL_STATE(991)] = 21728,
  [SMALL_STATE(992)] = 21744,
  [SMALL_STATE(993)] = 21758,
  [SMALL_STATE(994)] = 21772,
  [SMALL_STATE(995)] = 21786,
  [SMALL_STATE(996)] = 21800,
  [SMALL_STATE(997)] = 21812,
  [SMALL_STATE(998)] = 21824,
  [SMALL_STATE(999)] = 21838,
  [SMALL_STATE(1000)] = 21848,
  [SMALL_STATE(1001)] = 21860,
  [SMALL_STATE(1002)] = 21870,
  [SMALL_STATE(1003)] = 21884,
  [SMALL_STATE(1004)] = 21898,
  [SMALL_STATE(1005)] = 21912,
  [SMALL_STATE(1006)] = 21924,
  [SMALL_STATE(1007)] = 21938,
  [SMALL_STATE(1008)] = 21952,
  [SMALL_STATE(1009)] = 21964,
  [SMALL_STATE(1010)] = 21980,
  [SMALL_STATE(1011)] = 21994,
  [SMALL_STATE(1012)] = 22008,
  [SMALL_STATE(1013)] = 22022,
  [SMALL_STATE(1014)] = 22036,
  [SMALL_STATE(1015)] = 22050,
  [SMALL_STATE(1016)] = 22060,
  [SMALL_STATE(1017)] = 22074,
  [SMALL_STATE(1018)] = 22088,
  [SMALL_STATE(1019)] = 22104,
  [SMALL_STATE(1020)] = 22118,
  [SMALL_STATE(1021)] = 22132,
  [SMALL_STATE(1022)] = 22146,
  [SMALL_STATE(1023)] = 22160,
  [SMALL_STATE(1024)] = 22174,
  [SMALL_STATE(1025)] = 22188,
  [SMALL_STATE(1026)] = 22202,
  [SMALL_STATE(1027)] = 22216,
  [SMALL_STATE(1028)] = 22230,
  [SMALL_STATE(1029)] = 22244,
  [SMALL_STATE(1030)] = 22258,
  [SMALL_STATE(1031)] = 22268,
  [SMALL_STATE(1032)] = 22284,
  [SMALL_STATE(1033)] = 22298,
  [SMALL_STATE(1034)] = 22312,
  [SMALL_STATE(1035)] = 22326,
  [SMALL_STATE(1036)] = 22342,
  [SMALL_STATE(1037)] = 22352,
  [SMALL_STATE(1038)] = 22364,
  [SMALL_STATE(1039)] = 22378,
  [SMALL_STATE(1040)] = 22388,
  [SMALL_STATE(1041)] = 22400,
  [SMALL_STATE(1042)] = 22414,
  [SMALL_STATE(1043)] = 22428,
  [SMALL_STATE(1044)] = 22442,
  [SMALL_STATE(1045)] = 22452,
  [SMALL_STATE(1046)] = 22466,
  [SMALL_STATE(1047)] = 22478,
  [SMALL_STATE(1048)] = 22490,
  [SMALL_STATE(1049)] = 22504,
  [SMALL_STATE(1050)] = 22513,
  [SMALL_STATE(1051)] = 22522,
  [SMALL_STATE(1052)] = 22531,
  [SMALL_STATE(1053)] = 22540,
  [SMALL_STATE(1054)] = 22549,
  [SMALL_STATE(1055)] = 22558,
  [SMALL_STATE(1056)] = 22567,
  [SMALL_STATE(1057)] = 22580,
  [SMALL_STATE(1058)] = 22589,
  [SMALL_STATE(1059)] = 22598,
  [SMALL_STATE(1060)] = 22607,
  [SMALL_STATE(1061)] = 22616,
  [SMALL_STATE(1062)] = 22625,
  [SMALL_STATE(1063)] = 22634,
  [SMALL_STATE(1064)] = 22643,
  [SMALL_STATE(1065)] = 22652,
  [SMALL_STATE(1066)] = 22661,
  [SMALL_STATE(1067)] = 22674,
  [SMALL_STATE(1068)] = 22683,
  [SMALL_STATE(1069)] = 22692,
  [SMALL_STATE(1070)] = 22701,
  [SMALL_STATE(1071)] = 22710,
  [SMALL_STATE(1072)] = 22719,
  [SMALL_STATE(1073)] = 22728,
  [SMALL_STATE(1074)] = 22737,
  [SMALL_STATE(1075)] = 22746,
  [SMALL_STATE(1076)] = 22755,
  [SMALL_STATE(1077)] = 22764,
  [SMALL_STATE(1078)] = 22773,
  [SMALL_STATE(1079)] = 22786,
  [SMALL_STATE(1080)] = 22795,
  [SMALL_STATE(1081)] = 22804,
  [SMALL_STATE(1082)] = 22817,
  [SMALL_STATE(1083)] = 22826,
  [SMALL_STATE(1084)] = 22835,
  [SMALL_STATE(1085)] = 22844,
  [SMALL_STATE(1086)] = 22853,
  [SMALL_STATE(1087)] = 22862,
  [SMALL_STATE(1088)] = 22871,
  [SMALL_STATE(1089)] = 22880,
  [SMALL_STATE(1090)] = 22893,
  [SMALL_STATE(1091)] = 22902,
  [SMALL_STATE(1092)] = 22911,
  [SMALL_STATE(1093)] = 22920,
  [SMALL_STATE(1094)] = 22929,
  [SMALL_STATE(1095)] = 22938,
  [SMALL_STATE(1096)] = 22947,
  [SMALL_STATE(1097)] = 22956,
  [SMALL_STATE(1098)] = 22965,
  [SMALL_STATE(1099)] = 22974,
  [SMALL_STATE(1100)] = 22983,
  [SMALL_STATE(1101)] = 22992,
  [SMALL_STATE(1102)] = 23001,
  [SMALL_STATE(1103)] = 23010,
  [SMALL_STATE(1104)] = 23019,
  [SMALL_STATE(1105)] = 23028,
  [SMALL_STATE(1106)] = 23037,
  [SMALL_STATE(1107)] = 23046,
  [SMALL_STATE(1108)] = 23055,
  [SMALL_STATE(1109)] = 23064,
  [SMALL_STATE(1110)] = 23073,
  [SMALL_STATE(1111)] = 23082,
  [SMALL_STATE(1112)] = 23095,
  [SMALL_STATE(1113)] = 23108,
  [SMALL_STATE(1114)] = 23117,
  [SMALL_STATE(1115)] = 23126,
  [SMALL_STATE(1116)] = 23135,
  [SMALL_STATE(1117)] = 23144,
  [SMALL_STATE(1118)] = 23155,
  [SMALL_STATE(1119)] = 23166,
  [SMALL_STATE(1120)] = 23175,
  [SMALL_STATE(1121)] = 23188,
  [SMALL_STATE(1122)] = 23201,
  [SMALL_STATE(1123)] = 23210,
  [SMALL_STATE(1124)] = 23219,
  [SMALL_STATE(1125)] = 23228,
  [SMALL_STATE(1126)] = 23237,
  [SMALL_STATE(1127)] = 23246,
  [SMALL_STATE(1128)] = 23255,
  [SMALL_STATE(1129)] = 23266,
  [SMALL_STATE(1130)] = 23275,
  [SMALL_STATE(1131)] = 23284,
  [SMALL_STATE(1132)] = 23293,
  [SMALL_STATE(1133)] = 23302,
  [SMALL_STATE(1134)] = 23311,
  [SMALL_STATE(1135)] = 23320,
  [SMALL_STATE(1136)] = 23329,
  [SMALL_STATE(1137)] = 23338,
  [SMALL_STATE(1138)] = 23347,
  [SMALL_STATE(1139)] = 23356,
  [SMALL_STATE(1140)] = 23365,
  [SMALL_STATE(1141)] = 23378,
  [SMALL_STATE(1142)] = 23391,
  [SMALL_STATE(1143)] = 23400,
  [SMALL_STATE(1144)] = 23409,
  [SMALL_STATE(1145)] = 23420,
  [SMALL_STATE(1146)] = 23429,
  [SMALL_STATE(1147)] = 23440,
  [SMALL_STATE(1148)] = 23453,
  [SMALL_STATE(1149)] = 23466,
  [SMALL_STATE(1150)] = 23477,
  [SMALL_STATE(1151)] = 23488,
  [SMALL_STATE(1152)] = 23497,
  [SMALL_STATE(1153)] = 23506,
  [SMALL_STATE(1154)] = 23517,
  [SMALL_STATE(1155)] = 23526,
  [SMALL_STATE(1156)] = 23537,
  [SMALL_STATE(1157)] = 23546,
  [SMALL_STATE(1158)] = 23555,
  [SMALL_STATE(1159)] = 23564,
  [SMALL_STATE(1160)] = 23575,
  [SMALL_STATE(1161)] = 23586,
  [SMALL_STATE(1162)] = 23595,
  [SMALL_STATE(1163)] = 23604,
  [SMALL_STATE(1164)] = 23613,
  [SMALL_STATE(1165)] = 23622,
  [SMALL_STATE(1166)] = 23631,
  [SMALL_STATE(1167)] = 23640,
  [SMALL_STATE(1168)] = 23651,
  [SMALL_STATE(1169)] = 23662,
  [SMALL_STATE(1170)] = 23671,
  [SMALL_STATE(1171)] = 23680,
  [SMALL_STATE(1172)] = 23689,
  [SMALL_STATE(1173)] = 23698,
  [SMALL_STATE(1174)] = 23707,
  [SMALL_STATE(1175)] = 23716,
  [SMALL_STATE(1176)] = 23725,
  [SMALL_STATE(1177)] = 23734,
  [SMALL_STATE(1178)] = 23743,
  [SMALL_STATE(1179)] = 23752,
  [SMALL_STATE(1180)] = 23763,
  [SMALL_STATE(1181)] = 23774,
  [SMALL_STATE(1182)] = 23785,
  [SMALL_STATE(1183)] = 23794,
  [SMALL_STATE(1184)] = 23803,
  [SMALL_STATE(1185)] = 23814,
  [SMALL_STATE(1186)] = 23823,
  [SMALL_STATE(1187)] = 23832,
  [SMALL_STATE(1188)] = 23841,
  [SMALL_STATE(1189)] = 23850,
  [SMALL_STATE(1190)] = 23859,
  [SMALL_STATE(1191)] = 23868,
  [SMALL_STATE(1192)] = 23877,
  [SMALL_STATE(1193)] = 23886,
  [SMALL_STATE(1194)] = 23895,
  [SMALL_STATE(1195)] = 23904,
  [SMALL_STATE(1196)] = 23913,
  [SMALL_STATE(1197)] = 23922,
  [SMALL_STATE(1198)] = 23931,
  [SMALL_STATE(1199)] = 23940,
  [SMALL_STATE(1200)] = 23949,
  [SMALL_STATE(1201)] = 23958,
  [SMALL_STATE(1202)] = 23967,
  [SMALL_STATE(1203)] = 23976,
  [SMALL_STATE(1204)] = 23985,
  [SMALL_STATE(1205)] = 23994,
  [SMALL_STATE(1206)] = 24003,
  [SMALL_STATE(1207)] = 24012,
  [SMALL_STATE(1208)] = 24021,
  [SMALL_STATE(1209)] = 24030,
  [SMALL_STATE(1210)] = 24039,
  [SMALL_STATE(1211)] = 24048,
  [SMALL_STATE(1212)] = 24057,
  [SMALL_STATE(1213)] = 24066,
  [SMALL_STATE(1214)] = 24075,
  [SMALL_STATE(1215)] = 24084,
  [SMALL_STATE(1216)] = 24093,
  [SMALL_STATE(1217)] = 24101,
  [SMALL_STATE(1218)] = 24109,
  [SMALL_STATE(1219)] = 24117,
  [SMALL_STATE(1220)] = 24125,
  [SMALL_STATE(1221)] = 24133,
  [SMALL_STATE(1222)] = 24141,
  [SMALL_STATE(1223)] = 24149,
  [SMALL_STATE(1224)] = 24157,
  [SMALL_STATE(1225)] = 24165,
  [SMALL_STATE(1226)] = 24173,
  [SMALL_STATE(1227)] = 24181,
  [SMALL_STATE(1228)] = 24191,
  [SMALL_STATE(1229)] = 24199,
  [SMALL_STATE(1230)] = 24207,
  [SMALL_STATE(1231)] = 24215,
  [SMALL_STATE(1232)] = 24223,
  [SMALL_STATE(1233)] = 24231,
  [SMALL_STATE(1234)] = 24239,
  [SMALL_STATE(1235)] = 24247,
  [SMALL_STATE(1236)] = 24255,
  [SMALL_STATE(1237)] = 24263,
  [SMALL_STATE(1238)] = 24273,
  [SMALL_STATE(1239)] = 24281,
  [SMALL_STATE(1240)] = 24291,
  [SMALL_STATE(1241)] = 24299,
  [SMALL_STATE(1242)] = 24307,
  [SMALL_STATE(1243)] = 24317,
  [SMALL_STATE(1244)] = 24327,
  [SMALL_STATE(1245)] = 24337,
  [SMALL_STATE(1246)] = 24345,
  [SMALL_STATE(1247)] = 24353,
  [SMALL_STATE(1248)] = 24361,
  [SMALL_STATE(1249)] = 24369,
  [SMALL_STATE(1250)] = 24377,
  [SMALL_STATE(1251)] = 24385,
  [SMALL_STATE(1252)] = 24393,
  [SMALL_STATE(1253)] = 24401,
  [SMALL_STATE(1254)] = 24409,
  [SMALL_STATE(1255)] = 24417,
  [SMALL_STATE(1256)] = 24425,
  [SMALL_STATE(1257)] = 24433,
  [SMALL_STATE(1258)] = 24441,
  [SMALL_STATE(1259)] = 24449,
  [SMALL_STATE(1260)] = 24457,
  [SMALL_STATE(1261)] = 24465,
  [SMALL_STATE(1262)] = 24473,
  [SMALL_STATE(1263)] = 24481,
  [SMALL_STATE(1264)] = 24489,
  [SMALL_STATE(1265)] = 24497,
  [SMALL_STATE(1266)] = 24505,
  [SMALL_STATE(1267)] = 24513,
  [SMALL_STATE(1268)] = 24521,
  [SMALL_STATE(1269)] = 24529,
  [SMALL_STATE(1270)] = 24537,
  [SMALL_STATE(1271)] = 24545,
  [SMALL_STATE(1272)] = 24553,
  [SMALL_STATE(1273)] = 24561,
  [SMALL_STATE(1274)] = 24569,
  [SMALL_STATE(1275)] = 24577,
  [SMALL_STATE(1276)] = 24585,
  [SMALL_STATE(1277)] = 24593,
  [SMALL_STATE(1278)] = 24601,
  [SMALL_STATE(1279)] = 24609,
  [SMALL_STATE(1280)] = 24617,
  [SMALL_STATE(1281)] = 24625,
  [SMALL_STATE(1282)] = 24633,
  [SMALL_STATE(1283)] = 24641,
  [SMALL_STATE(1284)] = 24649,
  [SMALL_STATE(1285)] = 24657,
  [SMALL_STATE(1286)] = 24665,
  [SMALL_STATE(1287)] = 24673,
  [SMALL_STATE(1288)] = 24681,
  [SMALL_STATE(1289)] = 24689,
  [SMALL_STATE(1290)] = 24697,
  [SMALL_STATE(1291)] = 24705,
  [SMALL_STATE(1292)] = 24713,
  [SMALL_STATE(1293)] = 24721,
  [SMALL_STATE(1294)] = 24729,
  [SMALL_STATE(1295)] = 24737,
  [SMALL_STATE(1296)] = 24745,
  [SMALL_STATE(1297)] = 24753,
  [SMALL_STATE(1298)] = 24761,
  [SMALL_STATE(1299)] = 24769,
  [SMALL_STATE(1300)] = 24779,
  [SMALL_STATE(1301)] = 24787,
  [SMALL_STATE(1302)] = 24795,
  [SMALL_STATE(1303)] = 24803,
  [SMALL_STATE(1304)] = 24811,
  [SMALL_STATE(1305)] = 24819,
  [SMALL_STATE(1306)] = 24827,
  [SMALL_STATE(1307)] = 24835,
  [SMALL_STATE(1308)] = 24843,
  [SMALL_STATE(1309)] = 24851,
  [SMALL_STATE(1310)] = 24859,
  [SMALL_STATE(1311)] = 24867,
  [SMALL_STATE(1312)] = 24875,
  [SMALL_STATE(1313)] = 24883,
  [SMALL_STATE(1314)] = 24891,
  [SMALL_STATE(1315)] = 24901,
  [SMALL_STATE(1316)] = 24909,
  [SMALL_STATE(1317)] = 24917,
  [SMALL_STATE(1318)] = 24925,
  [SMALL_STATE(1319)] = 24933,
  [SMALL_STATE(1320)] = 24941,
  [SMALL_STATE(1321)] = 24951,
  [SMALL_STATE(1322)] = 24959,
  [SMALL_STATE(1323)] = 24967,
  [SMALL_STATE(1324)] = 24975,
  [SMALL_STATE(1325)] = 24983,
  [SMALL_STATE(1326)] = 24993,
  [SMALL_STATE(1327)] = 25001,
  [SMALL_STATE(1328)] = 25009,
  [SMALL_STATE(1329)] = 25017,
  [SMALL_STATE(1330)] = 25025,
  [SMALL_STATE(1331)] = 25035,
  [SMALL_STATE(1332)] = 25043,
  [SMALL_STATE(1333)] = 25051,
  [SMALL_STATE(1334)] = 25059,
  [SMALL_STATE(1335)] = 25067,
  [SMALL_STATE(1336)] = 25075,
  [SMALL_STATE(1337)] = 25083,
  [SMALL_STATE(1338)] = 25091,
  [SMALL_STATE(1339)] = 25099,
  [SMALL_STATE(1340)] = 25107,
  [SMALL_STATE(1341)] = 25115,
  [SMALL_STATE(1342)] = 25123,
  [SMALL_STATE(1343)] = 25131,
  [SMALL_STATE(1344)] = 25139,
  [SMALL_STATE(1345)] = 25147,
  [SMALL_STATE(1346)] = 25155,
  [SMALL_STATE(1347)] = 25163,
  [SMALL_STATE(1348)] = 25171,
  [SMALL_STATE(1349)] = 25179,
  [SMALL_STATE(1350)] = 25187,
  [SMALL_STATE(1351)] = 25195,
  [SMALL_STATE(1352)] = 25203,
  [SMALL_STATE(1353)] = 25211,
  [SMALL_STATE(1354)] = 25219,
  [SMALL_STATE(1355)] = 25227,
  [SMALL_STATE(1356)] = 25235,
  [SMALL_STATE(1357)] = 25243,
  [SMALL_STATE(1358)] = 25251,
  [SMALL_STATE(1359)] = 25259,
  [SMALL_STATE(1360)] = 25269,
  [SMALL_STATE(1361)] = 25277,
  [SMALL_STATE(1362)] = 25285,
  [SMALL_STATE(1363)] = 25293,
  [SMALL_STATE(1364)] = 25301,
  [SMALL_STATE(1365)] = 25309,
  [SMALL_STATE(1366)] = 25317,
  [SMALL_STATE(1367)] = 25325,
  [SMALL_STATE(1368)] = 25333,
  [SMALL_STATE(1369)] = 25341,
  [SMALL_STATE(1370)] = 25349,
  [SMALL_STATE(1371)] = 25359,
  [SMALL_STATE(1372)] = 25367,
  [SMALL_STATE(1373)] = 25375,
  [SMALL_STATE(1374)] = 25383,
  [SMALL_STATE(1375)] = 25393,
  [SMALL_STATE(1376)] = 25401,
  [SMALL_STATE(1377)] = 25409,
  [SMALL_STATE(1378)] = 25417,
  [SMALL_STATE(1379)] = 25425,
  [SMALL_STATE(1380)] = 25433,
  [SMALL_STATE(1381)] = 25441,
  [SMALL_STATE(1382)] = 25449,
  [SMALL_STATE(1383)] = 25457,
  [SMALL_STATE(1384)] = 25465,
  [SMALL_STATE(1385)] = 25473,
  [SMALL_STATE(1386)] = 25481,
  [SMALL_STATE(1387)] = 25489,
  [SMALL_STATE(1388)] = 25497,
  [SMALL_STATE(1389)] = 25505,
  [SMALL_STATE(1390)] = 25513,
  [SMALL_STATE(1391)] = 25521,
  [SMALL_STATE(1392)] = 25529,
  [SMALL_STATE(1393)] = 25537,
  [SMALL_STATE(1394)] = 25545,
  [SMALL_STATE(1395)] = 25553,
  [SMALL_STATE(1396)] = 25561,
  [SMALL_STATE(1397)] = 25569,
  [SMALL_STATE(1398)] = 25577,
  [SMALL_STATE(1399)] = 25585,
  [SMALL_STATE(1400)] = 25593,
  [SMALL_STATE(1401)] = 25601,
  [SMALL_STATE(1402)] = 25609,
  [SMALL_STATE(1403)] = 25617,
  [SMALL_STATE(1404)] = 25625,
  [SMALL_STATE(1405)] = 25633,
  [SMALL_STATE(1406)] = 25641,
  [SMALL_STATE(1407)] = 25649,
  [SMALL_STATE(1408)] = 25657,
  [SMALL_STATE(1409)] = 25665,
  [SMALL_STATE(1410)] = 25673,
  [SMALL_STATE(1411)] = 25680,
  [SMALL_STATE(1412)] = 25687,
  [SMALL_STATE(1413)] = 25694,
  [SMALL_STATE(1414)] = 25701,
  [SMALL_STATE(1415)] = 25708,
  [SMALL_STATE(1416)] = 25715,
  [SMALL_STATE(1417)] = 25722,
  [SMALL_STATE(1418)] = 25729,
  [SMALL_STATE(1419)] = 25736,
  [SMALL_STATE(1420)] = 25743,
  [SMALL_STATE(1421)] = 25750,
  [SMALL_STATE(1422)] = 25757,
  [SMALL_STATE(1423)] = 25764,
  [SMALL_STATE(1424)] = 25771,
  [SMALL_STATE(1425)] = 25778,
  [SMALL_STATE(1426)] = 25785,
  [SMALL_STATE(1427)] = 25792,
  [SMALL_STATE(1428)] = 25799,
  [SMALL_STATE(1429)] = 25806,
  [SMALL_STATE(1430)] = 25813,
  [SMALL_STATE(1431)] = 25820,
  [SMALL_STATE(1432)] = 25827,
  [SMALL_STATE(1433)] = 25834,
  [SMALL_STATE(1434)] = 25841,
  [SMALL_STATE(1435)] = 25848,
  [SMALL_STATE(1436)] = 25855,
  [SMALL_STATE(1437)] = 25862,
  [SMALL_STATE(1438)] = 25869,
  [SMALL_STATE(1439)] = 25876,
  [SMALL_STATE(1440)] = 25883,
  [SMALL_STATE(1441)] = 25890,
  [SMALL_STATE(1442)] = 25897,
  [SMALL_STATE(1443)] = 25904,
  [SMALL_STATE(1444)] = 25911,
  [SMALL_STATE(1445)] = 25918,
  [SMALL_STATE(1446)] = 25925,
  [SMALL_STATE(1447)] = 25932,
  [SMALL_STATE(1448)] = 25939,
  [SMALL_STATE(1449)] = 25946,
  [SMALL_STATE(1450)] = 25953,
  [SMALL_STATE(1451)] = 25960,
  [SMALL_STATE(1452)] = 25967,
  [SMALL_STATE(1453)] = 25974,
  [SMALL_STATE(1454)] = 25981,
  [SMALL_STATE(1455)] = 25988,
  [SMALL_STATE(1456)] = 25995,
  [SMALL_STATE(1457)] = 26002,
  [SMALL_STATE(1458)] = 26009,
  [SMALL_STATE(1459)] = 26016,
  [SMALL_STATE(1460)] = 26023,
  [SMALL_STATE(1461)] = 26030,
  [SMALL_STATE(1462)] = 26037,
  [SMALL_STATE(1463)] = 26044,
  [SMALL_STATE(1464)] = 26051,
  [SMALL_STATE(1465)] = 26058,
  [SMALL_STATE(1466)] = 26065,
  [SMALL_STATE(1467)] = 26072,
  [SMALL_STATE(1468)] = 26079,
  [SMALL_STATE(1469)] = 26086,
  [SMALL_STATE(1470)] = 26093,
  [SMALL_STATE(1471)] = 26100,
  [SMALL_STATE(1472)] = 26107,
  [SMALL_STATE(1473)] = 26114,
  [SMALL_STATE(1474)] = 26121,
  [SMALL_STATE(1475)] = 26128,
  [SMALL_STATE(1476)] = 26135,
  [SMALL_STATE(1477)] = 26142,
  [SMALL_STATE(1478)] = 26149,
  [SMALL_STATE(1479)] = 26156,
  [SMALL_STATE(1480)] = 26163,
  [SMALL_STATE(1481)] = 26170,
  [SMALL_STATE(1482)] = 26177,
  [SMALL_STATE(1483)] = 26184,
  [SMALL_STATE(1484)] = 26191,
  [SMALL_STATE(1485)] = 26198,
  [SMALL_STATE(1486)] = 26205,
  [SMALL_STATE(1487)] = 26212,
  [SMALL_STATE(1488)] = 26219,
  [SMALL_STATE(1489)] = 26226,
  [SMALL_STATE(1490)] = 26233,
  [SMALL_STATE(1491)] = 26240,
  [SMALL_STATE(1492)] = 26247,
  [SMALL_STATE(1493)] = 26254,
  [SMALL_STATE(1494)] = 26261,
  [SMALL_STATE(1495)] = 26268,
  [SMALL_STATE(1496)] = 26275,
  [SMALL_STATE(1497)] = 26282,
  [SMALL_STATE(1498)] = 26289,
  [SMALL_STATE(1499)] = 26296,
  [SMALL_STATE(1500)] = 26303,
  [SMALL_STATE(1501)] = 26310,
  [SMALL_STATE(1502)] = 26317,
  [SMALL_STATE(1503)] = 26324,
  [SMALL_STATE(1504)] = 26331,
  [SMALL_STATE(1505)] = 26338,
  [SMALL_STATE(1506)] = 26345,
  [SMALL_STATE(1507)] = 26352,
  [SMALL_STATE(1508)] = 26359,
  [SMALL_STATE(1509)] = 26366,
  [SMALL_STATE(1510)] = 26373,
  [SMALL_STATE(1511)] = 26380,
  [SMALL_STATE(1512)] = 26387,
  [SMALL_STATE(1513)] = 26394,
  [SMALL_STATE(1514)] = 26401,
  [SMALL_STATE(1515)] = 26408,
  [SMALL_STATE(1516)] = 26415,
  [SMALL_STATE(1517)] = 26422,
  [SMALL_STATE(1518)] = 26429,
  [SMALL_STATE(1519)] = 26436,
  [SMALL_STATE(1520)] = 26443,
  [SMALL_STATE(1521)] = 26450,
  [SMALL_STATE(1522)] = 26457,
  [SMALL_STATE(1523)] = 26464,
  [SMALL_STATE(1524)] = 26471,
  [SMALL_STATE(1525)] = 26478,
  [SMALL_STATE(1526)] = 26485,
  [SMALL_STATE(1527)] = 26492,
  [SMALL_STATE(1528)] = 26499,
  [SMALL_STATE(1529)] = 26506,
  [SMALL_STATE(1530)] = 26513,
  [SMALL_STATE(1531)] = 26520,
  [SMALL_STATE(1532)] = 26527,
  [SMALL_STATE(1533)] = 26534,
  [SMALL_STATE(1534)] = 26541,
  [SMALL_STATE(1535)] = 26548,
  [SMALL_STATE(1536)] = 26555,
  [SMALL_STATE(1537)] = 26562,
  [SMALL_STATE(1538)] = 26569,
  [SMALL_STATE(1539)] = 26576,
  [SMALL_STATE(1540)] = 26583,
  [SMALL_STATE(1541)] = 26590,
  [SMALL_STATE(1542)] = 26597,
  [SMALL_STATE(1543)] = 26604,
  [SMALL_STATE(1544)] = 26611,
  [SMALL_STATE(1545)] = 26618,
  [SMALL_STATE(1546)] = 26625,
  [SMALL_STATE(1547)] = 26632,
  [SMALL_STATE(1548)] = 26639,
  [SMALL_STATE(1549)] = 26646,
  [SMALL_STATE(1550)] = 26653,
  [SMALL_STATE(1551)] = 26660,
  [SMALL_STATE(1552)] = 26667,
  [SMALL_STATE(1553)] = 26674,
  [SMALL_STATE(1554)] = 26681,
  [SMALL_STATE(1555)] = 26688,
  [SMALL_STATE(1556)] = 26695,
  [SMALL_STATE(1557)] = 26702,
  [SMALL_STATE(1558)] = 26709,
  [SMALL_STATE(1559)] = 26716,
  [SMALL_STATE(1560)] = 26723,
  [SMALL_STATE(1561)] = 26730,
  [SMALL_STATE(1562)] = 26737,
  [SMALL_STATE(1563)] = 26744,
  [SMALL_STATE(1564)] = 26751,
  [SMALL_STATE(1565)] = 26758,
  [SMALL_STATE(1566)] = 26765,
  [SMALL_STATE(1567)] = 26772,
  [SMALL_STATE(1568)] = 26779,
  [SMALL_STATE(1569)] = 26786,
  [SMALL_STATE(1570)] = 26793,
  [SMALL_STATE(1571)] = 26800,
  [SMALL_STATE(1572)] = 26807,
  [SMALL_STATE(1573)] = 26814,
  [SMALL_STATE(1574)] = 26821,
  [SMALL_STATE(1575)] = 26828,
  [SMALL_STATE(1576)] = 26835,
  [SMALL_STATE(1577)] = 26842,
  [SMALL_STATE(1578)] = 26849,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [71] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_key_itm, 1, 0, 0),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_val_itm, 1, 0, 0),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_val_itm, 1, 0, 0),
  [117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_key_itm, 1, 0, 0),
  [119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_val_itm, 1, 0, 0),
  [121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_key_itm, 1, 0, 0),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_seq_itm, 1, 0, 0),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_seq_itm, 1, 0, 0),
  [167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_seq_itm, 1, 0, 0),
  [169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__blk_imp_itm_tal, 1, 0, 0),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_doc, 1, 0, 0),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_prp_val, 1, 0, 0),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_prp_val, 1, 0, 0),
  [379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__doc_w_bgn_w_end_seq, 1, 0, 0),
  [381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__doc_wo_bgn_w_end_seq, 1, 0, 0),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_flw_exp_par, 1, 0, 0), REDUCE(sym__r_sgl_flw_exp_par, 1, 0, 0),
  [396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_exp_par, 1, 0, 0),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_flw_njl_ann_par, 1, 0, 0), REDUCE(sym__r_sgl_flw_njl_ann_par, 1, 0, 0),
  [477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_njl_ann_par, 1, 0, 0),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_map_dat, 2, 0, 0),
  [553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_map_dat, 3, 0, 0),
  [555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_map_dat, 2, 0, 0),
  [557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_map_dat, 3, 0, 0),
  [559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_seq_dat, 2, 0, 0),
  [561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_seq_dat, 2, 0, 0),
  [563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_seq_dat, 3, 0, 0),
  [565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_seq_dat, 3, 0, 0),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_exp_par, 1, 0, 0),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_njl_ann_par, 1, 0, 0),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_jsl_ann_par, 1, 0, 0),
  [613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_jsl_ann_par, 1, 0, 0),
  [615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_prp, 1, 0, 0),
  [617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_prp, 1, 0, 0),
  [619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_prp, 1, 0, 0), REDUCE(sym__r_sgl_prp, 1, 0, 0),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_prp, 1, 0, 0), SHIFT(1539),
  [627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_prp, 1, 0, 0),
  [629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_prp, 1, 0, 0),
  [631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__br_prp, 1, 0, 0), REDUCE(sym__br_sgl_prp, 1, 0, 0),
  [634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__br_prp, 1, 0, 0), SHIFT(1539),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_acr, 2, 0, 0),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_prp, 1, 0, 0), SHIFT(110),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__br_prp, 1, 0, 0), SHIFT(111),
  [651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_acr, 2, 0, 0),
  [653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_prp, 2, 0, 0),
  [655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_prp, 2, 0, 0),
  [657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_prp, 2, 0, 0), REDUCE(sym__r_sgl_prp, 2, 0, 0),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_prp, 2, 0, 0),
  [664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_prp, 2, 0, 0),
  [666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__br_prp, 2, 0, 0), REDUCE(sym__br_sgl_prp, 2, 0, 0),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_prp, 1, 0, 0), SHIFT(1439),
  [674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__br_prp, 1, 0, 0), SHIFT(1439),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_blk_map_repeat1, 2, 0, 0), SHIFT_REPEAT(7),
  [702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_blk_map_repeat1, 2, 0, 0), SHIFT_REPEAT(6),
  [705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_blk_map_repeat1, 2, 0, 0), SHIFT_REPEAT(140),
  [708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_blk_map_repeat1, 2, 0, 0), SHIFT_REPEAT(141),
  [711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_blk_map_repeat1, 2, 0, 0), SHIFT_REPEAT(970),
  [714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_blk_map_repeat1, 2, 0, 0), SHIFT_REPEAT(975),
  [717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_blk_map_repeat1, 2, 0, 0), SHIFT_REPEAT(1461),
  [720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_blk_map_repeat1, 2, 0, 0), SHIFT_REPEAT(406),
  [723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_blk_map_repeat1, 2, 0, 0), SHIFT_REPEAT(1484),
  [726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_blk_map_repeat1, 2, 0, 0), SHIFT_REPEAT(1488),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__r_blk_map_repeat1, 2, 0, 0),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_prp, 1, 0, 0), SHIFT(1511),
  [736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__br_prp, 1, 0, 0), SHIFT(1511),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__br_prp, 1, 0, 0), SHIFT(171),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_prp, 1, 0, 0), SHIFT(176),
  [841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_col_dat, 2, 0, 0),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_col_dat, 3, 0, 0),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_prp, 1, 0, 0), SHIFT(181),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__br_prp, 1, 0, 0), SHIFT(180),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_exp_par, 1, 0, 0),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_njl_ann_par, 1, 0, 0),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_jsl_ann_par, 1, 0, 0),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__drs_doc_end, 2, 0, 0),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__imp_doc_end, 2, 0, 0),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bgn_imp_doc_end, 2, 0, 0),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_doc_end, 2, 0, 0),
  [969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__doc_end, 1, 0, 0),
  [971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_prp_val, 1, 0, 0),
  [973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__blk_seq_itm_tal, 1, 0, 0),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__blk_imp_itm_tal, 2, 0, 5),
  [979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_als_val, 1, 0, 0),
  [981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_pln_blk_val, 2, 0, 0),
  [983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_pln_blk_val, 1, 0, 0),
  [985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_pln_blk_val, 2, 0, 0),
  [987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_dqt_str, 3, 0, 0),
  [989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_dqt_str, 3, 0, 0),
  [991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_dqt_str, 3, 0, 0),
  [993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_dqt_str, 3, 0, 0),
  [995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sqt_str, 3, 0, 0),
  [997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_sqt_str, 3, 0, 0),
  [999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sqt_str, 3, 0, 0),
  [1001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_sqt_str, 3, 0, 0),
  [1003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_pln_blk, 1, 0, 0),
  [1005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_als, 2, 0, 0),
  [1007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_exp_itm, 1, 0, 2),
  [1009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_exp_itm, 1, 0, 2),
  [1011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_exp_itm, 1, 0, 2),
  [1013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_pln_blk, 1, 0, 0),
  [1015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_pln_blk_val, 1, 0, 0),
  [1017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_pln_blk_val, 1, 0, 0),
  [1019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_pln_blk_val, 1, 0, 0),
  [1021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_als_val, 1, 0, 0),
  [1023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__flw_seq_tal, 1, 0, 0),
  [1025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sgl_flw_seq_tal, 1, 0, 0),
  [1027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__flw_map_tal, 1, 0, 0),
  [1029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sgl_flw_map_tal, 1, 0, 0),
  [1031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_dqt_str, 2, 0, 0),
  [1033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_dqt_str, 2, 0, 0),
  [1035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_dqt_str, 2, 0, 0),
  [1037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_dqt_str, 2, 0, 0),
  [1039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sqt_str, 2, 0, 0),
  [1041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_sqt_str, 2, 0, 0),
  [1043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sqt_str, 2, 0, 0),
  [1045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_sqt_str, 2, 0, 0),
  [1047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_als, 2, 0, 0),
  [1049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_seq_spc_val, 2, 0, 0),
  [1051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_map, 3, 0, 0),
  [1053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_dqt_str, 4, 0, 0),
  [1055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_dqt_str, 4, 0, 0),
  [1057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_dqt_str_val, 2, 0, 0),
  [1059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sqt_str, 4, 0, 0),
  [1061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_dqt_str, 5, 0, 0),
  [1063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_dqt_str, 5, 0, 0),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_map, 2, 0, 0),
  [1067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_map, 2, 0, 0),
  [1069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_key_itm, 2, 0, 4),
  [1071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_val_itm, 2, 0, 5),
  [1073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_imp_itm, 2, 0, 9),
  [1075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_str, 3, 0, 0),
  [1077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_exp_itm, 2, 0, 10),
  [1079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_str, 3, 0, 0),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [1091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_prp_val, 1, 0, 0),
  [1093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_seq_spc_val, 1, 0, 0),
  [1095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_key_itm, 2, 0, 4),
  [1097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_key_itm, 2, 0, 4),
  [1099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_imp_itm, 2, 0, 9),
  [1101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_imp_itm, 2, 0, 9),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_val_itm, 2, 0, 5),
  [1105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_val_itm, 2, 0, 5),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_map_itm, 1, 0, 1),
  [1109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_map_itm, 1, 0, 1),
  [1111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__flw_seq_tal, 2, 0, 0),
  [1113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__flw_map_tal, 2, 0, 0),
  [1115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_prp_val, 1, 0, 0),
  [1117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_map_itm, 1, 0, 1),
  [1119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_exp_itm, 1, 0, 3),
  [1121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_exp_itm, 1, 0, 3),
  [1123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_exp_itm, 1, 0, 3),
  [1125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_exp_itm, 2, 0, 10),
  [1127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_exp_itm, 2, 0, 10),
  [1129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_mtl_pln_blk, 1, 0, 0),
  [1131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_mtl_pln_blk, 1, 0, 0),
  [1133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_seq_spc_val, 2, 0, 0),
  [1135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_map_val, 2, 0, 0),
  [1137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_seq_r_val, 1, 0, 0),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_seq_val, 1, 0, 0),
  [1141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_map_r_val, 1, 0, 0),
  [1143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_map_val, 1, 0, 0),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_str_val, 1, 0, 0),
  [1147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_str_val, 1, 0, 0),
  [1149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_seq_val, 1, 0, 0),
  [1151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_seq_val, 1, 0, 0),
  [1153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_map_val, 1, 0, 0),
  [1155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_map_val, 1, 0, 0),
  [1157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_dqt_str_val, 1, 0, 0),
  [1159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_dqt_str_val, 1, 0, 0),
  [1161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sqt_str_val, 1, 0, 0),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sqt_str_val, 1, 0, 0),
  [1165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sqt_str_val, 2, 0, 0),
  [1167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_seq, 2, 0, 0),
  [1169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_seq_spc, 2, 0, 0),
  [1171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_str, 2, 0, 0),
  [1173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_str, 2, 0, 0),
  [1175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_seq, 2, 0, 0),
  [1177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_seq, 2, 0, 0),
  [1179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_seq, 2, 0, 0),
  [1181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_map, 2, 0, 0),
  [1183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_map, 2, 0, 0),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_seq, 3, 0, 0),
  [1187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_seq, 3, 0, 0),
  [1189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_seq_val, 2, 0, 0),
  [1191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_seq_br_val, 2, 0, 0),
  [1193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_map_br_val, 2, 0, 0),
  [1195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_str_val, 2, 0, 0),
  [1197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_seq_val, 2, 0, 0),
  [1199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_map_val, 2, 0, 0),
  [1201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_dqt_str_val, 2, 0, 0),
  [1203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sqt_str_val, 2, 0, 0),
  [1205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_map, 3, 0, 0),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_seq_val, 2, 0, 0),
  [1209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_map_val, 2, 0, 0),
  [1211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_str_val, 2, 0, 0),
  [1213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sqt_str, 4, 0, 0),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_prp, 1, 0, 0),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_acr, 2, 0, 0),
  [1533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_flw_map_itm, 1, 0, 0), REDUCE(sym__r_sgl_flw_col_itm, 1, 0, 0),
  [1536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_map_itm, 1, 0, 0),
  [1538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__doc_w_bgn_wo_end_seq, 1, 0, 0),
  [1540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_prp, 2, 0, 0),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__doc_wo_bgn_wo_end_seq, 1, 0, 0),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [1594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_map_itm, 1, 0, 0),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_mtl_dqt_ctn, 2, 0, 0),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [1622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_sgl_dqt_ctn, 2, 0, 0), SHIFT_REPEAT(501),
  [1625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__r_sgl_dqt_ctn, 2, 0, 0),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [1643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__br_mtl_dqt_ctn_repeat1, 2, 0, 0), SHIFT_REPEAT(507),
  [1646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__br_mtl_dqt_ctn_repeat1, 2, 0, 0),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [1660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__drs_doc_repeat1, 2, 0, 0), SHIFT_REPEAT(1427),
  [1663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__drs_doc_repeat1, 2, 0, 0), SHIFT_REPEAT(1515),
  [1666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__drs_doc_repeat1, 2, 0, 0), SHIFT_REPEAT(694),
  [1669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__drs_doc_repeat1, 2, 0, 0),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_mtl_dqt_ctn, 1, 0, 0),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [1749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_flw_seq_itm, 1, 0, 0), REDUCE(sym__r_sgl_flw_col_itm, 1, 0, 0),
  [1752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_seq_itm, 1, 0, 0),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [1758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__r_flw_seq_dat_repeat1, 2, 0, 0),
  [1760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_flw_seq_dat_repeat1, 2, 0, 0), SHIFT_REPEAT(79),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__flw_seq_tal, 1, 0, 0), REDUCE(sym__sgl_flw_seq_tal, 1, 0, 0),
  [1772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_pln_flw_val, 1, 0, 0), REDUCE(sym__r_sgl_pln_flw_val, 1, 0, 0),
  [1775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_pln_flw_val, 1, 0, 0),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_pln_flw_val, 1, 0, 0),
  [1791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_dqt_str_repeat1, 2, 0, 0), SHIFT_REPEAT(523),
  [1794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_dqt_str_repeat1, 2, 0, 0), SHIFT_REPEAT(565),
  [1797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__r_dqt_str_repeat1, 2, 0, 0),
  [1799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__r_flw_map_dat_repeat1, 2, 0, 0),
  [1801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_flw_map_dat_repeat1, 2, 0, 0), SHIFT_REPEAT(78),
  [1804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__flw_map_tal, 1, 0, 0), REDUCE(sym__sgl_flw_map_tal, 1, 0, 0),
  [1807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_dqt_str, 2, 0, 0), REDUCE(sym__r_sgl_dqt_str, 2, 0, 0),
  [1810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_sqt_str, 2, 0, 0), REDUCE(sym__r_sgl_sqt_str, 2, 0, 0),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [1821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__br_mtl_sqt_ctn_repeat1, 2, 0, 0), SHIFT_REPEAT(586),
  [1824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__br_mtl_sqt_ctn_repeat1, 2, 0, 0),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [1838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_dqt_str, 3, 0, 0), REDUCE(sym__r_sgl_dqt_str, 3, 0, 0),
  [1841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__r_sqt_str, 3, 0, 0), REDUCE(sym__r_sgl_sqt_str, 3, 0, 0),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [1846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_mtl_sqt_ctn, 2, 0, 0),
  [1848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_sgl_sqt_ctn, 2, 0, 0), SHIFT_REPEAT(615),
  [1851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__r_sgl_sqt_ctn, 2, 0, 0),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [1857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [1865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_pln_flw_val, 2, 0, 0),
  [1867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_pln_flw_val, 2, 0, 0),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_seq_itm, 1, 0, 0),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [1883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_mtl_sqt_ctn, 1, 0, 0),
  [1885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_seq_dat, 1, 0, 0),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_seq_dat, 1, 0, 0),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [1921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_map_dat, 1, 0, 0),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_map_dat, 1, 0, 0),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_pln_flw, 1, 0, 0),
  [1935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_pln_flw, 1, 0, 0),
  [1937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_mtl_pln_flw, 1, 0, 0),
  [1939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_mtl_pln_flw, 1, 0, 0),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [1953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__s_dir_rsv, 1, 0, 0),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [1957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__s_dir_rsv_repeat1, 2, 0, 0),
  [1959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__s_dir_rsv_repeat1, 2, 0, 0), SHIFT_REPEAT(698),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [1966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_sqt_str_repeat1, 2, 0, 0), SHIFT_REPEAT(648),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__r_sqt_str_repeat1, 2, 0, 0),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [1973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__s_dir_rsv, 2, 0, 0),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [2003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_imp_br_par, 2, 0, 9),
  [2005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_imp_br_par, 2, 0, 9),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_seq_itm, 1, 0, 6),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_seq_itm, 1, 0, 6),
  [2011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_seq_itm, 1, 0, 7),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_seq_itm, 1, 0, 7),
  [2015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_exp_par, 2, 0, 11),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_exp_par, 2, 0, 11),
  [2019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_njl_ann_par, 2, 0, 5),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_map_itm, 1, 0, 6),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_map_itm, 1, 0, 6),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_jsl_ann_par, 2, 0, 5),
  [2027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__flw_seq_dat_rpt, 2, 0, 0),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_jsl_ann_par, 2, 0, 5),
  [2031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__flw_map_dat_rpt, 2, 0, 0),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_map_itm, 1, 0, 7),
  [2035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_map_itm, 1, 0, 7),
  [2037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_mtl_dqt_ctn, 3, 0, 0),
  [2039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_doc_tal, 1, 0, 0),
  [2041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__flw_ann_par_tal, 1, 0, 0), REDUCE(sym__sgl_flw_ann_par_tal, 1, 0, 0),
  [2044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__flw_ann_par_tal, 1, 0, 0),
  [2046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_njl_ann_par, 2, 0, 5),
  [2048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_flw_imp_r_par, 2, 0, 9),
  [2050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_flw_imp_r_par, 2, 0, 9),
  [2052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__imp_doc, 1, 0, 0),
  [2054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__r_sgl_flw_col_dat_repeat1, 2, 0, 0),
  [2056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_sgl_flw_col_dat_repeat1, 2, 0, 0), SHIFT_REPEAT(175),
  [2059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_col_dat, 1, 0, 0),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [2067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__s_dir_tag, 3, 0, 0),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [2089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_col_itm, 1, 0, 0),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [2099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_blk_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(10),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__r_blk_seq_repeat1, 2, 0, 0),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [2150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__s_dir_yml, 2, 0, 0),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [2168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_sgl_dqt_ctn, 2, 0, 0), SHIFT_REPEAT(1023),
  [2171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_sgl_sqt_ctn, 2, 0, 0), SHIFT_REPEAT(1024),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [2192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_sgl_flw_col_dat_repeat1, 2, 0, 0), SHIFT_REPEAT(179),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [2209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_seq, 2, 0, 0),
  [2211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_seq_val, 2, 0, 0),
  [2213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_map_val, 2, 0, 0),
  [2215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_dqt_str_val, 2, 0, 0),
  [2217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_sqt_str_val, 2, 0, 0),
  [2219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__r_blk_str_repeat1, 2, 0, 0), SHIFT_REPEAT(1056),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__r_blk_str_repeat1, 2, 0, 0),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sgl_flw_seq_tal, 2, 0, 0),
  [2228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sgl_flw_map_tal, 2, 0, 0),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_map, 2, 0, 0),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [2244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_pln_flw_val, 2, 0, 0),
  [2246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__drs_doc, 2, 0, 0),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_seq_val, 1, 0, 0),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [2260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_map_val, 1, 0, 0),
  [2262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_dqt_str_val, 1, 0, 0),
  [2264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_sqt_str_val, 1, 0, 0),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [2270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bgn_imp_doc, 1, 0, 0),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [2276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_pln_flw_val, 1, 0, 0),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [2288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_doc, 2, 0, 0),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__doc_w_bgn_wo_end, 1, 0, 8),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__doc_wo_bgn_wo_end, 1, 0, 8),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_col_itm, 1, 0, 6),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_imp_par, 2, 0, 9),
  [2332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sgl_flw_col_dat_rpt, 2, 0, 0),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_col_itm, 1, 0, 7),
  [2336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_blk_seq_itm, 2, 0, 0),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_blk_seq_itm, 2, 0, 0),
  [2340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_exp_par, 2, 0, 11),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_blk_seq_itm, 2, 0, 0),
  [2344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_njl_ann_par, 2, 0, 5),
  [2346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_flw_jsl_ann_par, 2, 0, 5),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [2350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_als_val, 1, 0, 0),
  [2352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_dqt_str_val, 2, 0, 0),
  [2354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_flw_seq, 2, 0, 0),
  [2356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_sqt_str_val, 1, 0, 0),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_sqt_str_val, 2, 0, 0),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_pln_blk_val, 2, 0, 0),
  [2362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stream, 2, 0, 8),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [2368] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_dqt_str, 3, 0, 0),
  [2396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_sqt_str, 3, 0, 0),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_flw_seq, 2, 0, 0),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_dqt_str_val, 1, 0, 0),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_flw_map, 2, 0, 0),
  [2408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stream, 3, 0, 8),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__doc_w_bgn_w_end_seq, 2, 0, 0),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_pln_blk, 1, 0, 0),
  [2422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_dqt_str_val, 1, 0, 0),
  [2424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stream, 1, 0, 0),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_als, 2, 0, 0),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [2456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__doc_wo_bgn_w_end_seq, 2, 0, 0),
  [2458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__doc_wo_bgn_wo_end_seq, 2, 0, 0),
  [2460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_flw_seq_val, 2, 0, 0),
  [2462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_flw_map_val, 2, 0, 0),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_flw_seq_val, 1, 0, 0),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_flw_map, 2, 0, 0),
  [2470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_dqt_str, 2, 0, 0),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [2474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_sqt_str, 2, 0, 0),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_flw_map_val, 1, 0, 0),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_flw_map_val, 1, 0, 0),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_sqt_str_val, 1, 0, 0),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__doc_w_bgn_wo_end_seq, 2, 0, 0),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__r_sgl_pln_blk_val, 2, 0, 0),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_flw_seq_val, 2, 0, 0),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_flw_map_val, 2, 0, 0),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__b_sgl_pln_blk_val, 1, 0, 0),
  [2518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_dqt_str_val, 2, 0, 0),
  [2520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_sqt_str_val, 2, 0, 0),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_pln_blk_val, 2, 0, 0),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [2550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__br_sgl_flw_seq_val, 1, 0, 0),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__eof = 0,
  ts_external_token__s_dir_yml_bgn = 1,
  ts_external_token__r_dir_yml_ver = 2,
  ts_external_token__s_dir_tag_bgn = 3,
  ts_external_token__r_dir_tag_hdl = 4,
  ts_external_token__r_dir_tag_pfx = 5,
  ts_external_token__s_dir_rsv_bgn = 6,
  ts_external_token__r_dir_rsv_prm = 7,
  ts_external_token__s_drs_end = 8,
  ts_external_token__s_doc_end = 9,
  ts_external_token__r_blk_seq_bgn = 10,
  ts_external_token__br_blk_seq_bgn = 11,
  ts_external_token__b_blk_seq_bgn = 12,
  ts_external_token__r_blk_key_bgn = 13,
  ts_external_token__br_blk_key_bgn = 14,
  ts_external_token__b_blk_key_bgn = 15,
  ts_external_token__r_blk_val_bgn = 16,
  ts_external_token__br_blk_val_bgn = 17,
  ts_external_token__b_blk_val_bgn = 18,
  ts_external_token__r_blk_imp_bgn = 19,
  ts_external_token__r_blk_lit_bgn = 20,
  ts_external_token__br_blk_lit_bgn = 21,
  ts_external_token__r_blk_fld_bgn = 22,
  ts_external_token__br_blk_fld_bgn = 23,
  ts_external_token__br_blk_str_ctn = 24,
  ts_external_token__r_flw_seq_bgn = 25,
  ts_external_token__br_flw_seq_bgn = 26,
  ts_external_token__b_flw_seq_bgn = 27,
  ts_external_token__r_flw_seq_end = 28,
  ts_external_token__br_flw_seq_end = 29,
  ts_external_token__b_flw_seq_end = 30,
  ts_external_token__r_flw_map_bgn = 31,
  ts_external_token__br_flw_map_bgn = 32,
  ts_external_token__b_flw_map_bgn = 33,
  ts_external_token__r_flw_map_end = 34,
  ts_external_token__br_flw_map_end = 35,
  ts_external_token__b_flw_map_end = 36,
  ts_external_token__r_flw_sep_bgn = 37,
  ts_external_token__br_flw_sep_bgn = 38,
  ts_external_token__r_flw_key_bgn = 39,
  ts_external_token__br_flw_key_bgn = 40,
  ts_external_token__r_flw_jsv_bgn = 41,
  ts_external_token__br_flw_jsv_bgn = 42,
  ts_external_token__r_flw_njv_bgn = 43,
  ts_external_token__br_flw_njv_bgn = 44,
  ts_external_token__r_dqt_str_bgn = 45,
  ts_external_token__br_dqt_str_bgn = 46,
  ts_external_token__b_dqt_str_bgn = 47,
  ts_external_token__r_dqt_str_ctn = 48,
  ts_external_token__br_dqt_str_ctn = 49,
  ts_external_token__r_dqt_esc_nwl = 50,
  ts_external_token__br_dqt_esc_nwl = 51,
  ts_external_token__r_dqt_esc_seq = 52,
  ts_external_token__br_dqt_esc_seq = 53,
  ts_external_token__r_dqt_str_end = 54,
  ts_external_token__br_dqt_str_end = 55,
  ts_external_token__r_sqt_str_bgn = 56,
  ts_external_token__br_sqt_str_bgn = 57,
  ts_external_token__b_sqt_str_bgn = 58,
  ts_external_token__r_sqt_str_ctn = 59,
  ts_external_token__br_sqt_str_ctn = 60,
  ts_external_token__r_sqt_esc_sqt = 61,
  ts_external_token__br_sqt_esc_sqt = 62,
  ts_external_token__r_sqt_str_end = 63,
  ts_external_token__br_sqt_str_end = 64,
  ts_external_token__r_sgl_pln_nul_blk = 65,
  ts_external_token__br_sgl_pln_nul_blk = 66,
  ts_external_token__b_sgl_pln_nul_blk = 67,
  ts_external_token__r_sgl_pln_nul_flw = 68,
  ts_external_token__br_sgl_pln_nul_flw = 69,
  ts_external_token__r_sgl_pln_bol_blk = 70,
  ts_external_token__br_sgl_pln_bol_blk = 71,
  ts_external_token__b_sgl_pln_bol_blk = 72,
  ts_external_token__r_sgl_pln_bol_flw = 73,
  ts_external_token__br_sgl_pln_bol_flw = 74,
  ts_external_token__r_sgl_pln_int_blk = 75,
  ts_external_token__br_sgl_pln_int_blk = 76,
  ts_external_token__b_sgl_pln_int_blk = 77,
  ts_external_token__r_sgl_pln_int_flw = 78,
  ts_external_token__br_sgl_pln_int_flw = 79,
  ts_external_token__r_sgl_pln_flt_blk = 80,
  ts_external_token__br_sgl_pln_flt_blk = 81,
  ts_external_token__b_sgl_pln_flt_blk = 82,
  ts_external_token__r_sgl_pln_flt_flw = 83,
  ts_external_token__br_sgl_pln_flt_flw = 84,
  ts_external_token__r_sgl_pln_str_blk = 85,
  ts_external_token__br_sgl_pln_str_blk = 86,
  ts_external_token__b_sgl_pln_str_blk = 87,
  ts_external_token__r_sgl_pln_str_flw = 88,
  ts_external_token__br_sgl_pln_str_flw = 89,
  ts_external_token__r_mtl_pln_str_blk = 90,
  ts_external_token__br_mtl_pln_str_blk = 91,
  ts_external_token__r_mtl_pln_str_flw = 92,
  ts_external_token__br_mtl_pln_str_flw = 93,
  ts_external_token__r_tag = 94,
  ts_external_token__br_tag = 95,
  ts_external_token__b_tag = 96,
  ts_external_token__r_acr_bgn = 97,
  ts_external_token__br_acr_bgn = 98,
  ts_external_token__b_acr_bgn = 99,
  ts_external_token__r_acr_ctn = 100,
  ts_external_token__r_als_bgn = 101,
  ts_external_token__br_als_bgn = 102,
  ts_external_token__b_als_bgn = 103,
  ts_external_token__r_als_ctn = 104,
  ts_external_token__bl = 105,
  ts_external_token_comment = 106,
  ts_external_token__err_rec = 107,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__eof] = sym__eof,
  [ts_external_token__s_dir_yml_bgn] = sym__s_dir_yml_bgn,
  [ts_external_token__r_dir_yml_ver] = sym__r_dir_yml_ver,
  [ts_external_token__s_dir_tag_bgn] = sym__s_dir_tag_bgn,
  [ts_external_token__r_dir_tag_hdl] = sym__r_dir_tag_hdl,
  [ts_external_token__r_dir_tag_pfx] = sym__r_dir_tag_pfx,
  [ts_external_token__s_dir_rsv_bgn] = sym__s_dir_rsv_bgn,
  [ts_external_token__r_dir_rsv_prm] = sym__r_dir_rsv_prm,
  [ts_external_token__s_drs_end] = sym__s_drs_end,
  [ts_external_token__s_doc_end] = sym__s_doc_end,
  [ts_external_token__r_blk_seq_bgn] = sym__r_blk_seq_bgn,
  [ts_external_token__br_blk_seq_bgn] = sym__br_blk_seq_bgn,
  [ts_external_token__b_blk_seq_bgn] = sym__b_blk_seq_bgn,
  [ts_external_token__r_blk_key_bgn] = sym__r_blk_key_bgn,
  [ts_external_token__br_blk_key_bgn] = sym__br_blk_key_bgn,
  [ts_external_token__b_blk_key_bgn] = sym__b_blk_key_bgn,
  [ts_external_token__r_blk_val_bgn] = sym__r_blk_val_bgn,
  [ts_external_token__br_blk_val_bgn] = sym__br_blk_val_bgn,
  [ts_external_token__b_blk_val_bgn] = sym__b_blk_val_bgn,
  [ts_external_token__r_blk_imp_bgn] = sym__r_blk_imp_bgn,
  [ts_external_token__r_blk_lit_bgn] = sym__r_blk_lit_bgn,
  [ts_external_token__br_blk_lit_bgn] = sym__br_blk_lit_bgn,
  [ts_external_token__r_blk_fld_bgn] = sym__r_blk_fld_bgn,
  [ts_external_token__br_blk_fld_bgn] = sym__br_blk_fld_bgn,
  [ts_external_token__br_blk_str_ctn] = sym__br_blk_str_ctn,
  [ts_external_token__r_flw_seq_bgn] = sym__r_flw_seq_bgn,
  [ts_external_token__br_flw_seq_bgn] = sym__br_flw_seq_bgn,
  [ts_external_token__b_flw_seq_bgn] = sym__b_flw_seq_bgn,
  [ts_external_token__r_flw_seq_end] = sym__r_flw_seq_end,
  [ts_external_token__br_flw_seq_end] = sym__br_flw_seq_end,
  [ts_external_token__b_flw_seq_end] = sym__b_flw_seq_end,
  [ts_external_token__r_flw_map_bgn] = sym__r_flw_map_bgn,
  [ts_external_token__br_flw_map_bgn] = sym__br_flw_map_bgn,
  [ts_external_token__b_flw_map_bgn] = sym__b_flw_map_bgn,
  [ts_external_token__r_flw_map_end] = sym__r_flw_map_end,
  [ts_external_token__br_flw_map_end] = sym__br_flw_map_end,
  [ts_external_token__b_flw_map_end] = sym__b_flw_map_end,
  [ts_external_token__r_flw_sep_bgn] = sym__r_flw_sep_bgn,
  [ts_external_token__br_flw_sep_bgn] = sym__br_flw_sep_bgn,
  [ts_external_token__r_flw_key_bgn] = sym__r_flw_key_bgn,
  [ts_external_token__br_flw_key_bgn] = sym__br_flw_key_bgn,
  [ts_external_token__r_flw_jsv_bgn] = sym__r_flw_jsv_bgn,
  [ts_external_token__br_flw_jsv_bgn] = sym__br_flw_jsv_bgn,
  [ts_external_token__r_flw_njv_bgn] = sym__r_flw_njv_bgn,
  [ts_external_token__br_flw_njv_bgn] = sym__br_flw_njv_bgn,
  [ts_external_token__r_dqt_str_bgn] = sym__r_dqt_str_bgn,
  [ts_external_token__br_dqt_str_bgn] = sym__br_dqt_str_bgn,
  [ts_external_token__b_dqt_str_bgn] = sym__b_dqt_str_bgn,
  [ts_external_token__r_dqt_str_ctn] = sym__r_dqt_str_ctn,
  [ts_external_token__br_dqt_str_ctn] = sym__br_dqt_str_ctn,
  [ts_external_token__r_dqt_esc_nwl] = sym__r_dqt_esc_nwl,
  [ts_external_token__br_dqt_esc_nwl] = sym__br_dqt_esc_nwl,
  [ts_external_token__r_dqt_esc_seq] = sym__r_dqt_esc_seq,
  [ts_external_token__br_dqt_esc_seq] = sym__br_dqt_esc_seq,
  [ts_external_token__r_dqt_str_end] = sym__r_dqt_str_end,
  [ts_external_token__br_dqt_str_end] = sym__br_dqt_str_end,
  [ts_external_token__r_sqt_str_bgn] = sym__r_sqt_str_bgn,
  [ts_external_token__br_sqt_str_bgn] = sym__br_sqt_str_bgn,
  [ts_external_token__b_sqt_str_bgn] = sym__b_sqt_str_bgn,
  [ts_external_token__r_sqt_str_ctn] = sym__r_sqt_str_ctn,
  [ts_external_token__br_sqt_str_ctn] = sym__br_sqt_str_ctn,
  [ts_external_token__r_sqt_esc_sqt] = sym__r_sqt_esc_sqt,
  [ts_external_token__br_sqt_esc_sqt] = sym__br_sqt_esc_sqt,
  [ts_external_token__r_sqt_str_end] = sym__r_sqt_str_end,
  [ts_external_token__br_sqt_str_end] = sym__br_sqt_str_end,
  [ts_external_token__r_sgl_pln_nul_blk] = sym__r_sgl_pln_nul_blk,
  [ts_external_token__br_sgl_pln_nul_blk] = sym__br_sgl_pln_nul_blk,
  [ts_external_token__b_sgl_pln_nul_blk] = sym__b_sgl_pln_nul_blk,
  [ts_external_token__r_sgl_pln_nul_flw] = sym__r_sgl_pln_nul_flw,
  [ts_external_token__br_sgl_pln_nul_flw] = sym__br_sgl_pln_nul_flw,
  [ts_external_token__r_sgl_pln_bol_blk] = sym__r_sgl_pln_bol_blk,
  [ts_external_token__br_sgl_pln_bol_blk] = sym__br_sgl_pln_bol_blk,
  [ts_external_token__b_sgl_pln_bol_blk] = sym__b_sgl_pln_bol_blk,
  [ts_external_token__r_sgl_pln_bol_flw] = sym__r_sgl_pln_bol_flw,
  [ts_external_token__br_sgl_pln_bol_flw] = sym__br_sgl_pln_bol_flw,
  [ts_external_token__r_sgl_pln_int_blk] = sym__r_sgl_pln_int_blk,
  [ts_external_token__br_sgl_pln_int_blk] = sym__br_sgl_pln_int_blk,
  [ts_external_token__b_sgl_pln_int_blk] = sym__b_sgl_pln_int_blk,
  [ts_external_token__r_sgl_pln_int_flw] = sym__r_sgl_pln_int_flw,
  [ts_external_token__br_sgl_pln_int_flw] = sym__br_sgl_pln_int_flw,
  [ts_external_token__r_sgl_pln_flt_blk] = sym__r_sgl_pln_flt_blk,
  [ts_external_token__br_sgl_pln_flt_blk] = sym__br_sgl_pln_flt_blk,
  [ts_external_token__b_sgl_pln_flt_blk] = sym__b_sgl_pln_flt_blk,
  [ts_external_token__r_sgl_pln_flt_flw] = sym__r_sgl_pln_flt_flw,
  [ts_external_token__br_sgl_pln_flt_flw] = sym__br_sgl_pln_flt_flw,
  [ts_external_token__r_sgl_pln_str_blk] = sym__r_sgl_pln_str_blk,
  [ts_external_token__br_sgl_pln_str_blk] = sym__br_sgl_pln_str_blk,
  [ts_external_token__b_sgl_pln_str_blk] = sym__b_sgl_pln_str_blk,
  [ts_external_token__r_sgl_pln_str_flw] = sym__r_sgl_pln_str_flw,
  [ts_external_token__br_sgl_pln_str_flw] = sym__br_sgl_pln_str_flw,
  [ts_external_token__r_mtl_pln_str_blk] = sym__r_mtl_pln_str_blk,
  [ts_external_token__br_mtl_pln_str_blk] = sym__br_mtl_pln_str_blk,
  [ts_external_token__r_mtl_pln_str_flw] = sym__r_mtl_pln_str_flw,
  [ts_external_token__br_mtl_pln_str_flw] = sym__br_mtl_pln_str_flw,
  [ts_external_token__r_tag] = sym__r_tag,
  [ts_external_token__br_tag] = sym__br_tag,
  [ts_external_token__b_tag] = sym__b_tag,
  [ts_external_token__r_acr_bgn] = sym__r_acr_bgn,
  [ts_external_token__br_acr_bgn] = sym__br_acr_bgn,
  [ts_external_token__b_acr_bgn] = sym__b_acr_bgn,
  [ts_external_token__r_acr_ctn] = sym__r_acr_ctn,
  [ts_external_token__r_als_bgn] = sym__r_als_bgn,
  [ts_external_token__br_als_bgn] = sym__br_als_bgn,
  [ts_external_token__b_als_bgn] = sym__b_als_bgn,
  [ts_external_token__r_als_ctn] = sym__r_als_ctn,
  [ts_external_token__bl] = sym__bl,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token__err_rec] = sym__err_rec,
};

static const bool ts_external_scanner_states[110][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__eof] = true,
    [ts_external_token__s_dir_yml_bgn] = true,
    [ts_external_token__r_dir_yml_ver] = true,
    [ts_external_token__s_dir_tag_bgn] = true,
    [ts_external_token__r_dir_tag_hdl] = true,
    [ts_external_token__r_dir_tag_pfx] = true,
    [ts_external_token__s_dir_rsv_bgn] = true,
    [ts_external_token__r_dir_rsv_prm] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token__s_doc_end] = true,
    [ts_external_token__r_blk_seq_bgn] = true,
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__r_blk_key_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__b_blk_key_bgn] = true,
    [ts_external_token__r_blk_val_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__b_blk_val_bgn] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__br_blk_str_ctn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__b_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__b_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_flw_key_bgn] = true,
    [ts_external_token__br_flw_key_bgn] = true,
    [ts_external_token__r_flw_jsv_bgn] = true,
    [ts_external_token__br_flw_jsv_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__br_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__b_dqt_str_bgn] = true,
    [ts_external_token__r_dqt_str_ctn] = true,
    [ts_external_token__br_dqt_str_ctn] = true,
    [ts_external_token__r_dqt_esc_nwl] = true,
    [ts_external_token__br_dqt_esc_nwl] = true,
    [ts_external_token__r_dqt_esc_seq] = true,
    [ts_external_token__br_dqt_esc_seq] = true,
    [ts_external_token__r_dqt_str_end] = true,
    [ts_external_token__br_dqt_str_end] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__b_sqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_ctn] = true,
    [ts_external_token__br_sqt_str_ctn] = true,
    [ts_external_token__r_sqt_esc_sqt] = true,
    [ts_external_token__br_sqt_esc_sqt] = true,
    [ts_external_token__r_sqt_str_end] = true,
    [ts_external_token__br_sqt_str_end] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__b_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__b_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__b_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__b_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__b_sgl_pln_str_blk] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__b_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__b_acr_bgn] = true,
    [ts_external_token__r_acr_ctn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__b_als_bgn] = true,
    [ts_external_token__r_als_ctn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__err_rec] = true,
  },
  [2] = {
    [ts_external_token__eof] = true,
    [ts_external_token__s_dir_yml_bgn] = true,
    [ts_external_token__s_dir_tag_bgn] = true,
    [ts_external_token__s_dir_rsv_bgn] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token__s_doc_end] = true,
    [ts_external_token__r_blk_seq_bgn] = true,
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__r_blk_key_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__r_blk_val_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [3] = {
    [ts_external_token__r_blk_seq_bgn] = true,
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__r_blk_key_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__b_blk_key_bgn] = true,
    [ts_external_token__r_blk_val_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__b_blk_val_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__b_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__b_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__b_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__b_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__b_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__b_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__b_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__b_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__b_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__b_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__b_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__b_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [4] = {
    [ts_external_token__r_blk_seq_bgn] = true,
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__r_blk_key_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__r_blk_val_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [5] = {
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__b_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__b_blk_val_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__b_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__b_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__b_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__b_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__b_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__b_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__b_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__b_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__b_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__b_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__b_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__b_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [6] = {
    [ts_external_token__eof] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token__s_doc_end] = true,
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [7] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token__r_flw_key_bgn] = true,
    [ts_external_token__br_flw_key_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__br_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [8] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_key_bgn] = true,
    [ts_external_token__br_flw_key_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__br_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [9] = {
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__b_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__b_blk_val_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__b_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__b_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__b_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__b_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__b_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__b_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__b_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__b_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__b_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__b_tag] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__b_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__b_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [10] = {
    [ts_external_token__eof] = true,
    [ts_external_token__s_dir_yml_bgn] = true,
    [ts_external_token__s_dir_tag_bgn] = true,
    [ts_external_token__s_dir_rsv_bgn] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token__s_doc_end] = true,
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [11] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [12] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [13] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_key_bgn] = true,
    [ts_external_token__br_flw_key_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__br_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [14] = {
    [ts_external_token__eof] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token__s_doc_end] = true,
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [15] = {
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [16] = {
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__b_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__b_blk_val_bgn] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__b_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__b_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__b_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__b_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__b_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__b_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__b_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__b_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__b_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__b_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__b_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__b_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [17] = {
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__b_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__b_blk_val_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__b_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__b_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__b_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__b_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__b_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__b_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__b_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__b_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__b_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__b_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__b_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__b_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [18] = {
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__b_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__b_blk_val_bgn] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__b_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__b_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__b_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__b_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__b_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__b_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__b_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__b_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__b_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__b_tag] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__b_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__b_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [19] = {
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__b_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__b_blk_val_bgn] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__b_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__b_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__b_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__b_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__b_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__b_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__b_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__b_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__b_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__b_tag] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__b_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__b_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [20] = {
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__b_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__b_blk_val_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__b_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__b_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__b_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__b_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__b_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__b_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__b_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__b_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__b_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__b_tag] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__b_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__b_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [21] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__br_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token_comment] = true,
  },
  [22] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token_comment] = true,
  },
  [23] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token_comment] = true,
  },
  [24] = {
    [ts_external_token__eof] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token__s_doc_end] = true,
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [25] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token_comment] = true,
  },
  [26] = {
    [ts_external_token__b_blk_key_bgn] = true,
    [ts_external_token__b_blk_val_bgn] = true,
    [ts_external_token__b_flw_seq_bgn] = true,
    [ts_external_token__b_flw_map_bgn] = true,
    [ts_external_token__b_dqt_str_bgn] = true,
    [ts_external_token__b_sqt_str_bgn] = true,
    [ts_external_token__b_sgl_pln_nul_blk] = true,
    [ts_external_token__b_sgl_pln_bol_blk] = true,
    [ts_external_token__b_sgl_pln_int_blk] = true,
    [ts_external_token__b_sgl_pln_flt_blk] = true,
    [ts_external_token__b_sgl_pln_str_blk] = true,
    [ts_external_token__b_tag] = true,
    [ts_external_token__b_acr_bgn] = true,
    [ts_external_token__b_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [27] = {
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [28] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_key_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [29] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__r_flw_key_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [30] = {
    [ts_external_token__eof] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token__s_doc_end] = true,
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [31] = {
    [ts_external_token__eof] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token__s_doc_end] = true,
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [32] = {
    [ts_external_token__eof] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token__s_doc_end] = true,
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [33] = {
    [ts_external_token__eof] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token__s_doc_end] = true,
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [34] = {
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [35] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__br_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token_comment] = true,
  },
  [36] = {
    [ts_external_token__br_blk_seq_bgn] = true,
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__br_blk_key_bgn] = true,
    [ts_external_token__br_blk_val_bgn] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_blk_lit_bgn] = true,
    [ts_external_token__br_blk_lit_bgn] = true,
    [ts_external_token__r_blk_fld_bgn] = true,
    [ts_external_token__br_blk_fld_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__br_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__br_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__br_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__br_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__br_sgl_pln_str_blk] = true,
    [ts_external_token__r_mtl_pln_str_blk] = true,
    [ts_external_token__br_mtl_pln_str_blk] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token__br_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [37] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_key_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [38] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__br_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [39] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [40] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [41] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__r_als_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [42] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__br_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token_comment] = true,
  },
  [43] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [44] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [45] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token_comment] = true,
  },
  [46] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token_comment] = true,
  },
  [47] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token_comment] = true,
  },
  [48] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__br_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token__br_acr_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [49] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__br_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__br_flw_map_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__br_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__br_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__br_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__br_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__br_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__br_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__br_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__br_sgl_pln_str_flw] = true,
    [ts_external_token__r_mtl_pln_str_flw] = true,
    [ts_external_token__br_mtl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token__br_tag] = true,
    [ts_external_token_comment] = true,
  },
  [50] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token_comment] = true,
  },
  [51] = {
    [ts_external_token__b_blk_key_bgn] = true,
    [ts_external_token__b_blk_val_bgn] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__b_flw_seq_bgn] = true,
    [ts_external_token__b_flw_map_bgn] = true,
    [ts_external_token__b_dqt_str_bgn] = true,
    [ts_external_token__b_sqt_str_bgn] = true,
    [ts_external_token__b_sgl_pln_nul_blk] = true,
    [ts_external_token__b_sgl_pln_bol_blk] = true,
    [ts_external_token__b_sgl_pln_int_blk] = true,
    [ts_external_token__b_sgl_pln_flt_blk] = true,
    [ts_external_token__b_sgl_pln_str_blk] = true,
    [ts_external_token__b_tag] = true,
    [ts_external_token__b_acr_bgn] = true,
    [ts_external_token__b_als_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [52] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token_comment] = true,
  },
  [53] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token_comment] = true,
  },
  [54] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token_comment] = true,
  },
  [55] = {
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token_comment] = true,
  },
  [56] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token_comment] = true,
  },
  [57] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [58] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [59] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [60] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token_comment] = true,
  },
  [61] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token_comment] = true,
  },
  [62] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [63] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token_comment] = true,
  },
  [64] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token_comment] = true,
  },
  [65] = {
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [66] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_acr_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [67] = {
    [ts_external_token__r_dqt_str_ctn] = true,
    [ts_external_token__br_dqt_str_ctn] = true,
    [ts_external_token__r_dqt_esc_nwl] = true,
    [ts_external_token__br_dqt_esc_nwl] = true,
    [ts_external_token__r_dqt_esc_seq] = true,
    [ts_external_token__br_dqt_esc_seq] = true,
    [ts_external_token__r_dqt_str_end] = true,
    [ts_external_token__br_dqt_str_end] = true,
    [ts_external_token_comment] = true,
  },
  [68] = {
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_blk] = true,
    [ts_external_token__r_sgl_pln_bol_blk] = true,
    [ts_external_token__r_sgl_pln_int_blk] = true,
    [ts_external_token__r_sgl_pln_flt_blk] = true,
    [ts_external_token__r_sgl_pln_str_blk] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token_comment] = true,
  },
  [69] = {
    [ts_external_token__r_flw_seq_bgn] = true,
    [ts_external_token__r_flw_map_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__r_dqt_str_bgn] = true,
    [ts_external_token__r_sqt_str_bgn] = true,
    [ts_external_token__r_sgl_pln_nul_flw] = true,
    [ts_external_token__r_sgl_pln_bol_flw] = true,
    [ts_external_token__r_sgl_pln_int_flw] = true,
    [ts_external_token__r_sgl_pln_flt_flw] = true,
    [ts_external_token__r_sgl_pln_str_flw] = true,
    [ts_external_token__r_tag] = true,
    [ts_external_token_comment] = true,
  },
  [70] = {
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__br_flw_njv_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [71] = {
    [ts_external_token__s_dir_yml_bgn] = true,
    [ts_external_token__s_dir_tag_bgn] = true,
    [ts_external_token__s_dir_rsv_bgn] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token_comment] = true,
  },
  [72] = {
    [ts_external_token__eof] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token__s_doc_end] = true,
    [ts_external_token_comment] = true,
  },
  [73] = {
    [ts_external_token__r_sqt_str_ctn] = true,
    [ts_external_token__br_sqt_str_ctn] = true,
    [ts_external_token__r_sqt_esc_sqt] = true,
    [ts_external_token__br_sqt_esc_sqt] = true,
    [ts_external_token__r_sqt_str_end] = true,
    [ts_external_token__br_sqt_str_end] = true,
    [ts_external_token_comment] = true,
  },
  [74] = {
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_flw_jsv_bgn] = true,
    [ts_external_token__br_flw_jsv_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [75] = {
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [76] = {
    [ts_external_token__br_dqt_str_ctn] = true,
    [ts_external_token__br_dqt_esc_nwl] = true,
    [ts_external_token__br_dqt_esc_seq] = true,
    [ts_external_token__r_dqt_str_end] = true,
    [ts_external_token__br_dqt_str_end] = true,
    [ts_external_token_comment] = true,
  },
  [77] = {
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [78] = {
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token__r_flw_jsv_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [79] = {
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__br_flw_sep_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [80] = {
    [ts_external_token__br_sqt_str_ctn] = true,
    [ts_external_token__br_sqt_esc_sqt] = true,
    [ts_external_token__r_sqt_str_end] = true,
    [ts_external_token__br_sqt_str_end] = true,
    [ts_external_token_comment] = true,
  },
  [81] = {
    [ts_external_token__s_dir_yml_bgn] = true,
    [ts_external_token__s_dir_tag_bgn] = true,
    [ts_external_token__s_dir_rsv_bgn] = true,
    [ts_external_token__r_dir_rsv_prm] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token_comment] = true,
  },
  [82] = {
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token__br_flw_njv_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [83] = {
    [ts_external_token__eof] = true,
    [ts_external_token__s_drs_end] = true,
    [ts_external_token__s_doc_end] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [84] = {
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [85] = {
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [86] = {
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [87] = {
    [ts_external_token__b_blk_seq_bgn] = true,
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [88] = {
    [ts_external_token__r_dqt_str_ctn] = true,
    [ts_external_token__r_dqt_esc_seq] = true,
    [ts_external_token__r_dqt_str_end] = true,
    [ts_external_token_comment] = true,
  },
  [89] = {
    [ts_external_token__r_sqt_str_ctn] = true,
    [ts_external_token__r_sqt_esc_sqt] = true,
    [ts_external_token__r_sqt_str_end] = true,
    [ts_external_token_comment] = true,
  },
  [90] = {
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [91] = {
    [ts_external_token__r_flw_jsv_bgn] = true,
    [ts_external_token__br_flw_jsv_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [92] = {
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_flw_jsv_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [93] = {
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [94] = {
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__r_flw_sep_bgn] = true,
    [ts_external_token__r_flw_jsv_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [95] = {
    [ts_external_token__br_blk_str_ctn] = true,
    [ts_external_token__bl] = true,
    [ts_external_token_comment] = true,
  },
  [96] = {
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token__br_flw_seq_end] = true,
    [ts_external_token__b_flw_seq_end] = true,
    [ts_external_token_comment] = true,
  },
  [97] = {
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token__br_flw_map_end] = true,
    [ts_external_token__b_flw_map_end] = true,
    [ts_external_token_comment] = true,
  },
  [98] = {
    [ts_external_token__r_blk_imp_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [99] = {
    [ts_external_token__r_flw_njv_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [100] = {
    [ts_external_token__r_flw_jsv_bgn] = true,
    [ts_external_token_comment] = true,
  },
  [101] = {
    [ts_external_token__r_acr_ctn] = true,
    [ts_external_token_comment] = true,
  },
  [102] = {
    [ts_external_token_comment] = true,
  },
  [103] = {
    [ts_external_token__r_dir_yml_ver] = true,
    [ts_external_token_comment] = true,
  },
  [104] = {
    [ts_external_token__eof] = true,
    [ts_external_token_comment] = true,
  },
  [105] = {
    [ts_external_token__r_als_ctn] = true,
    [ts_external_token_comment] = true,
  },
  [106] = {
    [ts_external_token__r_flw_seq_end] = true,
    [ts_external_token_comment] = true,
  },
  [107] = {
    [ts_external_token__r_flw_map_end] = true,
    [ts_external_token_comment] = true,
  },
  [108] = {
    [ts_external_token__r_dir_tag_pfx] = true,
    [ts_external_token_comment] = true,
  },
  [109] = {
    [ts_external_token__r_dir_tag_hdl] = true,
    [ts_external_token_comment] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_yaml_external_scanner_create(void);
void tree_sitter_yaml_external_scanner_destroy(void *);
bool tree_sitter_yaml_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_yaml_external_scanner_serialize(void *, char *);
void tree_sitter_yaml_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_yaml(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_yaml_external_scanner_create,
      tree_sitter_yaml_external_scanner_destroy,
      tree_sitter_yaml_external_scanner_scan,
      tree_sitter_yaml_external_scanner_serialize,
      tree_sitter_yaml_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
